IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfBusinessCardExtraInfoGet')
	BEGIN
		PRINT 'Dropping Procedure adfBusinessCardExtraInfoGet'
		DROP  Procedure  adfBusinessCardExtraInfoGet
	END

GO

PRINT 'Creating Procedure adfBusinessCardExtraInfoGet'
GO
/******************************************************************************
**		File: 
**		Name: adfBusinessCardExtraInfoGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfBusinessCardExtraInfoGet
	@BusinessCardClass TClass,
	@BusinessCardID TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Address].[AddressTypeID],
		[Address].[Street],
		[Address].[City],
		[Address].[Region],
		[Address].[PostalCode],
		[Address].[Country],
		[Address].[Mail]
	FROM
		[Address]
	WHERE
		[Address].[BusinessCardID] = @BusinessCardID AND [Address].[BusinessCardClass] = @BusinessCardClass
		
	SELECT
		[Phone].[PhoneTypeID],
		[Phone].[Phone]
	FROM
		[Phone]	
	WHERE
		[Phone].[BusinessCardID] = @BusinessCardID AND [Phone].[BusinessCardClass] = @BusinessCardClass


	SELECT
		[Email].[EmailTypeID],
		[Email].[Email],
		[Email].[DisplayAs]
	FROM
		[Email]
	WHERE
		[Email].[BusinessCardID] = @BusinessCardID AND [Email].[BusinessCardClass] = @BusinessCardClass

	RETURN 0
GO

