IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfBusinessCardGet')
	BEGIN
		PRINT 'Dropping Procedure adfBusinessCardGet'
		DROP  Procedure  adfBusinessCardGet
	END

GO

PRINT 'Creating Procedure adfBusinessCardGet'
GO
/******************************************************************************
**		File: 
**		Name: adfBusinessCardGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfBusinessCardGet
	@ID TIdentifier,
	@Class TClass
AS
	SET NOCOUNT ON
	DECLARE @CompanyClass TClass, @EmployeeClass TClass
	SET NOCOUNT ON
	
	SET @CompanyClass = dbo.adfGetClassByName('Adf.Company')
	SET @EmployeeClass = dbo.adfGetClassByName('Adf.Employee')
	
	SELECT
		[BusinessCard].[ID],
		[BusinessCard].[Class],
		(CASE [BusinessCard].[Class] 
			WHEN @CompanyClass 
				THEN 1  
			WHEN @EmployeeClass 
				THEN 2
		END) as ImageIndex,
		[BusinessCard].[FileAs],
		(SELECT [FileAs] FROM [Position] WHERE [ID] = [BusinessCard].[PositionID]) as [Position],
		(SELECT COALESCE([LegalName], [FileAs]) FROM [Company] WHERE [ID] = [BusinessCard].[CompanyID]) as [Company]
	FROM
		[BusinessCard]
	WHERE
		[BusinessCard].[ID] = @ID AND
		[BusinessCard].[Class] = @Class
		

	RETURN 0
GO

GRANT EXEC ON adfBusinessCardGet TO PUBLIC
GO
