IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPropertyDelete')
	BEGIN
		PRINT 'Dropping Procedure adfPropertyDelete'
		DROP  Procedure  adfPropertyDelete
	END

GO

PRINT 'Creating Procedure adfPropertyDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfPropertyDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPropertyDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	BEGIN TRANSACTION
	
	DELETE [PropertyValue] WHERE [PropertyID] = @ID
	
	DELETE [PropertyGlobal] WHERE [ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	
	DELETE [Property] WHERE [ID] = @ID
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	RETURN 0

GO

GRANT EXEC ON adfPropertyDelete TO PUBLIC

GO
