IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCurrencyUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCurrencyUpdate'
		DROP PROCEDURE [dbo].[adfCurrencyUpdate]
	END
GO

PRINT 'Creating procedure adfCurrencyUpdate'
GO

/******************************************************************************
**		File: adfCurrencyUpdate.sql
**		Name: adfCurrencyUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 09/29/2004 15:33:41
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCurrencyUpdate
	@ID TIdentifier,
	@Code TCode3,
	@NumericCode TCode3,
	@FileAs TName,
	@Symbol TCurrencySymbol,
	@Width TCount,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[Currency]
	SET
		[Currency].[Code] = @Code,
		[Currency].[NumericCode] = @NumericCode,
		[Currency].[FileAs] = @FileAs,
		[Currency].[Symbol] = @Symbol,
		[Currency].[Width] = @Width,
		[Currency].[Comments] = @Comments,
		[Currency].[Modified] = DEFAULT,
		[Currency].[ModifiedBy] = DEFAULT
	WHERE
		[Currency].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfCurrencyGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCurrencyUpdate TO PUBLIC
GO
