IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeBrowse'
		DROP PROCEDURE [dbo].[adfEmployeeBrowse]
	END
GO

PRINT 'Creating procedure adfEmployeeBrowse'
GO

/******************************************************************************
**		File: adfEmployeeBrowse.sql
**		Name: adfEmployeeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeBrowse]
	@StateSelector INT
AS
	DECLARE @CurrencyCode TCode3,
	@ExperienceGroup varchar(64),
	@Lang TLanguage,
	@DateFirstBefore int
	SET @Lang = dbo.adfGetLanguage()
	SET @DateFirstBefore = @@datefirst
	
	SET NOCOUNT ON
	SET DATEFIRST 1
	
	SET @CurrencyCode = dbo.fnPjm5GetAccountingCurrency()
	
	SELECT
		[Employee].[ID],
		[Employee].[Class],
		[Employee].[State],
		[Employee].[Flag],
		[Employee].[FileAs],
		[Employee].[CompanyID],
		[Employee].[PositionID],
		[Employee].[QualificationID],
		[Employee].[DivisionID],
		[Employee].[HireDate],
		[Employee].[FireDate],
		(SELECT dbo.Pjm6GetExperienceFormatted([Employee].[HireDate],[Employee].[FireDate])) as [Experience],
		CASE
			WHEN @Lang = 'en' THEN
				CASE
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 120 THEN 'more than 10 years old'
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 60 THEN 'from 5 to 10 years'
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 36 THEN 'from 3 to 5 years'
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 12 THEN 'from 1 to 3 years'
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 6 THEN 'less 1 year'
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 3 THEN 'less 6 month'
					ELSE 'less 3 month'
				END
			ELSE
				CASE
					WHEN (dbo.fnPjm6GetExperience([Employee].[HireDate],[Employee].[FireDate])) > 120  THEN ' 10 '
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 60  THEN ' 5  10 '
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 36  THEN ' 3  5 '
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 12  THEN ' 1  3 '
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 6  THEN ' '
					WHEN dbo.fnPjm6GetExperience([HireDate],[FireDate]) > 3  THEN ' 6- '
					ELSE ' 3- '
				END
		END AS [ExperienceGroup],
		[Employee].[LastContact],
		[Employee].[NextContact],
		[QualificationRate].[Standard],
		[QualificationRate].[Overtime],
		@CurrencyCode as [CurrencyCode],
		[Employee].[UserID],
		[User].[NtLogin] as [WindowsLogin],
		[User].[SQLLogin] as [SqlLogin],
		[Employee].[Comments],
		[Employee].[Created],
		[Employee].[CreatedBy],
		[Employee].[Modified],
		[Employee].[ModifiedBy],
		[Employee].[Timestamp],
		[Employee].[Title],
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[LastName],
		[Employee].[Suffix],
		[Employee].[Initials],
		[Employee].[BirthDate],
		[Employee].[BirthPlace],
		[Employee].[LegalCode],
		[Employee].[Number],
		(CASE 
			WHEN  CAST([ExtendedProperties] as xml).value('(/ExtendedProperties/Values/Gender)[1]','int') = '1' THEN (CASE WHEN @lang='ru' THEN '.' ELSE 'male' END)
			WHEN  CAST([ExtendedProperties] as xml).value('(/ExtendedProperties/Values/Gender)[1]','int') = '2' THEN (CASE WHEN @lang='ru' THEN '.' ELSE 'female' END)
			ELSE (CASE WHEN @lang='ru' THEN ' ' ELSE 'not set' END)
		END) AS [Gender],
		(SELECT dbo.fnPjm7GetEmployeeBirthdayFormatted([Employee].[HireDate])) as [Anniversary],
		(SELECT dbo.fnPjm7GetEmployeeBirthdayFormatted([Employee].[BirthDate])) as [Birthdays],
		(SELECT dbo.fnPjm7GetDaysBeforeEvent([Employee].[BirthDate])) as [DaysBeforeBirthday],
		(SELECT dbo.fnPjm7GetDaysBeforeEvent([Employee].[HireDate])) as [DaysBeforeAnniversary],
		(SELECT dbo.fnPjm7GetFormattedDaysBeforeEvent(dbo.fnPjm7GetDaysBeforeEventInt([Employee].[BirthDate]), [Employee].[BirthDate])) AS [DaysUntilBirthday],
		(SELECT dbo.fnPjm7GetFormattedDaysBeforeEvent(dbo.fnPjm7GetDaysBeforeEventInt([Employee].[HireDate]), [Employee].[HireDate])) AS [DaysUntilAnniversary],
		(SELECT dbo.fnPjm7GetFormattedYearsBeforeEvent([Employee].[BirthDate])) AS [ComingAge],
		(SELECT dbo.fnPjm7GetFormattedYearsBeforeEvent([Employee].[HireDate])) AS [ComingAnniversary],
		[#PhoneType#1] as Phone1,
		[#PhoneType#2] as Phone2,
		(SELECT [Street] FROM [Address] WHERE [Address].[BusinessCardID] = [Employee].[ID] AND [Address].[BusinessCardClass] = [Employee].[Class] AND [Address].[AddressTypeID] = 1) as [Street],
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 1) as Email,
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 4) as WebPage,
		[#PhoneType#1],
		[#PhoneType#2],
		[#PhoneType#3],
		[#PhoneType#4],
		[#PhoneType#5],
		[#PhoneType#6],
		[#PhoneType#7],
		[#PhoneType#8],
		[#PhoneType#9],
		[#PhoneType#10],
		[#PhoneType#11]
	FROM
		[Employee]
		INNER JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID])
		LEFT OUTER JOIN [vwPhone]
			ON ([Employee].[ID] = [vwPhone].[BusinessCardID] AND [Employee].[Class] = [vwPhone].[BusinessCardClass])
		LEFT OUTER JOIN [QualificationRate]
			ON ([Employee].[QualificationID] = [QualificationRate].[QualificationID]
				AND [QualificationRate].[CurrencyCode] = @CurrencyCode)
		LEFT OUTER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
		LEFT OUTER JOIN [ExtendedProperties]
			ON [Employee].[ID] = [ExtendedProperties].[ID] AND [Employee].[Class] = [ExtendedProperties].[Class]
	WHERE
		(
			(@StateSelector = 0) 
		OR 
			(@StateSelector = 1 AND ([Employee].[State] = 1 AND [Company].[State] = 1))
		OR 
			(@StateSelector = 2 AND ([Employee].[State] = 2 OR [Company].[State] = 2))
		)
	AND
		[Employee].[CompanyID] IN (SELECT [ID] FROM [Company] WHERE [Own] != 0)
		
	SET DATEFIRST @DateFirstBefore
	RETURN 0
GO

GRANT EXECUTE ON [adfEmployeeBrowse] TO PUBLIC
GO
 