IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeCreate'
		DROP PROCEDURE [dbo].[adfEmployeeCreate]
	END
GO

PRINT 'Creating procedure adfEmployeeCreate'
GO

/******************************************************************************
**		File: adfEmployeeCreate.sql
**		Name: adfEmployeeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    11.02.10		syv				   pjm6AutoTransitionParametersSet  
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeCreate]
	@Xml XML,
	@ExtendedProperties XML
AS
	DECLARE @doc				INT,
			@result				INT,
			@State				TState,
			@ID					TIdentifier,
			@Title				TCode,
			@FirstName			TPersonName,
			@MiddleName			TPersonName,
			@LastName			TPersonName,
			@Suffix				TCode,
			@FileAs				TName,
			@BirthDate			TDate,
			@BirthPlace			TName,
			@LegalCode			TCode,
			@CompanyID			TIdentifier,
			@PositionID			TIdentifier,
			@DivisionID			TIdentifier,
			@HireDate			TDate,
			@FireDate			TDate,
			@UserID				TIdentifier,
			@Comments			TNotes,
			@Initials			TCode,
			@XPathRoot			nvarchar(256),
			@Class				TClass,
			@QualificationID	TIdentifier,
			@ExternalID			TExternalIdentifier,
			@Flag				TFlag,
			@NextContact		TDate,
			@LastContact		TDate,
			@Private			TBool,
			@ReminderState		TState,
			@ReminderTime		TDateTime,
			@ReminderInterval	TTimeSpan,
			@WindowsLogin		TSysName,
			@SqlLogin			TSysName,
			@Number				TCode,
			@CongratulateWithBirthday	TBool
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('219e9b7e-153a-4e93-ab63-0b3785d67c8a')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@FileAs = [FileAs],
		@Title = [Title],
		@FirstName = [FirstName],
		@MiddleName = [MiddleName],
		@LastName = [LastName],
		@Suffix = [Suffix],
		@BirthDate = CONVERT(datetime, [BirthDate], 126),
		@BirthPlace = [BirthPlace],
		@LegalCode = [LegalCode],
		@Comments = [Comments],
		@CompanyID = [CompanyID],
		@PositionID = [PositionID],
		@HireDate = CONVERT(datetime, [HireDate], 126),
		@FireDate = CONVERT(datetime, [FireDate], 126),
		@LastContact = CONVERT(datetime, [LastContact], 126),
		@NextContact = CONVERT(datetime, [NextContact], 126),
		@WindowsLogin = [WindowsLogin],
		@SqlLogin = [SqlLogin],
		@Initials = [Initials],
		@QualificationID = [QualificationID],
		@DivisionID = [DivisionID],
		@ExternalID = [ExternalID],
		@Flag = [Flag],
		@Private = CASE WHEN [Private]='f' THEN 0 ELSE 1 END,
		@ReminderState = (CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderTime = CAST([ReminderTime] as datetime),
		@Number = [Number],
		@CongratulateWithBirthday = [CongratulateWithBirthday]
	FROM
		OPENXML(@doc, '/adfEmployeeGet/Employee', 2)
			WITH (
				[FileAs]			nvarchar(256),
				[Title]				varchar(32),
				[FirstName]			nvarchar(50),
				[MiddleName]		nvarchar(50),
				[LastName]			nvarchar(50),
				[Suffix]			nvarchar(32),
				[BirthDate]			varchar(19),
				[BirthPlace]		nvarchar(256),
				[LegalCode]			varchar(32),
				[Comments]			nvarchar(max),
				[CompanyID]			int,
				[PositionID]		int,
				[DivisionID]		int,
				[HireDate]			varchar(19),
				[FireDate]			varchar(19),
				[LastContact]		varchar(19),
				[NextContact]		varchar(19),
				[WindowsLogin]		nvarchar(128),
				[SqlLogin]			nvarchar(128),
				[Initials]			varchar(32),
				[QualificationID]	int,
				[ExternalID]		varchar(256),
				[Flag]				int,
				[Private]			varchar(1),
				[ReminderState]		varchar(5),
				[ReminderTime]		varchar(19),
				[Number]			varchar(32),
				[CongratulateWithBirthday]	bit
				)

	DECLARE @Own TBool, @HasAccess TBool
	SELECT @Own = [Own] FROM [Company] WHERE [ID] = @CompanyID

	IF @Own = 1 AND dbo.adfHasAccessRightByName('ManageEmployees') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @Own = 0 AND dbo.adfHasAccessRightByName('ManageContacts') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @Flag IS NULL
	BEGIN
		SET @Flag = 0
	END
	
	BEGIN TRANSACTION
	
	DECLARE @OwnCompany TBool
	
	SELECT @OwnCompany = [Own] FROM [Company] WHERE [ID] = @CompanyID
	
	IF @OwnCompany = 1
	BEGIN
		SELECT @UserID = [User].[ID] FROM [User] INNER JOIN [Trustee] ON [User].[ID]=[Trustee].[ID] WHERE [Trustee].[Name] = @FileAs
		IF @UserID IS NOT NULL
		BEGIN
			IF EXISTS(SELECT * FROM [Employee] WHERE [UserID] = @UserID)
			BEGIN
				RAISERROR('#UserNameMustBeUnique', 16, -1)
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
			ELSE
			BEGIN
				UPDATE [User] 
				SET 
					[Locked] = 0, 
					[SQLLogin]=@SqlLogin, 
					[NTLogin]=@WindowsLogin 
				WHERE 
					[ID] = @UserID
				IF @@ERROR != 0
				BEGIN
					ROLLBACK TRANSACTION
					EXEC sp_xml_removedocument @doc
					RETURN 1
				END
			END
		END
		ELSE
		BEGIN
			EXEC @result = adfUserCreate @FileAs, @FileAs, @SqlLogin, @WindowsLogin, @UserID OUTPUT
			IF @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				EXEC sp_xml_removedocument @doc
				RETURN 1
			END
		END
	END
		
	INSERT INTO [Employee]
		([Flag], [State], [FileAs], [CompanyID], [PositionID], [HireDate], [FireDate], [UserID], [Comments],
		[QualificationID], [DivisionID], [LastContact], [NextContact],
		[Title], [FirstName], [MiddleName], [LastName], [Suffix], [BirthDate], [BirthPlace], [LegalCode], [Initials], [Number])
	VALUES
		(@Flag, @State, @FileAs, @CompanyID, @PositionID, @HireDate, @FireDate, @UserID, @Comments,
		@QualificationID, @DivisionID, @LastContact, @NextContact,
		@Title, @FirstName, @MiddleName, @LastName, @Suffix, @BirthDate, @BirthPlace, @LegalCode, @Initials, @Number)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()
	
	SELECT @Class = [Class] FROM [Employee] WHERE [ID] = @ID
	
	INSERT INTO [ExtendedProperties] 
		([ID], [Class], [ExtendedProperties])
	VALUES
		(@ID, @Class, @ExtendedProperties)	

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @XPathRoot = N'/adfEmployeeGet'
		
	EXEC @result = adfBusinessCardCreate @doc = @doc, @XPathRoot = @XPathRoot, @ID = @ID, 
		@Class = @Class, @State = @State, @FileAs = @FileAs, @Comments = @Comments,
		@CompanyID = @CompanyID, @PositionID = @PositionID, @ExternalID = @ExternalID, 
		@LastContact=@LastContact, @NextContact = @NextContact
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	IF @Private = 1
	BEGIN
		INSERT INTO UserContact ([UserID], [BusinessCardClass], [BusinessCardID])
			VALUES(dbo.adfGetCurrentUserID(), @Class, @ID)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END

	EXEC @result = adfPersonIdentityCardUpdate @doc = @doc, @XPathRoot = @XPathRoot, @EmployeeID = @ID
	
	IF @@error != 0 OR @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DECLARE @EmployeeClass TClass, @rv int
	SET @EmployeeClass = dbo.adfGetClassByName('Adf.Employee')
	SET @ReminderInterval =
		CASE WHEN @NextContact IS NOT NULL THEN
			DATEDIFF(minute, @ReminderTime, @NextContact)
			ELSE 0
		END
	EXEC @rv = pjm5ContactReminderCreate @EmployeeClass, @ID,
		@NextContact, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END

	COMMIT TRANSACTION	
	
	EXEC sp_xml_removedocument @doc

	EXEC adfEmployeeGet @ID

	IF @OwnCompany = 1
	BEGIN	
		EXEC pjm6AutoTransitionParametersSet @UserID
	END

	RETURN 0
GO

GRANT EXECUTE ON adfEmployeeCreate TO PUBLIC
GO
 