IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfEmployeeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfEmployeeGet'
		DROP PROCEDURE [dbo].[adfEmployeeGet]
	END
GO

PRINT 'Creating procedure adfEmployeeGet'
GO

/******************************************************************************
**		File: adfEmployeeGet.sql
**		Name: adfEmployeeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
**		23.04.10	KOV				    , 
**									  
**
**		29.04.10	KOV				 ,      
**									 
**    
*******************************************************************************/
CREATE PROCEDURE [adfEmployeeGet]
	@ID TIdentifier
AS
	DECLARE @Class TClass, @UserID TIdentifier, @Private BIT
	DECLARE @HasRights BIT
	SET NOCOUNT ON
	
	SET @Class = dbo.adfGetClassByName('Adf.Employee')
	SET @UserID = dbo.adfGetCurrentUserID()
	IF EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @UserID AND [BusinessCardClass]=@Class AND [BusinessCardID]=@ID)
		SET @Private = 1
	ELSE
		SET @Private = 0
		
	DECLARE @ViewRight TBool
	SET @ViewRight = dbo.adfHasAccessRightByName('ManageContacts') | dbo.adfHasAccessRightByName('ViewAllContacts')

		
	DECLARE @Own TBool, @HasAccess INT
	SELECT @Own = [Own] FROM [Employee] INNER JOIN [Company] ON [Employee].[CompanyID] = [Company].[ID] WHERE [Employee].[ID] = @ID
	IF @Own = 1
	BEGIN
		IF dbo.adfHasAccessRightByName('ViewEmployee') = 0
		BEGIN 
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	ELSE
	BEGIN
		IF @ViewRight = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END	
	END
	
	IF dbo.adfHasAccessRightByName('ViewEmployeeDetails') = 0 AND dbo.adfHasAccessRightByName('ViewContactDetails') = 0
		SET @HasRights = 0
	ELSE
		SET @HasRights = 1
	
	SELECT
		[Employee].[ID],
		[Employee].[Class],
		[Employee].[State],
		[Employee].[Flag],
		[Employee].[FileAs],
		[Employee].[CompanyID],
		[Employee].[PositionID],
		[Employee].[QualificationID],
		[Employee].[DivisionID],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[HireDate]
		END AS [HireDate],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[FireDate]
		END AS [FireDate],
		CASE
			WHEN @HasRights = 0 THEN NULL
			WHEN @Own = 0 THEN NULL
			ELSE (SELECT dbo.Pjm6GetExperienceFormatted([Employee].[HireDate],[Employee].[FireDate]))
		END as [Experience],
		[Employee].[LastContact],
		[Employee].[NextContact],
		[Employee].[UserID],
		[User].[NtLogin] as [WindowsLogin],
		[User].[SQLLogin] as [SqlLogin],
		[Employee].[Comments],
		[Employee].[Created],
		[Employee].[CreatedBy],
		[Employee].[Modified],
		[Employee].[ModifiedBy],
		[Employee].[Timestamp],
		[Employee].[Title],
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[LastName],
		[Employee].[Suffix],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[BirthDate]
		END AS [BirthDate],
		CASE
			WHEN @HasRights = 0 THEN NULL
			ELSE [Employee].[BirthPlace]
		END AS [BirthPlace],
		[Employee].[LegalCode],
		[Employee].[Initials],
		[Employee].[Number],
		[Employee].[CongratulateWithBirthday],
		[ExtendedProperties].[ExtendedProperties],
		ISNULL((SELECT [Own] FROM [Company] WHERE [ID] = [Employee].[CompanyID]),0) AS [Own],
		@Private as [Private],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		CASE
			WHEN [UserReminder].[OriginalInterval] IS NOT NULL THEN
				DATEADD(minute,-[UserReminder].[OriginalInterval],[Employee].[NextContact])
			ELSE
				DATEADD(minute,
					-dbo.fnPjm5GetReminderInterval([Employee].[Class], 'NC', @UserID),
					[Employee].[NextContact])
		END
		AS [ReminderTime]
	FROM
		[Employee]
		INNER JOIN [ExtendedProperties]
			ON ([Employee].[Class] = [ExtendedProperties].[Class] AND
				[Employee].[ID] = [ExtendedProperties].[ID])
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Employee].[Class] AND
				[Reminder].[DocumentID] = [Employee].[ID] AND
				[Reminder].[Subtype] = 'NC')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
		LEFT OUTER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
	WHERE
		[Employee].[ID] = @ID

	EXEC adfBusinessCardExtraInfoGet @Class, @ID

	IF @HasRights = 1
		EXEC adfPersonExtraInfoGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [adfEmployeeGet] TO PUBLIC
GO

 