IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfProjectManagerEmployeeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfProjectManagerEmployeeBrowse'
		DROP PROCEDURE [dbo].[adfProjectManagerEmployeeBrowse]
	END
GO

PRINT 'Creating procedure adfProjectManagerEmployeeBrowse'
GO

/******************************************************************************
**		File: adfEmployeeBrowse.sql
**		Name: adfEmployeeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.12.12	SAP				  StateSelector  
*******************************************************************************/
CREATE PROCEDURE [adfProjectManagerEmployeeBrowse]
@StateSelector INT=1

AS
	DECLARE @CurrencyCode TCode3
	--DECLARE @StateSelector INT	
	--SET @StateSelector = 1
	SET NOCOUNT ON
	
	SET @CurrencyCode = dbo.fnPjm5GetAccountingCurrency()
	
	SELECT
		[Employee].[ID],
		[Employee].[Class],
		[Employee].[State],
		[Employee].[Flag],
		[Employee].[FileAs],
		[Employee].[CompanyID],
		[Employee].[PositionID],
		[Employee].[QualificationID],
		[Employee].[DivisionID],
		[Employee].[HireDate],
		[Employee].[FireDate],
		[Employee].[LastContact],
		[Employee].[NextContact],
		[QualificationRate].[Standard],
		[QualificationRate].[Overtime],
		@CurrencyCode as [CurrencyCode],
		[Employee].[UserID],
		[User].[NtLogin] as [WindowsLogin],
		[User].[SQLLogin] as [SqlLogin],
		[Employee].[Comments],
		[Employee].[Created],
		[Employee].[CreatedBy],
		[Employee].[Modified],
		[Employee].[ModifiedBy],
		[Employee].[Timestamp],
		[Employee].[Title],
		[Employee].[FirstName],
		[Employee].[MiddleName],
		[Employee].[LastName],
		[Employee].[Suffix],
		[Employee].[Initials],
		[Employee].[BirthDate],
		[Employee].[BirthPlace],
		[Employee].[LegalCode],
		[Employee].[Number],
		[#PhoneType#1] as Phone1,
		[#PhoneType#2] as Phone2,
		(SELECT [Street] FROM [Address] WHERE [Address].[BusinessCardID] = [Employee].[ID] AND [Address].[BusinessCardClass] = [Employee].[Class] AND [Address].[AddressTypeID] = 1) as [Street],
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 1) as Email,
		(SELECT [Email] FROM [Email] WHERE [Email].[BusinessCardID] = [Employee].[ID] AND [Email].[BusinessCardClass] = [Employee].[Class] AND [Email].[EmailTypeID] = 4) as WebPage,
		[#PhoneType#1],
		[#PhoneType#2],
		[#PhoneType#3],
		[#PhoneType#4],
		[#PhoneType#5],
		[#PhoneType#6],
		[#PhoneType#7],
		[#PhoneType#8],
		[#PhoneType#9],
		[#PhoneType#10],
		[#PhoneType#11]
	FROM
		[Employee]
		INNER JOIN [Company]
			ON ([Employee].[CompanyID] = [Company].[ID])
		LEFT OUTER JOIN [vwPhone]
			ON ([Employee].[ID] = [vwPhone].[BusinessCardID] AND [Employee].[Class] = [vwPhone].[BusinessCardClass])
		LEFT OUTER JOIN [QualificationRate]
			ON ([Employee].[QualificationID] = [QualificationRate].[QualificationID]
				AND [QualificationRate].[CurrencyCode] = @CurrencyCode)
		LEFT OUTER JOIN [User]
			ON ([Employee].[UserID] = [User].[ID])
	WHERE
		(
			(@StateSelector = 0) 
		OR 
			(@StateSelector = 1 AND ([Employee].[State] = 1 AND [Company].[State] = 1))
		OR 
			(@StateSelector = 2 AND ([Employee].[State] = 2 OR [Company].[State] = 2))
		)
	AND
		[Employee].[CompanyID] IN (SELECT [ID] FROM [Company] WHERE [Own] != 0)
	AND 
		[Employee].[ID] IN (SELECT [ProjectManagerEmployeeID] FROM [Project])
		
	RETURN 0
GO

GRANT EXECUTE ON [adfProjectManagerEmployeeBrowse] TO PUBLIC
GO
  
