IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfEnterpriseCalendarBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfEnterpriseCalendarBrowse'
		DROP  Procedure  adfEnterpriseCalendarBrowse
	END

GO

PRINT 'Creating Procedure adfEnterpriseCalendarBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfEnterpriseCalendarBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
		10.06.10	SPV				     PWA
**    
*******************************************************************************/
CREATE Procedure adfEnterpriseCalendarBrowse
AS
	SET NOCOUNT ON
	SELECT
	(
	SELECT 
		[Date] as '@Date',
		[NonWorkingTime] as '@NonWorkingTime',
		[Recurrent] as '@Recurrent',
		[Description] as '@Description'
	FROM
		[Calendar]
	ORDER BY
		[Recurrent] DESC,
		[Date]
	--FOR XML AUTO
	FOR XML PATH('Calendar'), TYPE)
	FOR XML PATH('EnterpriseCalendar')
		
	RETURN 0
GO

GRANT EXEC ON adfEnterpriseCalendarBrowse TO PUBLIC
GO
