IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LanguageCodeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LanguageCodeBrowse'
		DROP PROCEDURE [dbo].[pjm6LanguageCodeBrowse]
	END
GO

PRINT 'Creating procedure pjm6LanguageCodeBrowse'
GO

/******************************************************************************
**		File: pjm6LanguageCodeBrowse.sql
**		Name: pjm6LanguageCodeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6LanguageCodeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[LanguageCode].[Class],
		[LanguageCode].[ID],
		[LanguageCode].[State],
		[LanguageCode].[Flag],
		[LanguageCode].[FileAs],
		[LanguageCode].[Code],
		[LanguageCode].[Comments],
		[LanguageCode].[Created],
		[LanguageCode].[CreatedBy],
		[LanguageCode].[Modified],
		[LanguageCode].[ModifiedBy],
		[LanguageCode].[Timestamp]
	FROM
		[LanguageCode]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [LanguageCode].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6LanguageCodeBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LanguageCodeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LanguageCodeGet'
		DROP PROCEDURE [dbo].[pjm6LanguageCodeGet]
	END
GO

PRINT 'Creating procedure pjm6LanguageCodeGet'
GO

/******************************************************************************
**		File: pjm6LanguageCodeGet.sql
**		Name: pjm6LanguageCodeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6LanguageCodeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[LanguageCode].[Class],
		[LanguageCode].[ID],
		[LanguageCode].[State],
		[LanguageCode].[Flag],
		[LanguageCode].[FileAs],
		[LanguageCode].[Code],
		[LanguageCode].[Comments],
		[LanguageCode].[Created],
		[LanguageCode].[CreatedBy],
		[LanguageCode].[Modified],
		[LanguageCode].[ModifiedBy],
		[LanguageCode].[Timestamp]
	FROM
		[LanguageCode]
	WHERE
		[LanguageCode].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm6LanguageCodeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LanguageCodeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LanguageCodeCreate'
		DROP PROCEDURE [dbo].[pjm6LanguageCodeCreate]
	END
GO

PRINT 'Creating procedure pjm6LanguageCodeCreate'
GO

/******************************************************************************
**		File: pjm6LanguageCodeCreate.sql
**		Name: pjm6LanguageCodeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6LanguageCodeCreate]
	@FileAs TName,
	@Code TCode,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('f7f428f8-90b1-4cc9-99c1-92b756ca2844')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [LanguageCode]
		([Flag], [State], [FileAs], [Code], [Comments])
	VALUES
		(0, @State, @FileAs, @Code, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm6LanguageCodeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6LanguageCodeCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LanguageCodeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LanguageCodeUpdate'
		DROP PROCEDURE [dbo].[pjm6LanguageCodeUpdate]
	END
GO

PRINT 'Creating procedure pjm6LanguageCodeUpdate'
GO

/******************************************************************************
**		File: pjm6LanguageCodeUpdate.sql
**		Name: pjm6LanguageCodeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6LanguageCodeUpdate
	@ID TIdentifier,
	@FileAs TName,
	@Code TCode,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE [LanguageCode]
	SET
		[LanguageCode].[FileAs] = @FileAs,
		[LanguageCode].[Code] = @Code,
		[LanguageCode].[Comments] = @Comments,
		[LanguageCode].[Modified] = DEFAULT,
		[LanguageCode].[ModifiedBy] = DEFAULT
	WHERE
		[LanguageCode].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm6LanguageCodeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6LanguageCodeUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LanguageCodeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LanguageCodeDelete'
		DROP PROCEDURE [dbo].[pjm6LanguageCodeDelete]
	END
GO

PRINT 'Creating procedure pjm6LanguageCodeDelete'
GO

/******************************************************************************
**		File: pjm6LanguageCodeDelete.sql
**		Name: pjm6LanguageCodeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6LanguageCodeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [LanguageCode] WHERE [LanguageCode].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm6LanguageCodeDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LanguageCodeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6LanguageCodeChangeState'
		DROP PROCEDURE [dbo].[pjm6LanguageCodeChangeState]
	END
GO

PRINT 'Creating procedure pjm6LanguageCodeChangeState'
GO

/******************************************************************************
**		File: pjm6LanguageCodeChangeState.sql
**		Name: pjm6LanguageCodeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAV
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6LanguageCodeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [LanguageCode].[Class],
		@FromState = [LanguageCode].[State]
	FROM
		[LanguageCode]
	WHERE
		[LanguageCode].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE [LanguageCode]
	SET
		[LanguageCode].[State] = @ToState,
		[LanguageCode].[Modified] = DEFAULT,
		[LanguageCode].[ModifiedBy] = DEFAULT
	WHERE
		[LanguageCode].[ID] = @ID
	AND
		[LanguageCode].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm6LanguageCodeChangeState TO PUBLIC
GO
