IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfManagerList')
	BEGIN
		PRINT 'Dropping Procedure adfManagerList'
		DROP  Procedure  adfManagerList
	END

GO

PRINT 'Creating Procedure adfManagerList'
GO
/******************************************************************************
**		File: 
**		Name: adfManagerList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfManagerList
AS
	SET NOCOUNT ON
		
	SELECT
		[Employee].[ID],
		[Employee].[FileAs] as [Name],
		[Employee].[State]
	FROM
		[Employee]
		INNER JOIN [Project]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
		INNER JOIN [Company]
			ON [Employee].[CompanyID] = [Company].[ID]	
	WHERE
		[Company].[Own] = 1
	GROUP BY 
		[Employee].[ID],
		[Employee].[FileAs],
		[Employee].[State]	

	RETURN 0
GO

GRANT EXEC ON adfManagerList TO PUBLIC
GO
