IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMailItemsDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMailItemsDelete'
		DROP PROCEDURE [dbo].[adfMailItemsDelete]
	END
GO

PRINT 'Creating procedure adfMailItemsDelete'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: adfMailItemsDelete.sql
**		Name: adfMailItemsDelete
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**		@XML xml
**		Auth: MAB
**		Date: 09/07/2012
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [adfMailItemsDelete] @XMl xml
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier;
	DECLARE @doc int;
	
	SET @UserID = dbo.adfGetCurrentUserID()
	IF NOT EXISTS(SELECT * FROM [MailItem] WHERE [ToID] = @UserID)
	BEGIN
		RAISERROR('#accessdenied', 16, -1);
		RETURN 1;
	END

	DELETE a from [MailItem] a inner join (SELECT id.value('@Id','int') as Id  FROM @XML.nodes('/Mail/MailId') as row(id)) as b on a.[ID]=b.Id

	RETURN 0
GO

GRANT EXECUTE ON [adfMailItemsDelete] TO PUBLIC
GO
   
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMailItemDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMailItemDelete'
		DROP PROCEDURE [dbo].[adfMailItemDelete]
	END
GO

PRINT 'Creating procedure adfMailItemDelete'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: adfMailItemDelete.sql
**		Name: adfMailItemDelete
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**		@ID TIdentifier,
**		Auth: Dmitry.Kolchev
**		Date: 10/17/2006
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [adfMailItemDelete] @ID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	
	SET @UserID = dbo.adfGetCurrentUserID()
	IF NOT EXISTS(SELECT * FROM [MailItem] WHERE [ToID] = @UserID AND [ID] = @ID)
	BEGIN
		RAISERROR('#accessdenied', 16, -1);
		RETURN 1;
	END

	DELETE [MailItem] WHERE [ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [adfMailItemDelete] TO PUBLIC
GO
   