IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MasterCreateSystemObjects]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MasterCreateSystemObjects'
		DROP PROCEDURE [dbo].[pjm6MasterCreateSystemObjects]
	END
GO

PRINT 'Creating procedure pjm6MasterCreateSystemObjects'
GO

/******************************************************************************
**		File: pjm6MasterCreateSystemObjects.sql
**		Name: pjm6MasterCreateSystemObjects
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: marat.akzhigitov, yuriy.soldatkin
**		Date: 07/07/2011 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		03.08.11	SYV				  
**		24.08.11	SAM
**		24.08.11	SYV				    BankAccount
*******************************************************************************/
CREATE PROCEDURE [pjm6MasterCreateSystemObjects]
	@Xml Xml
AS
	SET NOCOUNT ON
	SET XACT_ABORT ON
	
	BEGIN TRANSACTION
	
	DECLARE @rv INT
	
	-- 
	DECLARE @NationalCurrency TCode3
	SET @NationalCurrency = @Xml.value('(/MasterInfo/Parameters/NationalCurrency)[1]','TCode3')	
	--SELECT @NationalCurrency AS ' '
	EXEC @rv = adfParameterSet @Name='NationalCurrency',@Group='CommonBusiness',@Value=@NationalCurrency
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	-- 
	DECLARE @BaseCurrency TCode3
	SET @BaseCurrency = @Xml.value('(/MasterInfo/Parameters/BaseCurrency)[1]','TCode3')
	--SELECT @BaseCurrency AS ' '
	EXEC @rv = adfParameterSet @Name='BaseCurrency',@Group='CommonBusiness',@Value=@BaseCurrency
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	-- 
	DECLARE @VATRate TPercent
	SET @VatRate = @Xml.value('(/MasterInfo/Parameters/VATRate)[1]','TPercent')/100
	--SELECT @VATRate AS ' '
	EXEC @rv = adfParameterSet @Name='VATRate',@Group='CommonBusiness',@Value=@VATRate
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	-- 
	DECLARE @ApplyVAT TBool
	SET @ApplyVAT = @Xml.value('(/MasterInfo/Parameters/ApplyVAT)[1]','TBool')
	--SELECT @ApplyVAT AS ' '
	EXEC @rv = adfParameterSet 'ApplyVAT', 'CommonBusiness', @ApplyVAT
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	--   
	DECLARE @CalendarDate TDate, @CalendarDescription TNotes
	DECLARE calendar_cursor CURSOR FOR 
	SELECT 
		Calendar.value('./@Day','TDate'),
		Calendar.value('./@Description','TNotes')
	FROM
		@Xml.nodes('/MasterInfo/Parameters/CalendarList/Calendar') as List(Calendar)

	OPEN calendar_cursor

	FETCH NEXT FROM calendar_cursor INTO @CalendarDate,@CalendarDescription
	WHILE @@FETCH_STATUS = 0
	BEGIN
		--SELECT ':', @CalendarDate,@CalendarDescription 
		EXEC @rv = pjm5CalendarCreate @Date=@CalendarDate,@NonWorkingTime=1,@Recurrent=1,@Description=@CalendarDescription
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE calendar_cursor
			DEALLOCATE calendar_cursor
			RETURN 1
		END
		FETCH NEXT FROM calendar_cursor INTO @CalendarDate,@CalendarDescription
	END
	CLOSE calendar_cursor
	DEALLOCATE calendar_cursor

	-- 
	--  
	DECLARE @HasManageIndustryBranchDictionary TBool,
			@ManageIndustryBranchDictionary TSysname
	SET @ManageIndustryBranchDictionary = dbo.adfwfGetInitialRight('241f8cf7-5524-4ca3-a27c-82e85f8328ec')
	SET @HasManageIndustryBranchDictionary = dbo.adfHasAccessRightByName(@ManageIndustryBranchDictionary)
	IF (@HasManageIndustryBranchDictionary = 0)
	BEGIN
		EXEC pjm6SetRightForMasters @ManageIndustryBranchDictionary
	END

	DECLARE @IndustryBranch TName,
			@IndustryBranchID TIdentifier
	SET @IndustryBranch = @Xml.value('(/MasterInfo/Parameters/IndustryBranch)[1]','TName')
	EXEC adfIndustryBranchCreate @Code=@IndustryBranch,@FileAs=@IndustryBranch,@Comments=NULL

	SELECT
		@IndustryBranchID = [ID]
	FROM
		[IndustryBranch]
	WHERE
		[FileAs] = @IndustryBranch

	--  
	IF (@HasManageIndustryBranchDictionary = 0)
	BEGIN
		EXEC pjm6DelRightForMasters @ManageIndustryBranchDictionary
	END

	--   
	DECLARE
		@CompanyXML XML,
		@CompanyID TIdentifier,
		@CompanyFileAs TName,
		@CompanyLegalName TName,
		@CompanyKPP TCode,
		@CompanyLegalCode TCode,
		@CompanyLegalAddressStreet TName,
		@CompanyLegalAddressCity TCity,
		@CompanyLegalAddressRegion TName,
		@CompanyLegalAddressPostalCode TPostalCode,
		@CompanyLegalAddressCountry TName,
		@CompanyActualAddressStreet TName,
		@CompanyActualAddressCity TCity,
		@CompanyActualAddressRegion TName,
		@CompanyActualAddressPostalCode TPostalCode,
		@CompanyActualAddressCountry TName,
		@CompanyPhone TPhone,
		@CompanyFax TPhone,
		@CompanyWeb THref,
		@CompanyEmail THref
		--@CompanyAccountantEmployeeID TIdentifier,
		--@CompanyExecutiveEmployeeID TIdentifier

	SET @CompanyFileAs = @Xml.query('/MasterInfo/Company/FileAs').value('.', 'TName')
	SET @CompanyLegalName = @Xml.query('/MasterInfo/Company/LegalName').value('.', 'TName')
	SET @CompanyKPP = @Xml.query('/MasterInfo/Company/KPP').value('.', 'TCode')
	SET @CompanyLegalCode = @Xml.query('/MasterInfo/Company/LegalCode').value('.', 'TCode')
	SET @CompanyLegalAddressStreet = @Xml.query('/MasterInfo/LegalAddress/Street').value('.', 'TName')	
	SET @CompanyLegalAddressCity = @Xml.query('/MasterInfo/LegalAddress/City').value('.', 'TCity')
	SET @CompanyLegalAddressRegion = @Xml.query('/MasterInfo/LegalAddress/Region').value('.', 'TName')
	SET @CompanyLegalAddressPostalCode = @Xml.query('/MasterInfo/LegalAddress/PostalCode').value('.', 'TPostalCode')
	SET @CompanyLegalAddressCountry = @Xml.query('/MasterInfo/LegalAddress/Country').value('.', 'TName')
	SET @CompanyActualAddressStreet = @Xml.query('/MasterInfo/ActualAddress/Street').value('.', 'TName')
	SET @CompanyActualAddressCity = @Xml.query('/MasterInfo/ActualAddress/City').value('.', 'TName')
	SET @CompanyActualAddressRegion = @Xml.query('/MasterInfo/ActualAddress/Region').value('.', 'TName')
	SET @CompanyActualAddressPostalCode = @Xml.query('/MasterInfo/ActualAddress/PostalCode').value('.', 'TPostalCode')
	SET @CompanyActualAddressCountry = @Xml.query('/MasterInfo/ActualAddress/Country').value('.', 'TName')
	SET @CompanyPhone = @Xml.query('/MasterInfo/CompanyContact/Phone').value('.', 'TPhone')
	SET @CompanyFax = @Xml.query('/MasterInfo/CompanyContact/Fax').value('.', 'TPhone')
	SET @CompanyWeb = @Xml.query('/MasterInfo/CompanyContact/Web').value('.', 'THref')
	SET @CompanyEmail = @Xml.query('/MasterInfo/CompanyContact/Email').value('.', 'THref')

	SET @CompanyXML = '
	<adfCompanyGet>
		<Company>
			<ID>-1</ID>
			<State>0</State>
			<Flag>0</Flag>
			<Own>true</Own>
			<Guid>5206f98c-4e57-44ea-8dc9-0ab6b81fd9c2</Guid>
			<Private>true</Private>
			<PaymentCurrencyPoint>1</PaymentCurrencyPoint>
		</Company>
	</adfCompanyGet>
	'
	-- 
	SET @CompanyXML.modify('
	insert <FileAs>{sql:variable("@CompanyFileAs")}</FileAs>
	into (/adfCompanyGet/Company)[1]')

	SET @CompanyXML.modify('
	insert <LegalName>{sql:variable("@CompanyLegalName")}</LegalName>
	into (/adfCompanyGet/Company)[1]')	

	SET @CompanyXML.modify('
	insert <KPP>{sql:variable("@CompanyKPP")}</KPP>
	into (/adfCompanyGet/Company)[1]')	

	SET @CompanyXML.modify('
	insert <LegalCode>{sql:variable("@CompanyLegalCode")}</LegalCode>
	into (/adfCompanyGet/Company)[1]')	

	/*SET @CompanyXML.modify('
	insert <ExecutiveEmployeeID>{sql:variable("@CompanyExecutiveEmployeeID")}</ExecutiveEmployeeID>
	into (/adfCompanyGet/Company)[1]')

	SET @CompanyXML.modify('
	insert <AccountantEmployeeID>{sql:variable("@CompanyAccountantEmployeeID")}</AccountantEmployeeID>
	into (/adfCompanyGet/Company)[1]')*/

	SET @CompanyXML.modify('
	insert <ApplyVAT>{sql:variable("@ApplyVAT")}</ApplyVAT>
	into (/adfCompanyGet/Company)[1]')

	SET @CompanyXML.modify('
	insert <CompanyIndustryBranch>
			 <IndustryBranchID>{sql:variable("@IndustryBranchID")}</IndustryBranchID>
		   </CompanyIndustryBranch>
	into (/adfCompanyGet)[1]')

	SET @CompanyXML.modify('
	insert <Address>
			<AddressTypeID>1</AddressTypeID>
			<Street>{sql:variable("@CompanyLegalAddressStreet")}</Street>
			<City>{sql:variable("@CompanyLegalAddressCity")}</City>
			<Region>{sql:variable("@CompanyLegalAddressRegion")}</Region>
			<PostalCode>{sql:variable("@CompanyLegalAddressPostalCode")}</PostalCode>
			<Country>{sql:variable("@CompanyLegalAddressCountry")}</Country>
			<Mail>false</Mail>
		</Address>
	into (/adfCompanyGet)[1]')	

	SET @CompanyXML.modify('
	insert <Address>
			<AddressTypeID>3</AddressTypeID>
			<Street>{sql:variable("@CompanyActualAddressStreet")}</Street>
			<City>{sql:variable("@CompanyActualAddressCity")}</City>
			<Region>{sql:variable("@CompanyActualAddressRegion")}</Region>
			<PostalCode>{sql:variable("@CompanyActualAddressPostalCode")}</PostalCode>
			<Country>{sql:variable("@CompanyActualAddressCountry")}</Country>
			<Mail>true</Mail>
		</Address>
	into (/adfCompanyGet)[1]')	

	SET @CompanyXML.modify('
	insert <Phone>
			<PhoneTypeID>8</PhoneTypeID>
			<Phone>{sql:variable("@CompanyFax")}</Phone>
		</Phone>
	into (/adfCompanyGet)[1]')	

	SET @CompanyXML.modify('
	insert <Phone>
			<PhoneTypeID>7</PhoneTypeID>
			<Phone>{sql:variable("@CompanyPhone")}</Phone>
		</Phone>
	into (/adfCompanyGet)[1]')	

	SET @CompanyXML.modify('
	insert <Email>
			<EmailTypeID>4</EmailTypeID>
			<Email>{sql:variable("@CompanyWeb")}</Email>
		</Email>
	into (/adfCompanyGet)[1]')

	SET @CompanyXML.modify('
	insert <Email>
			<EmailTypeID>1</EmailTypeID>
			<Email>{sql:variable("@CompanyEmail")}</Email>
		</Email>
	into (/adfCompanyGet)[1]')	

	--SELECT @CompanyXML
	DECLARE @CompanyExtendedProperties XML
	SET @CompanyExtendedProperties = convert(xml,N'
		<ExtendedProperties>
			<Values>
				<PhoneSelector1>7</PhoneSelector1>
				<PhoneSelector2>11</PhoneSelector2>
				<PhoneSelector3>8</PhoneSelector3>
				<PhoneSelector4>4</PhoneSelector4>
				<AddressSelector>3</AddressSelector>
				<EmailSelector>1</EmailSelector>
				<WebPageSelector>4</WebPageSelector>
			</Values>
		</ExtendedProperties>')

    EXEC @rv = adfCompanyCreate @Xml=@CompanyXML,@ExtendedProperties=@CompanyExtendedProperties
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SELECT 
		@CompanyID = [Company].[ID] 
	FROM 
		[Company] 
	WHERE 
		[Company].[FileAs] = @CompanyFileAs

	-- 
	DECLARE
		@BankAccountFileAs TName,
		@BankAccountID TIdentifier,
		@BankAccountCurrencyCode TCode3,
		@BankAccountBankName TName,
		@BankAccountBankCode TCode,
		@BankAccountCountry TName,
		@BankAccountCity TCity,
		@BankAccountAddress TName,
		@BankAccountSWIFT TCode,
		@BankAccountABA TCode,
		@BankAccountIBAN TCode,
		@BankAccountAccount TAccount,
		@BankAccountIntermediaryBank TName,
		@BankAccountIntermediaryAddress TName,
		@BankAccountIntermediarySWIFT TCode,
		@BankAccountIntermediaryABA TCode,
		@BankAccountIntermediaryAccount TAccount
	
	SET @BankAccountFileAs = @Xml.query('/MasterInfo/BankAccount/FileAs').value('.', 'TName')
	
	IF @BankAccountFileAs IS NOT NULL AND @BankAccountFileAs != ''
	BEGIN
		SET @BankAccountCurrencyCode = @Xml.query('/MasterInfo/BankAccount/CurrencyCode').value('.', 'TCode3')
		SET @BankAccountBankName = @Xml.query('/MasterInfo/BankAccount/BankName').value('.', 'TName')
		SET @BankAccountBankCode = @Xml.query('/MasterInfo/BankAccount/BankCode').value('.', 'TCode')
		SET @BankAccountCountry = @Xml.query('/MasterInfo/BankAccount/Country').value('.', 'TName')
		SET @BankAccountCity = @Xml.query('/MasterInfo/BankAccount/City').value('.', 'TCity')
		SET @BankAccountAddress = @Xml.query('/MasterInfo/BankAccount/Address').value('.', 'TName')
		SET @BankAccountSWIFT = @Xml.query('/MasterInfo/BankAccount/SWIFT').value('.', 'TCode')
		SET	@BankAccountABA = @Xml.query('/MasterInfo/BankAccount/ABA').value('.', 'TCode')
		SET @BankAccountIBAN = @Xml.query('/MasterInfo/BankAccount/IBAN').value('.', 'TCode')
		SET @BankAccountAccount = @Xml.query('/MasterInfo/BankAccount/Account').value('.', 'TAccount')
		SET @BankAccountIntermediaryBank = @Xml.query('/MasterInfo/BankAccount/IntermediaryBank').value('.', 'TName')
		SET @BankAccountIntermediaryAddress = @Xml.query('/MasterInfo/BankAccount/IntermediaryAddress').value('.', 'TName')
		SET @BankAccountIntermediarySWIFT = @Xml.query('/MasterInfo/BankAccount/IntermediarySWIFT').value('.', 'TCode')
		SET @BankAccountIntermediaryABA = @Xml.query('/MasterInfo/BankAccount/IntermediaryABA').value('.', 'TCode')
		SET @BankAccountIntermediaryAccount = @Xml.query('/MasterInfo/BankAccount/IntermediaryAccount').value('.', 'TAccount')

		EXEC @rv = adfBankAccountCreate 
			@CompanyID,
			@FileAs=@BankAccountFileAs,
			@CurrencyCode=@BankAccountCurrencyCode,
			@BankName=@BankAccountBankName,
			@BankCode=@BankAccountBankCode,
			@Country=@BankAccountCountry,
			@City=@BankAccountCity,
			@Address=@BankAccountAddress,
			@SWIFT=@BankAccountSWIFT,
			@ABA=@BankAccountABA,
			@IBAN=@BankAccountIBAN,
			@Account=@BankAccountAccount,
			@IntermediaryBank=@BankAccountIntermediaryBank,
			@IntermediaryAddress=@BankAccountIntermediaryAddress,
			@IntermediarySWIFT=@BankAccountIntermediarySWIFT,
			@IntermediaryABA=@BankAccountIntermediaryABA,
			@IntermediaryAccount=@BankAccountIntermediaryAccount,
			@AdditionalAccounts=NULL
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		SELECT 
			@BankAccountID = [BankAccount].[ID] 
		FROM 
			[BankAccount] 
		WHERE 
			[BankAccount].[FileAs] = @BankAccountFileAs

		SET @CompanyXML.modify('
		insert <BankAccountID>{sql:variable("@BankAccountID")}</BankAccountID>
		into (/adfCompanyGet/Company)[1]')

		DECLARE @Class TCode
		SET @Class = dbo.adfGetClassByName('Adf.Company')
		SET @CompanyXML.modify('
		insert <Class>{sql:variable("@Class")}</Class>
		into (/adfCompanyGet/Company)[1]')

		/*SET @CompanyXML.modify('
		insert <Created>2011-08-17T10:44:34.07+04:00</Created>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <CreatedBy>1</CreatedBy>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <Modified>2011-08-18T10:24:43.477+04:00</Modified>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <ModifiedBy>1</ModifiedBy>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		insert <Timestamp>AAAAAAAAH3g=</Timestamp>
		into (/adfCompanyGet/Company)[1]')*/

		DECLARE @ExportFinanceOnce TBool
		SELECT 
			@ExportFinanceOnce = [Company].[ExportFinanceOnce] 
		FROM 
			[Company] 
		WHERE 
			[Company].[ID] = @CompanyID
		SET @CompanyXML.modify('
		insert <ExportFinanceOnce>{sql:variable("@ExportFinanceOnce")}</ExportFinanceOnce>
		into (/adfCompanyGet/Company)[1]')

		DECLARE @ExchangeBanned TBool
		SELECT 
			@ExchangeBanned = [Company].[ExchangeBanned] 
		FROM 
			[Company] 
		WHERE 
			[Company].[ID] = @CompanyID
		SET @CompanyXML.modify('
		insert <ExchangeBanned>{sql:variable("@ExchangeBanned")}</ExchangeBanned>
		into (/adfCompanyGet/Company)[1]')

		SET @CompanyXML.modify('
		replace value of (/adfCompanyGet/Company[1]/ID/text())[1]
		with sql:variable("@CompanyID")
		')

		DECLARE @State TCode
		SELECT 
			@State = [Company].[State] 
		FROM 
			[Company] 
		WHERE 
			[Company].[ID] = @CompanyID
		SET @CompanyXML.modify('
		replace value of (/adfCompanyGet/Company[1]/State/text())[1]
		with sql:variable("@State")
		')

	  --SELECT @CompanyXML as '!!!XML!!!'

		EXEC @rv = adfCompanyUpdate @Xml=@CompanyXML, @ExtendedProperties=@CompanyExtendedProperties
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	-- 
	DECLARE @DivisionFileAs TName
	DECLARE division_cursor CURSOR FOR 
	SELECT
		Division.value('(./@Description)','TName')
	FROM
		@Xml.nodes('/MasterInfo/DivisionList/Division') as List(Division)
	OPEN division_cursor
	FETCH NEXT FROM division_cursor INTO @DivisionFileAs
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC @rv = adfDivisionCreate @CompanyID,@Code = @DivisionFileAs,@FileAS = @DivisionFileAs,@Comments=NULL
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE division_cursor
			DEALLOCATE division_cursor
			RETURN 1
		END
		FETCH NEXT FROM division_cursor INTO @DivisionFileAs
	END
	CLOSE division_cursor
	DEALLOCATE division_cursor
	--  
	--  
	DECLARE @HasManagePositionDictionary TBool,
			@ManagePositionDictionary TSysname
	SET @ManagePositionDictionary = dbo.adfwfGetInitialRight('1da4d0a6-ed0f-4840-9d29-3090013ba2fb')
	SET @HasManagePositionDictionary = dbo.adfHasAccessRightByName(@ManagePositionDictionary)
	IF (@HasManagePositionDictionary = 0)
	BEGIN
		EXEC pjm6SetRightForMasters @ManagePositionDictionary
	END

	DECLARE @PositionFileAs TName
	DECLARE position_cursor CURSOR FOR 
	SELECT
		Position.value('./@Description','TName')
	FROM
		@Xml.nodes('/MasterInfo/PositionList/Position') as List(Position)
	OPEN position_cursor
	FETCH NEXT FROM position_cursor INTO @PositionFileAs
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC @rv = adfPositionCreate @Code=@PositionFileAs,@FileAs=@PositionFileAs, @Comments=NULL
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE position_cursor
			DEALLOCATE position_cursor
			RETURN 1
		END
		FETCH NEXT FROM position_cursor INTO @PositionFileAs
	END
	CLOSE position_cursor
	DEALLOCATE position_cursor

	--  
	IF (@HasManagePositionDictionary = 0)
	BEGIN
		EXEC pjm6DelRightForMasters @ManagePositionDictionary
	END
	
	--  
	DECLARE
		@EmployeeXML	XML,
		@EmployeeLastName TPersonName,
		@EmployeeFirstName TPersonName,
		@EmployeeMiddleName TPersonName,
		@EmployeeFileAs TName,
		@EmployeePositionID TIdentifier,
		@EmployeeQualificationID TIdentifier,
		@EmployeeDivisionID TIdentifier,
		@EmployeePhoneWork TPhone,
		@EmployeePhoneMobile TPhone,
		@EmployeeEmail THref,
		@EmployeeExtendedProperties XML
		
	SET @EmployeeExtendedProperties = convert(xml,N'
		<ExtendedProperties>
			<Values>
				<PhoneSelector1>1</PhoneSelector1>
				<PhoneSelector2>2</PhoneSelector2>
				<PhoneSelector3>3</PhoneSelector3>
				<PhoneSelector4>4</PhoneSelector4>
				<AddressSelector>2</AddressSelector>
				<EmailSelector>1</EmailSelector>
				<WebPageSelector>4</WebPageSelector>
				<IdentityCardType>1</IdentityCardType>
				<Gender>0</Gender>
			</Values>
		</ExtendedProperties>')
	
	DECLARE employee_cursor CURSOR FOR 
	SELECT
		Employee.value('./@LastName','TPersonName'),
		Employee.value('./@FirstName','TPersonName'),
		Employee.value('./@MiddleName','TPersonName'),
		Employee.value('./@FileAs','TName'),
		(SELECT 
			TOP(1) [Position].[ID] 
		FROM 
			[Position]
		WHERE 
			[Position].[FileAs] = Employee.value('./@Position','TName')),
		(SELECT 
			TOP(1) [Qualification].[ID] 
		FROM 
			[Qualification]
		WHERE 
			[Qualification].[FileAs] = Employee.value('./@Qualification','TName')),
		(SELECT 
			TOP(1) [Division].[ID] 
		FROM 
			[Division]
		WHERE 
			[Division].[FileAs] = Employee.value('./@Division','TName')),
		Employee.value('./@WorkPhone','TPhone'),
		Employee.value('./@MobilePhone','TPhone'),
		Employee.value('./@Email','THref')
	FROM
		@Xml.nodes('/MasterInfo/EmployeeList/Employee') as List(Employee)

	OPEN employee_cursor
	FETCH NEXT FROM employee_cursor INTO 
		@EmployeeLastName,
		@EmployeeFirstName,
		@EmployeeMiddleName,
		@EmployeeFileAs,
		@EmployeePositionID,
		@EmployeeQualificationID, 
		@EmployeeDivisionID, 
		@EmployeePhoneWork, 
		@EmployeePhoneMobile, 
		@EmployeeEmail 
	WHILE @@FETCH_STATUS = 0
	BEGIN		
		SET @EmployeeXML = 
		'<adfEmployeeGet>
			<Employee>
				<ID>-1</ID>
				<State>0</State>
				<Flag>0</Flag>
				<Guid>219e9b7e-153a-4e93-ab63-0b3785d67c8a</Guid>
				<Own>false</Own>
				<Private>true</Private>
				<ReminderState>false</ReminderState>
			</Employee>
		</adfEmployeeGet>'
		
		-- 
		SET @EmployeeXML.modify('
		insert <FileAs>{sql:variable("@EmployeeFileAs")}</FileAs>
		into (/adfEmployeeGet/Employee)[1]')
		--ID 
		SET @EmployeeXML.modify('
		insert <CompanyID>{sql:variable("@CompanyID")}</CompanyID>
		into (/adfEmployeeGet/Employee)[1]')
		--ID  
		IF @EmployeePositionID IS NOT NULL
		BEGIN
			SET @EmployeeXML.modify('
			insert <PositionID>{sql:variable("@EmployeePositionID")}</PositionID>
			into (/adfEmployeeGet/Employee)[1]')
		END
		IF @EmployeeQualificationID IS NOT NULL
		BEGIN
			--ID 
			SET @EmployeeXML.modify('
			insert <QualificationID>{sql:variable("@EmployeeQualificationID")}</QualificationID>
			into (/adfEmployeeGet/Employee)[1]')
		END
		IF @EmployeeDivisionID IS NOT NULL
		BEGIN
			--ID 
			SET @EmployeeXML.modify('
			insert <DivisionID>{sql:variable("@EmployeeDivisionID")}</DivisionID>
			into (/adfEmployeeGet/Employee)[1]')
		END
		--
		SET @EmployeeXML.modify('
		insert <FirstName>{sql:variable("@EmployeeFirstName")}</FirstName>
		into (/adfEmployeeGet/Employee)[1]')
		--
		SET @EmployeeXML.modify('
		insert <MiddleName>{sql:variable("@EmployeeMiddleName")}</MiddleName>
		into (/adfEmployeeGet/Employee)[1]')
		--
		SET @EmployeeXML.modify('
		insert <LastName>{sql:variable("@EmployeeLastName")}</LastName>
		into (/adfEmployeeGet/Employee)[1]')
		-- 
		SET @EmployeeXML.modify('
		insert
		<Phone>
			<PhoneTypeID>1</PhoneTypeID>
			<Phone>{sql:variable("@EmployeePhoneWork")}</Phone>
		</Phone>
		into (/adfEmployeeGet)[1]')
		-- 
		SET @EmployeeXML.modify('
		insert
		<Phone>
			<PhoneTypeID>3</PhoneTypeID>
			<Phone>{sql:variable("@EmployeePhoneMobile")}</Phone>
		</Phone>
		into (/adfEmployeeGet)[1]')
		--Email
		SET @EmployeeXML.modify('insert
		<Email>
			<EmailTypeID>1</EmailTypeID>
			<Email>{sql:variable("@EmployeeEmail")}</Email></Email>
		into (/adfEmployeeGet)[1]')
		
		--SELECT @EmployeeXML
		EXEC @rv = adfEmployeeCreate @Xml = @EmployeeXML, @ExtendedProperties = @EmployeeExtendedProperties
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE employee_cursor
			DEALLOCATE employee_cursor
			RETURN 1
		END
		
		FETCH NEXT FROM employee_cursor INTO 
		@EmployeeLastName,
		@EmployeeFirstName,
		@EmployeeMiddleName,
		@EmployeeFileAs,
		@EmployeePositionID, 
		@EmployeeQualificationID, 
		@EmployeeDivisionID, 
		@EmployeePhoneWork, 
		@EmployeePhoneMobile, 
		@EmployeeEmail
	END
	CLOSE employee_cursor
	DEALLOCATE employee_cursor

	-- 
	--  
	DECLARE @HasManageQualificationDictionary TBool,
			@ManageQualificationDictionary TSysname
	SET @ManageQualificationDictionary = dbo.adfwfGetInitialRight('a93253fa-ea27-48ac-9620-10ee3421b69d')
	SET @HasManageQualificationDictionary = dbo.adfHasAccessRightByName(@ManageQualificationDictionary)
	IF (@HasManageQualificationDictionary = 0)
	BEGIN
		EXEC pjm6SetRightForMasters @ManageQualificationDictionary
	END

	DECLARE @QualificationXML XML,
			@QualificationFileAs TName,
			@QualificationRatesXML XML
		
	DECLARE qualification_cursor CURSOR FOR 
	SELECT
		Qualification.value('./@Description','TName'),
		Qualification.query('QualificationRate')
	FROM
		@Xml.nodes('/MasterInfo/QualificationList/Qualification') as List(Qualification)
	OPEN qualification_cursor
	FETCH NEXT FROM qualification_cursor INTO @QualificationFileAs,@QualificationRatesXML
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @QualificationXML = 
		'<pjm5QualificationGet>
			<Qualification>
				<ID>-1</ID>
				<State>0</State>
				<Flag>0</Flag>
				<Guid>a93253fa-ea27-48ac-9620-10ee3421b69d</Guid>
			</Qualification>
		</pjm5QualificationGet>'
		
		--  Code  FileAs
		SET @QualificationXML.modify('
		insert <Code>{sql:variable("@QualificationFileAs")}</Code>
		into (/pjm5QualificationGet/Qualification)[1]       
		')  
		SET @QualificationXML.modify('
		insert <FileAs>{sql:variable("@QualificationFileAs")}</FileAs>            
		into (/pjm5QualificationGet/Qualification)[1]       
		')  
		DECLARE 
			@QualificationStandard TMoney,
			@QualificationCurrencyCode TCode3
		DECLARE qualificationRate_cursor CURSOR FOR 
		SELECT
			QualificationRate.value('./@Standard','TMoney'),
			QualificationRate.value('./@CurrencyCode','TCode3')
		FROM
			@QualificationRatesXML.nodes('/QualificationRate') as List(QualificationRate)
		OPEN qualificationRate_cursor
		FETCH NEXT FROM qualificationRate_cursor INTO @QualificationStandard, @QualificationCurrencyCode
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--  FileAs
			SET @QualificationXML.modify('
				insert 
				<QualificationRate>
					<Standard>{sql:variable("@QualificationStandard")}</Standard>
					<Overtime>{sql:variable("@QualificationStandard")}</Overtime>
					<CurrencyCode>{sql:variable("@QualificationCurrencyCode")}</CurrencyCode>
					</QualificationRate>            
				into (/pjm5QualificationGet)[1]       
				')
			FETCH NEXT FROM qualificationRate_cursor INTO @QualificationStandard,@QualificationCurrencyCode
		END
		CLOSE qualificationRate_cursor
		DEALLOCATE qualificationRate_cursor
		
		--SELECT @QualificationXML
		EXEC @rv = pjm5QualificationCreate @Xml=@QualificationXML
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE qualification_cursor
			DEALLOCATE qualification_cursor
			RETURN 1
		END
		
		FETCH NEXT FROM qualification_cursor INTO @QualificationFileAs,@QualificationRatesXML
	END
	CLOSE qualification_cursor
	DEALLOCATE qualification_cursor
	
	--  
	IF (@HasManageQualificationDictionary = 0)
	BEGIN
		EXEC pjm6DelRightForMasters @ManageQualificationDictionary
	END

	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6MasterCreateSystemObjects] TO PUBLIC
GO
