IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSuperTimerBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfSuperTimerBrowse'
		DROP  Procedure  adfSuperTimerBrowse
	END

GO

PRINT 'Creating Procedure adfSuperTimerBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfSuperTimerBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfSuperTimerBrowse
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIDentifier
	
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT
		[ID],
		[State],
		[FileAs],
		[Comments],
		[DocumentClass],
		[DocumentID],
		[BusinessCardClass],
		[BusinessCardID],
		[Persistent],
		[ActivityTypeID]
	FROM
		[SuperTimer]
	WHERE
		[CreatedBy] = @UserID AND ([State] IN (1, 2) OR ([State] = 3 AND [Persistent]=1))

	SELECT
		[SuperTimerID],
		[StartTime],
		[EndTime]
	FROM
		[SuperTimerHistory] INNER JOIN [SuperTimer]
			ON ([SuperTimerHistory].[SuperTimerID] = [SuperTimer].[ID])
	WHERE
		[SuperTimer].[CreatedBy] = @UserID AND [SuperTimer].[State] != 3 -- all but stopped
		
	RETURN 0

GO

GRANT EXEC ON adfSuperTimerBrowse TO PUBLIC
GO
