IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServicePWProjectsBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServicePWProjectsBrowse'
		DROP PROCEDURE [dbo].[adfServicePWProjectsBrowse]
	END
GO

PRINT 'Creating procedure adfServicePWProjectsBrowse'
GO

/******************************************************************************
**		File: adfServicePWProjectsBrowse.sql
**		Name: adfServicePWProjectsBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/07/2004 12:32:27
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.11.12	SAP				   ,   
**									 
**					SAP				  " "	  
*******************************************************************************/
CREATE PROCEDURE [adfServicePWProjectsBrowse]
	@ServiceID INT
	,@CostCentersXML XML
	,@ProjectManagerXML XML
	,@CustomerXML XML
	--,@CurrencyCode NCHAR(4)
	,@WithEmptyCostCenter INT
	,@WithEmptyManager INT
	,@WithEmptyCustomer INT
	
	
AS
	SET NOCOUNT ON
	
	DECLARE @CostCenters INT, @ProjectManager INT, @Customer INT
	
	EXEC sp_xml_preparedocument @CostCenters OUTPUT, @CostCentersXML
	EXEC sp_xml_preparedocument @ProjectManager OUTPUT, @ProjectManagerXML
	EXEC sp_xml_preparedocument @Customer OUTPUT, @CustomerXML
		
	SELECT
		[Project].[ID],
		[Project].[Number],
		[Project].[FileAs],
		[ServiceAssignment].[ID] AS [AssignmentID],
		[ServiceAssignment].[Price] AS [Price],
		[ServiceAssignment].[FileAs] AS [ServiceName],
		[Project].[CurrencyCode],
		[Service].[Code] AS [ServiceCode]
	FROM
		[Project]
		INNER JOIN [ServiceAssignment] 
			ON ([Project].[ID] = [ServiceAssignment].[ProjectID] AND [ServiceAssignment].[ServiceID] = @ServiceID)
		INNER JOIN [Service]
			ON [Service].[ID] = [ServiceAssignment].[ServiceID]
	WHERE
	(([Project].[CostCenterID] IN 
		(SELECT [CentersTable].[ID] 
		FROM OPENXML(@CostCenters, '/CostCenters/CostCenter', 2) 
		WITH ( [ID] int ) AS [CentersTable])
		OR (@WithEmptyCostCenter = 1 AND (([Project].[CostCenterID] IS NULL) OR [Project].[CostCenterID] IN 
																			(SELECT [CentersTable].[ID] 
																			FROM OPENXML(@CostCenters, '/CostCenters/CostCenter', 2) 
																			WITH ( [ID] int ) AS [CentersTable])))))
	AND (([Project].[ProjectManagerEmployeeID] IN 
		(SELECT [ManagersTable].[ID] 
		FROM OPENXML(@ProjectManager, '/Managers/Manager', 2) 
		WITH ( [ID] int ) AS [ManagersTable])
		OR (@WithEmptyManager = 1 AND (([Project].[ProjectManagerEmployeeID]  IS NULL) OR [Project].[ProjectManagerEmployeeID] IN 
																						(SELECT [ManagersTable].[ID] 
																						FROM OPENXML(@ProjectManager, '/Managers/Manager', 2) 
																						WITH ( [ID] int ) AS [ManagersTable])))))
	AND (([Project].[CustomerCompanyID] IN 
		(SELECT [CustomersTable].[ID] 
		FROM OPENXML(@Customer, '/Customers/Customer', 2) 
		WITH ( [ID] int ) 
		AS [CustomersTable]) 
		OR (@WithEmptyCustomer = 1 AND (([Project].[CustomerCompanyID] IS NULL) OR [Project].[CustomerCompanyID] IN
																					(SELECT [CustomersTable].[ID] 
																					FROM OPENXML(@Customer, '/Customers/Customer', 2) 
																					WITH ( [ID] int ) AS [CustomersTable])))))
	--AND (((@CurrencyCode <> 'NULL') AND ([Project].[CurrencyCode] = @CurrencyCode)) OR (@CurrencyCode = 'NULL'))
	AND ([Project].[State] = 2) AND ([ServiceAssignment].[State] = 1)
	AND [ServiceAssignment].[Price] IS NOT NULL
	
	
	
	IF @@ERROR != 0
	BEGIN
		EXEC sp_xml_removedocument @CostCenters
		EXEC sp_xml_removedocument @ProjectManager
		EXEC sp_xml_removedocument @Customer
		RETURN 1
	END

	EXEC sp_xml_removedocument @CostCenters
	EXEC sp_xml_removedocument @ProjectManager
	EXEC sp_xml_removedocument @Customer
		
	RETURN 0
GO

GRANT EXECUTE ON [adfServicePWProjectsBrowse] TO PUBLIC
GO
 
