IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetCurrentUserID]') AND xtype IN (N'FN', N'IF', N'TF'))
BEGIN
	EXEC sp_executesql N'/******************************************************************************
	**		File: 
	**		Name: adfGetCurrentUserID
	**		Desc: 
	**
	**		This template can be customized:
	**              
	**		Return values:
	** 
	**		Called by:   
	**              
	**		Parameters:
	**		Input							Output
	**      ----------						-----------
	**
	**		Auth: 
	**		Date: 
	*******************************************************************************
	**		Change History
	*******************************************************************************
	**		Date:		Author:			Description:
	**		--------	--------		-------------------------------------------
	**		16.11.10	SYV				 ORDER BY [User].[Locked] DESC
	*******************************************************************************/
	CREATE FUNCTION adfGetCurrentUserID()
	RETURNS INT
	AS
	BEGIN
		DECLARE @login sysname,
				@returnValue INT
				
		SET @login = SUSER_SNAME()

		IF CHARINDEX(''\'', @login) > 0
			SELECT @returnValue	= [User].[ID] FROM [User] WHERE [User].[NTLogin] = @login ORDER BY [User].[Locked] DESC
		ELSE
			SELECT @returnValue	= [User].[ID] FROM [User] WHERE [User].[SQLLogin] = @login ORDER BY [User].[Locked] DESC
		
		IF @returnValue IS NOT NULL
			RETURN @returnValue

		IF IS_MEMBER(''db_owner'') = 1
			RETURN 1
			
		RETURN NULL
	END'
END
GO

GRANT EXEC ON adfGetCurrentUserID TO PUBLIC
GO
