IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySizeBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySizeBrowse'
		DROP PROCEDURE [dbo].[adfCompanySizeBrowse]
	END
GO

PRINT 'Creating procedure adfCompanySizeBrowse'
GO

/******************************************************************************
**		File: adfCompanySizeBrowse.sql
**		Name: adfCompanySizeBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanySizeBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[CompanySize].[ID],
		[CompanySize].[Class],
		[CompanySize].[State],
		[CompanySize].[Flag],
		[CompanySize].[Code],
		[CompanySize].[FileAs],
		[CompanySize].[From],
		[CompanySize].[To],
		[CompanySize].[Comments],
		[CompanySize].[Created],
		[CompanySize].[CreatedBy],
		[CompanySize].[Modified],
		[CompanySize].[ModifiedBy],
		[CompanySize].[Timestamp]
	FROM
		[CompanySize]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [CompanySize].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfCompanySizeBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySizeGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySizeGet'
		DROP PROCEDURE [dbo].[adfCompanySizeGet]
	END
GO

PRINT 'Creating procedure adfCompanySizeGet'
GO

/******************************************************************************
**		File: adfCompanySizeGet.sql
**		Name: adfCompanySizeGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanySizeGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[CompanySize].[ID],
		[CompanySize].[Class],
		[CompanySize].[State],
		[CompanySize].[Flag],
		[CompanySize].[Code],
		[CompanySize].[FileAs],
		[CompanySize].[From],
		[CompanySize].[To],
		[CompanySize].[Comments],
		[CompanySize].[Created],
		[CompanySize].[CreatedBy],
		[CompanySize].[Modified],
		[CompanySize].[ModifiedBy],
		[CompanySize].[Timestamp]
	FROM
		[CompanySize]
	WHERE
		[CompanySize].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfCompanySizeGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySizeCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySizeCreate'
		DROP PROCEDURE [dbo].[adfCompanySizeCreate]
	END
GO

PRINT 'Creating procedure adfCompanySizeCreate'
GO

/******************************************************************************
**		File: adfCompanySizeCreate.sql
**		Name: adfCompanySizeCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanySizeCreate]
	@Code TCode,
	@FileAs TName,
	@From TCount,
	@To TCount,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('93eade9c-27c7-49a5-a32d-7659bdc1f34d')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [CompanySize]
		([Flag], [State], [Code], [FileAs], [From], [To], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @From, @To, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfCompanySizeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCompanySizeCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySizeUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySizeUpdate'
		DROP PROCEDURE [dbo].[adfCompanySizeUpdate]
	END
GO

PRINT 'Creating procedure adfCompanySizeUpdate'
GO

/******************************************************************************
**		File: adfCompanySizeUpdate.sql
**		Name: adfCompanySizeUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCompanySizeUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@From TCount,
	@To TCount,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[CompanySize]
	SET
		[CompanySize].[Code] = @Code,
		[CompanySize].[FileAs] = @FileAs,
		[CompanySize].[From] = @From,
		[CompanySize].[To] = @To,
		[CompanySize].[Comments] = @Comments,
		[CompanySize].[Modified] = GETDATE(),
		[CompanySize].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CompanySize].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfCompanySizeGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCompanySizeUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySizeDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySizeDelete'
		DROP PROCEDURE [dbo].[adfCompanySizeDelete]
	END
GO

PRINT 'Creating procedure adfCompanySizeDelete'
GO

/******************************************************************************
**		File: adfCompanySizeDelete.sql
**		Name: adfCompanySizeDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCompanySizeDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [CompanySize] WHERE [CompanySize].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfCompanySizeDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanySizeChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanySizeChangeState'
		DROP PROCEDURE [dbo].[adfCompanySizeChangeState]
	END
GO

PRINT 'Creating procedure adfCompanySizeChangeState'
GO

/******************************************************************************
**		File: adfCompanySizeChangeState.sql
**		Name: adfCompanySizeChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCompanySizeChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [CompanySize].[Class],
		@FromState = [CompanySize].[State]
	FROM
		[CompanySize]
	WHERE
		[CompanySize].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[CompanySize]
	SET
		[CompanySize].[State] = @ToState,
		[CompanySize].[Modified] = GETDATE(),
		[CompanySize].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CompanySize].[ID] = @ID
	AND
		[CompanySize].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfCompanySizeChangeState TO PUBLIC
GO
 