IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyTurnoverBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyTurnoverBrowse'
		DROP PROCEDURE [dbo].[adfCompanyTurnoverBrowse]
	END
GO

PRINT 'Creating procedure adfCompanyTurnoverBrowse'
GO

/******************************************************************************
**		File: adfCompanyTurnoverBrowse.sql
**		Name: adfCompanyTurnoverBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanyTurnoverBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[CompanyTurnover].[ID],
		[CompanyTurnover].[Class],
		[CompanyTurnover].[State],
		[CompanyTurnover].[Flag],
		[CompanyTurnover].[Code],
		[CompanyTurnover].[FileAs],
		[CompanyTurnover].[From],
		[CompanyTurnover].[To],
		[CompanyTurnover].[Comments],
		[CompanyTurnover].[Created],
		[CompanyTurnover].[CreatedBy],
		[CompanyTurnover].[Modified],
		[CompanyTurnover].[ModifiedBy],
		[CompanyTurnover].[Timestamp]
	FROM
		[CompanyTurnover]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [CompanyTurnover].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfCompanyTurnoverBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyTurnoverGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyTurnoverGet'
		DROP PROCEDURE [dbo].[adfCompanyTurnoverGet]
	END
GO

PRINT 'Creating procedure adfCompanyTurnoverGet'
GO

/******************************************************************************
**		File: adfCompanyTurnoverGet.sql
**		Name: adfCompanyTurnoverGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanyTurnoverGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[CompanyTurnover].[ID],
		[CompanyTurnover].[Class],
		[CompanyTurnover].[State],
		[CompanyTurnover].[Flag],
		[CompanyTurnover].[Code],
		[CompanyTurnover].[FileAs],
		[CompanyTurnover].[From],
		[CompanyTurnover].[To],
		[CompanyTurnover].[Comments],
		[CompanyTurnover].[Created],
		[CompanyTurnover].[CreatedBy],
		[CompanyTurnover].[Modified],
		[CompanyTurnover].[ModifiedBy],
		[CompanyTurnover].[Timestamp]
	FROM
		[CompanyTurnover]
	WHERE
		[CompanyTurnover].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfCompanyTurnoverGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyTurnoverCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyTurnoverCreate'
		DROP PROCEDURE [dbo].[adfCompanyTurnoverCreate]
	END
GO

PRINT 'Creating procedure adfCompanyTurnoverCreate'
GO

/******************************************************************************
**		File: adfCompanyTurnoverCreate.sql
**		Name: adfCompanyTurnoverCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfCompanyTurnoverCreate]
	@Code TCode,
	@FileAs TName,
	@From TMoney,
	@To TMoney,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('678f4f79-80fe-4d35-be9b-70ad538378ae')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [CompanyTurnover]
		([Flag], [State], [Code], [FileAs], [From], [To], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @From, @To, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfCompanyTurnoverGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyTurnoverCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyTurnoverUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyTurnoverUpdate'
		DROP PROCEDURE [dbo].[adfCompanyTurnoverUpdate]
	END
GO

PRINT 'Creating procedure adfCompanyTurnoverUpdate'
GO

/******************************************************************************
**		File: adfCompanyTurnoverUpdate.sql
**		Name: adfCompanyTurnoverUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCompanyTurnoverUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@From TMoney,
	@To TMoney,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[CompanyTurnover]
	SET
		[CompanyTurnover].[Code] = @Code,
		[CompanyTurnover].[FileAs] = @FileAs,
		[CompanyTurnover].[From] = @From,
		[CompanyTurnover].[To] = @To,
		[CompanyTurnover].[Comments] = @Comments,
		[CompanyTurnover].[Modified] = GETDATE(),
		[CompanyTurnover].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CompanyTurnover].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfCompanyTurnoverGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyTurnoverUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyTurnoverDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyTurnoverDelete'
		DROP PROCEDURE [dbo].[adfCompanyTurnoverDelete]
	END
GO

PRINT 'Creating procedure adfCompanyTurnoverDelete'
GO

/******************************************************************************
**		File: adfCompanyTurnoverDelete.sql
**		Name: adfCompanyTurnoverDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCompanyTurnoverDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [CompanyTurnover] WHERE [CompanyTurnover].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyTurnoverDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfCompanyTurnoverChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfCompanyTurnoverChangeState'
		DROP PROCEDURE [dbo].[adfCompanyTurnoverChangeState]
	END
GO

PRINT 'Creating procedure adfCompanyTurnoverChangeState'
GO

/******************************************************************************
**		File: adfCompanyTurnoverChangeState.sql
**		Name: adfCompanyTurnoverChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 11/30/2004 18:15:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfCompanyTurnoverChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [CompanyTurnover].[Class],
		@FromState = [CompanyTurnover].[State]
	FROM
		[CompanyTurnover]
	WHERE
		[CompanyTurnover].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[CompanyTurnover]
	SET
		[CompanyTurnover].[State] = @ToState,
		[CompanyTurnover].[Modified] = GETDATE(),
		[CompanyTurnover].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[CompanyTurnover].[ID] = @ID
	AND
		[CompanyTurnover].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfCompanyTurnoverChangeState TO PUBLIC
GO
 