IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServiceLevelBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServiceLevelBrowse'
		DROP PROCEDURE [dbo].[adfServiceLevelBrowse]
	END
GO

PRINT 'Creating procedure adfServiceLevelBrowse'
GO

/******************************************************************************
**		File: adfServiceLevelBrowse.sql
**		Name: adfServiceLevelBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2004 20:51:06
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfServiceLevelBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[ServiceLevel].[ID],
		[ServiceLevel].[Code],
		[ServiceLevel].[Comments],
		[ServiceLevel].[Class],
		[ServiceLevel].[State],
		[ServiceLevel].[Flag],
		[ServiceLevel].[FileAs],
		[ServiceLevel].[Created],
		[ServiceLevel].[CreatedBy],
		[ServiceLevel].[Modified],
		[ServiceLevel].[ModifiedBy],
		[ServiceLevel].[Timestamp]
	FROM
		[ServiceLevel]
	WHERE
		((@StateSelector = 0) OR (@StateSelector != 0 AND [ServiceLevel].[State] = @StateSelector))
		
	RETURN 0
GO

GRANT EXECUTE ON [adfServiceLevelBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServiceLevelGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServiceLevelGet'
		DROP PROCEDURE [dbo].[adfServiceLevelGet]
	END
GO

PRINT 'Creating procedure adfServiceLevelGet'
GO

/******************************************************************************
**		File: adfServiceLevelGet.sql
**		Name: adfServiceLevelGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2004 20:51:06
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfServiceLevelGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[ServiceLevel].[ID],
		[ServiceLevel].[Code],
		[ServiceLevel].[Comments],
		[ServiceLevel].[Class],
		[ServiceLevel].[State],
		[ServiceLevel].[Flag],
		[ServiceLevel].[FileAs],
		[ServiceLevel].[Created],
		[ServiceLevel].[CreatedBy],
		[ServiceLevel].[Modified],
		[ServiceLevel].[ModifiedBy],
		[ServiceLevel].[Timestamp]
	FROM
		[ServiceLevel]
	WHERE
		[ServiceLevel].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [adfServiceLevelGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServiceLevelCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServiceLevelCreate'
		DROP PROCEDURE [dbo].[adfServiceLevelCreate]
	END
GO

PRINT 'Creating procedure adfServiceLevelCreate'
GO

/******************************************************************************
**		File: adfServiceLevelCreate.sql
**		Name: adfServiceLevelCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2004 20:51:06
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfServiceLevelCreate]
	@Code TCode,
	@Comments TNotes,
	@FileAs TName
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('891ec3c5-c767-421f-98e4-c38c22fd2bd8')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [ServiceLevel]
		([Flag], [State], [Code], [Comments], [FileAs])
	VALUES
		(0, @State, @Code, @Comments, @FileAs)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC adfServiceLevelGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfServiceLevelCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServiceLevelUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServiceLevelUpdate'
		DROP PROCEDURE [dbo].[adfServiceLevelUpdate]
	END
GO

PRINT 'Creating procedure adfServiceLevelUpdate'
GO

/******************************************************************************
**		File: adfServiceLevelUpdate.sql
**		Name: adfServiceLevelUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2004 20:51:06
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfServiceLevelUpdate
	@ID TIdentifier,
	@Code TCode,
	@Comments TNotes,
	@FileAs TName
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[ServiceLevel]
	SET
		[ServiceLevel].[Code] = @Code,
		[ServiceLevel].[Comments] = @Comments,
		[ServiceLevel].[FileAs] = @FileAs,
		[ServiceLevel].[Modified] = GETDATE(),
		[ServiceLevel].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ServiceLevel].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC adfServiceLevelGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfServiceLevelUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServiceLevelDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServiceLevelDelete'
		DROP PROCEDURE [dbo].[adfServiceLevelDelete]
	END
GO

PRINT 'Creating procedure adfServiceLevelDelete'
GO

/******************************************************************************
**		File: adfServiceLevelDelete.sql
**		Name: adfServiceLevelDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2004 20:51:06
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfServiceLevelDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [ServiceLevel] WHERE [ServiceLevel].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfServiceLevelDelete TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfServiceLevelChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfServiceLevelChangeState'
		DROP PROCEDURE [dbo].[adfServiceLevelChangeState]
	END
GO

PRINT 'Creating procedure adfServiceLevelChangeState'
GO

/******************************************************************************
**		File: adfServiceLevelChangeState.sql
**		Name: adfServiceLevelChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/18/2004 20:51:06
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfServiceLevelChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [ServiceLevel].[Class],
		@FromState = [ServiceLevel].[State]
	FROM
		[ServiceLevel]
	WHERE
		[ServiceLevel].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[ServiceLevel]
	SET
		[ServiceLevel].[State] = @ToState,
		[ServiceLevel].[Modified] = GETDATE(),
		[ServiceLevel].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[ServiceLevel].[ID] = @ID
	AND
		[ServiceLevel].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON adfServiceLevelChangeState TO PUBLIC
GO
 