IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfSecurityImportGetTransitionTemplateID]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfSecurityImportGetTransitionTemplateID'
		DROP FUNCTION [dbo].[adfSecurityImportGetTransitionTemplateID]
	END

GO

PRINT 'Creating function adfSecurityImportGetTransitionTemplateID'
GO
/******************************************************************************
**		File: 
**		Name: adfSecurityImportGetTransitionTemplateID
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfSecurityImportGetTransitionTemplateID(@Guid TGuid, @FromState TState, @ToState TState)
RETURNS TIdentifier
AS
BEGIN
	DECLARE @Class TClass, @ID TIdentifier
	
	SELECT @Class = [Class] FROM [Class] WHERE [Guid] = @Guid
	
	SELECT 
		@ID = [ID]
	FROM
		[TransitionTemplate]
	WHERE
		[Class] = @Class
	AND
		((@FromState IS NULL AND [FromState] IS NULL) OR (@FromState = [FromState]))
	AND
		((@ToState IS NULL AND [ToState] IS NULL) OR (@ToState = [ToState]))

	RETURN @ID	
END
GO

  