IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSecurityPatch')
	BEGIN
		PRINT 'Dropping Procedure adfSecurityPatch'
		DROP  Procedure  adfSecurityPatch
	END

GO

PRINT 'Creating Procedure adfSecurityPatch'
GO
/******************************************************************************
**		File: 
**		Name: adfSecurityPatch
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfSecurityPatch
	@hdoc int
AS
	SET NOCOUNT ON
	DECLARE @NotUsedRight int
	SELECT @NotUsedRight = [ID] FROM [Right] WHERE [Name] = 'NotUsed'
	
	UPDATE
		[TransitionTemplate]
	SET
		[RightID] = @NotUsedRight
	FROM
		[TransitionTemplate]
	WHERE
		NOT EXISTS (
			SELECT * 
			FROM
				OPENXML(@hdoc, '/SecurityDataSet/State', 2) 
					WITH ([Guid] uniqueidentifier, [State] INT) AS [XmlTable]
				INNER JOIN [Class] 
					ON [Class].[Guid] = [XmlTable].[Guid]
			WHERE
				[Class].[Class] = [TransitionTemplate].[Class] AND
				(
					[XmlTable].[State] = [TransitionTemplate].[FromState] OR
					[XmlTable].[State] = [TransitionTemplate].[ToState]
				)
			)
	IF @@error != 0
		RETURN 1

	UPDATE
		[TransitionTemplate]
	SET
		[RightID] = @NotUsedRight
	FROM
		[TransitionTemplate]
	WHERE
		NOT EXISTS (
			SELECT * 
			FROM
				OPENXML(@hdoc, '/SecurityDataSet/TransitionTemplate', 2) 
					WITH ([Guid] uniqueidentifier, [FromState] INT, [ToState] INT) AS [XmlTable]
				INNER JOIN [Class] 
					ON [Class].[Guid] = [XmlTable].[Guid]
			WHERE
				[Class].[Class] = [TransitionTemplate].[Class] AND
				ISNULL([XmlTable].[FromState], -1) = ISNULL([TransitionTemplate].[FromState], -1) AND
				ISNULL([XmlTable].[ToState], -1) = ISNULL([TransitionTemplate].[ToState], -1)
			)
	IF @@error != 0
		RETURN 1

	RETURN 0
GO

 