IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfAccessRightDelete')
	BEGIN
		PRINT 'Dropping Procedure adfAccessRightDelete'
		DROP  Procedure  adfAccessRightDelete
	END

GO

PRINT 'Creating Procedure adfAccessRightDelete'
GO
/******************************************************************************
**		File: 
**		Name: adfAccessRightDelete
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfAccessRightDelete
	@RightName TSysname,
	@TrusteeName TSysname
AS
	
	SET NOCOUNT ON

	DECLARE @result INT
	EXEC @result = adfAccessRightCheck 'ManageRights'
	IF @result != 0
		RETURN @result

	DELETE [AccessRight]
	WHERE
		[AccessRight].[RightID] = dbo.adfGetRightID(@RightName)
	AND
		[AccessRight].[TrusteeID] = dbo.adfGetTrusteeID(@TrusteeName)
		
	IF @@ERROR != 0 OR @@ROWCOUNT = 0
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXEC ON adfAccessRightDelete TO PUBLIC
GO
