IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCurrentUserRightsGet')
	BEGIN
		PRINT 'Dropping Procedure adfCurrentUserRightsGet'
		DROP  Procedure  adfCurrentUserRightsGet
	END

GO

PRINT 'Creating Procedure adfCurrentUserRightsGet'
GO
/******************************************************************************
**		File: 
**		Name: adfCurrentUserRightsGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfCurrentUserRightsGet
AS
	SET NOCOUNT ON
	DECLARE 
		@UserID TIdentifier,
		@isDbOwner TBool
	SET @isDbOwner = IS_MEMBER('db_owner')
	SET @UserID = dbo.adfGetCurrentUserID()

	SELECT DISTINCT
		[Right].[Name]
	FROM
		[AccessRight] INNER JOIN [Right]
			ON ([AccessRight].[RightID] = [Right].[ID])
	WHERE
		[AccessRight].[TrusteeID] = @UserID
	OR
		[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = @UserID)
	UNION
	SELECT 'ManageLogins' WHERE @isDbOwner = 1 AND is_srvrolemember('securityadmin') = 1
	UNION
	SELECT 'ManageRights' WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageUsers' WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageCompanies' WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageOwnCompanies' WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageEmployees' WHERE @isDbOwner = 1
	UNION
	SELECT 'ManageContacts' WHERE @isDbOwner = 1
	UNION
	SELECT 'ManagePerson' WHERE @isDbOwner = 1
	UNION
	SELECT 'ViewContactDetails' WHERE @isDbOwner = 1
	UNION
	SELECT 'ViewEmployee' WHERE @isDbOwner = 1
	UNION
	SELECT 'ViewEmployeeDetails' WHERE @isDbOwner = 1
			
	RETURN 0
GO

GRANT EXEC ON adfCurrentUserRightsGet TO PUBLIC
GO
