IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetCurrentUserRights]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetCurrentUserRights'
		DROP FUNCTION [dbo].[adfGetCurrentUserRights]
	END

GO

PRINT 'Creating function adfGetCurrentUserRights'
GO
/******************************************************************************
**		File: 
**		Name: adfGetCurrentUserRights
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfGetCurrentUserRights()
RETURNS @CurrentUserRights TABLE ([ID] INT NOT NULL, [Name] sysname NOT NULL)
AS
BEGIN
	DECLARE 
		@UserID TIdentifier,
		@isDbOwner TBool
	SET @isDbOwner = IS_MEMBER('db_owner')
	SET @UserID = dbo.adfGetCurrentUserID()

	INSERT @CurrentUserRights
	SELECT DISTINCT
		[Right].[ID],
		[Right].[Name]
	FROM
		[AccessRight] INNER JOIN [Right]
			ON ([AccessRight].[RightID] = [Right].[ID])
	WHERE
		[AccessRight].[TrusteeID] = @UserID
	OR
		[AccessRight].[TrusteeID] IN (SELECT [UserRole].[RoleID] FROM [UserRole] WHERE [UserRole].[UserID] = @UserID)
	UNION
	SELECT 0, 'ManageLogins' WHERE @isDbOwner = 1 AND is_srvrolemember('securityadmin') = 1
	UNION
	SELECT 
		[Right].[ID], 
		[Right].[Name] 
	FROM 
		[Right] 
	WHERE 
		@isDbOwner = 1 AND 
		[Right].[Name] IN ('ManageRights', 'ManageUsers', 'ManageCompanies', 'ManageOwnCompanies', 'ManageEmployees', 'ManageContacts', 'ManagePerson', 'ViewContactDetails', 'ViewEmployee', 'ViewEmployeeDetails')

	RETURN
END
GO

