IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleGet')
	BEGIN
		PRINT 'Dropping Procedure adfRoleGet'
		DROP  Procedure  adfRoleGet
	END

GO

PRINT 'Creating Procedure adfRoleGet'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRoleGet
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT     
		[Trustee].[ID], 
		[Trustee].[Name], 
		ISNULL([TrusteeGlobal].[DisplayName], [Trustee].[DisplayName]) as [DisplayName], 
		[Trustee].[CreatedBy], 
		[Trustee].[ModifiedBy], 
		[Trustee].[Created], 
		[Trustee].[Modified], 
		ISNULL([TrusteeGlobal].[Comments], [Trustee].[Comments]) as [Comments],
		1 as [State]
	FROM         
		[Role] INNER JOIN [Trustee] 
			ON ([Role].[ID] = [Trustee].[ID])
		LEFT OUTER JOIN [TrusteeGlobal]
			ON ([Trustee].[ID] = [TrusteeGlobal].[ID] AND [TrusteeGlobal].[Language] = @Lang)
	WHERE
		[Role].[ID] = @ID AND [Role].[IsGroup] = 0

	RETURN 0
GO

GRANT EXEC ON adfRoleGet TO PUBLIC
GO
