IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleMemberCreate')
	BEGIN
		PRINT 'Dropping Procedure adfRoleMemberCreate'
		DROP  Procedure  adfRoleMemberCreate
	END

GO

PRINT 'Creating Procedure adfRoleMemberCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleMemberCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRoleMemberCreate
	@RoleName TSysname,
	@UserName TSysname,
	@UserID TIdentifier = NULL
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result
		
	IF @UserID IS NULL
		SET @UserID = dbo.adfGetUserID(@UserName);

	INSERT INTO [UserRole]
		([RoleID], [UserID])
	VALUES
		(dbo.adfGetRoleID(@RoleName), @UserID)

	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

GRANT EXEC ON adfRoleMemberCreate TO PUBLIC
GO
