IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfStateCreate')
	BEGIN
		PRINT 'Dropping Procedure adfStateCreate'
		DROP  Procedure  adfStateCreate
	END

GO

PRINT 'Creating Procedure adfStateCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfStateCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfStateCreate
	@Class TClass,
	@State TState,
	@Name TName,
	@Comments TNotes,
	@UIText TName,
	@Image TPicture
AS
	SET NOCOUNT ON
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	BEGIN TRANSACTION
	
	INSERT INTO [State]
		([Class], [State], [Name], [Comments], [UIText], [Image])
	VALUES
		(@Class, @State, @Name, @Comments, @UIText, @Image)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	INSERT INTO [StateGlobal] 
		([Class], [State], [Language], [Name], [Comments], [UIText])
	VALUES
		(@Class, @State, @Lang, @Name, @Comments, @UIText)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
		
	COMMIT TRANSACTION
	
	EXEC adfStateGet @Class, @State
	
	RETURN 0
GO

GRANT EXEC ON adfStateCreate TO PUBLIC
GO
