IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfTransitionTemplateBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfTransitionTemplateBrowse'
		DROP  Procedure  adfTransitionTemplateBrowse
	END

GO

PRINT 'Creating Procedure adfTransitionTemplateBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfTransitionTemplateBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfTransitionTemplateBrowse
	@Class TClass = NULL
AS
	DECLARE @C TClass
	SET NOCOUNT ON

	SET @C = dbo.adfGetClassByName('Adf.TransitionTemplate')

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[TransitionTemplate].[ID],
		@C as [Class],
		dbo.adfGetRightName([TransitionTemplate].[RightID]) as [Right],
		[TransitionTemplate].[Class] as [ClassID],
		[TransitionTemplate].[FromState],
		[TransitionTemplate].[ToState],
		[TransitionTemplate].[ActionID],
		ISNULL([TransitionTemplateGlobal].[Name], [TransitionTemplate].[Name]) as [Name],
		ISNULL([TransitionTemplateGlobal].[Comments], [TransitionTemplate].[Comments]) as [Comments],
		[TransitionTemplate].[UICommandID],
		[UICommand].[Name] as [UICommandName],
		dbo.adfGetStateName([TransitionTemplate].[Class], [TransitionTemplate].[FromState]) as [FromStateName],
		dbo.adfGetStateName([TransitionTemplate].[Class], [TransitionTemplate].[ToState]) as [ToStateName],
		[Class].[Code] as [ClassCode],
		[TransitionTemplate].[SPValidate],
		[TransitionTemplate].[SPBefore],
		[TransitionTemplate].[SPAfter],
		ISNULL([TransitionTemplateGlobal].[ConfirmationMessage], [TransitionTemplate].[ConfirmationMessage]) as [ConfirmationMessage],
		CAST(1 as INT) as [State]
	FROM
		[TransitionTemplate] INNER JOIN [Class]
			ON ([TransitionTemplate].[Class] = [Class].[Class])
		LEFT OUTER JOIN [UICommand]
			ON ([TransitionTemplate].[UICommandID] = [UICommand].[ID])
		LEFT OUTER JOIN [TransitionTemplateGlobal]
			ON ([TransitionTemplate].[ID] = [TransitionTemplateGlobal].[ID] AND [TransitionTemplateGlobal].[Language] = @Lang)
	WHERE
		(@Class IS NULL) OR (@Class IS NOT NULL AND [TransitionTemplate].[Class] = @Class)

	RETURN 0
GO

GRANT EXEC ON adfTransitionTemplateBrowse TO PUBLIC
GO
