/******************************************************************************
**		File: upgrade-budget.sql
**		Name: upgrade-budget
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				     PlannedAmount  ActualAmount   BudgetLineExpense
*******************************************************************************/

	
IF EXISTS (SELECT * FROM sys.columns WHERE [name] = 'PlannedAmount' AND type_name(sys.columns.system_type_id) = 'int' AND OBJECTPROPERTY(object_id, N'IsUserTable') = 1 AND OBJECT_NAME(object_id)='BudgetLineExpense')
BEGIN
	
	DECLARE @name varchar(500)
	
	SELECT @name = sysobjects.[name]
	FROM 
	sys.columns  INNER JOIN sysobjects ON sys.columns.default_object_id = sysobjects.id
	where 
	OBJECT_NAME(sys.columns.object_id) = 'BudgetLineExpense' AND 
	sys.columns.name = 'PlannedAmount' AND
	sysobjects.xtype = 'D' 
	
	IF @name IS NOT NULL
		EXEC ('ALTER TABLE [BudgetLineExpense] DROP CONSTRAINT ' + @name)
		
	ALTER TABLE [BudgetLineExpense] ALTER COLUMN [PlannedAmount] TAmount not null 
	
	IF @name IS NOT NULL
	EXEC('ALTER TABLE [BudgetLineExpense] ADD CONSTRAINT ' + @name + ' default 0 FOR [PlannedAmount]') 
	
END
GO

IF EXISTS (SELECT * FROM sys.columns WHERE [name] = 'ActualAmount' AND type_name(sys.columns.system_type_id) = 'int' AND OBJECTPROPERTY(object_id, N'IsUserTable') = 1 AND OBJECT_NAME(object_id)='BudgetLineExpense')
BEGIN
	
	DECLARE @name varchar(500)
	
	SELECT @name = sysobjects.[name]
	FROM 
	sys.columns  INNER JOIN sysobjects ON sys.columns.default_object_id = sysobjects.id
	where 
	OBJECT_NAME(sys.columns.object_id) = 'BudgetLineExpense' AND 
	sys.columns.name = 'ActualAmount' AND
	sysobjects.xtype = 'D' 
	
	IF @name IS NOT NULL
		EXEC ('ALTER TABLE [BudgetLineExpense] DROP CONSTRAINT ' + @name)
		
	ALTER TABLE [BudgetLineExpense] ALTER COLUMN [ActualAmount] TAmount not null 
	
	IF @name IS NOT NULL
	EXEC('ALTER TABLE [BudgetLineExpense] ADD CONSTRAINT ' + @name + ' default 0 FOR [ActualAmount]') 
	
END
GO

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Budget') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: Budget                                                */
/*==============================================================*/
create table Budget (
   ID                   TIdentifier          identity,
   Class                TClass               not null,
   State                TState               not null,
   Flag                 TFlag                not null,
   WarningFlagID        TIdentifier          null,
   FileAs               TName                not null,
   DocumentClass        TClass               null,
   DocumentID           TIdentifier          null,
   BudgetTypeID         TIdentifier          not null,
   StartDate            TDate                null,
   EndDate              TDate                null,
   UseWorkPlanning      TBool                not null default 1,
   UseExpensePlanning   TBool                not null default 0,
   WorkBudgetBottom     TMoney               not null,
   WorkBudgetHigh       TMoney               not null,
   WorkBudgetBottomEqualsPlan TBool                null,
   WorkBudgetHighEqualsPlan TBool                null,
   ExpenseBudgetBottom  TMoney               not null,
   ExpenseBudgetHigh    TMoney               not null,
   ExpenseBudgetBottomEqualsPlan TBool                null,
   ExpenseBudgetHighEqualsPlan TBool                null,
   LastCalculationDate  TDate                null,
   CalculationDuration  TCount               null,
   NextCalculationDate  TDate                null,
   SupervisorEmployeeID TIdentifier          null,
   CalculatedEmployeeID TIdentifier          null,
   CalculateBudgetPatternID TIdentifier          null,
   CurrencyCode         TCode3                not null,
   VATRate              TPercent             null,
   VATIsIncluded        TBool                not null default 0,
   DiscountViewWork     TBool                not null,
   DiscountPercentWork  TPercent             null,
   DiscountTotalWork    TMoney               null,
   DiscountViewExpense  TBool                not null,
   DiscountPercentExpense TPercent             null,
   DiscountTotalExpense TMoney               null,
   PlanningActivityForWork TBool                not null,
   PlanningEmployeeForWork TBool                not null,
   PlanningQualificationForWork TBool                not null,
   PlanningRateForWork  TBool                not null,
   PlanningDateForWork  TBool                null,
   PlanningExpenseTypeForExpense TBool                not null,
   PlanningEmployeeForExpense TBool                not null,
   PlanningPriceForExpense TBool                not null,
   PlanningDateForExpense TBool                null,
   TimeEntryAccount     TIdentifier          not null,
   TimeEntrySendingForApprovalAccount TBool  not null default 0,
   TimeEntryActualTotalsAccount TIdentifier		not null default 0,
   ExpenseAccount       TIdentifier          not null,
   ExpenseSendingForApprovalAccount	TBool    not null default 0,
   PlannedManHour       TAmount              not null default 0,
   PlannedManHourWithSub TAmount              not null default 0,
   ActualManHour        TAmount              not null default 0,
   ActualManHourWithSub TAmount              not null default 0,
   VATPCPlannedManHour  AS ([TotalWithVATPCPlannedManHour]-[TotalPCPlannedManHour]),
   TotalPCPlannedManHour TMoney               not null default 0,
   TotalWithVATPCPlannedManHour TMoney               not null default 0,
   VATPCPlannedManHourWithSub AS ([TotalWithVATPCPlannedManHourWithSub]-[TotalPCPlannedManHourWithSub]),
   TotalPCPlannedManHourWithSub TMoney               not null default 0,
   TotalWithVATPCPlannedManHourWithSub TMoney               not null default 0,
   VATPCWDPlannedManHourWithSub AS ([TotalWithVATPCWDPlannedManHourWithSub]-[TotalPCWDPlannedManHourWithSub]),
   TotalPCWDPlannedManHourWithSub TMoney               not null default 0,
   TotalWithVATPCWDPlannedManHourWithSub TMoney               not null default 0,
   VATPCActualManHour   AS ([TotalWithVATPCActualManHour]-[TotalPCActualManHour]),
   TotalPCActualManHour TMoney               not null default 0,
   TotalWithVATPCActualManHour TMoney               not null default 0,
   VATPCActualManHourWithSub AS ([TotalWithVATPCActualManHourWithSub]-[TotalPCActualManHourWithSub]),
   TotalPCActualManHourWithSub TMoney               not null default 0,
   TotalWithVATPCActualManHourWithSub TMoney               not null default 0,
   VATPCWDActualManHourWithSub AS ([TotalWithVATPCWDActualManHourWithSub]-[TotalPCWDActualManHourWithSub]),
   TotalPCWDActualManHourWithSub TMoney               not null default 0,
   TotalWithVATPCWDActualManHourWithSub TMoney               not null default 0,
   VATPCPlannedExpense  AS ([TotalWithVATPCPlannedExpense]-[TotalPCPlannedExpense]),
   TotalPCPlannedExpense TMoney               not null default 0,
   TotalWithVATPCPlannedExpense TMoney               not null default 0,
   VATPCPlannedExpenseWithSub AS ([TotalWithVATPCPlannedExpenseWithSub]-[TotalPCPlannedExpenseWithSub]),
   TotalPCPlannedExpenseWithSub TMoney               not null default 0,
   TotalWithVATPCPlannedExpenseWithSub TMoney               not null default 0,
   VATPCWDPlannedExpenseWithSub AS ([TotalWithVATPCWDPlannedExpenseWithSub]-[TotalPCWDPlannedExpenseWithSub]),
   TotalPCWDPlannedExpenseWithSub TMoney               not null default 0,
   TotalWithVATPCWDPlannedExpenseWithSub TMoney               not null default 0,
   VATPCActualExpense   AS ([TotalWithVATPCActualExpense]-[TotalPCActualExpense]),
   TotalPCActualExpense TMoney               not null default 0,
   TotalWithVATPCActualExpense TMoney               not null default 0,
   VATPCActualExpenseWithSub AS ([TotalWithVATPCActualExpenseWithSub]-[TotalPCActualExpenseWithSub]),
   TotalPCActualExpenseWithSub TMoney               not null default 0,
   TotalWithVATPCActualExpenseWithSub TMoney               not null default 0,
   VATPCWDActualExpenseWithSub AS ([TotalWithVATPCWDActualExpenseWithSub]-[TotalPCWDActualExpenseWithSub]),
   TotalPCWDActualExpenseWithSub TMoney               not null default 0,
   TotalWithVATPCWDActualExpenseWithSub TMoney               not null default 0,
   Comments             TNotes               null,
   Created              TSysDateTime         not null default GETDATE(),
   CreatedBy            TUserID              not null,
   Modified             TSysDateTime         not null default GETDATE(),
   ModifiedBy           TUserID              not null,
   Timestamp            timestamp            not null,
   constraint BudgetPK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineExpense') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineExpense                                     */
/*==============================================================*/
create table BudgetLineExpense (
   ID                   TIdentifier          identity,
   Class                TClass               not null,
   State                TState               not null,
   Flag                 TFlag                not null,
   FileAs               TName                not null,
   BudgetID             TIdentifier          not null,
   DocumentClass        TClass               null,
   DocumentID           TIdentifier          null,
   BudgetLineGroupID    TIdentifier          null,
   [Order]              TCount               not null,
   StartDate            TDate                null,
   EndDate              TDate                null,
   Price                TMoney               not null,
   EmployeeID           TIdentifier          null,
   ExpenseCodeID        TIdentifier          null,
   ExpenseID            TIdentifier          null,
   UOMID                TIdentifier          null,
   CurrencyRate         TMoney               not null,
   CurrencyCode         TCode3               not null,
   PlannedAmount        TAmount              not null default 0,
   ActualAmount         TAmount              not null default 0,
   VATIsIncluded        TBool                not null default 0,
   VATRate              TPercent             null,
   VATPlannedExpense    TMoney               null,
   VATPCPlannedExpense  AS ([TotalWithVATPCPlannedExpense]-[TotalPCPlannedExpense]),
   TotalPCPlannedExpense TMoney               not null default 0,
   TotalWithVATPCPlannedExpense TMoney               not null default 0,
   VATActualExpense     AS ([TotalWithVATActualExpense]-[TotalActualExpense]),
   TotalActualExpense   TMoney               null default 0,
   TotalWithVATActualExpense TMoney               null default 0,
   VATPCActualExpense   AS ([TotalWithVATPCActualExpense]-[TotalPCActualExpense]),
   TotalPCActualExpense TMoney               not null default 0,
   TotalWithVATPCActualExpense TMoney               not null default 0,
   Comments             TNotes               null,
   Created              TSysDateTime         not null default GETDATE(),
   CreatedBy            TUserID              not null,
   Modified             TSysDateTime         not null default GETDATE(),
   ModifiedBy           TUserID              not null,
   Timestamp            timestamp            not null,
   constraint BudgetLineExpensePK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineExpenseEntries') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineExpenseEntries                              */
/*==============================================================*/
create table BudgetLineExpenseEntries (
   BudgetLineID         TIdentifier          not null,
   BudgetID				TIdentifier			 not null,
   EntryID              TIdentifier          not null,
   constraint BudgetLineExpenseEntriesPK primary key  (BudgetLineID, BudgetID, EntryID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineGroup') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineGroup                                       */
/*==============================================================*/
create table BudgetLineGroup (
   ID                   TIdentifier          identity,
   Class                TClass               not null,
   State                TState               not null,
   Flag                 TFlag                not null,
   BudgetID             TIdentifier          not null,
   FileAs               TName                not null,
   StartDate            TDate                null,
   EndDate              TDate                null,
   [Order]              TCount               not null,
   GroupTypeID			TIdentifier          not null,
   Comments             TNotes               null,
   Created              TSysDateTime         not null default GETDATE(),
   CreatedBy            TUserID              not null,
   Modified             TSysDateTime         not null default GETDATE(),
   ModifiedBy           TUserID              not null,
   Timestamp            timestamp            not null,
   constraint BudgetLineGroupPK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineGroupGlobal') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineGroupGlobal                                 */
/*==============================================================*/
create table BudgetLineGroupGlobal (
   ID                   TIdentifier          not null,
   Language             TCode2               not null,
   FileAs               TName                null,
   constraint BudgetLineGroupGlobalPK primary key  (ID, Language)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineGroupType') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineGroupType                                   */
/*==============================================================*/
create table BudgetLineGroupType (
   ID                   TIdentifier          identity,
   FileAs               nvarchar(256)        not null,
   constraint BudgetLineGroupTypePK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineGroupTypeGlobal') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineGroupTypeGlobal                             */
/*==============================================================*/
create table BudgetLineGroupTypeGlobal (
   ID                   TIdentifier          not null,
   Language             TCode2               not null,
   FileAs               TName                not null,
   constraint BudgetLineGroupTypeGlobalPK primary key  (ID, Language)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineWork') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineWork                                        */
/*==============================================================*/
create table BudgetLineWork (
   ID                   TIdentifier          identity,
   Class                TClass               not null,
   State                TState               not null,
   Flag                 TFlag                not null,
   FileAs               TName                not null,
   BudgetID             TIdentifier          not null,
   DocumentClass        TClass               null,
   DocumentID           TIdentifier          null,
   BudgetLineGroupID    TIdentifier          null,
   [Order]              TCount               not null,
   StartDate            TDate                null,
   EndDate              TDate                null,
   Rate                 TMoney               not null,
   EmployeeID           TIdentifier          null,
   ActivityTypeID       TIdentifier          null,
   QualificationID      TIdentifier          null,
   PlannedManHour       TAmount               not null default 0,
   ActualManHour        TAmount               not null default 0,
   VATPCPlannedManHour  AS ([TotalWithVATPCPlannedManHour]-[TotalPCPlannedManHour]),
   TotalPCPlannedManHour TMoney               not null default 0,
   TotalWithVATPCPlannedManHour TMoney               not null default 0,
   VATPCActualManHour   AS ([TotalWithVATPCActualManHour]-[TotalPCActualManHour]),
   TotalPCActualManHour TMoney               not null default 0,
   TotalWithVATPCActualManHour TMoney               not null default 0,
   Comments             TNotes               null,
   Created              TSysDateTime         not null default GETDATE(),
   CreatedBy            TUserID              not null,
   Modified             TSysDateTime         not null default GETDATE(),
   ModifiedBy           TUserID              not null,
   Timestamp            timestamp            not null,
   constraint BudgetLineWorkPK unique (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetLineWorkEntries') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetLineWorkEntries                                 */
/*==============================================================*/
create table BudgetLineWorkEntries (
   BudgetLineID         TIdentifier          not null,
   BudgetID				TIdentifier			 not null,
   EntryID              TIdentifier          not null,
   constraint BudgetLineWorkEntriesPK primary key  (BudgetLineID,BudgetID, EntryID)
)
go


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetType') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetType                                            */
/*==============================================================*/
create table BudgetType (
   ID                   TIdentifier          identity,
   FileAs               TName                null,
   constraint BudgetTypePK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetTypeGlobal') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetTypeGlobal                                      */
/*==============================================================*/
create table BudgetTypeGlobal (
   ID                   TIdentifier          not null,
   Language             TLanguage            not null,
   FileAs               TName                null,
   constraint BudgetTypeGlobalPK primary key  (ID, Language)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetWarningFlag') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetWarningFlag                                     */
/*==============================================================*/
create table BudgetWarningFlag (
   ID                   TIdentifier          not null,
   FileAs               TName                not null,
   WarningType          TIdentifier          not null,
   constraint BudgetWarningFlagPK primary key  (ID)
)
go

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'BudgetWarningFlagGlobal') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: BudgetWarningFlagGlobal                               */
/*==============================================================*/
create table BudgetWarningFlagGlobal (
   ID                   TIdentifier          not null,
   Language             TLanguage            not null,
   FileAs               TName                not null,
   constraint BudgetWarningFlagGlobalPK primary key  (ID, Language)
)
go

IF NOT EXISTS (SELECT * FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Group] = 'Pjm6' AND [Name]='UseBudgetPlanning')
BEGIN
	DECLARE @false bit
	SET @false = 0
	EXEC adfParameterSet 'UseBudgetPlanning', 'Pjm6', @false
END
GO

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'BudgetTemplateID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ProjectTemplate')
	ALTER TABLE [ProjectTemplate] ADD [BudgetTemplateID] TIdentifier null
go

SET IDENTITY_INSERT [BudgetType] ON
IF NOT EXISTS(SELECT *FROM [BudgetType])
BEGIN
	INSERT INTO [BudgetType] ([ID], [FileAs]) VALUES(1, '  ')
	INSERT INTO [BudgetType] ([ID], [FileAs]) VALUES(2, '')
	INSERT INTO [BudgetType] ([ID], [FileAs]) VALUES(3, '')
	INSERT INTO [BudgetType] ([ID], [FileAs]) VALUES(4, '')
	INSERT INTO [BudgetType] ([ID], [FileAs]) VALUES(5, '')
END
SET IDENTITY_INSERT [BudgetType] OFF
GO

IF NOT EXISTS(SELECT *FROM [BudgetTypeGlobal])
BEGIN
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(1, 'ru', '  ')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(1, 'en', 'For Project')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(2, 'ru', '')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(2, 'en', 'Monthly')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(3, 'ru', '')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(3, 'en', 'Quarterly')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(4, 'ru', '')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(4, 'en', 'Half-yearly')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(5, 'ru', '')
	INSERT INTO [BudgetTypeGlobal] ([ID], [Language], [FileAs]) VALUES(5, 'en', 'Yearly')
END
GO

SET IDENTITY_INSERT [BudgetLineGroupType] ON
IF NOT EXISTS(SELECT *FROM [BudgetLineGroupType])
BEGIN
	INSERT INTO [BudgetLineGroupType] ([ID], [FileAs]) VALUES(1, ' ')
	INSERT INTO [BudgetLineGroupType] ([ID], [FileAs]) VALUES(2, ' ')
END
SET IDENTITY_INSERT [BudgetLineGroupType] OFF
GO

IF NOT EXISTS(SELECT *FROM [BudgetLineGroupTypeGlobal])
BEGIN
	INSERT INTO [BudgetLineGroupTypeGlobal] ([ID], [Language], [FileAs]) VALUES(1, 'en', 'Work group')
	INSERT INTO [BudgetLineGroupTypeGlobal] ([ID], [Language], [FileAs]) VALUES(2, 'en', 'Expense group')
	INSERT INTO [BudgetLineGroupTypeGlobal] ([ID], [Language], [FileAs]) VALUES(1, 'ru', ' ')
	INSERT INTO [BudgetLineGroupTypeGlobal] ([ID], [Language], [FileAs]) VALUES(2, 'ru', ' ')
END
GO

IF NOT EXISTS(SELECT *FROM [BudgetWarningFlag]s)
BEGIN
	INSERT INTO [BudgetWarningFlag] ([ID], [FileAs], [WarningType]) VALUES(0, '   ', 1)
	INSERT INTO [BudgetWarningFlag] ([ID], [FileAs], [WarningType]) VALUES(1, '  ,    ', 1)
	INSERT INTO [BudgetWarningFlag] ([ID], [FileAs], [WarningType]) VALUES(2, '     ''''', 1)
	INSERT INTO [BudgetWarningFlag] ([ID], [FileAs], [WarningType]) VALUES(3, ' .          ', 2)
	INSERT INTO [BudgetWarningFlag] ([ID], [FileAs], [WarningType]) VALUES(4, '     ', 2)
	INSERT INTO [BudgetWarningFlag] ([ID], [FileAs], [WarningType]) VALUES(5, '     ', 2)
END

IF NOT EXISTS(SELECT *FROM [BudgetWarningFlagGlobal])
BEGIN
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(0, 'ru', '   ')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(1, 'ru', '  ,    ')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(2, 'ru', '     ''''')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(3, 'ru', ' .          ')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(4, 'ru', '     ')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(5, 'ru', '     ')

	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(0, 'en', 'No warnings and errors')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(1, 'en', 'Budget has lines with empty budget parameters fields')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(2, 'en', 'Project already has an open budget')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(3, 'en', 'Calculation failed. The chain of the subbudgets contains ruptures or budgets with other parameters')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(4, 'en', 'Calculation is made without the subbudgets')
	INSERT INTO [BudgetWarningFlagGlobal] ([ID], [Language], [FileAs]) VALUES(5, 'en', 'There was an unforeseen error during calculation ')
END

IF NOT EXISTS (SELECT * FROM syscolumns WHERE [name] = 'TimeEntryActualTotalsAccount' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Budget')
BEGIN
	EXEC sp_executesql N'ALTER TABLE [Budget] ADD [TimeEntryActualTotalsAccount] TIdentifier not null default 0'
	EXEC sp_executesql N'Alter table [Budget] Disable trigger all'
	EXEC sp_executesql N'Alter table [Document] Disable trigger all'
	EXEC sp_executesql N'UPDATE [Budget] SET [TimeEntryActualTotalsAccount] = 1'
	EXEC sp_executesql N'Alter table [Budget] Disable trigger all'
	EXEC sp_executesql N'Alter table [Document] Enable trigger all'
END
GO