--- Expense table
IF NOT EXISTS(SELECT * FROM syscolumns WHERE [name] = 'DocumentClass' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Expense')
	ALTER TABLE [Expense] ADD [DocumentClass] [dbo].[TClass] NULL
GO

IF NOT EXISTS(SELECT * FROM syscolumns WHERE [name] = 'DocumentID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Expense')
	ALTER TABLE [Expense] ADD [DocumentID] [dbo].[TIdentifier] NULL
GO

--- TimeEntry table
IF NOT EXISTS(SELECT * FROM syscolumns WHERE [name] = 'DocumentClass' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TimeEntry')
	ALTER TABLE [TimeEntry] ADD [DocumentClass] [dbo].[TClass] NULL
GO

IF NOT EXISTS(SELECT * FROM syscolumns WHERE [name] = 'DocumentID' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TimeEntry')
	ALTER TABLE [TimeEntry] ADD [DocumentID] [dbo].[TIdentifier] NULL
GO

IF EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ServiceAssignmentID' 
AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TimeEntry')
BEGIN
	ALTER TABLE [TimeEntry] DISABLE TRIGGER ALL
	DECLARE @sql varchar(2000)
	SET @sql = 'UPDATE [TimeEntry]
				SET
					[TimeEntry].[DocumentClass] = dbo.adfGetClassByName(''Pjm5.ServiceAssignment''),
					[TimeEntry].[DocumentID] = [TimeEntry].[ServiceAssignmentID]
				WHERE
					[TimeEntry].[ServiceAssignmentID] IS NOT NULL'
	EXEC (@sql)
	SET @sql = 'ALTER TABLE [TimeEntry] DROP COLUMN [ServiceAssignmentID]'
	EXEC(@sql)
	ALTER TABLE [TimeEntry] ENABLE TRIGGER ALL
END
GO

--Issue table
IF EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualWork' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Issue')
EXEC sp_rename 'Issue.ActualWork', 'ActualManHour', 'Column'
GO

IF EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'PlannedWork' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Issue')
EXEC sp_rename 'Issue.PlannedWork', 'ManHour', 'Column'
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Issue')
ALTER TABLE [Issue] ADD [ManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Issue')
ALTER TABLE [Issue] ADD [ActualManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'Budget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Issue')
ALTER TABLE [Issue] ADD [Budget] TMoney not null default 0
GO
IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualBudget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Issue')
ALTER TABLE [Issue] ADD [ActualBudget] TMoney not null default 0
GO

--TaskRequest
IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
ALTER TABLE [TaskRequest] ADD [ManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
ALTER TABLE [TaskRequest] ADD [ActualManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'Budget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
ALTER TABLE [TaskRequest] ADD [Budget] TMoney not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualBudget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='TaskRequest')
ALTER TABLE [TaskRequest] ADD [ActualBudget] TMoney not null default 0

--ServiceAssignment
IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceAssignment')
ALTER TABLE [ServiceAssignment] ADD [ManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceAssignment')
ALTER TABLE [ServiceAssignment] ADD [ActualManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'Budget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceAssignment')
ALTER TABLE [ServiceAssignment] ADD [Budget] TMoney not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualBudget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceAssignment')
ALTER TABLE [ServiceAssignment] ADD [ActualBudget] TMoney not null default 0

--ServiceRequest
IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceRequest')
ALTER TABLE [ServiceRequest] ADD [ManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualManHour' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceRequest')
ALTER TABLE [ServiceRequest] ADD [ActualManHour] TCount not null default 0

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'ActualBudget' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='ServiceRequest')
ALTER TABLE [ServiceRequest] ADD [ActualBudget] TMoney not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'SendUpdate' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='MeetingRequest')
ALTER TABLE [MeetingRequest] ADD [SendUpdate] TBool not null default 0
GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trTimeEntryUpdateForTimeForAll')
	BEGIN
		PRINT 'Dropping Trigger pjm6trTimeEntryUpdateForTimeForAll'
		DROP  Trigger pjm6trTimeEntryUpdateForTimeForAll
	END
GO

--LastDocumentManager
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'LastDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
/*==============================================================*/
/* Table: LastDocument                                          */
/*==============================================================*/
CREATE TABLE LastDocument (
   ID                   TIdentifier          identity,
   DocumentClass        TClass               not null,
   DocumentID           TIdentifier          not null,
   ProjectID            TIdentifier          null,
   EmployeeID           TIdentifier          not null,
   Timestamp            timestamp            null,
   constraint LastDocumentPK primary key  (ID)
)
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'LastDocument') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DELETE 
		[LastDocument]
	WHERE 
		[LastDocument].[ID] NOT IN
		(SELECT
			[LastDocument].[ID]
		FROM
			[LastDocument]
		INNER JOIN [Document]
			ON [Document].[ID] = [LastDocument].[DocumentID]
				AND
			   [Document].[Class] = [LastDocument].[DocumentClass]
		)
END
GO

IF EXISTS (SELECT * FROM [Expense] WHERE [DocumentID] IS NULL AND [DocumentClass] IS NOT NULL)
BEGIN
	ALTER TABLE [Expense] DISABLE TRIGGER ALL
	UPDATE
		[Expense]
	SET
		[DocumentClass] = NULL 
	WHERE 
		[DocumentID] IS NULL 
		AND 
		[DocumentClass] IS NOT NULL	
	ALTER TABLE [Expense] ENABLE TRIGGER ALL
END
GO