IF NOT EXISTS(select * from systypes where name='TDouble')
BEGIN
	/*==============================================================*/
	/* Domain: TDouble                                              */
	/*==============================================================*/
	CREATE TYPE TDouble FROM double precision  not null
	GRANT REFERENCES ON TYPE ::dbo.TDouble TO PUBLIC
END

IF NOT EXISTS(select * from systypes where name='TInt16')
BEGIN
	/*==============================================================*/
	/* Domain: TInt16                                               */
	/*==============================================================*/
	CREATE TYPE TInt16 FROM smallint  not null
	GRANT REFERENCES ON TYPE ::dbo.TInt16 TO PUBLIC
END

IF NOT EXISTS(select * from systypes where name='TInt32')
BEGIN
	/*==============================================================*/
	/* Domain: TInt32                                               */
	/*==============================================================*/
	CREATE TYPE TInt32 FROM int  not null
	GRANT REFERENCES ON TYPE ::dbo.TInt32 TO PUBLIC
END
GO

DECLARE 
	@Length int

SET @Length = (select [length] from systypes where name='TAccount')
IF @Length = 20
BEGIN

	ALTER TABLE [BankAccount]
		ALTER COLUMN [Account] varchar(20) NULL
		
	ALTER TABLE [BankAccount]
		ALTER COLUMN [IntermediaryAccount] varchar(20) NULL
	
	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
		DROP PROCEDURE [dbo].[adfBankAccountCreate]
		
	IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfBankAccountUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
		DROP PROCEDURE [dbo].[adfBankAccountUpdate]
		
	DROP TYPE TAccount
	
	/*==============================================================*/
	/* Domain: TAccount                                             */
	/*==============================================================*/
	CREATE TYPE TAccount FROM varchar(25) 
	GRANT REFERENCES ON TYPE ::dbo.TAccount TO PUBLIC	
	
	ALTER TABLE [BankAccount]
		ALTER COLUMN [Account] TAccount NULL
		
	ALTER TABLE [BankAccount]
		ALTER COLUMN [IntermediaryAccount] TAccount NULL
END
GO