DECLARE @Class TClass, @ID TIdentifier

-- Company properties
SET @Class = dbo.adfGetClassByName('Adf.Company')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Name in additional language', 'Text')
END

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000002-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000002-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Address in additional language', 'Text')
END

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000003-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000003-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Legal address in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000004-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000004-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Actual/real address in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000005-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000005-0000-0000-0000-000000000000', ' ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Applicable legislation', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000006-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000006-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Applicable legislation in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000007-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000007-0000-0000-0000-000000000000', '  ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '  ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Basis for performing activities', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000008-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000008-0000-0000-0000-000000000000', '     ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '     ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Basis for performing activities in additional language', 'Text')
END
----
	
-- Employee properties
SET @Class = dbo.adfGetClassByName('Adf.Employee')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property]([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Name in the genitive case', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000002-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000002-0000-0000-0000-000000000000', '  ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '  ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Signature name', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000003-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000003-0000-0000-0000-000000000000', '  ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '  ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Basis for performing activities', 'Text')
END
----
	
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000004-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000004-0000-0000-0000-000000000000', ' e-mail ', 'Text', 'Text', 1) 
	SELECT @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' e-mail ', 'Text')
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'en', 'E-mail notification language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000005-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000005-0000-0000-0000-000000000000', '      ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '      ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Name in the genitive case in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000006-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000006-0000-0000-0000-000000000000', '     ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '     ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Signature name in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000007-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000007-0000-0000-0000-000000000000', '     ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '     ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Basis for performing activities in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000008-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000008-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Name in additional language', 'Text')
END

-- Issue builtin properties
SET @Class = dbo.adfGetClassByName('Pjm5.Issue')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', '-mail ', 'Text', 'Text', 1)
	SET @ID =  SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '-mail ', 'Text')
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'en', 'Originator -mail', 'Text')
END
----------------------------------------------------------------------------------------------

-- ActivityType properties
SET @Class = dbo.adfGetClassByName('Adf.ActivityType')
IF EXISTS (SELECT * FROM [Property] where [Class] = @Class AND [Guid] = '29895A1E-9260-478A-928A-0BC3975BE430')
BEGIN
	ALTER TABLE [Property] DISABLE TRIGGER ALL
	UPDATE 
		[Property] 
	SET
		[Guid] = '00000001-0000-0000-0000-000000000000'
	WHERE
		[Class] = @Class AND [Guid] = '29895A1E-9260-478A-928A-0BC3975BE430'
	ALTER TABLE [Property] ENABLE TRIGGER ALL
END

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Position in additional language', 'Text')
END
----

----------------------------------------------------------------------------------------------

-- Position properties
SET @Class = dbo.adfGetClassByName('Adf.Position')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1)
	SET @ID =  SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'en', 'Position in genitive case', 'Text')
END
----
	
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000002-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000002-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Position in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000003-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000003-0000-0000-0000-000000000000', '      ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '      ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Position in genitive case in additional language', 'Text')
END

-- Currency builtin properties
SET @Class = dbo.adfGetClassByName('Adf.Currency')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property]([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', ' ', 'Yes/No', 'NONE', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' ', 'NONE')
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'en', 'Is male', 'NONE')
END

-- Bank Account properties
SET @Class = dbo.adfGetClassByName('Adf.BankAccount')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000001-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Bank name in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000002-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000002-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Bank city in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000003-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000003-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Bank address in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000004-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000004-0000-0000-0000-000000000000', ' -   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' -   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Correspondent bank name in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000005-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000005-0000-0000-0000-000000000000', ' -   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' -   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Correspondent bank address in additional language', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000006-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000006-0000-0000-0000-000000000000', ' -', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' -', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Agency Bank name', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000007-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000007-0000-0000-0000-000000000000', ' -   ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' -   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Agency Bank address in additional language', 'Text')
END

-- Project properties
SET @Class = dbo.adfGetClassByName('Pjm5.Project')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000001-0000-0000-0000-000000000000', ' ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', ' ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Contract name', 'Text')
END
----

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000002-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000002-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Contract name in additional language', 'Text')
END

IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000003-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000003-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Project name in additional language', 'Text')
END
----

-- Qualification properties
SET @Class = dbo.adfGetClassByName('Pjm5.Qualification')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000001-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Qualification name in additional language', 'Text')
END
----

-- ServiceAssignment properties
SET @Class = dbo.adfGetClassByName('Pjm5.ServiceAssignment')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000001-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Service name in additional language', 'Text')
END
----

-- Service properties
SET @Class = dbo.adfGetClassByName('Pjm5.Service')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000001-0000-0000-0000-000000000000', '    ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '    ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Service name in additional language', 'Text')
END
----

-- PhoneCallCode properties
SET @Class = dbo.adfGetClassByName('Pjm5.PhoneCallCode')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES(@Class, '00000001-0000-0000-0000-000000000000', '     ', 'Text', 'Text', 1)
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '     ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Phone call code in additional language', 'Text')
END

-- ExpenseCode properties
SET @Class = dbo.adfGetClassByName('Pjm5.ExpenseCode')
IF NOT EXISTS (SELECT * FROM [Property] WHERE [Class] = @Class AND [Guid] = '00000001-0000-0000-0000-000000000000')
BEGIN
	INSERT INTO [Property] ([Class], [Guid], [Name], [Type], [Format], [BuiltIn])
	VALUES (@Class, '00000001-0000-0000-0000-000000000000', '   ', 'Text', 'Text', 1) 
	SET @ID = SCOPE_IDENTITY()
	INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format])
	VALUES (@ID, 'ru', '   ', 'Text')
	INSERT INTO [PropertyGlobal]	([ID], [Language], [Name], [Format])
	VALUES	(@ID, 'en', 'Name in additional language', 'Text')
END