/****** Object:  Schema [pjmams]    Script Date: 01/30/2007 19:19:26 ******/
CREATE SCHEMA [pjmams] AUTHORIZATION [dbo]
GO
/****** Object:  Table [pjmams].[Session]    Script Date: 01/30/2007 19:19:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [pjmams].[Session]
(
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[MachineName] [nvarchar](128) NOT NULL,
	[SessionStart] [datetime] NOT NULL CONSTRAINT [DF_Session_SessionStart]  DEFAULT (getdate()),
	[SessionEnd] [datetime] NOT NULL CONSTRAINT [DF_Session_SessionEnd]  DEFAULT (getdate()),
	[WinDir] [nvarchar](256) NULL,
	[ProgramFiles] [nvarchar](256) NULL,
	CONSTRAINT [PK_Session] PRIMARY KEY CLUSTERED 
	(
		[ID] ASC
	) WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO

/****** Object:  Table [pjmams].[Category]    Script Date: 01/30/2007 19:19:28 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [pjmams].[Category]
(
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](256) NOT NULL,
	CONSTRAINT [PK_Category] PRIMARY KEY CLUSTERED 
	(
		[ID] ASC
	) WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO

SET IDENTITY_INSERT [pjmams].[Category] ON
INSERT INTO [pjmams].[Category] ([ID], [Name]) VALUES(1, '')
SET IDENTITY_INSERT [pjmams].[Category] OFF
GO

/****** Object:  Table [pjmams].[Process]    Script Date: 01/30/2007 19:19:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [pjmams].[Process]
(
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[SessionID] [int] NULL,
	[ModuleID] [int] NULL,
	[PID] [int] NOT NULL,
	[UserName] [nvarchar](128) NOT NULL,
	[Created] [datetime] NOT NULL CONSTRAINT [DF_Process_Created]  DEFAULT (getdate()),
	[Closed] [datetime] NULL,
	CONSTRAINT [PK_Process] PRIMARY KEY CLUSTERED 
	(
		[ID] ASC
	) WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [pjmams].[Window]    Script Date: 01/30/2007 19:19:39 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [pjmams].[Window]
(
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[ProcessID] [int] NOT NULL,
	[HWND] [int] NOT NULL,
	[Caption] [nvarchar](max) NOT NULL,
	[Created] [datetime] NOT NULL CONSTRAINT [DF_Window_Created]  DEFAULT (getdate()),
	CONSTRAINT [PK_Window] PRIMARY KEY CLUSTERED 
	(
		[ID] ASC
	) WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [pjmams].[Module]    Script Date: 01/30/2007 19:19:30 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [pjmams].[Module]
(
	[ID] [int] IDENTITY(1,1) NOT NULL,
	[CategoryID] [int] NOT NULL CONSTRAINT [DF_Module_CategoryID]  DEFAULT (1),
	[Name] [nvarchar](max) NOT NULL,
	[Description] [nvarchar](max) NULL,
	[Version] [nvarchar](32) NULL,
	[Lang] [nvarchar](32) NULL,
	[Active] [bit] NOT NULL CONSTRAINT [DF_Module_Active] DEFAULT(1),
	CONSTRAINT [PK_Module] PRIMARY KEY CLUSTERED 
	(
		[ID] ASC
	) WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  ForeignKey [FK_Module_Category]    Script Date: 01/30/2007 19:19:31 ******/
ALTER TABLE [pjmams].[Module]  WITH CHECK ADD  CONSTRAINT [FK_Module_Category] FOREIGN KEY([CategoryID])
REFERENCES [pjmams].[Category] ([ID])
GO
ALTER TABLE [pjmams].[Module] CHECK CONSTRAINT [FK_Module_Category]
GO
/****** Object:  ForeignKey [FK_Process_Module]    Script Date: 01/30/2007 19:19:34 ******/
ALTER TABLE [pjmams].[Process]  WITH CHECK ADD  CONSTRAINT [FK_Process_Module] FOREIGN KEY([ModuleID])
REFERENCES [pjmams].[Module] ([ID])
GO
ALTER TABLE [pjmams].[Process] CHECK CONSTRAINT [FK_Process_Module]
GO
/****** Object:  ForeignKey [FK_Process_Session]    Script Date: 01/30/2007 19:19:34 ******/
ALTER TABLE [pjmams].[Process]  WITH CHECK ADD  CONSTRAINT [FK_Process_Session] FOREIGN KEY([SessionID])
REFERENCES [pjmams].[Session] ([ID])
GO
ALTER TABLE [pjmams].[Process] CHECK CONSTRAINT [FK_Process_Session]
GO
/****** Object:  ForeignKey [FK_Window_Process]    Script Date: 01/30/2007 19:19:40 ******/
ALTER TABLE [pjmams].[Window]  WITH CHECK ADD  CONSTRAINT [FK_Window_Process] FOREIGN KEY([ProcessID])
REFERENCES [pjmams].[Process] ([ID])
GO
ALTER TABLE [pjmams].[Window] CHECK CONSTRAINT [FK_Window_Process]
GO
 