﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6CanViewBudget]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6CanViewBudget'
		DROP FUNCTION [dbo].[fnPjm6CanViewBudget]
	END

GO

PRINT 'Creating function fnPjm6CanViewBudget'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6CanViewBudget
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 26.04.2011
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6CanViewBudget(
	@BudgetID TIdentifier
	)
RETURNS TBool
AS
BEGIN
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance')) = 1 
		RETURN 1

	DECLARE
		@BudgetClass			TClass,
		@CurrentEmployeeID		TIdentifier,
		@ProjectID				TIdentifier

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		@ProjectID = [DocumentID],
		@BudgetClass = (CASE WHEN [Budget].[State] IN (1,2,3) THEN dbo.adfGetClassByName('Pjm6.Budget') ELSE dbo.adfGetClassByName('Pjm6.BudgetTemplate') END)
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	IF @BudgetClass = dbo.adfGetClassByName('Pjm6.Budget') OR @BudgetClass IS NULL
	BEGIN
		IF dbo.adfHasAccessRight(dbo.adfGetRightID('ViewFinance')) = 1 
		BEGIN
			IF EXISTS(SELECT * FROM [vwAssignment]  WHERE [ProjectID] = @ProjectID AND 	[EmployeeID] = @CurrentEmployeeID AND [State] = 1)
				RETURN 1
		END

		IF EXISTS (
			SELECT [ID] FROM [Project] 
			WHERE 
				[ID] = @ProjectID AND 
				[ProjectManagerEmployeeID] = @CurrentEmployeeID
				)
			RETURN 1
	END
	ELSE IF @BudgetClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	BEGIN
		IF dbo.adfHasAccessRightByName('ManageBudgetTemplates') = 1 
			RETURN 1
	END
	RETURN 0
END
GO
GRANT EXEC ON fnPjm6CanViewBudget TO PUBLIC
GO
  