IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5CanViewDocument]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5CanViewDocument'
		DROP FUNCTION [dbo].[fnPjm5CanViewDocument]
	END

GO

PRINT 'Creating function fnPjm5CanViewDocument'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5CanViewDocument
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5CanViewDocument
	(@DocumentClass TClass, @DocumentID TIdentifier)
RETURNS BIT
AS
BEGIN

	DECLARE 
		@ProjectID TIdentifier, 
		@ClassName TCode, 
		@AssignmentID TIdentifier,
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@result bit
	
	IF is_member('db_owner') = 1
		RETURN 1
	
	SELECT @ClassName = [Code] FROM [Class] WHERE [Class] = @DocumentClass
	
	SET @ProjectID = dbo.fnPjm5GetDocumentProject(@DocumentClass, @DocumentID)
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @AssignmentID = dbo.fnPjm5GetProjectAssignment(@ProjectID, NULL)

	IF @ClassName = 'Pjm5.Issue' 
		OR @ClassName = 'Pjm5.Task' 
		OR @ClassName = 'Pjm5.Project' 
	BEGIN
		IF @AssignmentID IS NOT NULL OR dbo.fnPjm5IsProjectManager(@ProjectID, NULL) = 1 
			RETURN 1
	END
	ELSE IF @ClassName = 'Pjm5.ServiceRequest'
	BEGIN
		IF @AssignmentID IS NOT NULL OR dbo.fnPjm5IsProjectManager(@ProjectID, NULL) = 1 
			OR dbo.adfHasAccessRight(dbo.adfGetRightID('ViewServiceRequest')) = 1
			RETURN 1
	END
	ELSE IF @ClassName = 'Pjm5.TaskRequest'
	BEGIN
		IF @AssignmentID IS NOT NULL OR dbo.fnPjm5IsProjectManager(@ProjectID, NULL) = 1
			RETURN 1
		DECLARE
			@SupervisorEmployeeID TIdentifier,
			@CreatedBy TIdentifier
		SELECT
			@SupervisorEmployeeID = [TaskRequest].[SupervisorEmployeeID],
			@CreatedBy = [TaskRequest].[CreatedBy],
			@CurrentUserID = dbo.adfGetCurrentUserID()
		FROM 
			[TaskRequest]
			LEFT OUTER JOIN [DocumentCard]
				ON [DocumentCard].[ID] = [TaskRequest].[DocumentCardID]
		WHERE
			[TaskRequest].[ID] = @DocumentID

		IF @SupervisorEmployeeID = @CurrentEmployeeID
			RETURN 1
		IF @CreatedBy = @CurrentUserID
			RETURN 1
	END
	ELSE IF @ClassName = 'Pjm5.Calculation' 
		OR @ClassName = 'Pjm5.Invoice' 
		OR @ClassName = 'Pjm5.Statement'
		OR @ClassName = 'Pjm5.Facture'
		OR @ClassName = 'Pjm5.CreditMemo'
	BEGIN
		IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @CurrentEmployeeID, @DocumentClass, NULL) = 1
			RETURN 1
	END
	ELSE IF @ClassName = 'Adf.Payment'
	BEGIN
		IF dbo.adfHasAccessRight(dbo.adfGetRightID('CreatePayments')) = 1 
			OR dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance')) = 1
			RETURN 1
	END
	ELSE
		RETURN 1
		
	RETURN 0
END
GO

GRANT EXECUTE ON fnPjm5CanViewDocument TO PUBLIC
GO


 