IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetActivityTypeListByProject]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetActivityTypeListByProject'
		DROP FUNCTION [dbo].[fnPjm5GetActivityTypeListByProject]
	END

GO

PRINT 'Creating function fnPjm5GetActivityTypeListByProject'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetActivityTypeListByProject(@ProjectID TIdentifier)
RETURNS TName
AS
BEGIN
	
	DECLARE
		@Name		varchar(256),
		@Counter	int,
		@ActivityType	nvarchar(2048),
		@LastSymbol	char(8)		
			
	DECLARE my_cursor CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[ActivityType].[FileAs],
			COUNT(*)
		FROM 
			[ProjectActivityType] 				
			INNER JOIN	[ActivityType]
				ON [ProjectActivityType].[ActivityTypeID] = [ActivityType].[ID]
		WHERE
			[ProjectActivityType].[ProjectID] = @ProjectID
		GROUP BY
			[ActivityType].[FileAs]	
			
	OPEN my_cursor
	FETCH NEXT FROM my_cursor INTO @Name, @Counter
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Counter > 0
		BEGIN
			IF @ActivityType IS NULL
				SET @ActivityType = @Name
			ELSE
				SET @ActivityType = @ActivityType + N'; ' + @Name
		END
		FETCH NEXT FROM my_cursor INTO @Name, @Counter
	END
	IF @ActivityType IS NOT NULL
	BEGIN
		SET @ActivityType = RTRIM(@ActivityType)
		SET @LastSymbol = RIGHT(@ActivityType,1)
			IF @LastSymbol != '.'
			BEGIN
				SET @ActivityType = @ActivityType + N'.'
			END
	END
	CLOSE my_cursor
	DEALLOCATE my_cursor		
	RETURN(@ActivityType)
END
GO

GRANT EXEC ON fnPjm5GetActivityTypeListByProject TO PUBLIC
GO
