IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetCorrectPhone]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetCorrectPhone'
		DROP FUNCTION [dbo].[fnPjm5GetCorrectPhone]
	END

GO

PRINT 'Creating function fnPjm5GetCorrectPhone'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetCorrectPhone
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		03.03.10	PAM				      
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetCorrectPhone(@Phone TPhone)
RETURNS TPhone
AS
BEGIN
	DECLARE
		@CorrectPhone TPhone,
		@find bit,
		@FindIndex int

	set @find = 1
	SET @CorrectPhone = @Phone
	
	WHILE (@find = 1)
	BEGIN
		Set @FindIndex = Patindex('%[^0-9]%', @CorrectPhone )
		if(@FindIndex > 0)
		BEGIN 
			SET @CorrectPhone = Replace(@CorrectPhone, SUBSTRING(@CorrectPhone, @FindIndex, 1), '')
		END
		ELSE
			SET @find = 0
	END
	RETURN(@CorrectPhone)
END
GO

GRANT EXEC ON fnPjm5GetCorrectPhone TO PUBLIC
GO