IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetDeviationByTask]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetDeviationByTask'
		DROP FUNCTION [dbo].[fnPjm5GetDeviationByTask]
	END

GO

PRINT 'Creating function fnPjm5GetDeviationByTask'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetTaskListByAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetDeviationByTask(@TaskID int, @TodayDate datetime)
RETURNS decimal(18,2)
AS
BEGIN
	DECLARE @Deviation	decimal(18,2),
	--		@value			TVariant,
			@WorkTime		decimal		
	
	--SELECT @value = Value FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name]='WorkTime' AND [Group]='Pjm5'
	--SET @WorkTime =  24 * 60--CAST(@value as decimal)	
	
	SELECT
	@Deviation = ISNULL(-([Task].[Duration] * [Task].[PercentComplete] - dbo.fnPjm5GetWorkingDays([Task].[StartDate], DATEADD(day, -1, @TodayDate))), 0)
	FROM [Task]
	WHERE 	
		[Task].[ID] = @TaskID AND
		[Task].[State] IN (1,2)-- 1- , 2-
			
	RETURN(@Deviation)
END
GO

GRANT EXEC ON fnPjm5GetDeviationByTask TO PUBLIC
GO
