IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetDocumentProject]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetDocumentProject'
		DROP FUNCTION [dbo].[fnPjm5GetDocumentProject]
	END

GO

PRINT 'Creating function fnPjm5GetDocumentProject'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetDocumentProject
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetDocumentProject
	(@DocumentClass TClass, @DocumentID TIdentifier)
RETURNS TIdentifier
AS
BEGIN
	DECLARE @ProjectID TIdentifier, @ClassName TCode
	
	SELECT @ClassName = [Code] FROM [Class] WHERE [Class] = @DocumentClass
	
	IF @ClassName = 'Pjm5.Project'
		SET @ProjectID = @DocumentID
	ELSE IF @ClassName = 'Pjm5.Issue' 
		SELECT @ProjectID = [ProjectID] FROM [Issue] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.Task'
		SELECT @ProjectID = [ProjectID] FROM [Task] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.ServiceRequest'
		SELECT @ProjectID = [ProjectID] FROM [ServiceRequest] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.Calculation' 
		SELECT @ProjectID = [ProjectID] FROM [Calculation] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.Invoice'
		SELECT @ProjectID = [ProjectID] FROM [Invoice] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.Statement'
		SELECT @ProjectID = [ProjectID] FROM [Statement] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.Facture'
		SELECT @ProjectID = [ProjectID] FROM [Facture] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.CreditMemo'
		SELECT @ProjectID = [ProjectID] FROM [CreditMemo] WHERE [ID] = @DocumentID
	ELSE IF @ClassName = 'Pjm5.TaskRequest'
		SELECT @ProjectID = [ProjectID] FROM [TaskRequest] WHERE [ID] = @DocumentID
	
	RETURN @ProjectID
END
GO

GRANT EXECUTE ON fnPjm5GetDocumentProject TO PUBLIC
GO


 