IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetIndustryBranchList]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetIndustryBranchList'
		DROP FUNCTION [dbo].[fnPjm5GetIndustryBranchList]
	END

GO

PRINT 'Creating function fnPjm5GetIndustryBranchList'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetIndustryBranchList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetIndustryBranchList(@ID TIdentifier)
RETURNS TName
AS
BEGIN
	
	DECLARE
		@Name		varchar(256),
		@Counter	int,
		@Result	nvarchar(2048),
		@LastSymbol	char(8)		
			
	DECLARE my_cursor CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[IndustryBranch].[FileAs],
			COUNT(*)
		FROM 
			[CompanyIndustryBranch] 				
			INNER JOIN	[IndustryBranch]
				ON [CompanyIndustryBranch].[IndustryBranchID] = [IndustryBranch].[ID]
		WHERE
			[CompanyIndustryBranch].[CompanyID] = @ID
		GROUP BY
			[IndustryBranch].[FileAs]	
			
	OPEN my_cursor
	FETCH NEXT FROM my_cursor INTO @Name, @Counter
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Counter > 0
		BEGIN
			IF @Result IS NULL
				SET @Result = @Name
			ELSE
				SET @Result = @Result + N'; ' + @Name
		END
		FETCH NEXT FROM my_cursor INTO @Name, @Counter
	END
	IF @Result IS NOT NULL
	BEGIN
		SET @Result = RTRIM(@Result)
		SET @LastSymbol = RIGHT(@Result,1)
			IF @LastSymbol != '.'
			BEGIN
				SET @Result = @Result + N'.'
			END
	END
	CLOSE my_cursor
	DEALLOCATE my_cursor		
	RETURN(@Result)
END
GO

GRANT EXEC ON fnPjm5GetIndustryBranchList TO PUBLIC
GO
