IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5GetProjectAssignment]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5GetProjectAssignment'
		DROP FUNCTION [dbo].[fnPjm5GetProjectAssignment]
	END

GO

PRINT 'Creating function fnPjm5GetProjectAssignment'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5GetProjectAssignment
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5GetProjectAssignment
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS TIdentifier
AS
BEGIN
	DECLARE @AssignmentID TIdentifier
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SELECT 
		@AssignmentID = [ID] 
	FROM 
		vwAssignment 
	WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @EmployeeID AND [State] = 1	
	
	RETURN @AssignmentID
END
GO

GRANT EXECUTE ON dbo.fnPjm5GetProjectAssignment TO PUBLIC
GO


  