IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5ShiftDate]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5ShiftDate'
		DROP FUNCTION [dbo].[fnPjm5ShiftDate]
	END

GO

PRINT 'Creating function fnPjm5ShiftDate'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5ShiftDate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5ShiftDate(@start datetime, @days int)
RETURNS datetime
AS
BEGIN
	IF @start IS NULL OR @days IS NULL
		RETURN NULL
		
	DECLARE @end datetime,
			@curdate datetime,
			@value TVariant, @daymask int
	
	SET @curdate = CAST(CONVERT(varchar(8), @start, 112) AS DATETIME)
	SET @end = DATEADD(day, @days, @curdate)
	
	SELECT @value = Value FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name]='WorkDaysOfWeek' AND [Group]='Pjm5'
	SET @daymask = CAST(@value as int)

	WHILE (dbo.fnPjm5IsWorkingDayByMask(@end, @daymask) = 0)
	BEGIN
		SET @end = DATEADD(day, 1, @end)
	END

	RETURN @end
END
GO

GRANT EXEC ON fnPjm5ShiftDate TO PUBLIC
GO
  