IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6LastTimeEntryGet]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function pjm6LastTimeEntryGet'
		DROP FUNCTION [dbo].[pjm6LastTimeEntryGet]
	END

GO

PRINT 'Creating function pjm6LastTimeEntryGet'
GO
/******************************************************************************
**		File: 
**		Name: pjm6LastTimeEntryGet
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION pjm6LastTimeEntryGet
	()
RETURNS DATETIME 
AS
BEGIN
	DECLARE
	@EmployeeID TIdentifier,
	@CurrentDT TDate,
	@ReturnDT TDate

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SET @CurrentDT = GetDate()

	SELECT
		@ReturnDT = Max(DATEADD(minute, [TimeEntry].[Duration], [Timeentry].[StartTime]))
	FROM
		[TimeEntry]
	WHERE
		[TimeEntry].[EmployeeID] = @EmployeeID
		AND
		YEAR([Timeentry].[StartTime]) = YEAR(@CurrentDT)
		AND
		MONTH([Timeentry].[StartTime]) = MONTH(@CurrentDT)
		AND
		DAY([Timeentry].[StartTime]) = DAY(@CurrentDT)
		AND
		DATEADD(minute, [TimeEntry].[Duration], [Timeentry].[StartTime]) < @CurrentDT

	RETURN @ReturnDT
END
GO

GRANT EXECUTE ON [pjm6LastTimeEntryGet] TO PUBLIC
GO
