﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetCalculateBudgetForProject]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetCalculateBudgetForProject'
		DROP PROCEDURE [dbo].[pjm6BudgetCalculateBudgetForProject]
	END
GO

PRINT 'Creating procedure pjm6BudgetCalculateBudgetForProject'
GO

/******************************************************************************
**		File: BudgetCalculateBudgetForProject.sql
**		Name: pjm6BudgetCalculateBudgetForProject
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 21/01/2011 17:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				Изменение типа полей PlannedAmount и ActualAmount c TCount на TAmount
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetCalculateBudgetForProject]
	@CalculateWithSub								TBool,
	@BudgetID										TIdentifier,
	@StartCalculationTime							TDate,
	@PlannedManHourWithSub							TAmount = 0 OUTPUT,
	@ActualManHourWithSub							TAmount = 0 OUTPUT,
	@TotalPCPlannedManHourWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCPlannedManHourWithSub			TMoney = 0 OUTPUT,
	@TotalPCActualManHourWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCActualManHourWithSub				TMoney = 0 OUTPUT,
	@TotalPCPlannedExpenseWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCPlannedExpenseWithSub			TMoney = 0 OUTPUT,
	@TotalPCActualExpenseWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCActualExpenseWithSub				TMoney = 0 OUTPUT,
	@TotalPCWDPlannedManHourWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCWDPlannedManHourWithSub			TMoney = 0 OUTPUT,
	@TotalPCWDActualManHourWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCWDActualManHourWithSub			TMoney = 0 OUTPUT,
	@TotalPCWDPlannedExpenseWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCWDPlannedExpenseWithSub			TMoney = 0 OUTPUT,
	@TotalPCWDActualExpenseWithSub					TMoney = 0 OUTPUT,
	@TotalWithVATPCWDActualExpenseWithSub			TMoney = 0 OUTPUT 
AS
	DECLARE
		@BudgetTimeEntryAccount						TIdentifier,
		@BudgetTimeEntrySendingForApprovalAccount	TBool,
		@BudgetTimeEntryActualTotalsAccount			TIdentifier,
		@BudgetExpenseAccount						TIdentifier,
		@BudgetExpenseSendingForApprovalAccount		TBool,
		@BudgetDocumentID							Tidentifier,
		@BudgetCurrencyCode							TCode3,
		@BudgetState								TState,
		@BudgetClass								TClass,
		@BudgetTypeID								TIdentifier,
		@BudgetStartDate							TDate,
		@BudgetEndDate								TDate,
		@BudgetUseWorkPlanning						TBool,
		@BudgetUseExpensePlanning					TBool,
		@BudgetNextCalculationDate					TDate,
		@BudgetCalculateBudgetPatternID				TIdentifier,
		@VATRate									TPercent,
		@VATIsIncluded								TBool,
		@ApplyVAT									TBool,
		@value										TVariant,
		@Date										TDate,
		@ActualManHour								TAmount,
		@TotalPCActualManHour						TMoney,
		@TotalWithVATPCActualManHour				TMoney,
		@TotalPCActualExpense						TMoney,
		@TotalWithVATPCActualExpense				TMoney,
		@rv							int
		
		SELECT
			@BudgetTimeEntryAccount						= [TimeEntryAccount],
			@BudgetTimeEntrySendingForApprovalAccount	= [TimeEntrySendingForApprovalAccount],
			@BudgetTimeEntryActualTotalsAccount			= [TimeEntryActualTotalsAccount],
			@BudgetExpenseAccount						= [ExpenseAccount],
			@BudgetExpenseSendingForApprovalAccount		= [ExpenseSendingForApprovalAccount],
			@BudgetDocumentID							= [DocumentID],
			@BudgetCurrencyCode							= [CurrencyCode],
			@BudgetState								= [State],
			@BudgetClass								= [Class],
			@BudgetTypeID								= [BudgetTypeID],
			@BudgetStartDate							= [StartDate],
			@BudgetUseWorkPlanning						= [UseWorkPlanning],
			@BudgetUseExpensePlanning					= [UseExpensePlanning],
			@BudgetNextCalculationDate					= [NextCalculationDate],
			@BudgetCalculateBudgetPatternID				= [CalculateBudgetPatternID],
			@BudgetEndDate								= DATEADD(day, 1, [EndDate])
		FROM
			[Budget]
		WHERE
			[ID] = @BudgetID

	IF @BudgetState = 2
	BEGIN
		--Удалить все фактические данные из этого бюджета
		EXEC @rv = pjm6BudgetDeleteActualTotals @BudgetID, 1
		IF @rv != 0
			RETURN 2
		
		SET @ActualManHour					= 0 		
		SET @TotalPCActualManHour			= 0		
		SET @TotalWithVATPCActualManHour	= 0		
		SET @TotalPCActualExpense			= 0		
		SET @TotalWithVATPCActualExpense	= 0		
		--Расчет бюджета по записям о времени-----------------------------------------------------------------------------
		IF @BudgetUseWorkPlanning = 1
		BEGIN
			SELECT 
				@VATIsIncluded = [RatesWithVAT],
				@ApplyVAT = [ApplyVAT]
			FROM
				[Project]
			Where
				[ID] = @BudgetDocumentID
		
			SET @VATRate = 0
			IF @ApplyVAT = 1
			BEGIN
				EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
				SET @VATRate = ISNULL(CAST(@value as decimal(18,4)), 0)
			END

			DECLARE
				@TimeEntryID							TIdentifier,
				@TimeEntryDocumentClass					TClass,
				@TimeEntryDocumentID					TIdentifier,
				@TimeEntryFileAs						TName,
				@TimeEntryEmployeeID					TIdentifier,
				@TimeEntryActivityTypeID				TIdentifier,
				@TimeEntryQualificationID				TIdentifier,
				@TimeEntryBillableHour					TAmount,
				@TimeEntryRate							TMoney
			DECLARE @timeEntry TABLE
			(
				[ID] int,
				[DocumentClass]	int,
				[DocumentID] int,
				[FileAs] nvarchar(256),
				[EmployeeID] int,
				[QualificationID] int,
				[ActivityTypeID] int,
				[BillableHour] decimal(18, 4),
				[Rate] money
			)
			DECLARE @BugetLineTimeEntry TABLE
			(
				[BudgetLineID] int,
				[EntryID] int
			)

			INSERT INTO @TimeEntry
				([ID], [DocumentClass], [DocumentID], [FileAs], [EmployeeID],
				[QualificationID], [ActivityTypeID], [BillableHour], [Rate])
			SELECT
				[vwTimeEntry].[ID], 
				[DocumentClass], 
				[DocumentID], 
				[vwTimeEntry].[FileAs], 
				[EmployeeID],
				[QualificationID], 
				[ActivityTypeID], 
				CASE WHEN @BudgetTimeEntryActualTotalsAccount = 1 THEN [BillableHour] ELSE ROUND([Duration] / 60.0, 2) END, 
				CASE WHEN @BudgetTimeEntryActualTotalsAccount = 1 THEN [Rate] ELSE [OriginalRate] END
			FROM
				[vwTimeEntry]
				INNER JOIN [Assignment]
					ON [vwTimeEntry].[AssignmentID] = [Assignment].[ID]
			WHERE
				[vwTimeEntry].[ProjectID] = @BudgetDocumentID AND 
				((@BudgetTimeEntrySendingForApprovalAccount = 0) AND ([vwTimeEntry].[State] IN (3, 6)) OR 
				(@BudgetTimeEntrySendingForApprovalAccount = 1) AND ([vwTimeEntry].[State] IN (2, 3, 6))) AND
				((@BudgetTimeEntryAccount = 0) OR ((@BudgetTimeEntryAccount = 1) AND [vwTimeEntry].[Billable] = 1) OR
				((@BudgetTimeEntryAccount = 2) AND [vwTimeEntry].[Billable] = 0)) AND 
				((@BudgetTypeID = 1) OR (@BudgetTypeID >= 2 AND [vwTimeEntry].[StartTime] >= @BudgetStartDate AND [vwTimeEntry].[StartTime] < @BudgetEndDate))
				--AND [vwTimeEntry].[TaskID] IS NULL 
				--AND [vwTimeEntry].[CurrencyCode] = @BudgetCurrencyCode
			
			--Курсор обхода по записям о времени
			DECLARE TimeEntryCursor CURSOR LOCAL FOR
				SELECT 
					[ID], [DocumentClass], [DocumentID], [FileAs], [EmployeeID],
					[QualificationID], [ActivityTypeID], [BillableHour], [Rate]
				FROM @TimeEntry 

			OPEN TimeEntryCursor
			FETCH NEXT FROM TimeEntryCursor INTO @TimeEntryID, @TimeEntryDocumentClass, @TimeEntryDocumentID, @TimeEntryFileAs, @TimeEntryEmployeeID, 
				@TimeEntryQualificationID, @TimeEntryActivityTypeID, @TimeEntryBillableHour, @TimeEntryRate
			WHILE @@FETCH_STATUS = 0
			BEGIN	
				DECLARE
					@BudgetLineID TIdentifier

				EXEC @rv = pjm6BudgetFindBudgetWorkLineAndUpdateActualTotals	@BudgetID,  @TimeEntryID, @TimeEntryDocumentClass, @TimeEntryDocumentID,
																				@TimeEntryFileAs, @TimeEntryEmployeeID, @TimeEntryQualificationID, @TimeEntryActivityTypeID,
																				@TimeEntryBillableHour, @TimeEntryRate, @BudgetDocumentID, @VATRate, @VATIsIncluded,
																				@BudgetLineID = @BudgetLineID OUTPUT
				IF @rv != 0
					RETURN 2

				INSERT INTO @BugetLineTimeEntry (BudgetLineID, EntryID)
				VALUES(@BudgetLineID, @TimeEntryID)

				FETCH NEXT FROM TimeEntryCursor INTO @TimeEntryID, @TimeEntryDocumentClass, @TimeEntryDocumentID, @TimeEntryFileAs, @TimeEntryEmployeeID, 
					@TimeEntryQualificationID, @TimeEntryActivityTypeID, @TimeEntryBillableHour, @TimeEntryRate
			END
			CLOSE TimeEntryCursor
			DEALLOCATE TimeEntryCursor

			INSERT INTO [BudgetLineWorkEntries] ([BudgetLineID], [BudgetID], [EntryID])
			SELECT [BudgetLineID], @BudgetID, [EntryID]
			FROM @BugetLineTimeEntry
			IF @rv != 0
				RETURN 2
		END

		--Расчет бюджета по записям о затратах----------------------------------------------------------------------------
		IF @BudgetUseExpensePlanning = 1
		BEGIN
			DECLARE
				@ExpenseID								TIdentifier,
				@ExpenseDocumentClass					TClass,
				@ExpenseDocumentID						TIdentifier,
				@ExpenseProjectID						TIdentifier,
				@ExpenseFileAs							TName,
				@ExpenseEmployeeID						TIdentifier,
				@ExpenseCodeID							TIdentifier,
				@ExpenseAmount							TAmount,
				@ExpensePrice							TMoney,
				@ExpenseUOMID							TIdentifier,
				@ExpenseCurrencyCode					TCode3,
				@ExpenseVATIsIncluded					TBool,
				@ExpenseVATRate							TPercent,
				@ExpenseVATActualExpense				TMoney,
				@ExpenseCurrencyRate					TMoney,
				@ExpenseVATPCActualExpense				TMoney,
				@ExpenseTotalPCActualExpense			TMoney,
				@ExpenseTotalWithVATPCActualExpense		TMoney

			DECLARE @Expense TABLE
			(
				[ID] int,
				[DocumentClass] int,	
				[DocumentID] int ,				
				[FileAs] nvarchar(256),		
				[EmployeeID] int,				
				[ExpenseCodeID] int,	
				[Amount] decimal(18,4),		
				[Price] money,
				[UOMID] int,			
				[FromCurrencyCode] char(3),	
				[VATIsIncluded] bit,	
				[VATRate] decimal (18, 4),			
				[VAT] money,			
				[CurrencyRate] money,	
				[VATPC] money,			
				[TotalPC] money,		
				[TotalWithVATPC] money
			)

			DECLARE @BugetLineExpenseEntry TABLE
			(
				[BudgetLineID] int,
				[EntryID] int
			)

			INSERT INTO @Expense
				([ID], [DocumentClass], [DocumentID], [FileAs], [EmployeeID],
				[ExpenseCodeID], [Amount], [Price], [UOMID], [FromCurrencyCode],
				[VATIsIncluded], [VATRate], [VAT], [CurrencyRate], [VATPC], [TotalPC], [TotalWithVATPC])
			SELECT
				[ID], [DocumentClass], [DocumentID], [FileAs], [EmployeeID],			
				[ExpenseCodeID], [Amount], [Price], [UOMID], [FromCurrencyCode],	
				[VATIsIncluded], [VATRate],	[VAT], [CurrencyRate], [VATPC],	[TotalPC], [TotalWithVATPC]
			FROM
				[Expense]
			WHERE
				[Expense].[ProjectID] = @BudgetDocumentID AND 
				((@BudgetExpenseSendingForApprovalAccount = 0) AND ([Expense].[State] IN (3, 6)) OR 
				(@BudgetExpenseSendingForApprovalAccount = 1) AND ([Expense].[State] IN (2, 3, 6))) AND
				((@BudgetExpenseAccount = 0) OR ((@BudgetExpenseAccount = 1) AND [Expense].[Billable] = 1) OR
				((@BudgetExpenseAccount = 2) AND [Expense].[Billable] = 0)) AND 
				([Expense].[ToCurrencyCode] = @BudgetCurrencyCode) AND
				--[Expense].[TaskID] IS NULL AND
				((@BudgetTypeID = 1) OR (@BudgetTypeID >= 2 AND [Expense].[Date] >= @BudgetStartDate AND [Expense].[Date] <= @BudgetEndDate))   
				

			--Курсор обхода по записям о затратах
			DECLARE ExpenseCursor CURSOR LOCAL FOR
				SELECT [ID], [DocumentClass], [DocumentID], [FileAs], [EmployeeID],
				[ExpenseCodeID], [Amount], [Price], [UOMID], [FromCurrencyCode],
				[VATIsIncluded], [VATRate], [VAT], [CurrencyRate], [VATPC], [TotalPC], [TotalWithVATPC] FROM @Expense
			OPEN ExpenseCursor
			FETCH NEXT FROM ExpenseCursor INTO @ExpenseID, @ExpenseDocumentClass, @ExpenseDocumentID, @ExpenseFileAs, @ExpenseEmployeeID,				
				@ExpenseCodeID, @ExpenseAmount, @ExpensePrice, @ExpenseUOMID, @ExpenseCurrencyCode,@ExpenseVATIsIncluded, @ExpenseVATRate, 
				@ExpenseVATActualExpense, @ExpenseCurrencyRate, @ExpenseVATPCActualExpense, @ExpenseTotalPCActualExpense, @ExpenseTotalWithVATPCActualExpense				
			WHILE @@FETCH_STATUS = 0					   
			BEGIN

				EXEC @rv = pjm6BudgetFindBudgetExpenseLineAndUpdateActualTotals @BudgetID, @ExpenseID, @ExpenseDocumentClass, @ExpenseDocumentID, @ExpenseFileAs, @ExpenseEmployeeID,				
				@ExpenseCodeID, @ExpenseAmount, @ExpensePrice, @ExpenseUOMID, @ExpenseCurrencyCode,@ExpenseVATIsIncluded, @ExpenseVATRate, 
				@ExpenseVATActualExpense, @ExpenseCurrencyRate, @ExpenseVATPCActualExpense, @ExpenseTotalPCActualExpense, @ExpenseTotalWithVATPCActualExpense,
				@BudgetLineID = @BudgetLineID OUTPUT
				IF @rv != 0
					RETURN 2

				INSERT INTO @BugetLineExpenseEntry (BudgetLineID, EntryID)
				VALUES(@BudgetLineID, @ExpenseID)

				FETCH NEXT FROM ExpenseCursor INTO @ExpenseID, @ExpenseDocumentClass, @ExpenseDocumentID, @ExpenseFileAs, @ExpenseEmployeeID,				
					@ExpenseCodeID, @ExpenseAmount, @ExpensePrice, @ExpenseUOMID, @ExpenseCurrencyCode,@ExpenseVATIsIncluded, @ExpenseVATRate, 
					@ExpenseVATActualExpense, @ExpenseCurrencyRate, @ExpenseVATPCActualExpense, @ExpenseTotalPCActualExpense, @ExpenseTotalWithVATPCActualExpense
			END
			CLOSE ExpenseCursor
			DEALLOCATE ExpenseCursor

			INSERT INTO [BudgetLineExpenseEntries] ([BudgetLineID], [BudgetID], [EntryID])
			SELECT [BudgetLineID], @BudgetID, [EntryID]
			FROM @BugetLineExpenseEntry
			IF @rv != 0
				RETURN 2
		END
		
		SELECT
			@ActualManHour = ISNULL(SUM([BudgetLineWork].[ActualManHour]), 0),					
			@TotalPCActualManHour = ISNULL(SUM(ROUND([BudgetLineWork].[TotalPCActualManHour] , 2)), 0),			
			@TotalWithVATPCActualManHour = ISNULL(SUM(ROUND([BudgetLineWork].[TotalWithVATPCActualManHour], 2)), 0)		
		FROM
			[BudgetLineWork]
		WHERE
			[BudgetLineWork].[BudgetID] = @BudgetID

		SELECT
			@TotalPCActualExpense = ISNULL(SUM(ROUND([BudgetLineExpense].[TotalPCActualExpense], 2)), 0),			
			@TotalWithVATPCActualExpense = ISNULL(SUM(ROUND([BudgetLineExpense].[TotalWithVATPCActualExpense], 2)), 0)	
		FROM
			[BudgetLineExpense]
		WHERE
			[BudgetLineExpense].[BudgetID] = @BudgetID

		SET @Date = GETDATE()

		IF @CalculateWithSub = 1
		BEGIN
			UPDATE
				[Budget]
			SET
				[Budget].[ActualManHour]						= @ActualManHour,
				[Budget].[TotalPCActualManHour]					= @TotalPCActualManHour,
				[Budget].[TotalWithVATPCActualManHour]			= @TotalWithVATPCActualManHour,
				[Budget].[TotalPCActualExpense]					= @TotalPCActualExpense,
				[Budget].[TotalWithVATPCActualExpense]			= @TotalWithVATPCActualExpense,
				[Budget].[PlannedManHourWithSub]					= [PlannedManHour]					+ @PlannedManHourWithSub,				
				[Budget].[ActualManHourWithSub]					= @ActualManHour					+ @ActualManHourWithSub,							
				[Budget].[TotalPCPlannedManHourWithSub]			= [TotalPCPlannedManHour]			+ @TotalPCPlannedManHourWithSub,		
				[Budget].[TotalWithVATPCPlannedManHourWithSub]	= [TotalWithVATPCPlannedManHour]	+ @TotalWithVATPCPlannedManHourWithSub,		
				[Budget].[TotalPCActualManHourWithSub]			= @TotalPCActualManHour				+ @TotalPCActualManHourWithSub,		
				[Budget].[TotalWithVATPCActualManHourWithSub]	= @TotalWithVATPCActualManHour		+ @TotalWithVATPCActualManHourWithSub,				
				[Budget].[TotalPCPlannedExpenseWithSub]			= [TotalPCPlannedExpense]			+ @TotalPCPlannedExpenseWithSub,		
				[Budget].[TotalWithVATPCPlannedExpenseWithSub]	= [TotalWithVATPCPlannedExpense]	+ @TotalWithVATPCPlannedExpenseWithSub,		
				[Budget].[TotalPCActualExpenseWithSub]			= @TotalPCActualExpense				+ @TotalPCActualExpenseWithSub,		
				[Budget].[TotalWithVATPCActualExpenseWithSub]	= @TotalWithVATPCActualExpense		+ @TotalWithVATPCActualExpenseWithSub,
				[Budget].[TotalPCWDPlannedManHourWithSub]		= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) - 
					dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE
					dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) END + @TotalPCWDPlannedManHourWithSub,			 
		
				[Budget].[TotalWithVATPCWDPlannedManHourWithSub]= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE
					dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) + 
					dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) END
					+ @TotalWithVATPCWDPlannedManHourWithSub,	
		
				[Budget].[TotalPCWDActualManHourWithSub]		= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], @TotalPCActualManHour, @TotalWithVATPCActualManHour) - 
					dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], @TotalPCActualManHour, @TotalWithVATPCActualManHour) ELSE 
					dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], @TotalPCActualManHour, @TotalWithVATPCActualManHour) END + @TotalPCWDActualManHourWithSub,			
		
				[Budget].[TotalWithVATPCWDActualManHourWithSub]	= CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], @TotalPCActualManHour, @TotalWithVATPCActualManHour) ELSE
					dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], @TotalPCActualManHour, @TotalWithVATPCActualManHour) + 
					dbo.fnPjm6GetBudgetVATForTotal([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], @TotalPCActualManHour, @TotalWithVATPCActualManHour) END
					+ @TotalWithVATPCWDActualManHourWithSub,	
		
				[Budget].[TotalPCWDPlannedExpenseWithSub]		= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 0, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))		
					+ @TotalPCWDPlannedExpenseWithSub,			
		
				[Budget].[TotalWithVATPCWDPlannedExpenseWithSub]= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 1, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1))	
					+ @TotalWithVATPCWDPlannedExpenseWithSub,	
		
				[Budget].[TotalPCWDActualExpenseWithSub]		= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 0, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], @TotalPCActualExpense, @TotalPCActualExpense + dbo.fnPjm6GetVATForTotal(@TotalPCActualExpense, [VATRate], 0, 1))
					+ @TotalPCWDActualExpenseWithSub,			
		
				[Budget].[TotalWithVATPCWDActualExpenseWithSub]	= dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], 1, [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], @TotalPCActualExpense, @TotalPCActualExpense + dbo.fnPjm6GetVATForTotal(@TotalPCActualExpense, [VATRate], 0, 1))	
					+ @TotalWithVATPCWDActualExpenseWithSub,
				[Budget].[CalculatedEmployeeID] = dbo.adfGetCurrentEmployeeID(),
				[Budget].[LastCalculationDate] = @Date,
				[Budget].[CalculationDuration] = DATEDIFF(second, @StartCalculationTime, @Date),
				[Budget].[NextCalculationDate] = (CASE WHEN @BudgetCalculateBudgetPatternID IS NOT NULL AND (@BudgetNextCalculationDate IS NULL OR (@BudgetNextCalculationDate IS NOT NULL AND @BudgetNextCalculationDate < @Date)) THEN
					dbo.fnPjm6AssistantRecurrenceGetNextDateTime(@BudgetCalculateBudgetPatternID, @Date, @Date) ELSE [NextCalculationDate] END)
			WHERE
				[Budget].[ID] = @BudgetID
			IF @@ERROR != 0
				RETURN 2	
		END
		ELSE
		BEGIN
			UPDATE
				[Budget]
			SET
				[Budget].[ActualManHour]						= @ActualManHour,
				[Budget].[TotalPCActualManHour]					= @TotalPCActualManHour,
				[Budget].[TotalWithVATPCActualManHour]			= @TotalWithVATPCActualManHour,
				[Budget].[TotalPCActualExpense]					= @TotalPCActualExpense,
				[Budget].[TotalWithVATPCActualExpense]			= @TotalWithVATPCActualExpense,
				[Budget].[CalculatedEmployeeID] = dbo.adfGetCurrentEmployeeID(),
				[Budget].[LastCalculationDate] = @Date,
				[Budget].[CalculationDuration] = DATEDIFF(second, @StartCalculationTime, @Date),
				[Budget].[NextCalculationDate] = (CASE WHEN @BudgetCalculateBudgetPatternID IS NOT NULL AND (@BudgetNextCalculationDate IS NULL OR (@BudgetNextCalculationDate IS NOT NULL AND @BudgetNextCalculationDate < @Date)) THEN
					dbo.fnPjm6AssistantRecurrenceGetNextDateTime(@BudgetCalculateBudgetPatternID, @Date, @Date) ELSE [NextCalculationDate] END)
			WHERE
				[Budget].[ID] = @BudgetID
			IF @@ERROR != 0
				RETURN 2	
		END

	END

	SELECT 
		@PlannedManHourWithSub					= [PlannedManHourWithSub],						
		@ActualManHourWithSub					= [ActualManHourWithSub],						
		@TotalPCPlannedManHourWithSub			= [TotalPCPlannedManHourWithSub],				
		@TotalWithVATPCPlannedManHourWithSub	= [TotalWithVATPCPlannedManHourWithSub],		
		@TotalPCActualManHourWithSub			= [TotalPCActualManHourWithSub],				
		@TotalWithVATPCActualManHourWithSub		= [TotalWithVATPCActualManHourWithSub],		
		@TotalPCPlannedExpenseWithSub			= [TotalPCPlannedExpenseWithSub],				
		@TotalWithVATPCPlannedExpenseWithSub	= [TotalWithVATPCPlannedExpenseWithSub],		
		@TotalPCActualExpenseWithSub			= [TotalPCActualExpenseWithSub],				
		@TotalWithVATPCActualExpenseWithSub		= [TotalWithVATPCActualExpenseWithSub],
		@TotalPCWDPlannedManHourWithSub			= [TotalPCWDPlannedManHourWithSub],
		@TotalWithVATPCWDPlannedManHourWithSub	= [TotalWithVATPCWDPlannedManHourWithSub],
		@TotalPCWDActualManHourWithSub			= [TotalPCWDActualManHourWithSub],
		@TotalWithVATPCWDActualManHourWithSub	= [TotalWithVATPCWDActualManHourWithSub],
		@TotalPCWDPlannedExpenseWithSub			= [TotalPCWDPlannedExpenseWithSub],			
		@TotalWithVATPCWDPlannedExpenseWithSub	= [TotalWithVATPCWDPlannedExpenseWithSub],	
		@TotalPCWDActualExpenseWithSub			= [TotalPCWDActualExpenseWithSub],			
		@TotalWithVATPCWDActualExpenseWithSub	= [TotalWithVATPCWDActualExpenseWithSub],
		@BudgetNextCalculationDate				= [NextCalculationDate]	
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID		
	
	IF @BudgetNextCalculationDate IS NOT NULL
		EXEC @rv = pjm5BudgetReminderUpdate @BudgetClass, 'BC', @BudgetID, @BudgetNextCalculationDate
		IF @rv != 0
			RETURN 2

	RETURN 0
GRANT EXECUTE ON [pjm6BudgetCalculateBudgetForProject] TO PUBLIC
GO