IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetDelete'
		DROP PROCEDURE [dbo].[pjm6BudgetDelete]
	END
GO

PRINT 'Creating procedure pjm6BudgetDelete'
GO

/******************************************************************************
**		File: pjm6BudgetDelete.sql
**		Name: pjm6BudgetDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 29/09/2010 15:33:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetDelete
	@ID TIdentifier
AS
	DECLARE
		@RecurrencePatternID	TIdentifier
	SET NOCOUNT ON

	IF dbo.fnPjm6CanEditBudget(@ID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END		

	SET @RecurrencePatternID = (SELECT [RecurrencePatternID] FROM [Document] 
		WHERE [Class] = dbo.adfGetClassByName('Pjm6.Budget') AND [ID] = @ID)

	BEGIN TRANSACTION

	DELETE FROM [Budget] WHERE [Budget].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	--DELETE FROM [RecurrencePattern] WHERE [ID] = @RecurrencePatternID
	--IF @@ERROR != 0
	--BEGIN
	--	ROLLBACK TRANSACTION
	--	RETURN 1
	--END

	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetDelete TO PUBLIC
GO