IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetLineExpenseDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetLineExpenseDelete'
		DROP PROCEDURE [dbo].[pjm6BudgetLineExpenseDelete]
	END
GO

PRINT 'Creating procedure pjm6BudgetLineExpenseDelete'
GO

/******************************************************************************
**		File: pjm6BudgetLineExpenseDelete.sql
**		Name: pjm6BudgetLineExpenseDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 17/11/2010 15:20:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
*******************************************************************************/
CREATE PROCEDURE pjm6BudgetLineExpenseDelete
	@ID	TIdentifier
	
AS
	DECLARE
		@BudgetID						TIdentifier,
		@BudgetState					TState,
		@BudgetLineGroupID				TIdentifier
	
	SET NOCOUNT ON

	SELECT 
		@BudgetID = [BudgetID],
		@BudgetLineGroupID = [BudgetLineGroupID] 
	FROM 
		[BudgetLineExpense] 
	WHERE 
		[ID] = @ID
	SET @BudgetState = (SELECT [State] FROM [Budget] WHERE [ID] = @BudgetID)	

	IF dbo.fnPjm6CanEditBudget(@BudgetID) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @BudgetState NOT IN (1,4,5)
	BEGIN
		RAISERROR('#budgetIsOpenOrClosed', 18, -1)
		RETURN 1
	END

	DECLARE
		@Order	TCount
	SET @Order = (SELECT [Order] FROM [BudgetLineExpense] WHERE [ID] = @ID)
	BEGIN TRANSACTION

	DELETE FROM [BudgetLineExpense] WHERE ID = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END 

	UPDATE [BudgetLineExpense]
		SET [Order] = [Order] - 1
	WHERE 
		[Order] > @Order AND [BudgetID] = @BudgetID
		AND 
		ISNULL([BudgetLineGroupID], 0) = ISNULL(@BudgetLineGroupID, 0)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END 

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm6BudgetLineExpenseDelete TO PUBLIC
GO