﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetMyControlForCalculationBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetMyControlForCalculationBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetMyControlForCalculationBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetMyControlForCalculationBrowse'
GO

/******************************************************************************
**		File: BudgetMyControlForCalculationBrowse.sql
**		Name: pjm6BudgetMyControlForCalculationBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 11/01/2011 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetMyControlForCalculationBrowse]
	@BudgetTypeSelector			TIdentifier,
	@ProjectManagerEmployeeID	TIdentifier,
	@CostCenterSelector			TIdentifier,
	@CostCenterID				TIdentifier,
	@Date						TDate
AS
	DECLARE
		@Lang			TLanguage--,
		--@Date			TDate

	SET @Lang = dbo.adfGetLanguage()
	SET @Date = CAST(CONVERT(varchar(8), @Date, 112) as datetime)

	SELECT
		[Budget].[Class],
		[Budget].[ID],
		[Budget].[State],
		[Budget].[Flag],
		CASE @Lang
			WHEN 'en' THEN 'Budget for project ''' + [Project].[Number] + '''' ELSE
			'Бюджет по проекту ''' + [Project].[Number] + '''' END as [FileAs],
		[Budget].[WarningFlagID],
		[BudgetWarningFlag].[WarningType],
		[Project].[Number] AS [ProjectCode],
		[Project].[FileAs] AS [ProjectFileAs],
		[Project].[ProjectManagerEmployeeID],
		[Budget].[BudgetTypeID],
		dbo.fnPjm6GetBudgetPeriodName([Budget].[StartDate], [Budget].[EndDate], [BudgetTypeID], @Lang, 1) AS [Period],
		[Budget].[LastCalculationDate],
		[Budget].[NextCalculationDate],
		DATEDIFF(day,[NextCalculationDate], @Date) AS [DaysFromCalculation],
		[Budget].[CurrencyCode],		
		[Budget].[WorkBudgetBottom],
		[Budget].[WorkBudgetHigh],
		[Budget].[ExpenseBudgetBottom],
		[Budget].[ExpenseBudgetHigh],
		[Budget].[PlannedManHour],
		[Budget].[ActualManHour],
		[Budget].[PlannedManHourWithSub],
		[Budget].[ActualManHourWithSub],

		[Budget].[TotalPCPlannedManHour] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour]) 
			AS [TotalWDPlannedManHour],--Работа без НДС с учетом скидки, план
		[Budget].[TotalPCActualManHour] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour]) 
			AS [TotalWDActualManHour],--Работа без НДС с учетом скидки, факт
		
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
			AS [TotalWithVATPCWDPlannedManHour],--Работы с НДС, план
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
			AS [TotalWithVATPCWDActualManHour],--Работа С НДС, факт

		[Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense])
			AS [TotalWDPlannedExpense],--Затраты без НДС с учетом скидки, план
		[Budget].[TotalPCActualExpense] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense])
			AS [TotalWDActualExpense],--Затраты без НДС со скидкой, факт

		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense])
			AS [TotalWithVATPCWDPlannedExpense],--Затраты с НДС, план		
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalWithVATPCActualExpense])		
			AS [TotalWithVATPCWDActualExpense],--Затраты с НДС, факт
		
		[Budget].[TotalPCWDPlannedManHourWithSub] AS [TotalWDPlannedManHourWithSub],--Работа без НДС с  учетом скидки с п/п, план
		[Budget].[TotalPCWDActualManHourWithSub]  AS [TotalWDActualManHourWithSub],--Работа без НДС с  учетом скидки с п/п, факт

		[Budget].[TotalWithVATPCWDPlannedManHourWithSub] AS [TotalWithVATPCWDPlannedManHourWithSub],--Работа с НДС с п/п, план
		[Budget].[TotalWithVATPCWDActualManHourWithSub] AS [TotalWithVATPCWDActualManHourWithSub],--Работа с НДС с п/п, факт

		[Budget].[TotalPCWDPlannedExpenseWithSub] AS [TotalWDPlannedExpenseWithSub],--Затраты без НДС с п/п, план
		[Budget].[TotalPCWDActualExpenseWithSub] AS [TotalWDActualExpenseWithSub],--Затраты без НДС с учетом скидки с п/п, факт

		[Budget].[TotalWithVATPCWDPlannedExpenseWithSub] AS [TotalWithVATPCWDPlannedExpenseWithSub],--Затраты с НДС  с п/п, план
		[Budget].[TotalWithVATPCWDActualExpenseWithSub] AS [TotalWithVATPCWDActualExpenseWithSub],--Затраты с НДС с п/п, факт

		--Процент исполнения планового времени
		(CASE WHEN [PlannedManHour] > 0 THEN 
			ROUND(([ActualManHour]) / [PlannedManHour], 2)
			ELSE
				0
		END) AS [PercentOverdraftManHour],
		--Процент исполнения планового времени с подбюджетами
		(CASE WHEN [PlannedManHourWithSub] > 0 THEN 
			ROUND([ActualManHourWithSub] / [PlannedManHourWithSub], 2) 
			ELSE
				0
		END) AS [PercentOverdraftManHourWithSub],
		--Процент исполнения плана по работам
		(CASE WHEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) > 0 THEN 
			ROUND( dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour]) 
			/ dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]), 2) 
			ELSE
				0
		END) AS [PercentOverdraftTotalWDManHour],
		--Процент исполнения плана по затратам
		(CASE WHEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) > 0 THEN
			ROUND( dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalPCActualExpense] + dbo.fnPjm6GetVATForTotal([TotalPCActualExpense], [VATRate], 0, 1)) 
			/ dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)), 2) 
			ELSE
				0
		END) AS [PercentOverdraftTotalWDExpense],
		--Процент исполнения плана по работам с подбюджетами
		(CASE WHEN (CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN [Budget].[TotalWithVATPCWDPlannedManHourWithSub] ELSE [Budget].[TotalPCWDPlannedManHourWithSub] END) > 0 THEN
			ROUND((CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN [Budget].[TotalWithVATPCWDActualManHourWithSub] ELSE [Budget].[TotalPCWDActualManHourWithSub] END) 
			/ (CASE WHEN [VATRate] IS NOT NULL AND [VATIsIncluded] = 1 THEN [Budget].[TotalWithVATPCWDPlannedManHourWithSub] ELSE [Budget].[TotalPCWDPlannedManHourWithSub] END), 2) 
			ELSE
				0
		END) AS [PercentOverdraftTotalWDManHourWithSub],
		--Процент исполнения плана по затратам с подбюджетами
		(CASE WHEN (CASE WHEN [VATRate] IS NOT NULL THEN [Budget].[TotalWithVATPCWDPlannedExpenseWithSub] ELSE [Budget].[TotalPCWDPlannedExpenseWithSub] END) > 0 THEN
			ROUND((CASE WHEN [VATRate] IS NOT NULL THEN [Budget].[TotalWithVATPCWDActualExpenseWithSub] ELSE [Budget].[TotalPCWDActualExpenseWithSub] END)
			/ (CASE WHEN [VATRate] IS NOT NULL THEN [Budget].[TotalWithVATPCWDPlannedExpenseWithSub] ELSE [Budget].[TotalPCWDPlannedExpenseWithSub] END), 2) 
			ELSE
			 0
		END) AS [PercentOverdraftTotalWDExpenseWithSub],
		ISNULL([BudgetWarningFlagGlobal].[FileAs], [BudgetWarningFlag].[FileAs]) AS [WarningText],
		[Budget].[Comments],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy],
		[Budget].[Timestamp],
		[Project].[CostCenterID],
		[Project].[CustomerCompanyID],
		[Project].[SupplierCompanyID]
	FROM
		[Budget]
		INNER JOIN [Project]
			ON ([Budget].[DocumentID] = [Project].[ID])
		LEFT OUTER JOIN [BudgetWarningFlag]
			ON ([Budget].[WarningFlagID] = [BudgetWarningFlag].[ID])
		LEFT OUTER JOIN [BudgetWarningFlagGlobal] 
			ON ([BudgetWarningFlag].[ID] = [BudgetWarningFlagGlobal].[ID]
				AND [BudgetWarningFlagGlobal].[Language] = @Lang)
	WHERE
		[Budget].[NextCalculationDate] <= @Date AND [Budget].[NextCalculationDate] IS NOT NULL AND
		([Budget].[SupervisorEmployeeID] = dbo.adfGetCurrentEmployeeID()) AND
		((@BudgetTypeSelector = 0) OR ([Budget].[BudgetTypeID] = @BudgetTypeSelector)) AND
		(@ProjectManagerEmployeeID IS NULL OR [Project].[ProjectManagerEmployeeID] = @ProjectManagerEmployeeID) AND 
		((@CostCenterSelector = 0) OR (@CostCenterSelector = 1 AND ([Project].[CostCenterID] = @CostCenterID OR (@CostCenterID IS NULL AND [Project].[CostCenterID] IS NULL)))) AND
		[Budget].[State] = 2 AND
		(dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1 OR dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1)

RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetMyControlForCalculationBrowse] TO PUBLIC
GO