﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetTemplateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetTemplateUpdate'
		DROP PROCEDURE [dbo].[pjm6BudgetTemplateUpdate]
	END
GO

PRINT 'Creating procedure pjm6BudgetTemplateUpdate'
GO

/******************************************************************************
**		File: pjm6BudgetTemplateUpdate.sql
**		Name: pjm6BudgetTemplateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 09/12/2010 16:01:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetTemplateUpdate]
	@Xml	XML
AS
	DECLARE
		@ID								TIdentifier,
		@State							TState,
		@FileAs							TName,
		@BudgetTypeID					TIdentifier,
		@UseWorkPlanning				TBool,
		@UseExpensePlanning				TBool,
		@CurrencyCode					TCode3,
		@VATIsIncluded					TBool,
		@VATRate						TPercent,
		@Comments						TNotes,
		@value							TVariant,
		@WorkBudgetBottom				TMoney,
		@WorkBudgetHigh					TMoney,
		@WorkBudgetBottomEqualsPlan		TBool,
		@WorkBudgetHighEqualsPlan		TBool,
		@ExpenseBudgetBottom			TMoney,
		@ExpenseBudgetHigh				TMoney,
		@ExpenseBudgetBottomEqualsPlan	TBool,
		@ExpenseBudgetHighEqualsPlan	TBool,
		@SupervisorEmployeeID			TIdentifier,
		@DiscountViewWork				TBool,
		@DiscountPercentWork			TPercent,
		@DiscountTotalWork				TMoney,
		@DiscountPercentWorkFinal		TPercent,
		@DiscountTotalWorkFinal			TMoney,
		@DiscountTypeWork				TCount,
		@DiscountViewExpense			TBool,
		@DiscountPercentExpense			TPercent,
		@DiscountTotalExpense			TMoney,
		@DiscountPercentExpenseFinal	TPercent,
		@DiscountTotalExpenseFinal		TMoney,
		@DiscountTypeExpense			TCount,
		@PlanningActivityForWork		TBool,
		@PlanningEmployeeForWork		TBool,
		@PlanningQualificationForWork	TBool,
		@PlanningRateForWork			TBool,
		@PlanningDateForWork			TBool,
		@PlanningExpenseTypeForExpense	TBool,
		@PlanningEmployeeForExpense		TBool,
		@PlanningPriceForExpense		TBool,
		@PlanningDateForExpense			TBool,
		@TimeEntryAccount				TIdentifier,
		@TimeEntrySendingForApprovalAccount TBool,
		@TimeEntryActualTotalsAccount	TIdentifier,
		@ExpenseAccount					TIdentifier,
		@ExpenseSendingForApprovalAccount TBool,
		@doc				int

	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageBudgetTemplates')) != 1 
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET NOCOUNT ON

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ID = [ID],
		@FileAs = [FileAs],
		@BudgetTypeID = [BudgetTypeID],
		@UseWorkPlanning = [UseWorkPlanning],
		@UseExpensePlanning = [UseExpensePlanning],
		@CurrencyCode = [CurrencyCode],
		@VATIsIncluded = [VATIsIncluded],
		@WorkBudgetBottom = [WorkBudgetBottom],
		@WorkBudgetHigh = [WorkBudgetHigh],
		@WorkBudgetBottomEqualsPlan = [WorkBudgetBottomEqualsPlan],
		@WorkBudgetHighEqualsPlan = [WorkBudgetHighEqualsPlan],
		@ExpenseBudgetBottom = [ExpenseBudgetBottom],
		@ExpenseBudgetHigh = [ExpenseBudgetHigh],
		@ExpenseBudgetBottomEqualsPlan = [ExpenseBudgetBottomEqualsPlan],
		@ExpenseBudgetHighEqualsPlan = [ExpenseBudgetHighEqualsPlan],
		@SupervisorEmployeeID = [SupervisorEmployeeID],
		@DiscountViewWork = [DiscountViewWork],
		@DiscountPercentWork = ABS([DiscountPercentWork]),
		@DiscountTotalWork = ABS([DiscountTotalWork]),
		@DiscountTypeWork = [DiscountTypeWork],
		@DiscountViewExpense = [DiscountViewExpense],
		@DiscountPercentExpense = ABS([DiscountPercentExpense]),
		@DiscountTotalExpense = ABS([DiscountTotalExpense]),
		@DiscountTypeExpense = [DiscountTypeExpense],
		@PlanningActivityForWork = [PlanningActivityForWork],
		@PlanningEmployeeForWork = [PlanningEmployeeForWork],
		@PlanningQualificationForWork = [PlanningQualificationForWork],
		@PlanningRateForWork = [PlanningRateForWork],
		@PlanningDateForWork = [PlanningDateForWork],
		@PlanningExpenseTypeForExpense = [PlanningExpenseTypeForExpense],
		@PlanningEmployeeForExpense = [PlanningEmployeeForExpense],
		@PlanningPriceForExpense = [PlanningPriceForExpense],
		@PlanningDateForExpense = [PlanningDateForExpense],
		@TimeEntryAccount = [TimeEntryAccount],
		@TimeEntrySendingForApprovalAccount = [TimeEntrySendingForApprovalAccount],
		@TimeEntryActualTotalsAccount = [TimeEntryActualTotalsAccount],
		@ExpenseAccount = [ExpenseAccount],
		@ExpenseSendingForApprovalAccount = [ExpenseSendingForApprovalAccount],
		@Comments = [Comments]
	FROM 
		OPENXML(@doc, '/pjm6BudgetTemplateGet/BudgetTemplate', 2)
			WITH (
			[ID] int,
			[FileAs] nvarchar(256),
			[BudgetTypeID] int,
			[UseWorkPlanning] bit,
			[UseExpensePlanning] bit,
			[CurrencyCode] char(3),
			[VATIsIncluded] bit,
			[WorkBudgetBottom] money,
			[WorkBudgetHigh] money,
			[WorkBudgetBottomEqualsPlan] bit,
			[WorkBudgetHighEqualsPlan] bit,
			[ExpenseBudgetBottom] money,
			[ExpenseBudgetHigh] money,
			[ExpenseBudgetBottomEqualsPlan] bit,
			[ExpenseBudgetHighEqualsPlan] bit,
			[PaymentCurrencyPoint] int,
			[SupervisorEmployeeID] int,
			[DiscountViewWork] bit,
			[DiscountPercentWork] decimal(18,4),
			[DiscountTotalWork] decimal,
			[DiscountTypeWork] int,
			[DiscountViewExpense] bit,
			[DiscountPercentExpense] decimal(18,4),
			[DiscountTotalExpense] decimal,
			[DiscountTypeExpense] int,
			[PlanningActivityForWork] bit,
			[PlanningEmployeeForWork] bit,
			[PlanningQualificationForWork] bit,
			[PlanningRateForWork] bit,
			[PlanningDateForWork] bit,
			[PlanningExpenseTypeForExpense] bit,
			[PlanningEmployeeForExpense] bit,
			[PlanningPriceForExpense] bit,
			[PlanningDateForExpense] bit,
			[TimeEntryAccount] int,
			[TimeEntrySendingForApprovalAccount] bit,
			[TimeEntryActualTotalsAccount] int,
			[ExpenseAccount] int,
			[ExpenseSendingForApprovalAccount] bit,
			[Comments] nvarchar(max)
			)
	
	IF(@DiscountTypeWork != 0 AND ((@DiscountViewWork = 0 AND @DiscountPercentWork IS NULL) OR (@DiscountViewWork = 1 AND @DiscountTotalWork IS NULL))) OR
		(@DiscountTypeExpense != 0 AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense IS NULL) OR (@DiscountViewExpense = 1 AND @DiscountTotalExpense IS NULL)))
	BEGIN
		RAISERROR('#DiscountIsNotDefined', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
			
	IF ((@DiscountTypeWork = 1 OR @DiscountTypeWork = 2) AND ((@DiscountViewWork = 0 AND @DiscountPercentWork = 0) OR
		(@DiscountViewWork = 1 AND @DiscountTotalWork = 0))) OR
		((@DiscountTypeExpense = 1 OR @DiscountTypeExpense = 2) AND ((@DiscountViewExpense = 0 AND @DiscountPercentExpense = 0) OR
		(@DiscountViewExpense = 1 AND @DiscountTotalExpense = 0)))
	BEGIN
		RAISERROR('#DiscountCantBeZero', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @PlanningActivityForWork = 0 AND @PlanningEmployeeForWork = 0 AND 
		@PlanningQualificationForWork = 0 AND @PlanningRateForWork = 0
	BEGIN
		RAISERROR('#WorkPlanningParametersIsNull', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @PlanningExpenseTypeForExpense = 0 AND @PlanningEmployeeForExpense = 0 AND @PlanningPriceForExpense = 0
	BEGIN
		RAISERROR('#ExpensePlanningParametersIsNull', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND @UseExpensePlanning = 0 
	BEGIN
		RAISERROR('#BudgetMustHaveItemForPlanning', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseWorkPlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineWork] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 1 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseExpensePlanning = 0 AND (EXISTS(SELECT *FROM [BudgetLineExpense] WHERE [BudgetID] = @ID) OR
		EXISTS(SELECT *FROM [BudgetLineGroup] WHERE [BudgetID] = @ID AND [State] = 1 AND [GroupTypeID] = 2 ))
	BEGIN
		RAISERROR('#BudgetHasLinesOrGroupsForPlanningItem', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	SET @DiscountPercentWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 0 THEN -@DiscountPercentWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 0 THEN @DiscountPercentWork ELSE NULL END
									END
	SET @DiscountTotalWorkFinal = CASE @DiscountTypeWork 
									WHEN 0 THEN NULL 
									WHEN 1 THEN 
										CASE WHEN @DiscountViewWork = 1 THEN -@DiscountTotalWork ELSE NULL END
									WHEN 2 THEN
										CASE WHEN @DiscountViewWork = 1 THEN @DiscountTotalWork ELSE NULL END
									END
	SET @DiscountPercentExpenseFinal = CASE @DiscountTypeExpense 
										WHEN 0 THEN NULL 
										WHEN 1 THEN 
											CASE WHEN @DiscountViewExpense = 0 THEN -@DiscountPercentExpense ELSE NULL END
										WHEN 2 THEN
											CASE WHEN @DiscountViewExpense = 0 THEN @DiscountPercentExpense ELSE NULL END
										END
	SET @DiscountTotalExpenseFinal = CASE @DiscountTypeExpense 
										WHEN 0 THEN NULL 
										WHEN 1 THEN 
											CASE WHEN @DiscountViewExpense = 1 THEN -@DiscountTotalExpense ELSE NULL END
										WHEN 2 THEN
											CASE WHEN @DiscountViewExpense = 1 THEN @DiscountTotalExpense ELSE NULL END
										END

	BEGIN TRANSACTION

	UPDATE [Budget]
	SET
		[Budget].[FileAs] = @FileAs,
		[Budget].[CurrencyCode] = @CurrencyCode,
		[Budget].[VATIsIncluded] = @VATIsIncluded,
		[Budget].[BudgetTypeID] = @BudgetTypeID,
		[Budget].[UseWorkPlanning] = @UseWorkPlanning,
		[Budget].[UseExpensePlanning] = @UseExpensePlanning,
		[Budget].[WarningFlagID] = NULL,
		[Budget].[WorkBudgetBottom] = (CASE @WorkBudgetBottomEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetBottom END),
		[Budget].[WorkBudgetHigh] = (CASE @WorkBudgetHighEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithDiscount([VATRate], [VATIsIncluded], @DiscountViewWork, @DiscountPercentWorkFinal, @DiscountTotalWorkFinal, [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour]) ELSE @WorkBudgetHigh END) ,
		[Budget].[WorkBudgetBottomEqualsPlan] = @WorkBudgetBottomEqualsPlan,
		[Budget].[WorkBudgetHighEqualsPlan] = @WorkBudgetHighEqualsPlan,
		[Budget].[ExpenseBudgetBottom] =(CASE @ExpenseBudgetBottomEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], @DiscountViewExpense, @DiscountPercentExpenseFinal, @DiscountTotalExpenseFInal, [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) ELSE @ExpenseBudgetBottom END),
		[Budget].[ExpenseBudgetHigh] = (CASE @ExpenseBudgetHighEqualsPlan WHEN 1 THEN dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], @DiscountViewExpense, @DiscountPercentExpenseFinal, @DiscountTotalExpenseFinal, [TotalPCPlannedExpense], [TotalPCPlannedExpense] + dbo.fnPjm6GetVATForTotal([TotalPCPlannedExpense], [VATRate], 0, 1)) ELSE @ExpenseBudgetHigh END),
		[Budget].[ExpenseBudgetBottomEqualsPlan] = @ExpenseBudgetBottomEqualsPlan,
		[Budget].[ExpenseBudgetHighEqualsPlan] = @ExpenseBudgetHighEqualsPlan,
		[Budget].[SupervisorEmployeeID] = @SupervisorEmployeeID,
		[Budget].[DiscountViewWork] = @DiscountViewWork,
		[Budget].[DiscountPercentWork] = @DiscountPercentWorkFinal,
		[Budget].[DiscountTotalWork] = @DiscountTotalWorkFinal,
		[Budget].[DiscountViewExpense] = @DiscountViewExpense,
		[Budget].[DiscountPercentExpense] = @DiscountPercentExpenseFinal,
		[Budget].[DiscountTotalExpense] = @DiscountTotalExpenseFinal,
		[Budget].[PlanningActivityForWork] = @PlanningActivityForWork,
		[Budget].[PlanningEmployeeForWork] = @PlanningEmployeeForWork,
		[Budget].[PlanningQualificationForWork] = @PlanningQualificationForWork,
		[Budget].[PlanningRateForWork] = @PlanningRateForWork,
		[Budget].[PlanningDateForWork] = @PlanningDateForWork,
		[Budget].[PlanningExpenseTypeForExpense] = @PlanningExpenseTypeForExpense,
		[Budget].[PlanningEmployeeForExpense] = @PlanningEmployeeForExpense,
		[Budget].[PlanningPriceForExpense] = @PlanningPriceForExpense,
		[Budget].[PlanningDateForExpense] = @PlanningDateForExpense,
		[Budget].[TimeEntryAccount] = @TimeEntryAccount,
		[Budget].[TimeEntrySendingForApprovalAccount] = @TimeEntrySendingForApprovalAccount,
		[Budget].[TimeEntryActualTotalsAccount] = @TimeEntryActualTotalsAccount,
		[Budget].[ExpenseAccount] = @ExpenseAccount,
		[Budget].[ExpenseSendingForApprovalAccount] = @ExpenseSendingForApprovalAccount,
		[Budget].[Comments] = @Comments,
		[Budget].[Modified] = DEFAULT,
		[Budget].[ModifiedBy] = DEFAULT
	WHERE
		[Budget].[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm6.BudgetTemplate')
	UPDATE 
		[Document]
	SET 
		[Flag] = [Budget].[Flag], 
		[FileAs] = [Budget].[FileAs], 
		[Modified] = [Budget].[Modified], 
		[ModifiedBy] = [Budget].[ModifiedBy]
	FROM
		[Document]
		INNER JOIN [Budget]
			ON [Document].[ID] = [Budget].[ID] AND
				[Document].[Class] = @TemplateClass
	WHERE
		[Budget].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	COMMIT TRANSACTION
	
	EXEC sp_xml_removedocument @doc	

	EXEC pjm6BudgetTemplateGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetTemplateUpdate] TO PUBLIC
GO  