﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetWithOverdraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetWithOverdraftBrowse'
		DROP PROCEDURE [dbo].[pjm6BudgetWithOverdraftBrowse]
	END
GO

PRINT 'Creating procedure pjm6BudgetWithOverdraftBrowse'
GO

/******************************************************************************
**		File: BudgetWithOverdraftBrowse.sql
**		Name: pjm6BudgetWithOverdraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 11/01/2011 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.03.13	MAB				Исправление подсчета суммы превышения
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetWithOverdraftBrowse]
	@BudgetTypeSelector			TIdentifier,
	@StateSelector				TIdentifier,
	@OverdraftSelector			TIdentifier,
	@OverdraftLineTypeSelector	TIdentifier,
	@ProjectManagerEmployeeID	TIdentifier,
	@DateSelector				TIdentifier,
	@PeriodStart				TDate,
	@PeriodEnd					TDate,
	@CostCenterSelector			TIdentifier,
	@CostCenterID				TIdentifier
AS
	DECLARE
		@Lang			TLanguage,
		@Now			TDate

	SET @Now = GETDATE()
	IF @DateSelector = 1
		SET @PeriodStart = CAST(CAST(YEAR(@Now) AS varchar(4)) + '0101' AS datetime)
	ELSE IF @DateSelector = 2
		SET @PeriodStart = CAST(CAST(YEAR(@Now)-1 AS varchar(4)) + '0101' AS datetime)
	ELSE IF @DateSelector = 3
		SET @PeriodStart = DATEADD(day, 1-DATEPART(dayofyear, @PeriodStart), @PeriodStart)
	SET @PeriodStart = CONVERT(datetime, CONVERT(varchar(8), @PeriodStart, 112), 112)
	SET @PeriodEnd = DATEADD(year, 1, @PeriodStart)

	SET @Lang = dbo.adfGetLanguage()

		SELECT
		[Budget].[Class],
		[Budget].[ID],
		[Budget].[State],
		[Budget].[Flag],
			CASE @Lang
			WHEN 'en' THEN 'Budget for project ''' + [Project].[Number] + '''' ELSE
			'Бюджет по проекту ''' + [Project].[Number] + '''' END as [FileAs],
		[Budget].[WarningFlagID],
		[BudgetWarningFlag].[WarningType],
		[Project].[Number] AS [ProjectCode],
		[Project].[FileAs] AS [ProjectFileAs],
		[Project].[ProjectManagerEmployeeID],
		[Budget].[BudgetTypeID],
		dbo.fnPjm6GetBudgetPeriodName([Budget].[StartDate], [Budget].[EndDate], [BudgetTypeID], @Lang, 1) AS [Period],
		[Budget].[LastCalculationDate],
		[Budget].[NextCalculationDate],
		[Budget].[CurrencyCode],		
		[Budget].[WorkBudgetBottom],
		[Budget].[WorkBudgetHigh],
		[Budget].[ExpenseBudgetBottom],
		[Budget].[ExpenseBudgetHigh],
		[Budget].[PlannedManHour],
		[Budget].[ActualManHour],
		[Budget].[PlannedManHourWithSub],
		[Budget].[ActualManHourWithSub],

		[Budget].[TotalPCPlannedManHour] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour]) 
			AS [TotalWDPlannedManHour],--Работа без НДС с учетом скидки, план
		[Budget].[TotalPCActualManHour] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour]) 
			AS [TotalWDActualManHour],--Работа без НДС с учетом скидки, факт
		
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCPlannedManHour], [TotalWithVATPCPlannedManHour])
			AS [TotalWithVATPCWDPlannedManHour],--Работы с НДС, план
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewWork], [DiscountPercentWork], [DiscountTotalWork], [TotalPCActualManHour], [TotalWithVATPCActualManHour])
			AS [TotalWithVATPCWDActualManHour],--Работа С НДС, факт

		[Budget].[TotalPCPlannedExpense] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense])
			AS [TotalWDPlannedExpense],--Затраты без НДС с учетом скидки, план
		[Budget].[TotalPCActualExpense] + dbo.fnPjm6GetBudgetTotalDiscount([DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense])
			AS [TotalWDActualExpense],--Затраты без НДС со скидкой, факт

		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCPlannedExpense], [TotalWithVATPCPlannedExpense])
			AS [TotalWithVATPCWDPlannedExpense],--Затраты с НДС, план		
		dbo.fnPjm6GetBudgetTotalWithVATWD([VATRate], [VATIsIncluded], [DiscountViewExpense], [DiscountPercentExpense], [DiscountTotalExpense], [TotalPCActualExpense], [TotalWithVATPCActualExpense])		
			AS [TotalWithVATPCWDActualExpense],--Затраты с НДС, факт
		
		[Budget].[TotalPCWDPlannedManHourWithSub] AS [TotalWDPlannedManHourWithSub],--Работа без НДС с  учетом скидки с п/п, план
		[Budget].[TotalPCWDActualManHourWithSub]  AS [TotalWDActualManHourWithSub],--Работа без НДС с  учетом скидки с п/п, факт

		[Budget].[TotalWithVATPCWDPlannedManHourWithSub] AS [TotalWithVATPCWDPlannedManHourWithSub],--Работа с НДС с п/п, план
		[Budget].[TotalWithVATPCWDActualManHourWithSub] AS [TotalWithVATPCWDActualManHourWithSub],--Работа с НДС с п/п, факт

		[Budget].[TotalPCWDPlannedExpenseWithSub] AS [TotalWDPlannedExpenseWithSub],--Затраты без НДС с п/п, план
		[Budget].[TotalPCWDActualExpenseWithSub] AS [TotalWDActualExpenseWithSub],--Затраты без НДС с учетом скидки с п/п, факт

		[Budget].[TotalWithVATPCWDPlannedExpenseWithSub] AS [TotalWithVATPCWDPlannedExpenseWithSub],--Затраты с НДС  с п/п, план
		[Budget].[TotalWithVATPCWDActualExpenseWithSub] AS [TotalWithVATPCWDActualExpenseWithSub],--Затраты с НДС с п/п, факт

		--Сумма превышения
		(CASE 
			WHEN @OverdraftSelector = 0 THEN
				(CASE 
					WHEN @OverdraftLineTypeSelector = 0 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) > dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																												[VATIsIncluded], 
																												[DiscountViewWork], 
																												[DiscountPercentWork], 
																												[DiscountTotalWork],
																												[TotalPCPlannedManHour],
																												[TotalWithVATPCPlannedManHour]
																											) THEN
								dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) - dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																												[VATIsIncluded], 
																												[DiscountViewWork], 
																												[DiscountPercentWork], 
																												[DiscountTotalWork],
																												[TotalPCPlannedManHour],
																												[TotalWithVATPCPlannedManHour]
																											)
							ELSE
								0
						END)
					WHEN @OverdraftLineTypeSelector = 1 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	)	>	dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																													[VATIsIncluded], 
																													[DiscountViewExpense],
																													[DiscountPercentExpense], 
																													[DiscountTotalExpense],
																													[TotalPCPlannedExpense],
																													[TotalWithVATPCPlannedExpense]
																												) THEN
								dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	)	-	dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																													[VATIsIncluded], 
																													[DiscountViewExpense],
																													[DiscountPercentExpense], 
																													[DiscountTotalExpense],
																													[TotalPCPlannedExpense],
																													[TotalWithVATPCPlannedExpense]
																												)	
							ELSE
								0
						END)
				END)
			WHEN @OverdraftSelector = 1 THEN
				(CASE 
					WHEN @OverdraftLineTypeSelector = 0 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) >	[Budget].[WorkBudgetBottom] THEN
								dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) -	[Budget].[WorkBudgetBottom]	
							ELSE
								0
						END)
					WHEN @OverdraftLineTypeSelector = 1 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) >	[Budget].[ExpenseBudgetBottom] THEN
								dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) -	[Budget].[ExpenseBudgetBottom]	
							ELSE
								0
						END)
				END)
			WHEN @OverdraftSelector = 2 THEN
				(CASE 
					WHEN @OverdraftLineTypeSelector = 0 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) > [Budget].[WorkBudgetHigh] THEN
								 dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) - [Budget].[WorkBudgetHigh]	
							ELSE
								0
						END)
					WHEN @OverdraftLineTypeSelector = 1 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) > [Budget].[ExpenseBudgetHigh] THEN
								dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) - [Budget].[ExpenseBudgetHigh]	
							ELSE
								0
						END)
				END)
		END) AS [BudgetOverdraftTotal],
		--Процент превышения
		(CASE 
			WHEN @OverdraftSelector = 0 THEN
				(CASE 
					WHEN @OverdraftLineTypeSelector = 0 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) > dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																												[VATIsIncluded], 
																												[DiscountViewWork], 
																												[DiscountPercentWork], 
																												[DiscountTotalWork],
																												[TotalPCPlannedManHour],
																												[TotalWithVATPCPlannedManHour]
																											) AND
								 dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCPlannedManHour],
																		[TotalWithVATPCPlannedManHour]
																	) > 0 THEN
								ROUND((100 * dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																					[VATIsIncluded], 
																					[DiscountViewWork], 
																					[DiscountPercentWork], 
																					[DiscountTotalWork],
																					[TotalPCActualManHour], 
																					[TotalWithVATPCActualManHour]
																				)) / dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																															[VATIsIncluded], 
																															[DiscountViewWork], 
																															[DiscountPercentWork], 
																															[DiscountTotalWork],
																															[TotalPCPlannedManHour],
																															[TotalWithVATPCPlannedManHour]
																														), 2) - 100
							ELSE
								0
						END)
					WHEN @OverdraftLineTypeSelector = 1 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) >	dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																												[VATIsIncluded], 
																												[DiscountViewExpense],
																												[DiscountPercentExpense], 
																												[DiscountTotalExpense],
																												[TotalPCPlannedExpense],
																												[TotalWithVATPCPlannedExpense]
																											) AND
								 dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense],
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense],
																		[TotalPCPlannedExpense],
																		[TotalWithVATPCPlannedExpense]
																	) > 0 THEN
								ROUND((100 * dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																					[VATIsIncluded], 
																					[DiscountViewExpense], 
																					[DiscountPercentExpense], 
																					[DiscountTotalExpense], 
																					[TotalPCActualExpense], 
																					[TotalWithVATPCActualExpense]
																				)) / dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																															[VATIsIncluded], 
																															[DiscountViewExpense],
																															[DiscountPercentExpense], 
																															[DiscountTotalExpense],
																															[TotalPCPlannedExpense],
																															[TotalWithVATPCPlannedExpense]
																														), 2) - 100
							ELSE
								0
						END)
				END)
			WHEN @OverdraftSelector = 1 THEN
				(CASE 
					WHEN @OverdraftLineTypeSelector = 0 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) >	[Budget].[WorkBudgetBottom] AND 
								 [Budget].[WorkBudgetBottom] > 0 THEN
								ROUND((100 * dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																					[VATIsIncluded], 
																					[DiscountViewWork], 
																					[DiscountPercentWork], 
																					[DiscountTotalWork],
																					[TotalPCActualManHour], 
																					[TotalWithVATPCActualManHour]
																				)) / ([Budget].[WorkBudgetBottom]), 2) - 100
							ELSE
								0
						END)
					WHEN @OverdraftLineTypeSelector = 1 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) > [Budget].[ExpenseBudgetBottom] AND 
								 [Budget].[ExpenseBudgetBottom] > 0 THEN
								ROUND((100 * dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																					[VATIsIncluded], 
																					[DiscountViewExpense], 
																					[DiscountPercentExpense], 
																					[DiscountTotalExpense], 
																					[TotalPCActualExpense], 
																					[TotalWithVATPCActualExpense]
																				)) / ([Budget].[ExpenseBudgetBottom]), 2) - 100
							ELSE
								0
						END)
				END)
			WHEN @OverdraftSelector = 2 THEN
				(CASE 
					WHEN @OverdraftLineTypeSelector = 0 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewWork], 
																		[DiscountPercentWork], 
																		[DiscountTotalWork],
																		[TotalPCActualManHour], 
																		[TotalWithVATPCActualManHour]
																	) > [Budget].[WorkBudgetHigh] AND 
								 [Budget].[WorkBudgetHigh] > 0 THEN
								ROUND((100 * dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																					[VATIsIncluded], 
																					[DiscountViewWork], 
																					[DiscountPercentWork], 
																					[DiscountTotalWork],
																					[TotalPCActualManHour], 
																					[TotalWithVATPCActualManHour]
																				)) / ([Budget].[WorkBudgetHigh]), 2) - 100
							ELSE
								0
						END)
					WHEN @OverdraftLineTypeSelector = 1 THEN
						(CASE 
							WHEN dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																		[VATIsIncluded], 
																		[DiscountViewExpense], 
																		[DiscountPercentExpense], 
																		[DiscountTotalExpense], 
																		[TotalPCActualExpense], 
																		[TotalWithVATPCActualExpense]
																	) > [Budget].[ExpenseBudgetHigh] AND 
								 [Budget].[ExpenseBudgetHigh] > 0 THEN
								ROUND((100 * dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																					[VATIsIncluded], 
																					[DiscountViewExpense], 
																					[DiscountPercentExpense], 
																					[DiscountTotalExpense], 
																					[TotalPCActualExpense], 
																					[TotalWithVATPCActualExpense]
																				)) / ([Budget].[ExpenseBudgetHigh]), 2) - 100
							ELSE
								0
						END)
				END)
		END) AS [BudgetOverdraftPercent],
		ISNULL([BudgetWarningFlagGlobal].[FileAs], [BudgetWarningFlag].[FileAs]) AS [WarningText],
		[Budget].[Comments],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy],
		[Budget].[Timestamp],
		[Project].[CostCenterID],
		[Project].[CustomerCompanyID],
		[Project].[SupplierCompanyID]
	FROM
		[Budget]
		INNER JOIN [Project]
			ON ([Budget].[DocumentID] = [Project].[ID])
		LEFT OUTER JOIN [BudgetWarningFlag]
			ON ([Budget].[WarningFlagID] = [BudgetWarningFlag].[ID])
		LEFT OUTER JOIN [BudgetWarningFlagGlobal] 
			ON ([BudgetWarningFlag].[ID] = [BudgetWarningFlagGlobal].[ID]
				AND [BudgetWarningFlagGlobal].[Language] = @Lang)
	WHERE
		((@BudgetTypeSelector = 0) OR ([Budget].[BudgetTypeID] = @BudgetTypeSelector)) AND
		((@StateSelector = 0) OR ([Budget].[State] = @StateSelector + 1)) AND
		(
			(
				@OverdraftSelector = 0 AND 
				(
					(
						@OverdraftLineTypeSelector = 0 AND 
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewWork], 
																[DiscountPercentWork], 
																[DiscountTotalWork],
																[TotalPCActualManHour], 
																[TotalWithVATPCActualManHour]
															) > dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																										[VATIsIncluded], 
																										[DiscountViewWork], 
																										[DiscountPercentWork], 
																										[DiscountTotalWork],
																										[TotalPCPlannedManHour],
																										[TotalWithVATPCPlannedManHour]
																									) AND 
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewWork], 
																[DiscountPercentWork], 
																[DiscountTotalWork],
																[TotalPCPlannedManHour],
																[TotalWithVATPCPlannedManHour]
															) > 0
					) OR
					(
						@OverdraftLineTypeSelector = 1 AND 
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewExpense], 
																[DiscountPercentExpense], 
																[DiscountTotalExpense], 
																[TotalPCActualExpense], 
																[TotalWithVATPCActualExpense]
															) >	dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																										[VATIsIncluded], 
																										[DiscountViewExpense],
																										[DiscountPercentExpense], 
																										[DiscountTotalExpense],
																										[TotalPCPlannedExpense],
																										[TotalWithVATPCPlannedExpense]
																									) AND
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewExpense],
																[DiscountPercentExpense], 
																[DiscountTotalExpense],
																[TotalPCPlannedExpense],
																[TotalWithVATPCPlannedExpense]
															) > 0
					)
				) 
			) OR
			(
				@OverdraftSelector = 1 AND
				(
					(
						@OverdraftLineTypeSelector = 0 AND 
						[Budget].[WorkBudgetBottom] > 0 AND
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewWork], 
																[DiscountPercentWork], 
																[DiscountTotalWork],
																[TotalPCActualManHour], 
																[TotalWithVATPCActualManHour]
															) > [Budget].[WorkBudgetBottom]
					) OR
					(
						@OverdraftLineTypeSelector = 1 AND 
						[Budget].[ExpenseBudgetBottom] > 0 AND
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewExpense], 
																[DiscountPercentExpense], 
																[DiscountTotalExpense], 
																[TotalPCActualExpense], 
																[TotalWithVATPCActualExpense]
															) > [Budget].[ExpenseBudgetBottom]
					) 
				)
			)OR
			(
				@OverdraftSelector = 2 AND 
				(
					(
						@OverdraftLineTypeSelector = 0 AND
						[Budget].[WorkBudgetHigh] > 0 AND
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewWork], 
																[DiscountPercentWork], 
																[DiscountTotalWork],
																[TotalPCActualManHour], 
																[TotalWithVATPCActualManHour]
															) > [Budget].[WorkBudgetHigh]
					) OR
					(
						@OverdraftLineTypeSelector = 1 AND 
						[Budget].[ExpenseBudgetHigh] > 0 AND
						dbo.fnPjm6GetBudgetTotalWithVATWD	(	[VATRate], 
																[VATIsIncluded], 
																[DiscountViewExpense], 
																[DiscountPercentExpense], 
																[DiscountTotalExpense], 
																[TotalPCActualExpense], 
																[TotalWithVATPCActualExpense]
															) > [Budget].[ExpenseBudgetHigh]
					)
				)
			)
		) AND
		((@CostCenterSelector = 0) OR (@CostCenterSelector = 1 AND ([Project].[CostCenterID] = @CostCenterID OR (@CostCenterID IS NULL AND [Project].[CostCenterID] IS NULL)))) AND
		(@ProjectManagerEmployeeID IS NULL OR [Project].[ProjectManagerEmployeeID] = @ProjectManagerEmployeeID) AND 
		(
			(
				[Budget].[BudgetTypeID] = 1 
				AND
				(
					@DateSelector = 0 
					OR 
					(
						[Project].[Date] < @PeriodEnd AND ISNULL([Project].[EndDate], @Now)  > @PeriodStart
					)
				)
			)
			OR
			(
				[Budget].[BudgetTypeID] > 1 
				AND
				(
					@DateSelector = 0 
					OR 
					(
						[Budget].[StartDate] < @PeriodEnd AND ISNULL([Budget].[EndDate], @Now)  > @PeriodStart
					)
				)
			)
		)
		AND
		(dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1 OR dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1)

	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetWithOverdraftBrowse] TO PUBLIC
GO


