 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationGet'
		DROP PROCEDURE [dbo].[pjm5CalculationGet]
	END
GO

PRINT 'Creating procedure pjm5CalculationGet'
GO

/******************************************************************************
**		File: pjm5CalculationGet.sql
**		Name: pjm5CalculationGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		03.12.10	SYV				  AdvanceFlag    
**		30.03.11	SYV				    "  "
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@timeClass TClass,
		@CalculationClass TClass,
		@AdvanceValue TMoney,
		@AdvanceVAT TMoney,
		@ProjectID TIdentifier,
		@AdvanceFlag TBool,
		@serviceRequestClass TClass,
		@RatesWithVAT TBool,
		@VATRate TPercent
		
	SELECT 
		@AdvanceValue = ISNULL(SUM([Calculation].[TotalWithVATPC]), 0),
		@AdvanceVAT = ISNULL(SUM([Calculation].[VATPC]), 0),
		@AdvanceFlag = CASE WHEN COUNT(*) = 0 THEN 0 ELSE 1 END
	FROM
		[CalculationAdvance] 
		INNER JOIN [Calculation]
			ON [Calculation].[ID] = [CalculationAdvance].[AdvanceCalculationID]
	WHERE
		[CalculationAdvance].[CalculationID] = @ID

	SELECT 
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@CalculationClass = [DocumentClass],
		@ProjectID = [ProjectID],
		@RatesWithVAT = [RatesWithVAT],
		@VATRate = [VATRate]
	FROM
		[Calculation]
	WHERE
		[ID] = @ID

	SET @serviceRequestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, @CalculationClass, NULL) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	IF @CalculationClass != @timeClass AND @CalculationClass != @serviceRequestClass
		SET @AdvanceFlag = 0
		
	DECLARE @lines TABLE (
		[ID] int,
		[DocumentState] int,
		[DocumentClass] int,
		[DocumentID] int,
		[Date] datetime,
		[EmployeeID] int,
		[EmployeeName] nvarchar(256),
		[Description] nvarchar(max),
		[Amount] decimal(18, 4),
		[Price] money,
		[PriceWithVAT] money,
		[Sum] money,
		[VATIsIncluded] bit,
		[VAT] money,
		[SumWithoutVAT] money,
		[SumWithVAT] money
		)
	INSERT INTO @lines 
		(
		[ID],
		[DocumentState],
		[DocumentClass],
		[DocumentID],
		[Date],
		[EmployeeID],
		[EmployeeName],
		[Description],
		[Amount],
		[Price],
		[PriceWithVAT],
		[Sum],
		[VATIsIncluded],
		[VAT],
		[SumWithoutVAT],
		[SumWithVAT])
	SELECT
		[pjm5vwCalculationLine].[ID],
		[pjm5vwCalculationLine].[DocumentState],
		[pjm5vwCalculationLine].[DocumentClass],
		[pjm5vwCalculationLine].[DocumentID],
		[pjm5vwCalculationLine].[Date],
		[Employee].[ID] AS [EmployeeID],
		[Employee].[FileAs] AS [EmployeeName],
		[pjm5vwCalculationLine].[Description],
		[pjm5vwCalculationLine].[Amount],
		CASE
					WHEN  @CalculationClass != @timeClass
						THEN
							CASE 
								WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
									THEN [pjm5vwCalculationLine].[Price]
								WHEN [pjm5vwCalculationLine].[Amount] != 0
									THEN [pjm5vwCalculationLine].[Price] - [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
								ELSE [pjm5vwCalculationLine].[Price] / (1 + @VATRate)
							END
					ELSE CASE
							WHEN [pjm5vwCalculationLine].[VATIsIncluded] = @RatesWithVAT
								THEN [pjm5vwCalculationLine].[Price]
							WHEN [pjm5vwCalculationLine].[Amount] != 0
								THEN [pjm5vwCalculationLine].[Price] - 
									SIGN(([pjm5vwCalculationLine].[VATIsIncluded] * 2) - 1) * [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
							WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
								THEN [pjm5vwCalculationLine].[Price] * (1 + @VATRate)
							ELSE [pjm5vwCalculationLine].[Price] / (1 + @VATRate)
					END
				END
		AS [Price],
		CASE 
				WHEN [pjm5vwCalculationLine].[VAT] = 0 OR [pjm5vwCalculationLine].[VATIsIncluded] = 1
					THEN [pjm5vwCalculationLine].[Price]
				WHEN [pjm5vwCalculationLine].[Amount] != 0
					THEN [pjm5vwCalculationLine].[Price] + [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
				ELSE [pjm5vwCalculationLine].[Price] * (1 + @VATRate)
			END
		AS [PriceWithVAT],
		[pjm5vwCalculationLine].[Amount] * 
				CASE
					WHEN [pjm5vwCalculationLine].[VATIsIncluded] = @RatesWithVAT
						THEN [pjm5vwCalculationLine].[Price]
					WHEN [pjm5vwCalculationLine].[Amount] != 0
						THEN [pjm5vwCalculationLine].[Price] - 
							SIGN(([pjm5vwCalculationLine].[VATIsIncluded] * 2) - 1) * [pjm5vwCalculationLine].[VAT] / [pjm5vwCalculationLine].[Amount]
					WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
						THEN [pjm5vwCalculationLine].[Price] * (1 + @VATRate)
					ELSE [pjm5vwCalculationLine].[Price] / (1 + @VATRate)
				END
		AS [Sum],
		@RatesWithVAT AS [VATIsIncluded],
		[pjm5vwCalculationLine].[VAT],
		[pjm5vwCalculationLine].[Amount] * [pjm5vwCalculationLine].[Price] - [pjm5vwCalculationLine].[VATIsIncluded] * [pjm5vwCalculationLine].[VAT]
		AS [SumWithoutVAT],
		CASE 
			WHEN [pjm5vwCalculationLine].[VATIsIncluded] = 0
				THEN [pjm5vwCalculationLine].[Amount] * [pjm5vwCalculationLine].[Price] + [pjm5vwCalculationLine].[VAT]
			ELSE [pjm5vwCalculationLine].[Price] * [pjm5vwCalculationLine].[Amount]
		END AS [SumWithVAT]
	FROM
		[pjm5vwCalculationLine]
		INNER JOIN [Calculation] 
			ON [pjm5vwCalculationLine].[CalculationID] = [Calculation].[ID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [pjm5vwCalculationLine].[EmployeeID]
	WHERE
		[pjm5vwCalculationLine].[CalculationID] = @ID

	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Flag],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[ProjectID],
		[Project].[SupplierCompanyID],
		[Project].[CustomerCompanyID],
		[Calculation].[DocumentClass],
		[Calculation].[PeriodStart],
		[Calculation].[PeriodEnd],
		[Calculation].[ServiceTypeID],
		[Calculation].[Description],
		[Calculation].[Comments],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Calculation].[VATRate],
		@RatesWithVAT AS [VATIsIncluded],
		[Calculation].[VAT],
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[TotalPC],
		[Calculation].[TotalWithVATPC],
		[Calculation].[VATPC],
		[Project].[ContractNumber],
		ISNULL(@AdvanceValue, 0.0) AS [AdvanceValue],
		ISNULL(@AdvanceVAT, 0.0) AS [AdvanceVAT],
		@AdvanceFlag AS [AdvanceFlag],
		[CalculationAdvance].[CalculationID],
		[Calculation].[Scale],
		[Calculation].[InvoiceApproved],
		[Calculation].[StatementApproved],

		[Calculation].[Discount],
		[Calculation].[DiscountPC],
		[Calculation].[DiscountType],
		[Calculation].[DiscountView],
		[Calculation].[DiscountPercent],
		[Calculation].[TotalWithoutDiscount],
		[Calculation].[TotalWithVATWithoutDiscount],
		[Calculation].[VATWithoutDiscount],
		[Calculation].[TotalWithoutDiscountPC],
		[Calculation].[TotalWithVATWithoutDiscountPC],
		[Calculation].[VATWithoutDiscountPC],
		[Calculation].[RatesWithVAT],
		[Calculation].[EditedInProjectCurrency]
	FROM
		[Calculation]
		INNER JOIN [Project]
			ON [Project].[ID] = [Calculation].[ProjectID]
		LEFT OUTER JOIN [CalculationAdvance]
			ON [CalculationAdvance].[AdvanceCalculationID] = [Calculation].[ID]
	WHERE
		[Calculation].[ID] = @ID

	SELECT
		[ID],
		[DocumentState],
		[DocumentClass],
		[DocumentID],
		[Date],
		[EmployeeID],
		[EmployeeName],
		[Description],
		[Amount],
		[Price],
		[PriceWithVAT],
		[Sum],
		[VATIsIncluded],
		[VAT],
		[SumWithoutVAT],
		[SumWithVAT]
	FROM
		@lines
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationGet] TO PUBLIC
GO
