IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationUpdate'
		DROP PROCEDURE [dbo].[pjm5CalculationUpdate]
	END
GO

PRINT 'Creating procedure pjm5CalculationUpdate'
GO

/******************************************************************************
**		File: pjm5CalculationUpdate.sql
**		Name: pjm5CalculationUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		31.03.11	SYV				   
**		12.04.11	SYV				  RatesWithVAT
*******************************************************************************/
CREATE PROCEDURE pjm5CalculationUpdate
	@Xml XML
AS
	
	SET NOCOUNT ON
	DECLARE
			@ID TIdentifier,
			@Date TDate,
			@State TState,
			@Number TCode,
			@FileAs TName,
			@ProjectID TIdentifier,
			@DocumentClass TClass,
			@PeriodStart TDate,
			@PeriodEnd TDate,
			@ServiceTypeID TIdentifier,
			@CurrencyCode TCode,
			@Description TNotes,
			@Comments TNotes,
			@Scale TCount,
			@doc int,
			@Discount TAmount,
			@DiscountPC TAmount,
			@DiscountPercent TPercent,
			@DiscountView TBool,
			@DiscountType TIdentifier,
			@RatesWithVAT TBool,
			@VATRate TPercent,
			@EditedInProjectCurrency TBool,
			@EmployeeID TIdentifier,

			@ProjectCurrencyCode TCode,
			@Cost TMoney,
			@CostPC TMoney,
			@TotalAdvanced TMoney, 
			@TotalWithVATAdvanced TMoney, 
			@VATAdvanced TMoney,
			@TotalWithoutDiscount TMoney, 
			@TotalWithVATWithoutDiscount TMoney, 
			@TotalWithoutDiscountPC TMoney, 
			@TotalWithVATWithoutDiscountPC TMoney,
			@Total TMoney, 
			@TotalWithVAT TMoney, 
			@TotalPC TMoney, 
			@TotalWithVATPC TMoney,
			
			@OldDiscount TAmount,
			@OldDiscountPC TAmount,
			@OldDiscountPercent TPercent,
			@OldDiscountView TBool,
			@OldDiscountType TIdentifier,
			@RecalculateDiscount	TBool,
			@RecalculateSystemTotals TBool,
			@timeClass TClass

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID = [XmlTable].[ID],
		@Date = CAST([XmlTable].[Date] AS datetime),
		@State = [Calculation].[State],
		@Number = [XmlTable].[Number],
		@FileAs = [XmlTable].[FileAs],
		@ProjectID = [XmlTable].[ProjectID],
		@DocumentClass = [XmlTable].[DocumentClass],
		@PeriodStart = CAST([XmlTable].[PeriodStart] AS datetime),
		@PeriodEnd = CAST([XmlTable].[PeriodEnd] AS datetime),
		@ServiceTypeID = [XmlTable].[ServiceTypeID],
		@Description = [XmlTable].[Description],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		@Comments = [XmlTable].[Comments],
		@Scale = [XmlTable].[Scale],
		@Discount = [XmlTable].[Discount],
		@DiscountPC = [XmlTable].[DiscountPC],
		@DiscountPercent = [XmlTable].[DiscountPercent],
		@DiscountView = [XmlTable].[DiscountView],
		@DiscountType = [XmlTable].[DiscountType],
		@RatesWithVAT = [XmlTable].[RatesWithVAT],
		@VATRate = [XmlTable].[VATRate],
		@EditedInProjectCurrency = [XmlTable].[EditedInProjectCurrency],
		@OldDiscount = [Calculation].[Discount],
		@OldDiscountPC = [Calculation].[DiscountPC],
		@OldDiscountPercent = [Calculation].[DiscountPercent],
		@OldDiscountView = [Calculation].[DiscountView],
		@OldDiscountType = [Calculation].[DiscountType],
		@TotalWithoutDiscount = [Calculation].[TotalWithoutDiscountAndAdvanced],
		@TotalWithVATWithoutDiscount = [Calculation].[TotalWithVATWithoutDiscountAndAdvanced],
		@TotalWithoutDiscountPC = [Calculation].[TotalWithoutDiscountAndAdvancedPC],
		@TotalWithVATWithoutDiscountPC = [Calculation].[TotalWithVATWithoutDiscountAndAdvancedPC],
		@ProjectCurrencyCode = [Project].[CurrencyCode]
	FROM
		OPENXML(@doc, '/pjm5CalculationGet/Calculation', 2)
			WITH (
				[ID] int,
				[Date] nvarchar(19),
				[Number] varchar(32),
				[FileAs] nvarchar(512),
				[ProjectID] int,
				[DocumentClass] int,
				[PeriodStart] nvarchar(19),
				[PeriodEnd] nvarchar(19),
				[ServiceTypeID] int,
				[CurrencyCode] varchar(32),
				[Description] nvarchar(max),
				[Comments] nvarchar(max),
				[Scale] int,
				[Discount] decimal(18,4),
				[DiscountPC] decimal(18,4),
				[DiscountPercent] decimal(18,4),
				[DiscountView] bit,
				[DiscountType] int,
				[RatesWithVAT] bit,
				[VATRate] decimal(18,4),
				[EditedInProjectCurrency] bit
				) AS [XmlTable]
	INNER JOIN [Calculation]
		ON [Calculation].[ID] = [XmlTable].[ID]
	INNER JOIN [Project]
		ON [Calculation].[ProjectID] = [Project].[ID]

	EXEC sp_xml_removedocument @doc

	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	IF dbo.adfHasAccessRightByName('ManageAllCalculations') = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
		
	IF @State = 3
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		RETURN 1
	END

	SET @RecalculateDiscount = 0
	SET @RecalculateSystemTotals = 0
	--     
	IF @DiscountType != @OldDiscountType OR (@DiscountType = @OldDiscountType AND @DiscountView != @OldDiscountView) OR
		(@DiscountType = @OldDiscountType AND @DiscountView = @OldDiscountView AND @DiscountView = 0 AND @DiscountPercent != @OldDiscountPercent) OR 
		(@DiscountType = @OldDiscountType AND @DiscountView = @OldDiscountView AND @DiscountView = 1 AND (@Discount != @OldDiscount OR  @DiscountPC != @OldDiscountPC))
	BEGIN
		SET @RecalculateDiscount = 1
		--          ,   
		IF @TotalWithoutDiscount IS NULL OR @TotalWithoutDiscountPC IS NULL
		BEGIN
			SET @RecalculateSystemTotals = 1
			IF @DocumentClass = @timeClass
			BEGIN
				SELECT
					@TotalWithoutDiscount = ISNULL(SUM(
						[CalculationLine].[Amount] * [CalculationLine].[Price] - @RatesWithVAT * [CalculationLine].[VAT]), 0),
					@TotalWithVATWithoutDiscount = ISNULL(SUM(
						[CalculationLine].[Amount] * [CalculationLine].[Price] - (@RatesWithVAT - 1) * [CalculationLine].[VAT]), 0)
				FROM
					[Calculation]
					INNER JOIN [CalculationLine]
						ON [CalculationLine].[CalculationID] = [Calculation].[ID]
				WHERE
					[Calculation].[ID] = @ID
			END
			ELSE
			BEGIN
				SELECT
					@TotalWithoutDiscount = ISNULL(SUM(
						CASE 
							WHEN [CalculationLine].[VATIsIncluded] = 0
								THEN [CalculationLine].[Amount] * [CalculationLine].[Price]
							ELSE [CalculationLine].[Amount] * [CalculationLine].[Price] / (1 + @VATRate)
						END), 0),		
					@TotalWithVATWithoutDiscount = ISNULL(SUM(
						CASE 
							WHEN [CalculationLine].[VATIsIncluded] = 0
								THEN [CalculationLine].[Amount] * [CalculationLine].[Price] + [CalculationLine].[VAT]
							ELSE [CalculationLine].[Amount] * [CalculationLine].[Price]
						END), 0),
					@TotalWithoutDiscountPC = SUM([Expense].[TotalPC]),
					@TotalWithVATWithoutDiscountPC = SUM(
						CASE
							WHEN [Expense].[VATRate] = @VATRate
								THEN [Expense].[TotalWithVATPC]
							ELSE ([Expense].[TotalWithVATPC] - [Expense].[VATPC]) * (1 + @VATRate)
						END)
				FROM
					[Calculation]
					INNER JOIN [CalculationLine]
						ON [CalculationLine].[CalculationID] = [Calculation].[ID]
					LEFT OUTER JOIN [Expense]
						ON [Expense].[Class] = [CalculationLine].[DocumentClass] AND
							[Expense].[ID] = [CalculationLine].[DocumentID]
				WHERE
					[Calculation].[ID] = @ID
			END

			SET @TotalWithoutDiscount = ISNULL(@TotalWithoutDiscount, 0)
			SET @TotalWithVATWithoutDiscount = ISNULL(@TotalWithVATWithoutDiscount, 0)
			SET @TotalWithoutDiscountPC  = ISNULL(@TotalWithoutDiscountPC, @TotalWithoutDiscount)
			SET @TotalWithVATWithoutDiscountPC = ISNULL(@TotalWithVATWithoutDiscountPC, @TotalWithVATWithoutDiscount)
		END

		
		--     
		SET @Cost = @TotalWithoutDiscount * (1 - @RatesWithVAT) + @TotalWithVATWithoutDiscount * @RatesWithVAT
		SET @CostPC = @TotalWithoutDiscountPC * (1 - @RatesWithVAT) + @TotalWithVATWithoutDiscountPC * @RatesWithVAT
		
		SELECT 
			@TotalAdvanced = ISNULL(SUM([Calculation].[TotalPC]), 0),
			@VATAdvanced = ISNULL(SUM([Calculation].[VATPC]), 0),
			@TotalWithVATAdvanced = ISNULL(SUM([Calculation].[TotalWithVATPC]), 0)
		FROM
			[CalculationAdvance]
			INNER JOIN [Calculation]
				ON [CalculationAdvance].[AdvanceCalculationID] = [Calculation].[ID]
		WHERE 
			[CalculationAdvance].[CalculationID] = @ID

		--   
		SET @Discount = CASE WHEN @DiscountView = 0
							THEN @Cost * @DiscountPercent
						ELSE CASE WHEN @CurrencyCode = @ProjectCurrencyCode OR @EditedInProjectCurrency = 0
									THEN @Discount
								ELSE CASE WHEN @CostPC = 0
											THEN 0
										ELSE (@DiscountPC / @CostPC) * @Cost
									END
							END
					END
		SET @DiscountPC = CASE WHEN @DiscountView = 0
							THEN @CostPC * @DiscountPercent
						ELSE CASE WHEN @CurrencyCode = @ProjectCurrencyCode OR @EditedInProjectCurrency = 1
									THEN @DiscountPC
								ELSE CASE WHEN @Cost = 0
											THEN 0
										ELSE (@Discount / @Cost) * @CostPC
									END
							END
					END
		SET @DiscountPercent = CASE WHEN @DiscountView = 0
									THEN @DiscountPercent
								ELSE CASE WHEN @EditedInProjectCurrency = 1
											THEN CASE WHEN @CostPC = 0
														THEN 0
													ELSE @DiscountPC / @CostPC
												END
										ELSE CASE WHEN @Cost = 0
														THEN 0
													ELSE @Discount / @Cost
												END
									END
							END
	
		SET @Cost = dbo.fnPjm6GetCalculationTotal(@DiscountType, @DiscountView, @DiscountPercent, @Discount, @Cost)
		SET @CostPC = dbo.fnPjm6GetCalculationTotal(@DiscountType, @DiscountView, @DiscountPercent, @DiscountPC, @CostPC)

		SET @Total = (1 - @RatesWithVAT) * @Cost + @RatesWithVAT * @Cost / (1 + @VATRate) + (@TotalWithVATAdvanced - @VATAdvanced)
		SET @TotalWithVAT = @RatesWithVAT * @Cost + (1 - @RatesWithVAT) * @Cost * (1 + @VATRate) + (@TotalWithVATAdvanced - @VATAdvanced) * (1 + @VATRate)
		SET @TotalPC = (1 - @RatesWithVAT) * @CostPC + @RatesWithVAT * @CostPC / (1 + @VATRate) + (@TotalWithVATAdvanced - @VATAdvanced)
		SET @TotalWithVATPC = @RatesWithVAT * @CostPC + (1 - @RatesWithVAT) * @CostPC * (1 + @VATRate) + (@TotalWithVATAdvanced - @VATAdvanced) * (1 + @VATRate)
	END

	BEGIN TRANSACTION

	UPDATE 
		[Calculation]
	SET
		[Calculation].[Date] = @Date,
		[Calculation].[Number] = @Number,
		[Calculation].[FileAs] = @FileAs,
		[Calculation].[ProjectID] = @ProjectID,
		[Calculation].[DocumentClass] = @DocumentClass,
		[Calculation].[PeriodStart] = @PeriodStart,
		[Calculation].[PeriodEnd] = @PeriodEnd,
		[Calculation].[ServiceTypeID] = @ServiceTypeID,
		[Calculation].[CurrencyCode] = @CurrencyCode,
		[Calculation].[Description] = @Description,
		[Calculation].[Comments] = @Comments,
		[Calculation].[Scale] = @Scale,
		[Calculation].[Discount] = @Discount,
		[Calculation].[DiscountPC] = @DiscountPC,
		[Calculation].[DiscountPercent] = @DiscountPercent,
		[Calculation].[DiscountView] = @DiscountView,
		[Calculation].[DiscountType] = @DiscountType,
		[Calculation].[RatesWithVAT] = @RatesWithVAT,
		[Calculation].[VATRate] = @VATRate,
		[Calculation].[EditedInProjectCurrency] = @EditedInProjectCurrency,
		[Calculation].[Total] = CASE WHEN @RecalculateDiscount = 1 THEN @Total ELSE [Total] END,
		[Calculation].[TotalWithVAT] =  CASE WHEN @RecalculateDiscount = 1 THEN @TotalWithVAT ELSE [TotalWithVAT] END,
		[Calculation].[TotalPC] = CASE WHEN @RecalculateDiscount = 1 THEN @TotalPC ELSE [TotalPC] END,
		[Calculation].[TotalWithVATPC] =  CASE WHEN @RecalculateDiscount = 1 THEN @TotalWithVATPC ELSE [TotalWithVATPC] END,
		[Calculation].[TotalWithoutDiscountAndAdvanced] =  CASE WHEN @RecalculateSystemTotals = 1 THEN @TotalWithoutDiscount ELSE [TotalWithoutDiscountAndAdvanced] END, 
		[Calculation].[TotalWithVATWithoutDiscountAndAdvanced] = CASE WHEN @RecalculateSystemTotals = 1 THEN @TotalWithVATWithoutDiscount ELSE [TotalWithVATWithoutDiscountAndAdvanced] END, 
		[Calculation].[TotalWithoutDiscountAndAdvancedPC] = CASE WHEN @RecalculateSystemTotals = 1 THEN @TotalWithoutDiscountPC ELSE [TotalWithoutDiscountAndAdvancedPC] END, 
		[Calculation].[TotalWithVATWithoutDiscountAndAdvancedPC] = CASE WHEN @RecalculateSystemTotals = 1 THEN @TotalWithVATWithoutDiscountPC ELSE [TotalWithVATWithoutDiscountAndAdvancedPC] END, 
		[Calculation].[Modified] = DEFAULT,
		[Calculation].[ModifiedBy] = DEFAULT
	WHERE 
		[Calculation].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm5CalculationGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CalculationUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationUpdateLine]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationUpdateLine'
		DROP PROCEDURE [dbo].[pjm5CalculationUpdateLine]
	END
GO

PRINT 'Creating procedure pjm5CalculationUpdateLine'
GO

/******************************************************************************
**		File: pjm5CalculationUpdateLines.sql
**		Name: pjm5CalculationUpdateLines
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CalculationUpdateLine
	@ID TIdentifier,
	@Amount TAmount,
	@Price TMoney,
	@Description TNotes = NULL
AS
	
	SET NOCOUNT ON
	DECLARE @ProjectID TIdentifier,
			@VATRate TPercent,
			@DocumentClass TClass,
			@Scale TCount

	IF ISNULL((SELECT [State] FROM [Calculation] WHERE [ID] = @ID), 0) = 3
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		RETURN 1
	END

	SET @VATRate = 0
	SELECT 
		@VATRate = [Calculation].[VATRate],
		@DocumentClass = [CalculationLine].[DocumentClass],
		@Price = ISNULL(@Price, [CalculationLine].[Price]),
		@Amount = ISNULL(@Amount, [CalculationLine].[Amount]),
		@Scale = [Calculation].[Scale],
		@ProjectID = [Project].[ID]
	FROM 
		[Project]
		INNER JOIN [Calculation]
			ON [Calculation].[ProjectID] = [Project].[ID]
		INNER JOIN [CalculationLine]
			ON [CalculationLine].[CalculationID] = [Calculation].[ID]
	WHERE
		[CalculationLine].[ID] = @ID
		
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllCalculations')) = 0 AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	BEGIN
		UPDATE
			[CalculationLine]
		SET
			[Amount] = @Amount,
			[Price] = @Price,
			[VAT] = CASE WHEN [CalculationLine].[VATIsIncluded] = 1
						THEN ROUND(@Amount * @Price * @VATRate / (1 + @VATRate), @Scale)
						ELSE ROUND(@Amount * @Price * @VATRate, @Scale)
					END,
			[Description] = ISNULL(@Description, [Description])
		FROM
			[CalculationLine]
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		UPDATE
			[CalculationLine]
		SET
			[Description] = ISNULL(@Description, [Description])
		FROM
			[CalculationLine]
		WHERE
			[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5CalculationUpdateLine TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationDeleteLine]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationDeleteLine'
		DROP PROCEDURE [dbo].[pjm5CalculationDeleteLine]
	END
GO

PRINT 'Creating procedure pjm5CalculationDeleteLine'
GO

/******************************************************************************
**		File: pjm5CalculationDeleteLines.sql
**		Name: pjm5CalculationDeleteLines
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 05/03/2005 11:14:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CalculationDeleteLine
	@ID TIdentifier
AS
	
	SET NOCOUNT ON

	IF ISNULL((SELECT [State] FROM [Calculation] WHERE [ID] = @ID), 0) = 3
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		RETURN 1
	END

	DECLARE @ProjectID TIdentifier
	SELECT @ProjectID = [Calculation].[ProjectID]
	FROM
		[CalculationLine]
		INNER JOIN [Calculation]
			ON [CalculationLine].[CalculationID] = [Calculation].[ID] AND [CalculationLine].[ID] = @ID

	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllCalculations')) = 0 AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	DELETE [CalculationLine] WHERE [ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON pjm5CalculationDeleteLine TO PUBLIC
GO
