 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CaseCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CaseCreate'
		DROP PROCEDURE [dbo].[pjm5CaseCreate]
	END
GO

PRINT 'Creating procedure pjm5CaseCreate'
GO

SET QUOTED_IDENTIFIER ON
GO

/******************************************************************************
**		File: pjm5CaseCreate.sql
**		Name: pjm5CaseCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CaseCreate]
	@Xml XML
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@State TState,
		@doc int
	
	SET @State = dbo.adfwfGetInitialState('6043fc81-6f77-4e97-8a83-c4a60cd990f0')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
		@FileAs TName,
		@Code TCode,
		@CompanyID TIdentifier,
		@EmployeeID TIdentifier,
		@StartDate TDate,
		@EndDate TDate,
		@NumberTemplate TName,
		@CurrentNumber TCount,
		@Increment TCount,
		@AllowInternal TBool,
		@AllowIncoming TBool,
		@AllowOutgoing TBool,
		@AllowFolder TBool,
		@HasToBeSentBack TBool,
		@Comments TNotes,
		@WordTemplatesFolderID TIdentifier,
		@WordTemplatesPath TNotes
		
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@FileAs = [XmlTable].[FileAs],
		@Code = [XmlTable].[Code],
		@CompanyID = [XmlTable].[CompanyID],
		@EmployeeID = [XmlTable].[EmployeeID],
		@StartDate = CAST([XmlTable].[StartDate] as datetime),
		@EndDate = CAST([XmlTable].[EndDate] as datetime),
		@NumberTemplate  = [XmlTable].[NumberTemplate],
		@CurrentNumber = [XmlTable].[CurrentNumber],
		@Increment = [XmlTable].[Increment],
		@AllowInternal = CASE WHEN [AllowInternal] = 'false' THEN 0 ELSE 1 END,
		@AllowIncoming = CASE WHEN [AllowIncoming] = 'false' THEN 0 ELSE 1 END,
		@AllowOutgoing = CASE WHEN [AllowOutgoing] = 'false' THEN 0 ELSE 1 END,
		@AllowFolder = CASE WHEN [AllowFolder] = 'false' THEN 0 ELSE 1 END,
		@HasToBeSentBack  = CASE WHEN [HasToBeSentBack] = 'false' THEN 0 ELSE 1 END,
		@Comments = [XmlTable].[Comments],
		@WordTemplatesFolderID = [XmlTable].[WordTemplatesFolderID],
		@WordTemplatesPath = [XmlTable].[WordTemplatesPath]
	FROM 
		OPENXML(@doc, '/pjm5CaseGet/Case', 2)
			WITH (
				[FileAs] nvarchar(512),
				[Code] nvarchar(32),
				[CompanyID] int,
				[EmployeeID] int,
				[StartDate] varchar(19),
				[EndDate] varchar(19),
				[NumberTemplate] nvarchar(512),
				[CurrentNumber] int,
				[Increment] int,
				[AllowInternal] varchar(5),
				[AllowIncoming] varchar(5),
				[AllowOutgoing] varchar(5),
				[AllowFolder] varchar(5),
				[HasToBeSentBack] varchar(5),
				[Comments] nvarchar(max),
				[WordTemplatesFolderID] int,
				[WordTemplatesPath] nvarchar(max)
				) AS [XmlTable]
	EXEC sp_xml_removedocument @doc

	BEGIN TRANSACTION
	INSERT INTO [Case]
		([State], 
		[Flag], 
		[Code],
		[FileAs],
		[CompanyID],
		[EmployeeID],
		[StartDate],
		[EndDate],
		[NumberTemplate],
		[CurrentNumber],
		[Increment],
		[AllowInternal],
		[AllowIncoming],
		[AllowOutgoing],
		[AllowFolder],
		[HasToBeSentBack],
		[Comments],
		[WordTemplatesFolderID],
		[WordTemplatesPath])
	VALUES
		(@State, 
		0, 
		@Code,
		@FileAs,
		@CompanyID,
		@EmployeeID,
		@StartDate,
		@EndDate,
		@NumberTemplate,
		@CurrentNumber,
		@Increment,
		@AllowInternal,
		@AllowIncoming,
		@AllowOutgoing,
		@AllowFolder,
		@HasToBeSentBack,
		@Comments,
		@WordTemplatesFolderID,
		@WordTemplatesPath)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [CaseOfFolder] ([FolderID], [CaseID], [Allowed])
	SELECT
		[Folder].[ID], @ID, 
		CASE WHEN ISNULL(T.C.value('.', 'int'), 0) = 0 THEN 1 ELSE 0 END
	FROM
		[Folder]
		OUTER APPLY [Folder].[Parameters].nodes('/Parameters/AllowClassFlag') T(C)
	WHERE
		[Folder].[CompanyID] = @CompanyID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	EXEC pjm5CaseGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CaseCreate TO PUBLIC
GO