IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm6AssistantRecurrenceGetNextDateTime]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6AssistantRecurrenceGetNextDateTime'
		DROP FUNCTION [dbo].[fnPjm6AssistantRecurrenceGetNextDateTime]
	END

GO

PRINT 'Creating function fnPjm6AssistantRecurrenceGetNextDateTime'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm6AssistantRecurrenceGetNextDateTime
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm6AssistantRecurrenceGetNextDateTime(
	@RecurrenceID	TIdentifier,
	@Datetime		TDatetime,
	@CurrentDate	TDatetime
	)
RETURNS TDatetime
AS
BEGIN
	DECLARE 
		@Result TDatetime,
		@TempResult TDateTime
		
	SET @Datetime = ISNULL(@Datetime, @CurrentDate)
	
	ExecFunction:
	
	DECLARE -- RECURRENCE
		@StartDate TDate, 
		@EndDate TDate, 
		@RecurrenceType TIdentifier, 
		@Occurrences TCount,
		@Interval TCount, 
		@DayOfWeekMask TIdentifier, 
		@Instance TIdentifier, 
		@MonthOfYear TCount, 
		@DayOfMonth TCount,
		@DayTransferRule TCount
		
	SELECT
		@StartDate = [StartDate], 
		@EndDate = [EndDate], 
		@RecurrenceType = [RecurrenceType], 
		@Occurrences = [Occurrences],
		@Interval = [Interval], 
		@DayOfWeekMask = [DayOfWeekMask], 
		@Instance = [Instance], 
		@MonthOfYear = [MonthOfYear], 
		@DayOfMonth = [DayOfMonth],
		@DayTransferRule = [DayTransferRule]
	FROM
		[AssistantRecurrencePattern]
	WHERE
		[ID] = @RecurrenceID
		
	IF @StartDate > @CurrentDate
		RETURN @Datetime
	IF @Occurrences IS NOT NULL AND @Occurrences = 0
		RETURN @Datetime
	IF @EndDate IS NOT NULL
	BEGIN
		IF @EndDate <= @CurrentDate
			RETURN @Datetime
		IF @EndDate <= @Datetime
			RETURN @Datetime
	END
		
	DECLARE
		@weekday int,
		@w int,
		@p int,
		@d datetime
	DECLARE 
		@delta int,----------------
		@count int
		
	IF @RecurrenceType = 0
	BEGIN
		IF @DayOfWeekMask = 0
			RETURN @Datetime
			
		SET @weekday = DATEPART(weekday, @Datetime)
		SET @w = @weekday
		
		IF @weekday = 7
			SET @weekday = 1
		ELSE
			SET @weekday = @weekday + 1
		WHILE @DayOfWeekMask != @DayOfWeekMask | POWER(2, @weekday - 1)
		BEGIN
			IF @weekday = 7
				SET @weekday = 1
			ELSE
				SET @weekday = @weekday + 1
		END

		SET @Result = @Datetime
		IF @w = 1 
		BEGIN
			SET @Result = DATEADD(week, @Interval, @Result)
			IF @weekday != 1
				SET @Result = DATEADD(day, @weekday - 8, @Result)
		END
		ELSE IF @w < @weekday OR @weekday = 1
		BEGIN
			IF @weekday = 1
				SET @Result = DATEADD(day, 8 - @w, @Result)
			ELSE
				SET @Result = DATEADD(day, @weekday - @w, @Result)
		END
		ELSE
		BEGIN
			SET @Result = DATEADD(week, @Interval, @Result)
			IF @weekday != 1
				SET @Result = DATEADD(day, @weekday - @w, @Result)
		END
	END
	ELSE IF @RecurrenceType = 1
	BEGIN
		IF @DayOfWeekMask = 0
			RETURN NULL
		
		DECLARE
			@Decade int,
			@Month int
			
		SET @Decade = 1
		SET @Month = 0
		SET @d = CAST(CAST(YEAR(@Datetime) AS varchar(4)) + '.' + CAST(MONTH(@Datetime) AS varchar(2)) + '.01' AS datetime)
		SET @Result = @d
		
		WHILE @Result <= @Datetime
		BEGIN
			IF @DayOfWeekMask = @DayOfWeekMask | POWER(2, @Decade + 6)
			BEGIN
				SET @Result = @d
				SET @Result = DATEADD(month, @Month, @Result)
			
				IF (@Interval = 5 AND @Decade = 3)
				BEGIN
					SET @Result = DATEADD(month, 1, @Result)
					SET @Result = DATEADD(day, -1, @Result)
				END
				ELSE IF (@Interval = 5)
					SET @Result = DATEADD(day, @Decade * 10 - 1, @Result)
				ELSE 
					SET @Result = DATEADD(day, (@Decade - 1) * 10 + @Interval - 1, @Result)
			END
			
			IF @Decade = 3
				BEGIN
					SET @Decade = 1
					SET @Month = @Month + 1
				END
				ELSE
					SET @Decade = @Decade + 1			
		END
	END
	ELSE IF @RecurrenceType = 2
	BEGIN
		SET @Result = DATEADD(day, 1 - DAY(@Datetime), @Datetime)
		SET @Result = DATEADD(month, @Interval, @Result)
		IF @DayOfMonth > DAY(DATEADD(day, -1, DATEADD(month, 1, @Result)))
			SET @DayOfMonth = DAY(DATEADD(day, -1, DATEADD(month, 1, @Result)))
		SET @Result = DATEADD(day, @DayOfMonth - 1, @Result)
	END
	ELSE IF @RecurrenceType = 3
	BEGIN
		SET @Result = DATEADD(day, 1 - DAY(@Datetime), @Datetime)
		SET @Result = DATEADD(month, @Interval, @Result)
		
		IF @Instance = 5 
		BEGIN
			SET @delta = -1 
			SET @count = 1
			SET @Result = DATEADD(day, -1, DATEADD(month, 1, @Result))
		END
		ELSE 
		BEGIN
			SET @delta = 1
			SET @count = @Instance
		END

		SET @weekday = DATEPART(weekday, @Result)
		WHILE @count != 0
		BEGIN
			WHILE @DayOfWeekMask != @DayOfWeekMask | POWER(2, @weekday - 1) 
			BEGIN
				SET @Result = DATEADD(day, @delta, @Result)
				SET @weekday = DATEPART(weekday, @Result)
			END
			IF @count > 1
			BEGIN
				SET @Result = DATEADD(day, @delta, @Result)
				SET @weekday = DATEPART(weekday, @Result)
			END
			SET @count = @count -1
		END
	END
	ELSE IF @RecurrenceType = 4
	BEGIN
		SET @Result = DATEADD(day, 1 - DAY(@Datetime), @Datetime)
		SET @Result = DATEADD(month, @MonthOfYear - MONTH(@Datetime), @Result)
		
		IF @DayOfMonth > DAY(DATEADD(day, -1, DATEADD(month, 1, @Result)))
			SET @DayOfMonth = DAY(DATEADD(day, -1, DATEADD(month, 1, @Result)))
		SET @Result = DATEADD(day, @DayOfMonth - 1, @Result)
		IF @Result <= @Datetime
			SET @Result = DATEADD(year, 1, @Result)
	END
	ELSE IF @RecurrenceType = 5
	BEGIN
		SET @Result = DATEADD(year, -1, @Datetime)
		WHILE (@Result <= @Datetime)
		BEGIN	
			SET	@Result = DATEADD(year, 1, @Result)		
			SET @Result = DATEADD(day, 1 - DAY(@Result), @Result)
			SET @Result = DATEADD(month, @MonthOfYear - MONTH(@Result), @Result)
			IF @Instance = 5 
			BEGIN
				SET @delta = -1 
				SET @count = 1
				SET @Result = DATEADD(day, -1, DATEADD(month, 1, @Result))
			END
			ELSE 
			BEGIN
				SET @delta = 1
				SET @count = @Instance
			END
			SET @weekday = DATEPART(weekday, @Result)
						
			WHILE @count != 0
				BEGIN
					WHILE @DayOfWeekMask != @DayOfWeekMask | POWER(2, @weekday - 1) 
				BEGIN
					SET @Result = DATEADD(day, @delta, @Result)
					SET @weekday = DATEPART(weekday, @Result)
				END
				IF @count > 1
				BEGIN
					SET @Result = DATEADD(day, @delta, @Result)
					SET @weekday = DATEPART(weekday, @Result)
				END
				SET @count = @count -1
			END
		END
	END
	
	SET @TempResult = dbo.fnPjm5AddWorkingDays(@Result, @DayTransferRule)
	
	If ((@EndDate IS NOT NULL AND @TempResult > @EndDate))
		RETURN @Datetime

	WHILE (@TempResult < @StartDate OR @TempResult <= @DateTime)
	BEGIN
		SET @Datetime = @Result
		GOTO ExecFunction	
	END	
	
	RETURN @TempResult
END
 