 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardGet'
		DROP PROCEDURE [dbo].[pjm5DocumentCardGet]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardGet'
GO

/******************************************************************************
**		File: pjm5DocumentCardGet.sql
**		Name: pjm5DocumentCardGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentCardGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @rv int
	EXEC @rv = pjm6DocumentCardCheckReadAccess @ID
	IF @rv != 0
		RETURN 1

	SELECT
		[DocumentCard].[Class],
		[DocumentCard].[ID],
		[DocumentCard].[State],
		[DocumentCard].[Flag],
		[DocumentCard].[FileAs],
		[DocumentCard].[FolderID],

		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DocumentCardID],

		[DocumentCard].[Number],
		[DocumentCard].[Date],
		[DocumentCard].[NumberIn],
		[DocumentCard].[DateIn],
		[DocumentCard].[NumberOut],
		[DocumentCard].[DateOut],

		[DocumentItem].[ID]		AS [DocumentItemID],
		[DocumentItem].[State]	AS [DocumentItemState],
		[DocumentItem].[Flag]	AS [DocumentItemFlag],
		[DocumentItem].[FileName],
		[DocumentItem].[LatestVersion],
		[DocumentItem].[Extension],
		[DocumentItem].[CheckedOutBy],
		
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[DivisionID],

		[DocumentCard].[Package],
		[DocumentCard].[Copy],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[StorePeriod], 
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[CaseID],
		[DocumentCard].[SentTime],
		[DocumentCard].[DocumentSendTypeID],
		ISNULL([Case].[AllowInternal], 1) AS [Internal],
		ISNULL([Case].[AllowIncoming], 0) AS [Incoming],
		ISNULL([Case].[AllowOutgoing], 0) AS [Outgoing],

		[DocumentCard].[HasToBeSentBack],
		[DocumentCard].[SentBackTime],
		[DocumentCard].[DocumentSendBackTypeID],

		[DocumentCard].[Comments],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		[DocumentCard].[Timestamp]
	FROM
		[DocumentCard]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
		LEFT OUTER JOIN [Case]
			ON [Case].[ID] = [DocumentCard].[CaseID]
		
	WHERE
		[DocumentCard].[ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentCardGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentGet'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentGet]
	END
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentGet'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentGet]
	END
GO

