IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemChangeStateInternal]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemChangeStateInternal'
		DROP PROCEDURE [dbo].[pjm5DocumentItemChangeStateInternal]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemChangeStateInternal'
GO

/******************************************************************************
**		File: pjm5DocumentItemChangeStateInternal.sql
**		Name: pjm5DocumentItemChangeStateInternal
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemChangeStateInternal
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@UserID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@Version TCount,
			@CreatedBy TIdentifier,
			@FolderID TIdentifier,
			@VersionControl TBool,
			@Extension TName,
			@rv int
	
	SET NOCOUNT ON

	IF @ToState = 4 SET @ToState = 1
	SELECT
		@Class = [DocumentItem].[Class],
		@FromState = [DocumentItem].[State],
		@Version = [DocumentItem].[LatestVersion],
		@Extension = [DocumentItem].[Extension],
		@FolderID = [Folder].[ID],
		@VersionControl = [Folder].[VersionControl],
		@CreatedBy = [DocumentItem].[CreatedBy]
	FROM
		[DocumentItem]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentItem].[FolderID]
	WHERE
		[DocumentItem].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @ToState = 3
	BEGIN
		EXEC @rv = pjm5DocumentItemCheckOut @FolderID, @ID, @Version, @CreatedBy, @Extension
		IF @rv != 0
		BEGIN
			RETURN 1
		END
	END
	IF @FromState = 1 AND @ToState = 2
	BEGIN
		EXEC @rv = pjm5DocumentItemCheckIn @ID, @Version, @VersionControl
		IF @rv != 0
		BEGIN
			RETURN 1
		END
	END
	IF @FromState = 3 AND @ToState = 2
	BEGIN
		SELECT TOP 1 @ToState = [TransitionTemplate].[FromState]
		FROM
			[Transition]
			INNER JOIN [TransitionTemplate]
				ON [TransitionTemplate].[ID] = [Transition].[TransitionTemplateID]
		WHERE
			[Transition].[Class] = @Class AND [Transition].[DocumentID] = @ID
			AND [TransitionTemplate].[ToState] = 3
		ORDER BY
			[Transition].[Created] DESC
		EXEC @rv = pjm5DocumentItemUndoCheckOut @ID, @Version
		IF @rv != 0
		BEGIN
			RETURN 1
		END
	END

	SET @UserID = dbo.adfGetCurrentUserID()
	UPDATE
		[DocumentItem]
	SET
		[DocumentItem].[State] = @ToState,
		[DocumentItem].[CheckedOutBy] = CASE @ToState WHEN 3 THEN @UserID ELSE NULL END,
		[DocumentItem].[Modified] = DEFAULT,
		[DocumentItem].[ModifiedBy] = DEFAULT
	WHERE
		[DocumentItem].[ID] = @ID
	AND
		[DocumentItem].[State] = @FromState
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemChangeStateInternal TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCheckOut]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemCheckOut'
		DROP PROCEDURE [dbo].[pjm5DocumentItemCheckOut]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemCheckOut'
GO

/******************************************************************************
**		File: pjm5DocumentItemCheckOut.sql
**		Name: pjm5DocumentItemCheckOut
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemCheckOut
	@FolderID TIdentifier,
	@ID TIdentifier,
	@Version TCount,
	@CreatedBy TIdentifier,
	@Extension TName
AS
	SET NOCOUNT ON
	DECLARE 
		@UserID TIdentifier,
		@rv int
		
	SET @UserID = dbo.adfGetCurrentUserID()
	EXEC @rv = pjm5DocumentItemCheckEditAccess @ID
	IF @@error != 0 OR @rv != 0 
	BEGIN
		RETURN 1
	END

	IF NOT EXISTS (SELECT * FROM [DocumentVersion] WHERE [DocumentItemID] = @ID AND [Version] = @Version + 1)
	BEGIN
		INSERT INTO [DocumentVersion] ([DocumentItemID], [Version], [Extension]) VALUES (@ID, @Version + 1, @Extension)
		IF @@ERROR != 0
			RETURN 1
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemCheckOut TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCheckIn]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemCheckIn'
		DROP PROCEDURE [dbo].[pjm5DocumentItemCheckIn]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemCheckIn'
GO

/******************************************************************************
**		File: pjm5DocumentItemCheckIn.sql
**		Name: pjm5DocumentItemCheckIn
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemCheckIn
	@ID TIdentifier,
	@Version TCount,
	@VersionControl TBool
AS
	SET NOCOUNT ON
	DECLARE
		@versionID TIdentifier,
		@dataIsNull TBool,
		@rv int
	
	SELECT
		@versionID = [ID],
		@dataIsNull = CASE WHEN [DataLength] IS NULL THEN 1 ELSE 0 END
	FROM 
		[DocumentVersion] 
	WHERE 
		[DocumentItemID] = @ID AND [Version] = (@Version + 1)
	
	IF @dataIsNull = 1 OR @versionID IS NULL
	BEGIN
		DELETE FROM [DocumentVersion] WHERE [DocumentItemID] = @ID AND [Version] > @Version
		IF @@ERROR != 0
			RETURN 1
	END
	ELSE IF @versionID IS NOT NULL
	BEGIN
		UPDATE [DocumentItem] SET [LatestVersion] = (@Version + 1) WHERE[ID] = @ID
		IF @@ERROR != 0
			RETURN 1
		IF @VersionControl = 0
		BEGIN
			DELETE FROM [DocumentVersion] WHERE [DocumentItemID] = @ID AND [Version] = @Version
			IF @@ERROR != 0
				RETURN 1
		END
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemCheckIn TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemUndoCheckOut]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemUndoCheckOut'
		DROP PROCEDURE [dbo].[pjm5DocumentItemUndoCheckOut]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemUndoCheckOut'
GO

/******************************************************************************
**		File: pjm5DocumentItemUndoCheckOut.sql
**		Name: pjm5DocumentItemUndoCheckOut
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemUndoCheckOut
	@ID TIdentifier,
	@Version TCount
AS
	SET NOCOUNT ON
	DELETE FROM [DocumentVersion] WHERE [DocumentItemID] = @ID AND [Version] > @Version
	IF @@ERROR != 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemUndoCheckOut TO PUBLIC
GO
