 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemCopy]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemCopy'
		DROP PROCEDURE [dbo].[pjm5DocumentItemCopy]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemCopy'
GO

/******************************************************************************
**		File: pjm5DocumentItemCopy.sql
**		Name: pjm5DocumentItemCopy
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
/*
CREATE PROCEDURE [pjm5DocumentItemCopy]
	@ID TIdentifier,
	@FolderID TIdentifier
AS
	SET NOCOUNT ON
	IF NOT EXISTS(SELECT * FROM [Folder] WHERE [ID] = @FolderID)
	BEGIN
		RAISERROR('#folderisdeleted', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@UserID TIdentifier,
		@PrevFolderID TIdentifier,
		@CreatedBy TIdentifier,
		@NewID TIdentifier,
		@PrevState TState,
		@State TState,
		@CardClass TClass,
		@CardState TState,
		@PublicationControl TBool,
		@FolderPublication TBool,
		@rv int

	SELECT
		@PublicationControl = [Folder].[PublicationControl]
	FROM
		[Folder]
	WHERE
		[ID] = @FolderID
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @FolderPublication = 1
	IF @PublicationControl = 1
		SET @FolderPublication = dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'FolderPublication')
	SELECT 
		@PrevFolderID = [DocumentItem].[FolderID],
		@CreatedBy = [DocumentItem].[CreatedBy],
		@PrevState = [DocumentItem].[State],
		@CardClass = [DocumentCard].[Class]
	FROM 
		[DocumentItem] 
		LEFT OUTER JOIN [DocumentCard]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE
		[DocumentItem].[ID] = @ID

	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateItems') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @State = 1 --dbo.adfwfGetInitialState('acb865ab-ae3c-429e-af10-d14d6a46363b')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @CardState = dbo.adfwfGetInitialState('6cc877ce-4425-4e49-a3d5-76b01ae709ae')
	IF @CardState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	INSERT INTO [DocumentCard] ([State], [Flag], [Date], [FileAs], [FolderID],
		[DocumentCardClassID],
		[Number],
		[NumberIn],
		[DateIn],
		[NumberOut],
		[DateOut],
		[CompanyID],
		[ContactID],
		[CorrespondentCompanyID],
		[CorrespondentContactID],
		[DivisionID],
		[CardOwnerID],
		[CustodyPlaceID],
		[AppendixCount],
		[PageCount],
		[Copy],
		[StorePeriod],
		[Package],
		[CaseID],
		[Comments]) 
	SELECT 
		@CardState, 0, [DocumentCard].[Date], [DocumentCard].[FileAs], @FolderID,
		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[Number],
		[DocumentCard].[NumberIn],
		[DocumentCard].[DateIn],
		[DocumentCard].[NumberOut],
		[DocumentCard].[DateOut],
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],
		[DocumentCard].[Package],
		[DocumentCard].[CaseID],
		[DocumentCard].[Comments]
	FROM
		[DocumentCard]
		INNER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE
		[DocumentItem].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @NewID = SCOPE_IDENTITY()
	
	INSERT INTO [DocumentItem]
		([State], [Flag], [FileAs], [FileName], [Extension], [LatestVersion], [FolderID], [DocumentCardID])
	SELECT
		@State, 0, [FileAs], [FileName], [Extension], [LatestVersion], @FolderID, @NewID
	FROM
		[DocumentItem]
	WHERE
		[ID] = @ID
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @NewID = SCOPE_IDENTITY()
	
	INSERT INTO [DocumentVersion] ([DocumentItemID], [Version], [Extension], [Data]) 
	SELECT
		@NewID, [Version], [Extension], [Data]
	FROM 
		[DocumentVersion]
	WHERE
		[DocumentItemID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @FolderPublication = 1
	BEGIN
		EXEC @rv = pjm5DocumentItemChangeStateInternal @NewID, 2
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION

	EXEC pjm5DocumentItemGet @NewID
	RETURN 0
*/
GO

--GRANT EXECUTE ON pjm5DocumentItemCopy TO PUBLIC
GO

