 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentItemDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentItemDelete'
		DROP PROCEDURE [dbo].[pjm5DocumentItemDelete]
	END
GO

PRINT 'Creating procedure pjm5DocumentItemDelete'
GO

/******************************************************************************
**		File: pjm5DocumentItemDelete.sql
**		Name: pjm5DocumentItemDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentItemDelete
	@ID TIdentifier,
	@Forced int = 0
AS
	SET NOCOUNT ON
	IF NOT EXISTS(SELECT * FROM [DocumentItem] WHERE [ID] = @ID)
		RETURN 0

	DECLARE
		@UserID TIdentifier,
		@CreatedBy TIdentifier,
		@ModifiedBy TIdentifier,
		@FolderID TIdentifier,
		@CardID TIdentifier,
		@State TState,
		@CardState TState,
		@CaseID TIdentifier
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SELECT 
		@State = [DocumentItem].[State],
		@FolderID = [DocumentItem].[FolderID],
		@CreatedBy = [DocumentItem].[CreatedBy],
		@ModifiedBy = [DocumentItem].[ModifiedBy],
		@CardID = [DocumentItem].[DocumentCardID],
		@CardState = [DocumentCard].[State],
		@CaseID = [DocumentCard].[CaseID]
	FROM 
		[DocumentItem] 
		INNER JOIN [DocumentCard]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE 
		[DocumentItem].[ID] = @ID
		
	IF NOT (@FolderID = -1 AND @UserID = @ModifiedBy)
	BEGIN
		IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'DeleteAll') = 0
		BEGIN
			IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'DeleteOwn') = 0
			BEGIN
				RAISERROR('#accessdenied', 18, -1)
				RETURN 1
			END
			IF @UserID != @CreatedBy
			BEGIN
				RAISERROR('#accessdenied', 18, -1)
				RETURN 1
			END
		END
	END

	IF @Forced = 0
	BEGIN
		IF @State = 3 -- Checked out
		BEGIN
			RAISERROR('?IsCheckedOut', 18, -1)
			RETURN 1
		END
	END

	BEGIN TRANSACTION
	IF @FolderID = -1 
	BEGIN
		DELETE FROM [DocumentVersion] WHERE [DocumentItemID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DELETE FROM [DocumentItem] WHERE [DocumentItem].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

		DELETE FROM [DocumentFlowEntry] 
		FROM
			[DocumentFlowEntry]
			INNER JOIN [DocumentCard]
				ON [DocumentFlowEntry].[DocumentClass] = [DocumentCard].[Class] AND 
					[DocumentFlowEntry].[DocumentID] = [DocumentCard].[ID]
		WHERE 
			[DocumentCard].[ID] = @CardID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DELETE [DocumentCard] WHERE [ID] = @CardID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END

	END
	ELSE
	BEGIN
		IF @CaseID IS NOT NULL
		BEGIN
			DELETE FROM [DocumentVersion] WHERE [DocumentItemID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			DELETE FROM [DocumentItem] WHERE [DocumentItem].[ID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			UPDATE 
				[DocumentCard] 
			SET 
				[Modified] = DEFAULT,
				[ModifiedBy] = DEFAULT
			WHERE 
				[ID] = @CardID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE
		BEGIN
			UPDATE 
				[DocumentItem] 
			SET 
				[State] = 100,
				[FolderID] = -1,
				[Modified] = DEFAULT,
				[ModifiedBy] = DEFAULT
			WHERE 
				[ID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END

			UPDATE 
				[DocumentCard] 
			SET 
				[State] = 100,
				[FolderID] = -1,
				[Modified] = DEFAULT,
				[ModifiedBy] = DEFAULT
			WHERE 
				[ID] = @CardID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			EXEC pjm5DocumentItemDeleteNotification @ID
		END
	END
	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentItemDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentVersionDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentVersionDelete'
		DROP PROCEDURE [dbo].[pjm5DocumentVersionDelete]
	END
GO

PRINT 'Creating procedure pjm5DocumentVersionDelete'
GO

/******************************************************************************
**		File: pjm5DocumentVersionDelete.sql
**		Name: pjm5DocumentVersionDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentVersionDelete
	@VersionID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@ID TIdentifier,
		@LatestVersion TCount,
		@Version TCount,
		@UserID TIdentifier,
		@CreatedBy TIdentifier,
		@FolderID TIdentifier,
		@CardID TIdentifier
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SELECT 
		@ID = [DocumentItem].[ID],
		@LatestVersion = [DocumentItem].[LatestVersion],
		@Version = [DocumentVersion].[Version],
		@FolderID = [DocumentItem].[FolderID],
		@CreatedBy = [DocumentItem].[CreatedBy]
	FROM 
		[DocumentVersion]
		INNER JOIN [DocumentItem] 
			ON [DocumentVersion].[DocumentItemID] = [DocumentItem].[ID]
	WHERE 
		[DocumentVersion].[ID] = @VersionID
	
	IF @LatestVersion = @Version
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @rv int
	EXEC @rv = pjm5DocumentItemCheckEditAccess @ID
	IF @@error != 0 OR @rv != 0 
	BEGIN
		RETURN 1
	END
	
	BEGIN TRANSACTION
	DELETE FROM [DocumentVersion] WHERE [ID] = @VersionID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE
		[DocumentItem]
	SET 
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION
	
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentVersionDelete TO PUBLIC
GO
