 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentVersionGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentVersionGet'
		DROP PROCEDURE [dbo].[pjm5DocumentVersionGet]
	END
GO

PRINT 'Creating procedure pjm5DocumentVersionGet'
GO

/******************************************************************************
**		File: pjm5DocumentVersionGet.sql
**		Name: pjm5DocumentVersionGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentVersionGet]
	@ID TIdentifier
AS
	SELECT
		[DocumentVersion].[ID],
		[DocumentVersion].[DocumentItemID],
		[DocumentVersion].[Version],
		[DocumentVersion].[DataLength],
		[DocumentVersion].[Created],
		[DocumentVersion].[CreatedBy],
		[DocumentVersion].[Comments],
		[Trustee].[DisplayName] AS [UserName]
	FROM
		[DocumentVersion]
		INNER JOIN [Trustee]
			ON [Trustee].[ID] = [DocumentVersion].[CreatedBy]
	WHERE
		[DocumentVersion].[ID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentVersionGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentVersionUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentVersionUpdate'
		DROP PROCEDURE [dbo].[pjm5DocumentVersionUpdate]
	END
GO

PRINT 'Creating procedure pjm5DocumentVersionUpdate'
GO

/******************************************************************************
**		File: pjm5DocumentVersionUpdate.sql
**		Name: pjm5DocumentVersionUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentVersionUpdate]
	@ID TIdentifier,
	@Comments TNotes
AS
	DECLARE 
		@DocumentItemID TIdentifier
	SELECT
		@DocumentItemID = [DocumentVersion].[DocumentItemID]
	FROM
		[DocumentVersion]
	WHERE
		[DocumentVersion].[ID] = @ID
	DECLARE @rv int
	EXEC @rv = pjm5DocumentItemCheckEditAccess @DocumentItemID
	IF @@error != 0 OR @rv != 0 
	BEGIN
		RETURN 1
	END

	UPDATE 
		[DocumentVersion]
	SET
		[Comments] = @Comments
	WHERE
		[ID] = @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentVersionUpdate] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentVersionGetPointer]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentVersionGetPointer'
		DROP PROCEDURE [dbo].[pjm5DocumentVersionGetPointer]
	END
GO

PRINT 'Creating procedure pjm5DocumentVersionGetPointer'
GO

/******************************************************************************
**		File: pjm5DocumentVersionGetPointer.sql
**		Name: pjm5DocumentVersionGetPointer
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentVersionGetPointer]
	@VersionID	TIdentifier,
	@Created	TBool OUTPUT
AS
	SET @Created = 0
	IF EXISTS(SELECT * FROM [DocumentVersion] WHERE [ID] = @VersionID AND [DataLength] IS NULL)
	BEGIN
		UPDATE [DocumentVersion] SET [Data] = 0x0 WHERE [ID] = @VersionID
		SET @Created = 1
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentVersionGetPointer] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentVersionClearPointer]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentVersionClearPointer'
		DROP PROCEDURE [dbo].[pjm5DocumentVersionClearPointer]
	END
GO

PRINT 'Creating procedure pjm5DocumentVersionClearPointer'
GO

/******************************************************************************
**		File: pjm5DocumentVersionClearPointer.sql
**		Name: pjm5DocumentVersionClearPointer
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5DocumentVersionClearPointer]
	@VersionID	TIdentifier
AS
	UPDATE
		[DocumentVersion]
	SET
		[Data] = NULL
	WHERE
		[ID] = @VersionID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5DocumentVersionClearPointer] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentVersionCompare]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentVersionCompare'
		DROP PROCEDURE [dbo].[pjm6DocumentVersionCompare]
	END
GO

PRINT 'Creating procedure pjm6DocumentVersionCompare'
GO
/******************************************************************************
**		File: pjm6DocumentVersionCompare.sql
**		Name: pjm6DocumentVersionCompare
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/

CREATE PROCEDURE [pjm6DocumentVersionCompare]
	@DocumentItemID		TIdentifier,
	@OriginVersion		TCount,
	@ComparedVersion	TCount

AS
	DECLARE @Index int,
			@OriginLenght int,
			@ComparedLenght int

	SELECT
		@OriginLenght = [DocumentVersion].[DataLength],
		@Index=0
	FROM
		[DocumentVersion]
	WHERE
		[DocumentVersion].[Version] = @OriginVersion
		AND [DocumentVersion].[DocumentItemID] = @DocumentItemID

	SELECT
		@ComparedLenght = [DocumentVersion].[DataLength]
	FROM
		[DocumentVersion]
	WHERE
		[DocumentVersion].[Version] = @ComparedVersion
		AND [DocumentVersion].[DocumentItemID] = @DocumentItemID
	
	IF(@ComparedLenght = @OriginLenght)
		WHILE ((SELECT SUBSTRING([Data],@index ,1) 
			FROM 
				[DocumentVersion]
			WHERE 
				[Version] = @OriginVersion AND [DocumentItemID] = @DocumentItemID)
			 = (SELECT SUBSTRING([Data],@index ,1)
			FROM
				[DocumentVersion]
			WHERE
				[Version]=@ComparedVersion AND [DocumentItemID] = @DocumentItemID))
			BEGIN
				IF(@OriginLenght = @index)
					BEGIN
						SELECT 1
						RETURN 0
					END		
				SET @index = @index + 1
			END
	
	SELECT 0

RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentVersionCompare] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6DocumentVersionSetDataLength]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6DocumentVersionSetDataLength'
		DROP PROCEDURE [dbo].[pjm6DocumentVersionSetDataLength]
	END
GO

PRINT 'Creating procedure pjm6DocumentVersionSetDataLength'
GO

/******************************************************************************
**		File: pjm5DocumentVersionGetPointer.sql
**		Name: pjm6DocumentVersionSetDataLength
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6DocumentVersionSetDataLength]
	@VersionID	TIdentifier,
	@Length	bigint
AS
	IF EXISTS(SELECT * FROM [DocumentVersion] WHERE [ID] = @VersionID AND [DataLength] IS NULL)
	BEGIN
		UPDATE [DocumentVersion] SET [DataLength] = @Length WHERE [ID] = @VersionID
	END
	RETURN 0
GO

GRANT EXECUTE ON [pjm6DocumentVersionSetDataLength] TO PUBLIC
GO