/******************************************************************************
**		File: ExchangeSyncGetInstanceInfo.sql
**		Name: pjm6ExchangeSyncGetInstanceInfo
**
**		Auth: pavel.svintsov
**		Date: 27.01.2011 16:00:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		
**    
*******************************************************************************/
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExchangeSyncGetInstanceInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExchangeSyncGetInstanceInfo'
		DROP PROCEDURE [dbo].[pjm6ExchangeSyncGetInstanceInfo]
	END
GO
PRINT 'Creating procedure pjm6ExchangeSyncGetInstanceInfo'
GO

SET QUOTED_IDENTIFIER ON
GO
--------------------------------------------------------------------------------
CREATE PROCEDURE [pjm6ExchangeSyncGetInstanceInfo]
	@ExchangeDate TDate
AS
	DECLARE
		@ExchangeServer TName,
		@AdminEmail TName,
		@TimeOffset int


	SELECT @ExchangeServer = CAST([Value] as nvarchar(256)) FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'ExchangeSyncServerName'
	SELECT @AdminEmail = CAST([Value] as nvarchar(256)) FROM [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] WHERE [Name] = 'ExchangeSyncAdministrator'
	SET @TimeOffset = DATEDIFF(MINUTE, @ExchangeDate, GETDATE())
		
	SELECT
		ISNULL(@ExchangeServer, '') as 'ExchangeServer',
		ISNULL(@AdminEmail, '') as 'AdminEmail',
		@TimeOffset as 'TimeOffset'

	RETURN 0
GO

GRANT EXECUTE ON pjm6ExchangeSyncGetInstanceInfo TO PUBLIC
GO