IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseCreate'
		DROP PROCEDURE [dbo].[pjm5ExpenseCreate]
	END
GO

PRINT 'Creating procedure pjm5ExpenseCreate'
GO

/******************************************************************************
**		File: pjm5ExpenseCreate.sql
**		Name: pjm5ExpenseCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		13.09.12	MAB				   Amount c TCount  TAmount
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseCreate]
	@Xml XML
AS
	DECLARE 
		@ID TIdentifier,
		@FileAs TName,
		@ProjectID TIdentifier,
		@DocumentClass TClass,
		@DocumentID TIdentifier,
		@TaskID TIdentifier,
		@ExpenseCodeID TIdentifier,
		@Date TDateTime,
		@Amount TAmount,
		@Billable TBool,
		@VATIsIncluded TBool,
		@Price TMoney,
		@FromCurrencyCode TCode3,
		@ToCurrencyCode TCode3,
		@CurrencyRate TMoney,
		@VATRate TPercent,
		@Comments TNotes,
		@EmployeeID TIdentifier,
		@Doc int,
		@rv int,
		@MyEmployeeID int,
		@PhoneCallCodeID TIdentifier,
		@State TState,
		@VAT TMoney,
		@UOMID TIdentifier
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @Doc OUTPUT, @Xml

	SELECT
		@FileAs = [XmlTable].[FileAs], 
		@ProjectID = [XmlTable].[ProjectID], 
		@DocumentClass = dbo.adfGetClassByName([XmlTable].[DocumentClass]),
		@DocumentID = [XmlTable].[documentID],
		@TaskID = [XmlTable].[TaskID], 
		@ExpenseCodeID = [XmlTable].[ExpenseCodeID], 
		@Date = CAST([XmlTable].[Date] as datetime), 
		@Amount = [XmlTable].[Amount], 
		@Billable = CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END, 
		@Price = [XmlTable].[Price], 
		@FromCurrencyCode = [XmlTable].[FromCurrencyCode],
		@ToCurrencyCode = [Project].[CurrencyCode],
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@VATRate = [XmlTable].[VATRate],
		@VATIsIncluded = CASE WHEN [VATIsIncluded] = 'false' THEN 0 ELSE 1 END,
		@VAT = [XmlTable].[VAT],
		@Comments = [XmlTable].[Comments],
		@EmployeeID = [XmlTable].[EmployeeID],
		@PhoneCallCodeID = [XmlTable].[PhoneCallCodeID],
		@UOMID = [XmlTable].[UOMID]
	FROM
		OPENXML(@Doc, '/pjm5ExpenseGet/Expense', 2)
			WITH (
				[FileAs] nvarchar(256),
				[ExpenseCodeID] int,
				[EmployeeID] int,
				[ProjectID] int,
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[TaskID] int,
				[Date] varchar(19),
				[Amount] decimal(18,4),
				[Billable] varchar(5),
				[Price] money,
				[VATRate] decimal(18,4),
				[VAT] money,
				[VATIsIncluded] varchar(5),
				[FromCurrencyCode] char(3),
				[CurrencyRate] decimal(18,4),
				[Comments] nvarchar(max),
				[PhoneCallCodeID] int,
				[UOMID] int
				) as [XmlTable]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]
			
	EXEC sp_xml_removedocument @Doc

	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NULL
	BEGIN
		RAISERROR('#PhoneCallCodeIsNotDefined', 18, -1)
		RETURN 1
	END

	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NOT NULL
	BEGIN
		SET @State = dbo.adfwfGetInitialState('b196878b-db17-446f-bbf1-13fccf77acf7')
		IF @State IS NULL
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END

	BEGIN TRANSACTION
	EXEC @rv = pjm5ExpenseCreateInternal 
		@ID OUTPUT, 
		@FileAs,
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@ExpenseCodeID,
		@Date,
		@UOMID,
		@Amount,
		@Billable,
		@Price,
		@FromCurrencyCode,
		@ToCurrencyCode,
		@CurrencyRate,
		@VATRate,
		@VATIsIncluded,
		@VAT,
		@Comments

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	IF @ExpenseCodeID = 1 AND @PhoneCallCodeID IS NOT NULL
	BEGIN
		INSERT INTO [PhoneCall]
			([Flag], [State], [FileAs], [TimeEntryID], [ExpenseID], [PhoneCallCodeID], [Comments])
		VALUES
			(0, @State, @FileAs, NULL, @ID, @PhoneCallCodeID, @Comments)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION

	EXEC pjm5ExpenseGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ExpenseCreate TO PUBLIC
GO
 