IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExpenseGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExpenseGet'
		DROP PROCEDURE [dbo].[pjm5ExpenseGet]
	END
GO

PRINT 'Creating procedure pjm5ExpenseGet'
GO

/******************************************************************************
**		File: pjm5ExpenseGet.sql
**		Name: pjm5ExpenseGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExpenseGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@date datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@ProjectID TIdentifier,
		@RestrictedView TBool,
		@EmployeeID TIdentifier,
		@CreatedBy TIdentifier,
		@ExpenseSecretary TIdentifier
	
	SET @ExpenseSecretary = dbo.adfHasAccessRightByName('ManageExpenseWithoutAssignment')	
	SET @RestrictedView = dbo.adfHasAccessRight(dbo.adfGetRightID('RestrictedView'))	
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime)
		
	SELECT
		@ProjectID = [ProjectID],
		@EmployeeID = [EmployeeID],
		@CreatedBy = [CreatedBy]
	FROM 
		[Expense] 
	WHERE 
		[ID] = @ID
	IF (@ViewAllFinance = 0 AND
		@EmployeeID != @CurrentEmployeeID AND
		@CreatedBy != @CurrentUserID AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 AND
		dbo.fnPjm5IsProjectEnhancementMember(@ProjectID, @CurrentEmployeeID) = 0 AND
		@ExpenseSecretary = 0
		)
	BEGIN
		RAISERROR('#NotEnoughPermissions', 18, -1)
		RETURN 1
	END
	
	DECLARE 
		@value TVariant,
		@FlagTask TBool,
		@FlagService TBool,
		@FlagFileAs TBool,
		@FlagComments TBool,
		@Separator1 TName,
		@Separator2 TName,
		@Separator3 TName,
		@TaskRequestSeparator TName,
		@ServiceRequestSeparator TName,
		@IssueSeparator TName,
		@FlagTaskRequest TBool,
		@FlagServiceRequest TBool,
		@FlagIssue TBool

	EXEC adfParameterGet @Name='DocumentLineSeparator1', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator1 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='DocumentLineSeparator2', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator2 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='DocumentLineSeparator3', @Group='Pjm5', @Value = @value OUTPUT
	SET @Separator3 = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='TaskRequestSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @TaskRequestSeparator = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='ServiceRequestSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @ServiceRequestSeparator = CAST(@value as nvarchar(256))
	EXEC adfParameterGet @Name='IssueSeparator', @Group='Pjm5', @Value = @value OUTPUT
	SET @IssueSeparator = CAST(@value as nvarchar(256))
	
	EXEC adfParameterGet @Name='DocumentLineContainsTask', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagTask = ISNULL(CAST(@value as bit), 0)
		
	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsService', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagService = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsFileAs', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagFileAs = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsComments', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagComments = ISNULL(CAST(@value as bit), 0)
	
	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsServiceRequest', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagServiceRequest = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsTaskRequest', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagTaskRequest = ISNULL(CAST(@value as bit), 0)

	SET @value = NULL
	EXEC adfParameterGet @Name='DocumentLineContainsIssue', @Group='Pjm5', @Value = @value OUTPUT
	SET @FlagIssue = ISNULL(CAST(@value as bit), 0)

	DECLARE 
		@NationalCurrencyCode TCode3, 
		@BaseCurrencyCode TCode3

	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @value OUTPUT	
	SET @NationalCurrencyCode = CAST(@value AS varchar(3))
	EXEC adfParameterGet 'BaseCurrency', 'CommonBusiness', @value OUTPUT	
	SET @BaseCurrencyCode = CAST(@value AS varchar(3))

	SELECT
		[Expense].[Class],
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Flag],
		[Expense].[FileAs],
		[Expense].[ProjectID],
		[Class].[Code] as [DocumentClass],
		[Expense].[DocumentID],
		[Expense].[TaskID],
		[Expense].[ExpenseCodeID],
		[Expense].[Date],
		[Expense].[Amount],
		[Expense].[Billable],
		[Expense].[Price],
		[Expense].[FromCurrencyCode],
		[Expense].[ToCurrencyCode],
		[Expense].[CurrencyRate],
		[Expense].[VATIsIncluded],
		[Expense].[VATRate],
		[Expense].[VAT],
		[Expense].[Comments],
		[Expense].[Created],
		[Expense].[CreatedBy],
		[Expense].[Modified],
		[Expense].[ModifiedBy],
		[Expense].[Timestamp],
		[Expense].[EmployeeID],
		[PhoneCall].[PhoneCallCodeID],
		[Expense].[TotalPC],
		[Expense].[TotalWithVATPC],
		[Expense].[VATPC],
		[Expense].[UOMID],
		dbo.fnPjm5GetEntryDescription(
			CASE @FlagTask WHEN 1 THEN [Task].[FileAs] ELSE NULL END,
			NULL,
			CASE @FlagFileAs WHEN 1 THEN [Expense].[FileAs] ELSE NULL END,
			CASE @FlagComments WHEN 1 THEN [Expense].[Comments] ELSE NULL END,
			CASE @FlagIssue WHEN 1 THEN [Issue].[FileAs] ELSE NULL END,
			CASE @FlagServiceRequest WHEN 1 THEN [ServiceRequest].[FileAs] ELSE NULL END,
			CASE @FlagTaskRequest WHEN 1 THEN [TaskRequest].[FileAs] ELSE NULL END,
			ISNULL(@Separator1, ' '),
			ISNULL(@Separator2, ' '),
			ISNULL(@Separator3, ' '),
			ISNULL(@IssueSeparator, ' '),
			ISNULL(@ServiceRequestSeparator, ' '),
			ISNULL(@TaskRequestSeparator, ' '),
			[Expense].[FileAs]
		) AS [Description],
		@NationalCurrencyCode as [NationalCurrencyCode]
		
	FROM
		[Expense]
		LEFT OUTER JOIN [Class]
			ON [Class].[Class] = [Expense].[DocumentClass]
		LEFT OUTER JOIN [PhoneCall]
			ON [PhoneCall].[ExpenseID] = [Expense].[ID]
		LEFT OUTER JOIN [Task]
			ON [Task].[ID] = [Expense].[TaskID]
		LEFT OUTER JOIN [ServiceRequest]
			ON [ServiceRequest].[Class] = [Expense].[DocumentClass] 
				AND [ServiceRequest].[ID] = [Expense].[DocumentID]
		LEFT OUTER JOIN [Issue]
			ON [Issue].[Class] = [Expense].[DocumentClass] 
				AND [Issue].[ID] = [Expense].[DocumentID]
		LEFT OUTER JOIN [TaskRequest]
			ON [TaskRequest].[Class] = [Expense].[DocumentClass] 
				AND [TaskRequest].[ID] = [Expense].[DocumentID]
	WHERE
		[Expense].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExpenseGet] TO PUBLIC
GO

 