 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureSuspicious]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureSuspicious'
		DROP PROCEDURE [dbo].[pjm5FactureSuspicious]
	END
GO

PRINT 'Creating procedure pjm5FactureSuspicious'
GO

/******************************************************************************
**		File: pjm5FactureSuspicious.sql
**		Name: pjm5FactureSuspicious
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5FactureSuspicious
	@ID TIdentifier
AS
BEGIN
	DECLARE
		@TotalWithVAT TMoney,
		@TotalWithVATPC TMoney,
		@CurrencyRate TAmount
		
	SELECT
		@TotalWithVAT = [TotalWithVAT],
		@TotalWithVATPC = [TotalWithVATPC],
		@CurrencyRate = [CurrencyRate]
	FROM
		[Facture]
	WHERE
		[ID] = @ID
		
	IF NOT(
		(
		@TotalWithVAT * @CurrencyRate > @TotalWithVATPC * 0.9 AND @TotalWithVAT * @CurrencyRate < @TotalWithVATPC * 1.1 
		OR
		@TotalWithVAT / @CurrencyRate > @TotalWithVATPC * 0.9 AND @TotalWithVAT / @CurrencyRate < @TotalWithVATPC * 1.1
		) 
	)
	BEGIN
		RETURN 1
	END
	
	RETURN 0
END
GO

GRANT EXECUTE ON pjm5FactureSuspicious TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FactureChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FactureChangeState'
		DROP PROCEDURE [dbo].[pjm5FactureChangeState]
	END
GO

PRINT 'Creating procedure pjm5FactureChangeState'
GO

/******************************************************************************
**		File: pjm5FactureChangeState.sql
**		Name: pjm5FactureChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5FactureChangeState
	@ID TIdentifier,
	@ToState TState,
	@Forced TBool
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@Number TName,
			@ProjectID TIdentifier,
			@rv int
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [Facture].[Class],
		@FromState = [Facture].[State],
		@Number = [Facture].[Number],
		@ProjectID = [Facture].[ProjectID]
	FROM
		[Facture]
	WHERE
		[Facture].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	IF @Forced = 0 AND @FromState = 1 AND @ToState = 2
	BEGIN
		EXEC @rv = pjm5FactureSuspicious @ID
		IF @rv != 0
		BEGIN
			RAISERROR('?SuspiciousData', 18, -1)
			RETURN 1
		END
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0 AND
		dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END	
	
	UPDATE
		[Facture]
	SET
		[Facture].[State] = @ToState,
		[Facture].[Modified] = GETDATE(),
		[Facture].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Facture].[ID] = @ID
	AND
		[Facture].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5FactureChangeState TO PUBLIC
GO
