 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PaymentFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PaymentFind'
		DROP PROCEDURE [dbo].[pjm5PaymentFind]
	END
GO

PRINT 'Creating procedure pjm5PaymentFind'
GO

/******************************************************************************
**		File: pjm5PaymentFind.sql
**		Name: pjm5PaymentFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				     [Payment].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5PaymentFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier, @ViewAllProjects TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))

	SELECT
		[Payment].[Class],
		[Payment].[ID],
		[Payment].[State],
		[Payment].[Date],
		[Payment].[Number],
		[Payment].[FileAs],
		[Payment].[Comments],
		[Payment].[ProjectID],
		[Payment].[Flag],
		[Payment].[Created],
		[Payment].[CreatedBy],
		[Payment].[Modified],
		[Payment].[ModifiedBy]
	FROM
		[Payment] 
	WHERE
		(
			@ViewAllProjects = 1 OR 
			dbo.fnPjm5IsProjectManager([Payment].[ProjectID], @EmployeeID) = 1
		) 
		AND
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Payment].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Payment].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Payment].[FileAs] LIKE '%' + @Text + '%' OR [Payment].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Payment].[Number] LIKE '%' + @Text + '%' OR [Payment].[FileAs] LIKE '%' + @Text + '%' OR [Payment].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Payment].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Payment].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND dbo.fnPjm5IsProjectManager([Payment].[ProjectID], @EmployeeID) = 1)
			OR
			(@UserOption = 1 AND ([Payment].[CreatedBy] = @UserID OR [Payment].[ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [Payment].[CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [Payment].[ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Payment].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Payment].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Payment].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5PaymentFind] TO PUBLIC
GO 