 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5StatementFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5StatementFind'
		DROP PROCEDURE [dbo].[pjm5StatementFind]
	END
GO

PRINT 'Creating procedure pjm5StatementFind'
GO

/******************************************************************************
**		File: pjm5StatementFind.sql
**		Name: pjm5StatementFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/19/2005 10:53:44
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				     [Statement].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm5StatementFind]
	@Text nvarchar(256), -- NULL -  , 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - 
	@Flag tinyint, -- NULL -  , 0-7 
	@UserOption int,
	@TimeField int, -- 0 - , 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier, @ViewAllProjects TBool
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))

	SELECT
		[Statement].[Class],
		[Statement].[ID],
		[Statement].[State],
		[Statement].[Date],
		[Statement].[Number],
		[Statement].[FileAs],
		[Statement].[Comments],
		[Statement].[ProjectID],
		[Statement].[Flag],
		[Statement].[Created],
		[Statement].[CreatedBy],
		[Statement].[Modified],
		[Statement].[ModifiedBy]
	FROM
		[Statement] INNER JOIN dbo.fnPjm5GetAvailableProjects() as [P]
			ON ([Statement].[ProjectID] = [P].[ID])
	WHERE
		(
			@ViewAllProjects = 1 OR 
			dbo.fnPjm5IsProjectManager([Statement].[ProjectID], @EmployeeID) = 1
		) AND
		(
			@ProjectID IS NULL OR (@ProjectID IS NOT NULL AND [Statement].[ProjectID] = @ProjectID)
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Statement].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Statement].[FileAs] LIKE '%' + @Text + '%' OR [Statement].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Statement].[Number] LIKE '%' + @Text + '%' OR [Statement].[FileAs] LIKE '%' + @Text + '%' OR [Statement].[Comments] LIKE '%' + @Text + '%'))			
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Statement].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Statement].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND dbo.fnPjm5IsProjectManager([Statement].[ProjectID], @EmployeeID) = 1)
			OR
			(@UserOption = 1 AND ([Statement].[CreatedBy] = @UserID OR [Statement].[ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [Statement].[CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [Statement].[ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Statement].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Statement].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Statement].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm5StatementFind] TO PUBLIC
GO 