﻿ IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6BudgetFind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6BudgetFind'
		DROP PROCEDURE [dbo].[pjm6BudgetFind]
	END
GO

PRINT 'Creating procedure pjm6BudgetFind'
GO

/******************************************************************************
**		File: pjm6BudgetFind.sql
**		Name: pjm6BudgetFind
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Anton.Paramonov
**		Date: 13/05/2011 16:48:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		14.08.12	SOV				Добавлена сортировка результатов по полю [Budget].[FileAs]
*******************************************************************************/
CREATE PROCEDURE [pjm6BudgetFind]
	@Text nvarchar(256), -- NULL - не искать, 
	@TextField int, -- 0 - FileAs, -- 1 - FileAs, Comments
	@State int, -- NULL - любое
	@Flag tinyint, -- NULL - не важно, 0-7 флаг
	@UserOption int,
	@TimeField int, -- 0 - нет, 1 - Created, 2 - Modified
	@StartTime datetime,
	@EndTime datetime
AS
	
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier, @EmployeeID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		[Budget].[Class],
		[Budget].[ID],
		[Budget].[State],
		[Project].[Number] AS [ProjectCode],
		[Budget].[FileAs],
		[Budget].[Comments],
		[Budget].[Flag],
		[Company].[FileAs] AS [Customer],
		[Employee].[FileAs] AS [ProjectManager],
		[Budget].[LastCalculationDate] AS [Calculated],
		[Budget].[Created],
		[Budget].[CreatedBy],
		[Budget].[Modified],
		[Budget].[ModifiedBy]
	FROM
		[Budget] 
		INNER JOIN [Project]
			ON ([Budget].[DocumentID] = [Project].[ID])
		INNER JOIN [Employee]
			ON [Project].[ProjectManagerEmployeeID] = [Employee].[ID]
		LEFT OUTER JOIN [Company]
			ON [Project].[CustomerCompanyID] = [Company].[ID]

	WHERE
		(
			dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1
			OR 
			dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1
		)
		AND
		(
			@Text IS NULL
			OR
			(@TextField = 0 AND [Budget].[FileAs] LIKE '%' + @Text + '%')
			OR
			(@TextField = 1 AND ([Budget].[FileAs] LIKE '%' + @Text + '%' OR [Budget].[Comments] LIKE '%' + @Text + '%'))
			OR
			(@TextField = 2 AND ([Budget].[FileAs] LIKE '%' + @Text + '%' OR [Budget].[Comments] LIKE '%' + @Text + '%'))
		)
		AND
		(
			@State IS NULL
			OR
			(@State IS NOT NULL AND [Budget].[State] = @State)
		)		
		AND
		(
			@Flag IS NULL
			OR
			(@Flag IS NOT NULL AND [Budget].[Flag] = @Flag)
		)
		AND
		(
			@UserOption IS NULL
			OR
			(@UserOption = 0 AND (dbo.fnPjm6CanEditBudget([Budget].[ID]) = 1 OR dbo.fnPjm6CanViewBudget([Budget].[ID]) = 1))
			OR
			(@UserOption = 1 AND ([Budget].[CreatedBy] = @UserID OR [Budget].[ModifiedBy] = @UserID))
			OR
			(@UserOption = 2 AND [Budget].[CreatedBy] = @UserID)
			OR
			(@UserOption = 3 AND [Budget].[ModifiedBy] = @UserID)
		)
		AND
		(
			@TimeField = 0
			OR
			(@TimeField = 1 AND [Budget].[Created] BETWEEN @StartTime AND @EndTime)
			OR
			(@TimeField = 2 AND [Budget].[Modified] BETWEEN @StartTime AND @EndTime)
		)
	ORDER BY
		[Budget].[FileAs]
	RETURN 0
GO

GRANT EXECUTE ON [pjm6BudgetFind] TO PUBLIC
GO 