IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5GenerateInvoiceFromRecord]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5GenerateInvoiceFromRecord'
		DROP PROCEDURE [dbo].[pjm5GenerateInvoiceFromRecord]
	END
GO

PRINT 'Creating procedure pjm5GenerateInvoiceFromRecord'
GO

/******************************************************************************
**		File: pjm5GenerateInvoiceFromRecord.sql
**		Name: pjm5GenerateInvoiceFromRecord
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    14.09.09		syv				     Pjm5.ServiceAssignment
*******************************************************************************/
CREATE PROCEDURE [pjm5GenerateInvoiceFromRecord]
	@Xml XML,
	@DocumentClass TClass,
	@Number TName,
	@Date TDate,
	@FileAs TName,
	@BankAccountID TIdentifier,
	@CurrencyCode TCode3,
	@CurrencyRate TMoney,
	@Advance TBool, 
	@ServiceTypeID TIdentifier,
	@Description TNotes
AS
	SET NOCOUNT ON
	DECLARE 
		@ID TIdentifier,
		@rv int
		
	SET @Date = CAST(CONVERT(varchar(8), @Date, 112) as datetime)

	BEGIN TRANSACTION
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Calculation')
	BEGIN
		EXEC @rv = pjm5GenerateInvoiceFromCalculation @ID OUTPUT,	
						@Xml, @DocumentClass, @Number, @Date, @FileAs,
						@BankAccountID, @CurrencyCode, @CurrencyRate,
						@Advance, @ServiceTypeID, @Description
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Expense')
	BEGIN
		EXEC @rv = pjm5GenerateInvoiceFromExpense @ID OUTPUT,	
						@Xml, @DocumentClass, @Number, @Date, @FileAs,
						@BankAccountID, @CurrencyCode, @CurrencyRate,
						@Advance, @ServiceTypeID, @Description
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	BEGIN
		EXEC @rv = pjm5GenerateInvoiceFromRequest @ID OUTPUT,	
						@Xml, @DocumentClass, @Number, @Date, @FileAs,
						@BankAccountID, @CurrencyCode, @CurrencyRate,
						@Advance, @ServiceTypeID, @Description
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.TimeEntry')
	BEGIN
		EXEC @rv = pjm5GenerateInvoiceFromTimeEntry @ID OUTPUT,	
						@Xml, @DocumentClass, @Number, @Date, @FileAs,
						@BankAccountID, @CurrencyCode, @CurrencyRate,
						@Advance, @ServiceTypeID, @Description
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.Statement')
	BEGIN
		EXEC @rv = pjm5GenerateInvoiceFromStatement @ID OUTPUT,	
						@Xml, @DocumentClass, @Number, @Date, @FileAs,
						@BankAccountID, @CurrencyCode, @CurrencyRate,
						@Advance, @ServiceTypeID, @Description
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	IF @DocumentClass = dbo.adfGetClassByName('Pjm5.ServiceAssignment')
	BEGIN
		EXEC @rv = pjm6GenerateInvoiceFromServiceAssignment @ID OUTPUT,	
						@Xml, @DocumentClass, @Number, @Date, @FileAs,
						@BankAccountID, @CurrencyCode, @CurrencyRate,
						@Advance, @ServiceTypeID, @Description
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	COMMIT TRANSACTION
	
	SELECT
		[Class], [ID], [State], [FileAs]
	FROM
		[Document]
	WHERE
		[Class] = dbo.adfGetClassByName('Pjm5.Invoice') AND [ID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5GenerateInvoiceFromRecord TO PUBLIC
GO



IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5GenerateInvoiceFromStatement]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5GenerateInvoiceFromStatement'
		DROP PROCEDURE [dbo].[pjm5GenerateInvoiceFromStatement]
	END
GO

PRINT 'Creating procedure pjm5GenerateInvoiceFromStatement'
GO

/******************************************************************************
**		File: pjm5GenerateInvoiceFromStatement.sql
**		Name: pjm5GenerateInvoiceFromStatement
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.10.13	SOV				   ,   
**									      
*******************************************************************************/
CREATE PROCEDURE [pjm5GenerateInvoiceFromStatement]
	@ID TIdentifier OUTPUT,
	@Xml XML,
	@DocumentClass TClass,
	@Number TName,
	@Date TDate,
	@FileAs TName,
	@BankAccountID TIdentifier,
	@CurrencyCode TCode3,
	@CurrencyRate TMoney,
	@Advance TBool, 
	@ServiceTypeID TIdentifier,
	@Description TNotes
AS
	SET NOCOUNT ON
	DECLARE @DocumentID TIdentifier,
			@State TState,
			@Class TClass,
			@Guid TGuid,
			@ProjectID TIdentifier,
			@DocumentCurrencyCode TCode3,
			@ProjectCurrencyCode TCode3,
			@DocumentCurrencyRate TMoney,
			@InvoiceCurrencyRate TMoney,
			@InvoiceBaseCurrencyRate TMoney,
			@doc int,
			@rv int,
			@ApplyVAT TBool,
			@PaymentCurrencyPoint TIdentifier,
			@InvoiceExpirationPeriod TCount,
			@InvoiceExpirationPeriodType TIdentifier,
			@VATRate TPercent,
			@VATIsIncluded TBool,
			@Amount TAmount,
			@Price TMoney,
			@VAT TMoney,
			@value TVariant,
			@StatementClass TClass,
			@CalculationClass TClass,
			@ExpenseClass TClass,
			@StatementCurrencyCode TCode3,
			@StatementCurrencyRate TMoney,
			@StatementValue TMoney,
			@StatementVat TMoney,
			@StatementValuePC TMoney,
			@StatementVatPC TMoney,
			@PaymentValue TMoney,
			@PaymentVat TMoney,
			@PaymentValuePC TMoney,
			@PaymentVatPC TMoney,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@Scale TCount
	
	DECLARE @PricePC decimal(18, 4), @VATPC decimal(18, 4)
	DECLARE
		@TotalPC TMoney,
		@TotalWithVATPC TMoney,
		@t TMoney

	SET @State = dbo.adfwfGetInitialState('98b8f49e-202e-4b46-8074-421734078da6')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE 
		@BaseCurrencyCode TCode3,
		@NationalCurrencyCode TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))
	EXEC adfParameterGet @Name='NationalCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @NationalCurrencyCode = CAST(@value as varchar(3))

	EXEC adfParameterGet @Name='VATRate', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @VATRate = CAST(@value as decimal(18,4))

	SET @Class = dbo.adfGetClassByName('Pjm5.Invoice')
	SET @StatementClass = dbo.adfGetClassByName('Pjm5.Statement')
	SET @CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')
	SET @ExpenseClass = dbo.adfGetClassByName('Pjm5.Expense')

	DECLARE @lines TABLE (
		ID                   int,
		DocumentClass        int,
		DocumentID           int,
		Description          nvarchar(max),
		Amount               decimal(18,4),
		VATRate              decimal(18,4),
		VATIsIncluded        bit,
		Price				 money null,
		VAT					 money null,
		PricePC              money,
		VATPC                money,
		UOMID				 int null,
		ServiceTypeID		 int null,
		BasePrice			 int,
		SortKey				 varchar(32)
		)
	
	DECLARE
		@lineID int,
		@lineStatementID int, @lineDocumentClass int, @lineDocumentID int, @lineDescription nvarchar(2048),
		@lineAmount decimal(18, 4), @lineVATRate decimal(18, 4),
		@lineVATIsIncluded bit,
		@linePrice money, @lineVAT money, @linePricePC money,
		@lineVATPC money, @lineUOMID int, @lineServiceTypeID int, @lineBasePrice int, @lineSortKey varchar(32)

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@DocumentID = [XmlTable].[ID],
		@ProjectID = [XmlTable].[ProjectID],
		@DocumentCurrencyCode = [XmlTable].[CurrencyCode],
		@DocumentCurrencyRate = [XmlTable].[CurrencyRate],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@InvoiceBaseCurrencyRate = [XmlTable].[BaseCurrencyRate],
		@PaymentCurrencyPoint = [Project].[PaymentCurrencyPoint],
		@InvoiceExpirationPeriod = [Project].[InvoiceExpirationPeriod],
		@InvoiceExpirationPeriodType = [Project].[InvoiceExpirationPeriodType],
		@ApplyVAT = [Project].[ApplyVAT],
		@SupplierCompanyID = [XmlTable].[SupplierCompanyID],
		@CustomerCompanyID = [XmlTable].[CustomerCompanyID],
		@Scale = [XmlTable].[Scale]
	FROM 
		OPENXML(@doc, '/pjm5StatementGet/Statement', 2)
			WITH (
				[ID] int,
				[ProjectID] int,
				[CurrencyCode] char(3),
				[CurrencyRate] money,
				[BaseCurrencyRate] money,
				[SupplierCompanyID] int,
				[CustomerCompanyID] int,
				[Scale] int
				) AS [XmlTable]
		INNER JOIN [Project]
			ON [XmlTable].[ProjectID] = [Project].[ID]

	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
			
	SET @InvoiceCurrencyRate = @CurrencyRate
	IF @ProjectCurrencyCode = @BaseCurrencyCode
		SET @InvoiceBaseCurrencyRate = 1.0
	IF @ApplyVAT = 0 SET @VATRate = 0.0
		
	IF @Advance = 1
	BEGIN
		DECLARE statementLines CURSOR FAST_FORWARD READ_ONLY FOR
			SELECT
				[ID],
				[StatementID], [DocumentClass], [DocumentID], [Description],
				[Amount], [VATRate],
				CASE [XmlTable].[VATIsIncluded] WHEN 'false' THEN 0 ELSE 1 END,
				[Price], [VAT], [PricePC], [VATPC], [UOMID], [ServiceTypeID], [BasePrice], [SortKey]
			FROM
				OPENXML(@doc, '/pjm5StatementGet/Line', 2)
					WITH (
						[ID] int,
						[StatementID] int, [DocumentClass] int, [DocumentID] int, [Description] nvarchar(max),
						[Amount] decimal(18, 4), [VATRate] decimal(18, 4),
						[VATIsIncluded] varchar(5),
						[Price] money, [VAT] money, [PricePC] money,
						[VATPC] money, [UOMID] int, [ServiceTypeID] int, [BasePrice] int, [SortKey] varchar(32)) 
						AS [XmlTable]
		OPEN statementLines
		FETCH NEXT FROM statementLines INTO
			@lineID,
			@lineStatementID, @lineDocumentClass, @lineDocumentID, @lineDescription,
			@lineAmount, @lineVATRate,
			@lineVATIsIncluded,
			@linePrice, @lineVAT, @linePricePC,
			@lineVATPC, @lineUOMID, @lineServiceTypeID, @lineBasePrice, @lineSortKey
		WHILE @@FETCH_STATUS = 0
		BEGIN
			IF @ProjectCurrencyCode = @CurrencyCode
			BEGIN
				SET @linePrice = @linePricePC
				SET @lineVAT = @lineVATPC
			END
			ELSE
			BEGIN
				DECLARE @continue bit, @t1 money, @t2 money, @vi bit, @cc TCode3, @vt money
				SET @continue = 1
		
				IF @lineDocumentClass = @CalculationClass
				BEGIN
					SELECT 
						@t1 = [Total], @t2 = [TotalWithVAT], @vt = [VAT], @cc = [CurrencyCode]
					FROM
						[Calculation]
					WHERE	
						[ID] = @lineDocumentID
					IF @cc = @CurrencyCode
					BEGIN
						IF @lineVATIsIncluded = 0 OR @ApplyVAT = 0 SET @linePrice = @t1 ELSE SET @linePrice = @t2
						IF @ApplyVAT = 1 SET @lineVAT = @vt ELSE SET @lineVAT = 0.0
						SET @continue = 0
					END
				END 
				ELSE IF @lineDocumentClass = @ExpenseClass
				BEGIN
					SELECT 
						@t1 = [Price], @t2 = [Amount], @vt = [VAT], @vi = [VATIsIncluded], @cc = [FromCurrencyCode]
					FROM
						[Expense]
					WHERE	
						[ID] = @lineDocumentID
					IF @cc = @CurrencyCode
					BEGIN
						SET @lineVATIsIncluded = @vi
						IF @lineVATIsIncluded = @ApplyVAT OR @lineVATIsIncluded = 0
							SET @linePrice = @t1 
						ELSE
							SET @linePrice = ROUND((@t1 * @t2 - @vt) / @t2, 2)
						IF @ApplyVAT = 1 SET @lineVAT = @vt ELSE SET @lineVAT = 0.0
						SET @continue = 0
					END
				END
				IF @continue = 1
				BEGIN
					IF @CurrencyCode != @NationalCurrencyCode
						SET @linePrice = ROUND(ROUND(@linePricePC * @lineAmount / @CurrencyRate, 2) / @lineAmount, 2)
					ELSE
						SET @linePrice = ROUND(ROUND(@linePricePC * @lineAmount * @CurrencyRate, 2) / @lineAmount, 2)
						
					IF @ApplyVAT = 1 
					BEGIN
						SET @lineVAT = @linePrice * @lineAmount * @lineVATRate
						IF @lineVATIsIncluded = 1
							SET @lineVAT = @lineVAT / (1.0 + @lineVATRate)
						SET @lineVAT = ROUND(@lineVAT, 2)
					END
					ELSE SET @lineVAT = 0.0
				END
			END
			INSERT INTO @lines 
				(
				ID, DocumentClass, DocumentID, Description,
				Amount, VATRate, VATIsIncluded, Price, VAT, PricePC, VATPC, UOMID, ServiceTypeID, BasePrice, SortKey
				)
			VALUES 
				(@lineID, @lineDocumentClass, @lineDocumentID, @lineDescription,
				@lineAmount, @lineVATRate, @lineVATIsIncluded,
				@linePrice, @lineVAT, 
				@linePricePC, @lineVATPC, @lineUOMID, @lineServiceTypeID, @lineBasePrice, @lineSortKey
				)
				
			FETCH NEXT FROM statementLines INTO
				@lineID, 
				@lineStatementID, @lineDocumentClass, @lineDocumentID, @lineDescription,
				@lineAmount, @lineVATRate,
				@lineVATIsIncluded,
				@linePrice, @lineVAT, @linePricePC,
				@lineVATPC, @lineUOMID, @lineServiceTypeID, @lineBasePrice, @lineSortKey
		END
		CLOSE statementLines
		DEALLOCATE statementLines
	END
	ELSE
	BEGIN
		SELECT 
			/*@PaymentValue = ISNULL(SUM([PaymentDetail].[PaymentValue]), 0),
			@PaymentValuePC = ISNULL(SUM([PaymentDetail].[Value]), 0),
			@PaymentVAT = ISNULL(SUM([PaymentDetail].[PaymentVAT]), 0),
			@PaymentVATPC = ISNULL(SUM([PaymentDetail].[VAT]), 0)*/
			@PaymentValue = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValue]), 0),
			@PaymentValuePC = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValuePC]), 0),
			@PaymentVAT = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentVAT]), 0),
			@PaymentVATPC = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentVATPC]), 0)
		FROM
			[StatementAdvanceInvoice]/* 
			INNER JOIN [Invoice]
				ON [Invoice].[ID] = [StatementAdvanceInvoice].[AdvanceInvoiceID]
			INNER JOIN [PaymentDetail]
				ON [PaymentDetail].[InvoiceID] = [Invoice].[ID]
			*/
		WHERE
			[StatementAdvanceInvoice].[StatementID] = @DocumentID

		SELECT 
			@StatementCurrencyCode = [Statement].[CurrencyCode],
			@StatementCurrencyRate  = [Statement].[CurrencyRate],

			@StatementValue = [Statement].[TotalWithVAT],
			@StatementValuePC = [Statement].[TotalWithVATPC],
			@StatementVAT = [Statement].[VAT],
			@StatementVATPC = [Statement].[VATPC]
		FROM
			[Statement] 
		WHERE
			[Statement].[ID] = @DocumentID
			
		SET @linePricePC = @StatementValuePC - @PaymentValuePC
		SET @lineVATPC = @StatementVATPC - @PaymentVATPC
		SET @linePrice = @StatementValue - @PaymentValue
		SET @lineVAT = @StatementVAT - @PaymentVAT
		IF @StatementCurrencyRate != @CurrencyRate
		BEGIN
			IF @CurrencyRate != 1
			BEGIN
				IF @CurrencyCode != @NationalCurrencyCode
					SET @linePrice = ROUND(@linePricePC / @CurrencyRate, 2)
				ELSE
					SET @linePrice = ROUND(@linePricePC * @CurrencyRate, 2)
					
				IF @ApplyVAT = 1 
					SET @lineVAT = ROUND(@linePrice * @VATRate / (1.0 + @VATRate), 2)
				ELSE
					SET @lineVAT = 0.0
			END
			ELSE
			BEGIN
				SET @linePrice = @linePricePC
				SET @lineVAT = @lineVATPC
			END
		END
		INSERT INTO @lines 
			(
			ID, DocumentClass, DocumentID, Description,
			Amount, VATRate, VATIsIncluded, Price, VAT, PricePC, VATPC, UOMID, ServiceTypeID, BasePrice, SortKey
			)
		VALUES 
			(1, NULL, NULL, @Description,
			1, @VATRate, 1,
			@linePrice, @lineVAT, @linePricePC, @lineVATPC, NULL, @ServiceTypeID, 1, '1'
			)
	END
	EXEC sp_xml_removedocument @doc

	IF @ApplyVAT = 0 SET @VATIsIncluded = 0
	IF @ProjectCurrencyCode = @CurrencyCode
		SET @InvoiceCurrencyRate = 1.0
	IF @ProjectCurrencyCode = @BaseCurrencyCode
		SET @InvoiceBaseCurrencyRate = 1.0
		
	DECLARE 
		@c1 TCode3,
		@c2 TCode3
	IF @InvoiceCurrencyRate IS NULL
	BEGIN
		IF @NationalCurrencyCode = @CurrencyCode
		BEGIN
			SET @c1 = @ProjectCurrencyCode
			SET @c2 = @CurrencyCode
		END
		ELSE
		BEGIN
			SET @c2 = @ProjectCurrencyCode
			SET @c1 = @CurrencyCode
		END

		SELECT
			@InvoiceCurrencyRate = [Rate]
		FROM
			[CurrencyRate]
		WHERE
			[FromCurrencyCode] = @c1 AND 
			[ToCurrencyCode] = @c2 AND
			@Date BETWEEN [ValidFrom] AND [ValidTo]
	END
	IF @InvoiceBaseCurrencyRate IS NULL
	BEGIN
		IF @NationalCurrencyCode = @ProjectCurrencyCode
		BEGIN
			SET @c1 = @BaseCurrencyCode
			SET @c2 = @ProjectCurrencyCode
		END
		ELSE
		BEGIN
			SET @c2 = @BaseCurrencyCode
			SET @c1 = @ProjectCurrencyCode
		END

		SELECT
			@InvoiceBaseCurrencyRate = [Rate]
		FROM
			[CurrencyRate]
		WHERE
			[FromCurrencyCode] = @c1 AND 
			[ToCurrencyCode] = @c2 AND
			@Date BETWEEN [ValidFrom] AND [ValidTo]
	END

	DECLARE @InvoiceDueDate TDate
	
	IF @InvoiceExpirationPeriodType = 1
		SET @InvoiceDueDate = dbo.fnPjm5AddWorkingDays(@Date, @InvoiceExpirationPeriod)
	ELSE
		SET @InvoiceDueDate = DATEADD(day, @InvoiceExpirationPeriod - 1, @Date)

	INSERT INTO [Invoice]
		([Flag], [State], [Date], [Number], [FileAs],
		 [SupplierBankAccountID], [ProjectID],
		 [CurrencyRate], [BaseCurrencyRate], [CurrencyCode], 
		 [PaymentCurrencyPoint], [DueDate], [InvoiceExpirationPeriodType],
		 [SupplierCompanyID], [CustomerCompanyID],
		 [Scale])
	VALUES(0, @State, @Date, @Number, @FileAs,
		@BankAccountID, @ProjectID,
		@InvoiceCurrencyRate, @InvoiceBaseCurrencyRate, @CurrencyCode,
		@PaymentCurrencyPoint, @InvoiceDueDate, @InvoiceExpirationPeriodType,
		@SupplierCompanyID, @CustomerCompanyID,
		@Scale)
	IF @@ERROR != 0
		RETURN 1
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [InvoiceLine] (
		[InvoiceID], [DocumentClass], [DocumentID], [Description], [Amount], [VATIsIncluded], [VATRate], 
		[Price], [VAT], [PricePC], [VATPC], 
		[UOMID], [ServiceTypeID],
		[TotalBC], [TotalWithVATBC],[BasePrice],[SortKey])
	SELECT 
		@ID, [DocumentClass], [DocumentID], [Description], [Amount], [VATIsIncluded], [VATRate], 
		[Price], [VAT], [PricePC], [VATPC], 
		[UOMID], [ServiceTypeID],
		ROUND(CASE 
						WHEN @ProjectCurrencyCode = @BaseCurrencyCode
							THEN [PricePC] * [Amount] - [VATIsIncluded] * [VATPC]
						WHEN @ProjectCurrencyCode = @NationalCurrencyCode
							THEN ([PricePC] * [Amount] - [VATIsIncluded] * [VATPC]) / @InvoiceBaseCurrencyRate
						ELSE ([PricePC] * [Amount] - [VATIsIncluded] * [VATPC]) * @InvoiceBaseCurrencyRate
					END, 2),
		ROUND(CASE 
						WHEN @ProjectCurrencyCode = @BaseCurrencyCode
							THEN [PricePC] * [Amount] + (1 - [VATIsIncluded]) * [VATPC]
						WHEN @ProjectCurrencyCode = @NationalCurrencyCode
							THEN ([PricePC] * [Amount] + (1 - [VATIsIncluded]) * [VATPC]) / @InvoiceBaseCurrencyRate
						ELSE ([PricePC] * [Amount] + (1 - [VATIsIncluded]) * [VATPC]) * @InvoiceBaseCurrencyRate
					END, 2),
		[BasePrice],
		[SortKey]
	FROM @lines
	IF @@ERROR != 0
		RETURN 1
	
	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@StatementClass, @DocumentID, '',
		@Class, @ID, 2)	
	IF @@ERROR != 0
		RETURN 1

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(@Class, @ID, '',
		@StatementClass, @DocumentID, 2)	
	
	IF @@ERROR != 0
		RETURN 1
		
	DECLARE 
		@UserID TIdentifier,
		@InvoiceClass TClass,
		@ReminderPublishState TState,
		@ReminderPublishInterval TTimeSpan,
		@ReminderState TState,
		@ReminderInterval TTimeSpan
	
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@ReminderPublishState = dbo.fnPjm5GetUserInitialReminderState(@InvoiceClass, 'VA', @UserID),
		@ReminderPublishInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VA', @UserID),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@InvoiceClass, 'VP', @UserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VP', @UserID)

	EXEC @rv = pjm5InvoiceReminderCreate @ID, 'VP',
		@InvoiceDueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	EXEC @rv = pjm5InvoiceReminderCreate @ID, 'VA',
		@Date, @ReminderPublishState, @ReminderPublishInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5GenerateInvoiceFromStatement TO PUBLIC
GO

