 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceCreate'
		DROP PROCEDURE [dbo].[pjm5InvoiceCreate]
	END
GO

PRINT 'Creating procedure pjm5InvoiceCreate'
GO

/******************************************************************************
**		File: pjm5InvoiceCreate.sql
**		Name: pjm5InvoiceCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceCreate]
	@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@ApplyVAT bit,
			@VATRate TPercent,
			@ProjectType TIdentifier,
			@InvoiceExpirationPeriod TCount,
			@InvoiceExpirationPeriodType TIdentifier,
			@ProjectCurrencyCode TCode3,
			@CurrencyCode TCode3,
			@value TVariant,			
			@doc int,
			@CurrencyRate TMoney,
			@BaseCurrencyRate TMoney,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ReminderPublishState TState,
			@ReminderPublishTime TDateTime,
			@ReminderPublishInterval TTimeSpan,
			@Date TDate,
			@DueDate TDate,
			@rv int,
			@InvoiceClass TClass,
			@UserID TIdentifier,
			@Scale TCount
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('98b8f49e-202e-4b46-8074-421734078da6')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	--   Number   FileAs
	SELECT 
		@ProjectID = [XmlTable].[ProjectID],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		@CurrencyRate = [XmlTable].[CurrencyRate],
		@BaseCurrencyRate = [XmlTable].[BaseCurrencyRate],
		@ApplyVAT = [Project].[ApplyVAT],
		@VATRate = 0,
		@ProjectType = [Project].[ProjectTypeID],
		@ProjectCurrencyCode = [Project].[CurrencyCode],
		@InvoiceExpirationPeriod = [Project].[InvoiceExpirationPeriod],
		@InvoiceExpirationPeriodType = [Project].[InvoiceExpirationPeriodType],
		@ReminderPublishState = CASE [XmlTable].[ReminderPublishState] WHEN 'false' THEN 0 ELSE 1 END,
		@ReminderPublishTime = CONVERT(datetime, [XmlTable].[ReminderPublishTime]),
		@Date = CONVERT(datetime, [XmlTable].[Date]),
		@DueDate = (CASE WHEN @InvoiceExpirationPeriodType = 1 
			THEN dbo.fnPjm5AddWorkingDays(CONVERT(datetime, [XmlTable].[Date]), @InvoiceExpirationPeriod)
			ELSE DATEADD(day, @InvoiceExpirationPeriod, CONVERT(datetime, [XmlTable].[Date]))
		END),
		@Scale = [Project].[Scale]
	FROM
		OPENXML(@doc, '/pjm5InvoiceGet/Invoice', 2)
			WITH (
				[ProjectID] int,
				[CurrencyCode] char(3),
				[CurrencyRate] decimal(18, 4),
				[BaseCurrencyRate] decimal(18, 4),
				[ReminderPublishState] varchar(5),
				[ReminderPublishTime] varchar(19),
				[Date] nvarchar(19)
				) AS [XmlTable]
		INNER JOIN [Project]
			ON [Project].[ID] = [XmlTable].[ProjectID]
			
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('ManageAllInvoices')) = 0 AND
		dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, NULL, NULL) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @ProjectType NOT IN (1, 2)
	BEGIN
		RAISERROR('#wrongprojecttype', 18, -1)
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	DECLARE @Class TClass
	SET @Class = dbo.adfGetClassByName('Pjm5.Invoice')
	
	DECLARE @BaseCurrencyCode TCode3
	EXEC adfParameterGet @Name='BaseCurrency', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @BaseCurrencyCode = CAST(@value as varchar(3))

	IF @BaseCurrencyCode = @ProjectCurrencyCode
		SET @BaseCurrencyRate = 1.0
	IF @ProjectCurrencyCode = @CurrencyCode
		SET @CurrencyRate = 1.0

	DECLARE
		@RecurrenceID TIdentifier,
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate = CAST([StartDate] as datetime),
		@REndDate = CAST([EndDate] as datetime),
		@RRecurrenceType = [RecurrenceType],
		@ROccurrences = [Occurrences],
		@RInterval = [Interval],
		@RDayOfWeekMask = [DayOfWeekMask],
		@RInstance = [Instance],
		@RMonthOfYear = [MonthOfYear],
		@RDayOfMonth = [DayOfMonth]
	FROM
		OPENXML(@doc, '/pjm5InvoiceGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19) 'StartDate',
				[EndDate] varchar(19) 'EndDate',
				[RecurrenceType] int 'RecurrenceType',
				[Occurrences] int 'Occurrences',
				[Interval] int 'Interval',
				[DayOfWeekMask] int 'DayOfWeekMask',
				[Instance] int 'Instance',
				[MonthOfYear] int 'MonthOfYear',
				[DayOfMonth] int 'DayOfMonth'
				)

	BEGIN TRANSACTION
	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END

	INSERT INTO [Invoice]
		([Flag], [State], [Date], [Number], [FileAs],
		 [SupplierBankAccountID], [ProjectID],
		 [CurrencyRate], [BaseCurrencyRate], [CurrencyCode], 
		 [Comments], [PaymentCurrencyPoint], 
		 [Advance], [DueDate], [InvoiceExpirationPeriodType],
		 [TotalPC], [TotalWithVATPC], [TotalBC], [TotalWithVATBC],
		 [SupplierCompanyID], [CustomerCompanyID],
		 [Scale])
	SELECT
		0,
		@State,
		CONVERT(datetime, [Date]),
		ISNULL([Number], ''),
		[FileAs],
		[SupplierBankAccountID],
		[ProjectID],
		@CurrencyRate,
		@BaseCurrencyRate,
		[CurrencyCode],
		[Comments],
		[PaymentCurrencyPoint],
		(CASE [Advance] WHEN 'false' THEN 0 ELSE 1 END) AS [Advance],
		(CASE WHEN @InvoiceExpirationPeriodType = 1 
			THEN dbo.fnPjm5AddWorkingDays(CONVERT(datetime, [Date]), @InvoiceExpirationPeriod)
			ELSE DATEADD(day, @InvoiceExpirationPeriod - 1, CONVERT(datetime, [Date]))
		END),
		@InvoiceExpirationPeriodType,
		0, 0, 0, 0,
		[SupplierCompanyID], [CustomerCompanyID],
		@Scale
	FROM
		OPENXML(@doc, '/pjm5InvoiceGet/Invoice', 2)
			WITH (
				[Date] nvarchar(19),
				[Number] varchar(32),
				[FileAs] nvarchar(512),
				[SupplierCompanyID] int,
				[SupplierBankAccountID] int,
				[CustomerCompanyID] int,
				[ProjectID] int,
				[CurrencyRate] money,
				[BaseCurrencyRate] money,
				[CurrencyCode] char(3),
				[Comments] nvarchar(max),
				[PaymentCurrencyPoint] int,
				[Advance] varchar(5)
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @Class AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	
	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@InvoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@ReminderPublishState = dbo.fnPjm5GetUserInitialReminderState(@InvoiceClass, 'VA', @UserID),
		@ReminderPublishInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VA', @UserID),
		@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@InvoiceClass, 'VP', @UserID),
		@ReminderInterval = dbo.fnPjm5GetReminderInterval(@InvoiceClass, 'VP', @UserID)

	EXEC @rv = pjm5InvoiceReminderCreate @ID, 'VP',
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	EXEC @rv = pjm5InvoiceReminderCreate @ID, 'VA',
		@Date, @ReminderPublishState, @ReminderPublishInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	COMMIT TRANSACTION
	EXEC sp_xml_removedocument @doc

	EXEC pjm5InvoiceGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5InvoiceCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceCreateFromWizard]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5InvoiceCreateFromWizard'
	DROP PROCEDURE [dbo].[pjm5InvoiceCreateFromWizard]
END
GO
