 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5InvoiceGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5InvoiceGet'
		DROP PROCEDURE [dbo].[pjm5InvoiceGet]
	END
GO

PRINT 'Creating procedure pjm5InvoiceGet'
GO

/******************************************************************************
**		File: pjm5InvoiceGet.sql
**		Name: pjm5InvoiceGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/20/2005 15:20:31
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5InvoiceGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@ProjectID TIdentifier,
		@Class	TClass,
		@Lang	TLanguage

	SET @Lang = dbo.adfGetLanguage()

	SELECT
		@ProjectID = [Invoice].[ProjectID],
		@Class = [Invoice].[Class]
	FROM 
		[Invoice]
	WHERE
		[Invoice].[ID] = @ID
	DECLARE @EmployeeID TIdentifier
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5HasFinansDataAccess(@ProjectID, @EmployeeID, @Class, NULL) != 1
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE
		@RecurrencePatternID TIdentifier,
		@UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	SELECT @RecurrencePatternID = [RecurrencePatternID] FROM [Document] WHERE [Document].[Class] = @Class AND [Document].[ID] = @ID

	DECLARE
		@value TMoney,
		@vat TMoney,
		@valuePC TMoney,
		@vatPC TMoney,
		@advanceCount TCount,
		@advanceValue TMoney,
		@advanceVat TMoney,
		@statementPaymentValue TMoney,
		@statementPaymentVAT TMoney,
		@statementPaymentValuePC TMoney,
		@statementPaymentVATPC TMoney,
		@paymentValue TMoney,
		@paymentVat TMoney
		
	SELECT 
		@value = ISNULL(SUM([PaymentDetail].[PaymentValue]), 0),
		@vat = ISNULL(SUM([PaymentDetail].[PaymentVAT]), 0),
		@valuePC = ISNULL(SUM([PaymentDetail].[Value]), 0),
		@vatPC = ISNULL(SUM([PaymentDetail].[VAT]), 0)
	FROM
		[PaymentDetail]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE
		[PaymentDetail].[InvoiceID] = @ID AND
		[Payment].[State] IN (2, 3)

	SELECT 
		@advanceCount = COUNT(*),
		@advanceValue = ISNULL(SUM([Invoice].[TotalWithVAT]), 0),
		@advanceVat = ISNULL(SUM([Invoice].[VAT]), 0)	
	FROM
		[AdvanceInvoice] 
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [AdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[AdvanceInvoice].[InvoiceID] = @ID

	SELECT 
		@statementPaymentValue = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValue]), 0),
		@statementPaymentVAT = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentVAT]), 0),	
		@statementPaymentValuePC = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentValuePC]), 0),
		@statementPaymentVATPC = ISNULL(SUM([StatementAdvanceInvoice].[StatementPaymentVATPC]), 0)	
	FROM
		[StatementAdvanceInvoice] 
	WHERE
		[StatementAdvanceInvoice].[AdvanceInvoiceID] = @ID

	SELECT
		@paymentValue = SUM(ISNULL([PaymentDetail].[PaymentValue], 0.0)),
		@paymentVat = SUM(ISNULL([PaymentDetail].[PaymentVAT], 0.0))
	FROM
		[AdvanceInvoice] 
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [AdvanceInvoice].[AdvanceInvoiceID]
		INNER JOIN [PaymentDetail]
			ON [PaymentDetail].[InvoiceID] = [Invoice].[ID]
	WHERE
		[AdvanceInvoice].[InvoiceID] = @ID
		
	SELECT
		[Invoice].[Class],
		[Invoice].[ID],
		[Invoice].[State],
		[Invoice].[Flag],
		[Invoice].[WarningFlagID],
		ISNULL([WarningFlagGlobal].[FileAs], [WarningFlag].[FileAs]) AS [WarningMessage],
		[WarningFlag].[WarningType],
		[Invoice].[Date],
		[Invoice].[DueDate],
		[Invoice].[InvoiceExpirationPeriodType],
		[Invoice].[Number],
		[Invoice].[FileAs],
		[Invoice].[SupplierBankAccountID],
		[Invoice].[ProjectID],
		[Invoice].[CurrencyCode],
		[Invoice].[CurrencyRate],
		[Invoice].[BaseCurrencyRate],
		[Invoice].[Comments],
		[Invoice].[Created],
		[Invoice].[CreatedBy],
		[Invoice].[Modified],
		[Invoice].[ModifiedBy],
		[Invoice].[Timestamp],
		[Project].[CurrencyCode] AS [ProjectCurrencyCode],
		[Invoice].[SupplierCompanyID],
		[Invoice].[CustomerCompanyID],
		[Project].[ContractNumber],
		[Invoice].[PaymentCurrencyPoint],
		[Invoice].[Advance],
		[Invoice].[Total],
		[Invoice].[TotalWithVAT],
		[Invoice].[VAT],
		[Invoice].[TotalPC],
		[Invoice].[TotalWithVATPC],
		[Invoice].[VATPC],
		@value AS [PaymentValue],
		@vat AS [PaymentVAT],
		@valuePC AS [PaymentValuePC],
		@vatPC AS [PaymentVATPC],
		[AdvanceInvoice].[InvoiceID],
		ISNULL(@advanceCount, 0) AS [AdvanceCount],
		@advanceValue AS [AdvanceValue],
		@advanceVat AS [AdvanceVAT],
		@statementPaymentValue AS [StatementPaymentValue],
		@statementPaymentVAT AS [StatementPaymentVAT],	
		@statementPaymentValuePC AS [StatementPaymentValuePC],
		@statementPaymentVATPC AS [StatementPaymentVATPC],	
		@paymentValue AS [AdvancePaymentValue],
		@paymentVat AS [AdvancePaymentVAT],
		@RecurrencePatternID AS [RecurrencePatternID],
		ISNULL([UserReminder].[State], CAST(0 as int)) AS [ReminderState],
		CASE
			WHEN [UserReminder].[OriginalInterval] IS NOT NULL THEN
				DATEADD(minute,-[UserReminder].[OriginalInterval],[Invoice].[DueDate])
			ELSE
				DATEADD(minute,
					-dbo.fnPjm5GetReminderInterval([Invoice].[Class], 'VP', @UserID),
					[Invoice].[DueDate])
		END
		AS [ReminderTime],
		ISNULL([UserReminderPublish].[State], CAST(0 as int)) AS [ReminderPublishState],
		CASE
			WHEN [UserReminderPublish].[OriginalInterval] IS NOT NULL THEN
				DATEADD(minute,-[UserReminderPublish].[OriginalInterval],[Invoice].[Date])
			ELSE
				DATEADD(minute,
					-dbo.fnPjm5GetReminderInterval([Invoice].[Class], 'VA', @UserID),
					[Invoice].[Date])
		END
		AS [ReminderPublishTime],
		[Invoice].[Scale],
		[Invoice].[ExchangeBanned],
		[ExportItem].[Date] as [Exported],
		[ExportItem].[EmployeeID] as [ExportedBy]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Invoice].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [AdvanceInvoice]
			ON [AdvanceInvoice].[AdvanceInvoiceID] = [Invoice].[ID]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [Invoice].[Class] AND
				[Reminder].[DocumentID] = [Invoice].[ID] AND
				[Reminder].[Subtype] = 'VP')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
		LEFT OUTER JOIN [Reminder] AS [ReminderPublish]
			ON ([ReminderPublish].[DocumentClass] = [Invoice].[Class] AND
				[ReminderPublish].[DocumentID] = [Invoice].[ID] AND
				[ReminderPublish].[Subtype] = 'VA')
		LEFT OUTER JOIN [UserReminder] AS [UserReminderPublish]
			ON ([ReminderPublish].[ID] = [UserReminderPublish].[ReminderID] AND
				[UserReminderPublish].[UserID] = @UserID)
		LEFT OUTER JOIN [ExportItem]
			ON [Invoice].[ExportItemID] = [ExportItem].[ID]
		LEFT OUTER JOIN [WarningFlag]
			ON [WarningFlag].[ID] = [Invoice].[WarningFlagID]
		LEFT OUTER JOIN [WarningFlagGlobal] 
			ON ([WarningFlag].[ID] = [WarningFlagGlobal].[ID]
				AND [WarningFlagGlobal].[Language] = @Lang)
	WHERE
		[Invoice].[ID] = @ID
		
	SELECT
		[InvoiceLine].[ID],
		[InvoiceLine].[DocumentClass],
		[InvoiceLine].[DocumentID],
		[InvoiceLine].[Description],
		[InvoiceLine].[ServiceTypeID],
		[InvoiceLine].[Amount],
		[InvoiceLine].[UOMID],
		[UOM].[Code] AS [UOMCode],
		[InvoiceLine].[VATRate],
		[InvoiceLine].[VATIsIncluded],
		[InvoiceLine].[Price],
		
		CASE 
			WHEN [InvoiceLine].[VATIsIncluded] = 1 OR [InvoiceLine].[VAT] = 0
				THEN [InvoiceLine].[Price] 
			WHEN [InvoiceLine].[VATIsIncluded] = 0 AND [InvoiceLine].[Amount] != 0
				THEN ROUND([InvoiceLine].[Price] * [InvoiceLine].[Amount] + [InvoiceLine].[VAT], [Invoice].[Scale]) / [InvoiceLine].[Amount]
			ELSE [InvoiceLine].[Price] * (1 + [InvoiceLine].[VATRate])
		END [PriceWithVAT],
		
		[InvoiceLine].[VAT],
		ROUND(CASE 
				WHEN [InvoiceLine].[VATIsIncluded] = 1
					THEN [InvoiceLine].[Price] * [InvoiceLine].[Amount]
				ELSE [InvoiceLine].[Price] * [InvoiceLine].[Amount] + [InvoiceLine].[VAT]
			END, [Invoice].[Scale]) AS [SumWithVAT],
		[InvoiceLine].[PricePC],
		
		CASE 
			WHEN [InvoiceLine].[VATIsIncluded] = 1
				THEN [InvoiceLine].[PricePC]
			WHEN [InvoiceLine].[Amount] != 0 AND [InvoiceLine].[VATPC] = 0
				THEN [InvoiceLine].[PricePC]
			WHEN [InvoiceLine].[Amount] = 0
				THEN [InvoiceLine].[PricePC] * (1 + [InvoiceLine].[VATRate])
			ELSE
				ROUND(ROUND([InvoiceLine].[PricePC] * [InvoiceLine].[Amount] + [InvoiceLine].[VATPC], [Invoice].[Scale]) / [InvoiceLine].[Amount], [Invoice].[Scale]) 
		END AS  [PriceWithVATPC],
		
		[InvoiceLine].[VATPC],

		ROUND(CASE 
				WHEN [InvoiceLine].[VATIsIncluded] = 1
					THEN [InvoiceLine].[PricePC] * [InvoiceLine].[Amount]
				ELSE [InvoiceLine].[PricePC] * [InvoiceLine].[Amount] + [InvoiceLine].[VATPC]
			END, [Invoice].[Scale]) AS [SumPC],
		[InvoiceLine].[BasePrice],
		[InvoiceLine].[SortKey],
		[ServiceType].[FileAs] AS [ServiceTypeFileAs]
	FROM
		[InvoiceLine]
		INNER JOIN [Invoice]
			ON [InvoiceLine].[InvoiceID] = [Invoice].[ID]
		LEFT OUTER JOIN [UOM]
			ON [InvoiceLine].[UOMID] = [UOM].[ID]
		LEFT OUTER JOIN [ServiceType]
			ON [InvoiceLine].[ServiceTypeID] = [ServiceType].[ID]
	WHERE
		([InvoiceLine].[InvoiceID] = @ID)
	ORDER BY 
		[InvoiceLine].[Description]
	
	SELECT
		[RecurrencePattern].[ID],
		[RecurrencePattern].[StartDate],
		[RecurrencePattern].[EndDate],
		[RecurrencePattern].[Occurrences],
		[RecurrencePattern].[RecurrenceType],
		[RecurrencePattern].[Interval],
		[RecurrencePattern].[DayOfWeekMask],
		[RecurrencePattern].[Instance],
		[RecurrencePattern].[MonthOfYear],
		[RecurrencePattern].[DayOfMonth]
	FROM
		[RecurrencePattern]
	WHERE
		[RecurrencePattern].[ID] = @RecurrencePatternID

	SELECT
		[StatementAdvanceInvoice].[AdvanceInvoiceID],
		[StatementAdvanceInvoice].[StatementID]
	FROM
		[StatementAdvanceInvoice]
	WHERE
		[StatementAdvanceInvoice].[AdvanceInvoiceID] = @ID
	RETURN 0
GO

GRANT EXECUTE ON [pjm5InvoiceGet] TO PUBLIC
GO
