IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmCalendarProjects')
	BEGIN
		PRINT 'Dropping Procedure lmCalendarProjects'
		DROP  Procedure  lmCalendarProjects
	END

GO

PRINT 'Creating Procedure lmCalendarProjects'
GO
/******************************************************************************
**		File: 
**		Name: lmCalendarProjects
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure lmCalendarProjects
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier,
			@UserID TIdentifier,
			@IsAssistant TBool

	SET @IsAssistant = dbo.fnPjm5IsAssistant()	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT
		[ID],
		[Number] as [Code],
		[FileAs] as [Name],
		CAST((CASE WHEN [CalendarProject].[ProjectID] IS NULL THEN 0 ELSE 1 END) AS BIT) as [Selected]
	FROM
		[Project]
		LEFT OUTER JOIN [CalendarProject]
			ON ([Project].[ID] = [CalendarProject].[ProjectID] AND [CalendarProject].[UserID] = @UserID)
	WHERE
		[State] = 2 AND 
		(@IsAssistant = 1 OR [Project].[ID] IN (SELECT [ID] FROM dbo.fnPjm6GetAvailableProjectsForProjectMemberAndManager()))
		
	RETURN 0
GO

GRANT EXEC ON lmCalendarProjects TO PUBLIC
GO
  