IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'lmOwnCompanyExchange')
	BEGIN
		PRINT 'Dropping Procedure lmOwnCompanyExchange'
		DROP  Procedure  lmOwnCompanyExchange
	END

GO

PRINT 'Creating Procedure lmOwnCompanyExchange'
GO
/******************************************************************************
**		File: lmOwnCompanyExchange
**		Name: lmOwnCompanyExchange
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**      21.06.10	SPV				first version
*******************************************************************************/
CREATE Procedure lmOwnCompanyExchange
AS
	SET NOCOUNT ON
		
	SELECT
		[Company].[ID],
		[Company].[FileAs] as [Name],
		[Company].[ExchangeBanned]
	FROM
		[Company]
	WHERE
		[Company].[State] = 1 AND
		[Company].[Own] = 1
		
	RETURN 0
GO

GRANT EXEC ON lmOwnCompanyExchange TO PUBLIC
GO
