 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestSendResponse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestSendResponse'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestSendResponse]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestSendResponse'
GO

/******************************************************************************
**		File: pjm5MeetingRequestSendResponse.sql
**		Name: pjm5MeetingRequestSendResponse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 06/05/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestSendResponse
	@MeetingRequestID TIdentifier,
	@ResponseType TCode,
	@FileAs TName,
	@Comments TNotes
AS
		
	SET NOCOUNT ON
	
	DECLARE @EmployeeID TIdentifier
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	IF NOT EXISTS(SELECT * FROM [Attendee] WHERE [MeetingRequestID] = @MeetingRequestID AND [EmployeeID] = @EmployeeID)
	BEGIN
		RAISERROR('#YouAreNotAttendee', 18, -1);
		RETURN 1;
	END
	
	IF NOT EXISTS(SELECT * FROM [MeetingRequest] WHERE [ID] = @MeetingRequestID AND [State] = 2)
	BEGIN
		RAISERROR('#MeetingNotAppointed', 18, -1)
		RETURN 1;
	END
	
	BEGIN TRANSACTION
	
	IF @FileAs IS NOT NULL
	BEGIN
		INSERT INTO [AttendeeResponse]
			([MeetingRequestID], [EmployeeID], [ResponseType], [FileAs], [Comments], [Created])
		VALUES
			(@MeetingRequestID, @EmployeeID, @ResponseType, @FileAs, @Comments, GETDATE())
			
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
			
	UPDATE [Attendee]
	SET
		[Present] = (CASE WHEN @ResponseType IN ('Tentative', 'Accept') THEN 1 ELSE 0 END),
		[ResponseType] = @ResponseType
	WHERE
		[MeetingRequestID] = @MeetingRequestID AND [EmployeeID] = @EmployeeID
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @ResponseType = 'Decline' 
	BEGIN
		DECLARE @ReminderID TIdentifier, @result int
		SELECT 
			@ReminderID = [ID]
		FROM 
			[Reminder]
		WHERE 
			[DocumentClass] = dbo.adfGetClassByName('Pjm5.MeetingRequest') 
			AND 
			[DocumentID] = @MeetingRequestID 
			AND
			[Subtype] = 'MS'
		IF @ReminderID IS NOT NULL
		BEGIN
			EXEC @result = pjm5ReminderDismiss @ReminderID
			IF @result != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	IF @ResponseType = 'Accept' OR @ResponseType = 'Tentative'
	BEGIN
		DECLARE @Reminder TIdentifier
		SELECT 
			@Reminder = [ID]
		FROM 
			[Reminder]
		WHERE 
			[DocumentClass] = dbo.adfGetClassByName('Pjm5.MeetingRequest') 
			AND 
			[DocumentID] = @MeetingRequestID 
			AND
			[Subtype] = 'MS'
		IF @Reminder IS NOT NULL
		BEGIN
			UPDATE [UserReminder] SET [State] = 1 WHERE UserID = dbo.adfGetCurrentUserID() AND [ReminderID] = @Reminder   
		END
	END
	
	COMMIT TRANSACTION

	DECLARE @Data Xml
	
	SET @Data = (SELECT 
			[EmployeeID],
			[ResponseType],
			[Subject],
			[Comments]
		FROM
			(SELECT
				@EmployeeID as [EmployeeID],
				@ResponseType as [ResponseType],
				@FileAs as [Subject],
				@Comments as [Comments]) as [Response]
		FOR XML AUTO, ELEMENTS)

	EXEC pjm5PostDocumentChangeNotificationEvent 'MeetingRequestResponse', 'Pjm5.MeetingRequest', @MeetingRequestID, @Data

	RETURN 0
GO

GRANT EXECUTE ON pjm5MeetingRequestSendResponse TO PUBLIC
GO
 