 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsTaskDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsTaskDelete'
		DROP PROCEDURE [dbo].[pjm6MsTaskDelete]
	END
GO

PRINT 'Creating procedure pjm6MsTaskDelete'
GO


CREATE PROCEDURE [pjm6MsTaskDelete] @ID TIdentifier
AS
	
	SET NOCOUNT ON

DECLARE @TaskID TIdentifier,
		@State TState,
		@SubprojectID TIdentifier
		
SELECT 
	@TaskID = [ID],
	@State = [State],
	@SubprojectID  = [SubprojectID]
FROM [Task] WHERE [MsTaskID] = @ID

IF @State = 3
	RETURN 0
	
IF(@State = 8 OR @SubprojectID IS NOT NULL)
BEGIN
	BEGIN TRANSACTION
	UPDATE [Task]
	SET [ParentID] = NULL
	WHERE [ParentID] = @TaskID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE [MsTask]
	SET [ParentID] = NULL
	WHERE [ParentID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [Task]
	WHERE [Task].[ID] = @TaskID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE [MsTask]
	WHERE [MsTask].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
END
ELSE
BEGIN
	UPDATE [BusyEntry]
	SET 
		[Work] = 0,
		[Planned] = 0,
		[OvertimeWork] = 0
	WHERE [TaskID] = @TaskID	

	UPDATE [Task]
	SET
		[ManHour]=0,
		[Budget]=0
	WHERE [ID] = @TaskID 

	UPDATE [MsTask]
	SET
		[Work]=0,
		[Cost]=0,
		[OvertimeWork]=0,
		[OvertimeCost]=0,
		[RemainingWork]=0,
		[RemainingCost]=0,
		[RemainingDuration]=0,
		[RemainingOvertimeWork]=0,
		[RemainingOvertimeCost]=0
	WHERE [ID] = @ID 

	UPDATE [MsAssignment]
	SET
		[Work]=0,
		[Cost]=0,
		[OvertimeWork]=0,
		[OvertimeCost]=0,
		[RemainingWork]=0,
		[RemainingCost]=0,
		[RemainingOvertimeWork]=0,
		[RemainingOvertimeCost]=0
	WHERE [TaskID] = @ID

	UPDATE [TaskAssignment]
	SET
		[Work]=0,
		[RemainingWork]=0,
		[RemainingOvertimeWork]=0,
		[Units]=0
	WHERE [TaskID] = @TaskID 
	
	UPDATE [Task]
	SET	[State] = 6
	WHERE [ID] = @TaskID 
END

BEGIN TRY
	BEGIN TRANSACTION;
	DELETE [Task]
	WHERE [ParentID] = @TaskID
	
	DELETE [Task]
	WHERE [ID] = @TaskID
	
	DELETE [MsTask]
	WHERE [ParentID] = @ID
	
	DELETE [MsTask]
	WHERE [MsTask].[ID] = @ID
	COMMIT TRANSACTION;
END TRY
BEGIN CATCH
	ROLLBACK TRANSACTION;
	
	
END CATCH;
RETURN 0
GO

GRANT EXECUTE ON [pjm6MsTaskDelete] TO PUBLIC
GO
   