IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TimeEntryCountGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TimeEntryCountGet'
		DROP PROCEDURE [dbo].[pjm6TimeEntryCountGet]
	END
GO

PRINT 'Creating procedure pjm6TimeEntryCountGet'
GO


CREATE PROCEDURE [pjm6TimeEntryCountGet]
	@ProjectID TIdentifier


AS
	
	SET NOCOUNT ON

	DECLARE @Val TVariant,
			@UncheckTimeEntrySentToApproval TBool
	EXEC adfParameterGet @Name='UncheckTimeEntrySentToApproval', @Group='Pjm6', @Value = @val OUTPUT
		SET @UncheckTimeEntrySentToApproval = CAST(@val as int)
	
	SELECT
		[ID]
	FROM 
		[TimeEntry]
	WHERE 
		[ProjectID] = @ProjectID
		AND [State] = 2
		AND @UncheckTimeEntrySentToApproval = 0
	SELECT
		[ID]
	FROM 
		[TimeEntry]
	WHERE 
		[ProjectID] = @ProjectID
		AND [State] in (2,3,6)
		AND [StartTime] > GetDate()

	SELECT
		[ID]
	FROM 
		[TimeEntry]
	WHERE 
		[ProjectID] = @ProjectID
		AND [State] in (1,5)
		AND [StartTime] <= GetDate()
		
	SELECT
		[TimeEntry].[ID]
	FROM 
		[TimeEntry]
			INNER JOIN [Project]
				ON [Project].[ID] = [TimeEntry].[ProjectID]
			INNER JOIN [MsProject]
				ON [MsProject].[ID] = [Project].[MsProjectID]
	WHERE 
		[TimeEntry].[ProjectID] = @ProjectID
		AND [TimeEntry].[Created] < [MsProject].[LastDateSync]
		AND [TimeEntry].[Modified] > [MsProject].[LastDateSync]
		AND [TimeEntry].[State] in (2,3,6)
			
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TimeEntryCountGet] TO PUBLIC
GO
 
