IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContactReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContactReminderCreate'
		DROP PROCEDURE [dbo].[pjm5ContactReminderCreate]
	END
GO

PRINT 'Creating procedure pjm5ContactReminderCreate'
GO

/******************************************************************************
**		File: pjm5ContactReminderCreate.sql
**		Name: pjm5ContactReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ContactReminderCreate]
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID TIdentifier,
		@rv int
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID()
		
	EXEC @rv = dbo.pjm5ReminderCreate @DocumentClass,
		@DocumentID,
		'NC',
		@ReminderEventTime,
		@CurrentUserID,
		@ReminderState,
		@ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ContactReminderCreate] TO PUBLIC
GO  