IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ExternalSubscriptionCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ExternalSubscriptionCreate'
		DROP PROCEDURE [dbo].[pjm5ExternalSubscriptionCreate]
	END
GO

PRINT 'Creating procedure pjm5ExternalSubscriptionCreate'
GO

/******************************************************************************
**		File: pjm5ExternalSubscriptionCreate.sql
**		Name: pjm5ExternalSubscriptionCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ExternalSubscriptionCreate]
	@SubscriptionRuleID TIdentifier,
	@SubscriptionTypeID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @ID TIdentifier
		
	IF NOT EXISTS (SELECT *
		FROM
			[Subscription]
		WHERE
			[SubscriptionRuleID] = @SubscriptionRuleID AND
			[SubscriptionTypeID] = @SubscriptionTypeID)
	BEGIN
		INSERT INTO [Subscription] ([SubscriptionTypeID], [SubscriptionRuleID])
		SELECT
			@SubscriptionTypeID, @SubscriptionRuleID
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ExternalSubscriptionCreate] TO PUBLIC
GO
    