IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderCreateInternal]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderCreateInternal'
		DROP PROCEDURE [dbo].[pjm5ReminderCreateInternal]
	END
GO

PRINT 'Creating procedure pjm5ReminderCreateInternal'
GO

/******************************************************************************
**		File: pjm5ReminderCreateInternal.sql
**		Name: pjm5ReminderCreateInternal
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderCreateInternal]
	@ID TIdentifier OUTPUT,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@ReminderSubtype TCode2,
	@ReminderEventTime TDateTime
AS
	SET NOCOUNT ON
	
	IF @DocumentClass IS NULL OR @DocumentID IS NULL
	BEGIN
		RETURN 1
	END
	
	SET @ID = NULL
	
	SELECT @ID = [ID]
	FROM [Reminder]
	WHERE 
		[DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND
		[Subtype] = @ReminderSubtype
	
	IF @ID IS NULL
	BEGIN
		INSERT INTO [Reminder] ([DocumentClass], [DocumentID], [Subtype], [EventTime])
		VALUES (@DocumentClass, @DocumentID, @ReminderSubtype, @ReminderEventTime)
		IF @@error != 0
		BEGIN
			RETURN 1
		END
		SET @ID = SCOPE_IDENTITY()
	END
	ELSE
	BEGIN
		UPDATE [Reminder] 
		SET [EventTime] = @ReminderEventTime
		WHERE [ID] = @ID
		IF @@error != 0
		BEGIN
			RETURN 1
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderCreateInternal] TO PUBLIC
GO