IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderDismiss]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderDismiss'
		DROP PROCEDURE [dbo].[pjm5ReminderDismiss]
	END
GO

PRINT 'Creating procedure pjm5ReminderDismiss'
GO

/******************************************************************************
**		File: pjm5ReminderDismiss.sql
**		Name: pjm5ReminderDismiss
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderDismiss]
	@ReminderID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	UPDATE [UserReminder]
	SET [State] = 0
	WHERE
		[ReminderID] = @ReminderID AND [UserID] = @UserID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderDismiss] TO PUBLIC
GO 