IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ReminderUserSettingsGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ReminderUserSettingsGet'
		DROP PROCEDURE [dbo].[pjm5ReminderUserSettingsGet]
	END
GO

PRINT 'Creating procedure pjm5ReminderUserSettingsGet'
GO

/******************************************************************************
**		File: pjm5ReminderUserSettingsGet.sql
**		Name: pjm5ReminderUserSettingsGet
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ReminderUserSettingsGet]
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT 
		[Class],
		[Subtype],
		[InitialState],
		[InitialInterval]
	FROM
		[ReminderSetting]
	WHERE
		[UserID] = @UserID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ReminderUserSettingsGet] TO PUBLIC
GO   