/*=========================================================*/
/* Database View:               */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwSendToApproveExpense]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwSendToApproveExpense]
go

create view pjm5vwSendToApproveExpense
as
	SELECT
		[Expense].[Class] as [DocumentClass],
		[Expense].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Expense].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Expense].[ModifiedBy] as [OwnerUserID]
	FROM
		[Expense]
	WHERE
		[Expense].[State] = 2
go

/*=====================================================================*/
/* Database View:       */
/*=====================================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRecipientSendToApproveExpense]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRecipientSendToApproveExpense]
go

create view pjm5vwRecipientSendToApproveExpense
as
	SELECT
		NULL as [DocumentClass],
		NULL as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Project].[ProjectManagerEmployeeID]
	WHERE
		[Project].[State] = 2
	UNION ALL
	SELECT
		NULL as [DocumentClass],
		NULL as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Project].[ID] as [ContainerID],
		[Employee].[UserID] as [UserID]
	FROM
		[Project]
		INNER JOIN [Assignment]
			ON [Assignment].[ProjectID] = [Project].[ID]
		INNER JOIN [AssignmentEntry]
			ON [Assignment].[ID] = [AssignmentEntry].[AssignmentID]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [AssignmentEntry].[EmployeeID]
	WHERE
		[Project].[State] = 2 AND [Assignment].[Approver] = 1 AND
		GETDATE() BETWEEN [AssignmentEntry].[ValidFrom] AND ISNULL([AssignmentEntry].[ValidTo], GETDATE())
go

/*==========================================================*/
/* Database View:                  */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwSendToWorkExpense]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwSendToWorkExpense]
go

create view pjm5vwSendToWorkExpense
as
	SELECT
		[Expense].[Class] as [DocumentClass],
		[Expense].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Expense].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[Expense].[ModifiedBy] as [OwnerUserID]
	FROM
		[Expense]
		INNER JOIN [Employee]
			ON [Expense].[EmployeeID] = [Employee].[ID]
	WHERE
		[Expense].[State] = 5
go

/*===========================================================*/
/* Database View:                            */
/*===========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwDenyExpense]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwDenyExpense]
go

create view pjm5vwDenyExpense
as
	SELECT
		[Expense].[Class] as [DocumentClass],
		[Expense].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Expense].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[Expense].[ModifiedBy] as [OwnerUserID]
	FROM
		[Expense]
		INNER JOIN [Employee]
			ON [Expense].[EmployeeID] = [Employee].[ID]
	WHERE
		[Expense].[State] = 4
go  