/*=======================================================*/
/* Database View:                        */
/*=======================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAdvanceInvoice]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAdvanceInvoice]
go

create view pjm5vwAdvanceInvoice
as
	SELECT
		[Invoice].[Class] as [DocumentClass],
		[Invoice].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Invoice].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Invoice].[ModifiedBy] as [OwnerUserID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] = 2
go

/*==================================================*/
/* Database View:                        */
/*==================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwPaidInvoice]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwPaidInvoice]
go

create view pjm5vwPaidInvoice
as
	SELECT
		[Invoice].[Class] as [DocumentClass],
		[Invoice].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Invoice].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Invoice].[ModifiedBy] as [OwnerUserID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] = 5
go

/*========================================================*/
/* Database View:                       */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCancelInvoice]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCancelInvoice]
go

create view pjm5vwCancelInvoice
as
	SELECT
		[Invoice].[Class] as [DocumentClass],
		[Invoice].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Invoice].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Invoice].[ModifiedBy] as [OwnerUserID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] = 3
go

/*========================================================*/
/* Database View:                       */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwRevisionInvoice]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwRevisionInvoice]
go

create view pjm5vwRevisionInvoice
as
	SELECT
		[Invoice].[Class] as [DocumentClass],
		[Invoice].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Invoice].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Invoice].[ModifiedBy] as [OwnerUserID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] = 1 AND EXISTS
		(
			SELECT *		
			FROM [Transition]
			INNER JOIN [TransitionTemplate]
				ON [TransitionTemplate].[ID] = [Transition].[TransitionTemplateID]
			WHERE
				[Transition].[Class] = [Invoice].[Class] AND
				(([TransitionTemplate].[FromState] = 2 AND
				 [TransitionTemplate].[ToState] = 1) OR
				([TransitionTemplate].[FromState] = 5 AND
				 [TransitionTemplate].[ToState] = 1)) AND
				[Transition].[ID] IN (
					SELECT TOP 1 [ID]
					FROM [Transition]
					WHERE [Class] = [Invoice].[Class] AND
					[DocumentID] = [Invoice].[ID]
					ORDER BY [Created] DESC
				)
		)	
go

/*========================================================*/
/* Database View:             */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderInvoiceVP]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderInvoiceVP]
go

create view pjm5vwReminderInvoiceVP
as
	SELECT
		[Invoice].[Class] as [DocumentClass],
		[Invoice].[ID] as [DocumentID],
		[Invoice].[DueDate] as [EventTime],
		NULL as [RecipientUserID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] = 2
go

grant select on [dbo].[pjm5vwReminderInvoiceVP] to [public]
go

/*========================================================*/
/* Database View:         */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderInvoiceVA]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderInvoiceVA]
go

create view pjm5vwReminderInvoiceVA
as
	SELECT
		[Invoice].[Class] as [DocumentClass],
		[Invoice].[ID] as [DocumentID],
		[Invoice].[Date] as [EventTime],
		NULL as [RecipientUserID]
	FROM
		[Invoice]
	WHERE
		[Invoice].[State] IN (1, 6)
go

grant select on [dbo].[pjm5vwReminderInvoiceVA] to [public]
go