/*=========================================================*/
/* Database View:                           */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwOpenIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwOpenIssue]
go

create view pjm5vwOpenIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		NUll as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
	WHERE
		[Issue].[State] = 2
go

/*==========================================================*/
/* Database View:                          */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwResolveIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwResolveIssue]
go

create view pjm5vwResolveIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		NULL as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
	WHERE
		[Issue].[State] = 4
go

/*===========================================================*/
/* Database View:                             */
/*===========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwCloseIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwCloseIssue]
go

create view pjm5vwCloseIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Issue].[EmployeeID]
	WHERE
		[Issue].[State] = 5
go

/*===========================================================*/
/* Database View:                          */
/*===========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwAssignOnIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwAssignOnIssue]
go

create view pjm5vwAssignOnIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Issue].[EmployeeID]
	WHERE
		[Issue].[State] = 3 AND [Employee].[UserID] IS NOT NULL
go

/*===========================================================*/
/* Database View:             */
/*===========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExclusionFromIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExclusionFromIssue]
go

create view pjm5vwExclusionFromIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		[Employee].[UserID] as [UserID],
		[Employee].[UserID] as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		INNER JOIN [Employee]
			ON [Employee].[ID] = [Issue].[EmployeeID]
	WHERE
		[Employee].[UserID] IS NOT NULL
go

/*==========================================================*/
/* Database View:         */
/*==========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwReminderIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwReminderIssue]
go

create view pjm5vwReminderIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		[Employee].[UserID] as [RecipientUserID],
		[Issue].[DueDate] as [EventTime]
	FROM
		[Issue]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Issue].[EmployeeID]
go

grant select on [dbo].[pjm5vwReminderIssue] to [public]
go

/*=========================================================*/
/* Database View:       */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExternalOpenIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExternalOpenIssue]
go

create view pjm5vwExternalOpenIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		NUll as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		INNER JOIN [PropertyValue]
			ON ([PropertyValue].[DocumentID] = [Issue].[ID] AND
				[PropertyValue].[DocumentClass] = [Issue].[Class])
		INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID] AND
			[Property].[Guid] = CAST('{00000001-0000-0000-0000-000000000000}' as uniqueidentifier))
	WHERE
		[Issue].[State] = 2
go

/*===========================================================*/
/* Database View:       */
/*===========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExternalResolveIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExternalResolveIssue]
go

create view pjm5vwExternalResolveIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		NUll as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		INNER JOIN [PropertyValue]
			ON ([PropertyValue].[DocumentID] = [Issue].[ID] AND
				[PropertyValue].[DocumentClass] = [Issue].[Class])
		INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID] AND
			[Property].[Guid] = CAST('{00000001-0000-0000-0000-000000000000}' as uniqueidentifier))
	WHERE
		[Issue].[State] = 4
go

/*=========================================================*/
/* Database View:       */
/*=========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExternalCloseIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExternalCloseIssue]
go

create view pjm5vwExternalCloseIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		NUll as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		INNER JOIN [PropertyValue]
			ON ([PropertyValue].[DocumentID] = [Issue].[ID] AND
				[PropertyValue].[DocumentClass] = [Issue].[Class])
		INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID] AND
			[Property].[Guid] = CAST('{00000001-0000-0000-0000-000000000000}' as uniqueidentifier))
	WHERE
		[Issue].[State] = 5
go

/*========================================================*/
/* Database View:       */
/*========================================================*/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pjm5vwExternalPostponeIssue]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[pjm5vwExternalPostponeIssue]
go

create view pjm5vwExternalPostponeIssue
as
	SELECT
		[Issue].[Class] as [DocumentClass],
		[Issue].[ID] as [DocumentID],
		dbo.adfGetClassByName('Pjm5.Project') as [ContainerClass],
		[Issue].[ProjectID] as [ContainerID],
		NUll as [UserID],
		NULL as [Value],
		[Issue].[ModifiedBy] as [OwnerUserID]
	FROM
		[Issue]
		INNER JOIN [PropertyValue]
			ON ([PropertyValue].[DocumentID] = [Issue].[ID] AND
				[PropertyValue].[DocumentClass] = [Issue].[Class])
		INNER JOIN [Property]
			ON ([PropertyValue].[PropertyID] = [Property].[ID] AND
			[Property].[Guid] = CAST('{00000001-0000-0000-0000-000000000000}' as uniqueidentifier))
	WHERE
		[Issue].[State] = 6
go