IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPaymentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfPaymentUpdate'
		DROP PROCEDURE [dbo].[adfPaymentUpdate]
	END
GO

PRINT 'Creating procedure adfPaymentUpdate'
GO

/******************************************************************************
**		File: adfPaymentUpdate.sql
**		Name: adfPaymentUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE adfPaymentUpdate
	@Xml XML
AS
	DECLARE @ID TIdentifier,
			@FileAs TName,
			@Date TDate,
			@Number TCode,
			@PaymentTypeID TIdentifier,
			@PayeeCompanyID TIdentifier,
			@PayeeBankAccountID TIdentifier,
			@PayerCompanyID TIdentifier,
			@Value TMoney,
			@BaseCurrencyRate TMoney,
			@CurrencyCode TCode3,
			@VAT TMoney,
			@Comments TNotes,
			@Reason TName,
			@Payer TName,
			@doc int
				
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT 
		@ID = [ID],
		@Date = CONVERT(datetime, [Date]),
		@FileAs = [FileAs],
		@Number = [Number],
		@PaymentTypeID = [PaymentTypeID],
		@CurrencyCode = [CurrencyCode],
		@PayeeCompanyID = [SupplierCompanyID],
		@PayeeBankAccountID = [PayeeBankAccountID],
		@PayerCompanyID = [CustomerCompanyID],
		@Value = [Value],
		@VAT = [VAT],
		@BaseCurrencyRate = [BaseCurrencyRate],
		@Comments = [Comments],
		@Reason = [Reason],
		@Payer = [Payer]
	FROM
		OPENXML(@doc, '/adfPaymentGet/Payment', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(512),
				[Date] nvarchar(19),
				[Number] varchar(32),
				[PaymentTypeID] int,
				[CurrencyCode] char(3),
				[SupplierCompanyID] int,
				[PayeeBankAccountID] int,
				[CustomerCompanyID] int,
				[Value] money,
				[VAT] money,
				[BaseCurrencyRate] money,
				[Comments] nvarchar(max),
				[Reason] nvarchar(256),
				[Payer] nvarchar(256)
				)

	EXEC sp_xml_removedocument @doc
	SET @Date = CAST(CONVERT(varchar(8), @Date, 112) AS DATETIME)
	
	IF @PaymentTypeID = 1 --  
	BEGIN
		SET @Payer = NULL
	END
	ELSE IF @PaymentTypeID = 2 --  
	BEGIN
		SET @PayeeBankAccountID = NULL
	END
	ELSE -- Invalid payment type
	BEGIN
		RAISERROR('#internalerror', 16, -1)
		RETURN 1
	END	

	BEGIN TRANSACTION
	UPDATE 
		[Payment]
	SET
		[Payment].[FileAs] = @FileAs,
		[Payment].[Date] = @Date,
		[Payment].[Number] = @Number,
		[Payment].[PaymentTypeID] = @PaymentTypeID,
		[Payment].[CurrencyCode] = @CurrencyCode,
		[Payment].[PayeeCompanyID] = @PayeeCompanyID,
		[Payment].[PayeeBankAccountID]= @PayeeBankAccountID,
		[Payment].[PayerCompanyID] = @PayerCompanyID,
		[Payment].[Value] = @Value,
		[Payment].[VAT] = @VAT,
		[Payment].[BaseCurrencyRate] = @BaseCurrencyRate,
		[Payment].[Comments] = @Comments,
		[Payment].[Reason] = @Reason,
		[Payment].[Payer] = @Payer,
		[Payment].[Modified] = DEFAULT,
		[Payment].[ModifiedBy] = DEFAULT
	WHERE
		[Payment].[ID] = @ID

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	COMMIT TRANSACTION

	EXEC adfPaymentGet @ID

	RETURN 0
GO

GRANT EXECUTE ON adfPaymentUpdate TO PUBLIC
GO
 