IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ExportContact')
	BEGIN
		PRINT 'Dropping Procedure ExportContact'
		DROP  Procedure  ExportContact
	END

GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncExportContact')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncExportContact'
		DROP  Procedure  PjmSyncExportContact
	END

GO

PRINT 'Creating Procedure PjmSyncExportContact'
GO

--------------------------------------------------------------------------------------
CREATE Procedure PjmSyncExportContact
	@DeviceID varchar(40),
	@TimeStampEmployee bigint,
	@TimeStampCompany bigint,
	@ContactSelector int,
	@CreateDeleted BIT
	
AS
	SET NOCOUNT ON

SELECT
[Class],
	[ID],
	[ItemID],

	[FileAs],
	[LastName],
	[JobTitle],
	[FirstName],
	[MiddleName],	
	[Birthday],
	[Nickname],
	[Body],

	[CompanyName],
	[Department],
	[GovernmentId],
	[Manager],
	
	[HomeTelephoneNumber],
	[BusinessTelephoneNumber],
	[Business2TelephoneNumber],
	[MobileTelephoneNumber],
	[BusinessFaxNumber],
	[HomeFaxNumber],
	[CompanyTelephoneNumber],
	[AssistantTelephoneNumber],

	[HomeAddressStreet],
	[HomeAddressCity] ,
	[HomeAddressState],
	[HomeAddressPostalCode],
	[HomeAddressCountry],

	[BusinessAddressStreet],
	[BusinessAddressCity],
	[BusinessAddressState],
	[BusinessAddressPostalCode],
	[BusinessAddressCountry],	

	[OtherAddressStreet],
	[OtherAddressCity],
	[OtherAddressState],
	[OtherAddressPostalCode],
	[OtherAddressCountry],

	[Email1Address],
	[Email2Address],
	[Email3Address],
	[WebPage],

	[Categories],
	[TimeStampEmployee],
	[TimeStampCompany]
	FROM dbo.PjmSyncExportContactFunction(@DeviceID,
	@TimeStampEmployee,
	@TimeStampCompany,
	@ContactSelector,
	@CreateDeleted)
	
	
RETURN 0
GO

GRANT EXEC ON PjmSyncExportContact TO PUBLIC
GO



