IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalendarProjectUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalendarProjectUpdate'
		DROP PROCEDURE [dbo].[pjm5CalendarProjectUpdate]
	END
GO

PRINT 'Creating procedure pjm5CalendarProjectUpdate'
GO

/******************************************************************************
**		File: CalendarProjectUpdate.sql
**		Name: pjm5CalendarProjectUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 02/15/2006 15:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalendarProjectUpdate]
	@Xml XML
AS
	DECLARE @UserID TIdentifier, @doc int
	
	SET NOCOUNT ON

	SET @UserID = dbo.adfGetCurrentUserID()
		
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	BEGIN TRANSACTION
	
	DELETE [CalendarProject] WHERE [UserID] = @UserID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	INSERT INTO [CalendarProject] ([UserID], [ProjectID])
	SELECT
		@UserID, [ID]
	FROM
		OPENXML(@doc, '/Projects/ID', 2)
			WITH (
				[ID] int '.'
			)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
		
	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc

	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalendarProjectUpdate] TO PUBLIC
GO
  