IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectCreate'
		DROP PROCEDURE [dbo].[pjm5ProjectCreate]
	END
GO

PRINT 'Creating procedure pjm5ProjectCreate'
GO

/******************************************************************************
**		File: pjm5ProjectCreate.sql
**		Name: pjm5ProjectCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.09.09	syv				  BankAccountID
**
**		6.05.10		KOV				  ApplyVAT,     INSERT
**
**		7.05.10		KOV				 @PaymentCurrencyPoint    
**		13.11.10	SYV				  [GroupingAdvanceCalculations]
**		24.11.10	SYV				  [StatementCurrencyPoint]
**		22.04.11	SYV				 GroupingAdvanceCalculations   int
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectCreate]
@Xml	XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@ResponsiblePersonEmployeeID TIdentifier,
			@PriorityID TIdentifier,
			@StartDate TDate,
			@DueDate TDate,
			@EndDate TDate,
			@CurrencyCode TCode3,
			@CostCenterID TIdentifier,
			@ManHour TAmount,
			@Budget TMoney,
			@ContractNumber TCode,
			@ContractDate TDate,
			@ContractSubject TName,
			@ServiceLevelID TIdentifier,
			@WSSDocumentsURL THref,
			@Comments TNotes,
			@doc INT,
			@AssignmentState TState,
			@AssignmentID TIdentifier,
			@EmployeeName TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@rv int,
			@value TVariant,
			@InvoiceExpirationPeriod TCount,
			@InvoiceExpirationPeriodType TIdentifier,
			@ProjectTypeID TIdentifier,
			@PaymentCurrencyPoint TIdentifier,
			@GroupCalculationLines TBool,
			@Flag TFlag,
			@ProjectManagerEmployeeID TIdentifier,
			@CustomerFinanceManagerID TIdentifier,
			@StatementCurrencyPoint TIdentifier,
			@UseSubProjects TBool
			
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('e64c30d7-1ade-4f9e-8bde-c35357ea6e8a')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@ManHour = [ManHour], 
		@Budget = [Budget],
		@CurrencyCode = [CurrencyCode],
		@ProjectTypeID = [ProjectTypeID],
		@Flag = [Flag]
	FROM
		OPENXML(@doc, '/pjm5ProjectGet/Project', 2)
			WITH (
				[ManHour] decimal(18,4),
				[Budget] money,
				[CurrencyCode] char(3),
				[ProjectTypeID] int,
				[Flag] int
				)
				
	IF @Flag IS NULL
	BEGIN
		SET @Flag = 0
	END
		
	IF @Budget IS NOT NULL AND @Budget < 0
	BEGIN
		RAISERROR('#BudgetIsInvalid', 18, -1)
		RETURN 1
	END
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		RETURN 1
	END
	
	-- Global parameters
	DECLARE @RoundInterval int,
			@RoundingMode int,
			@DefaultMoneyScale TCount,
			@StatementPrintCurrency TCount,
			@InvoicePrintCurrency TCount,
			@FacturePrintCurrency TCount,
			@ApplyVAT TBool,
			@CheckTaskWorkOverdraft TBool,
			@GroupingAdvanceCalculations TCount,
			@SupportsRequestManagement bit,
			@ShowActivityTypes TBool,
			@ShowPrice TBool,
			@ProjectLanguageCode	TCode
	
	EXEC adfParameterGet @Name='StatementPrintCurrency', @Group='Pjm5', @Value = @value OUTPUT
	SET @StatementPrintCurrency = CAST(@value as int)
	EXEC adfParameterGet @Name='InvoicePrintCurrency', @Group='Pjm5', @Value = @value OUTPUT
	SET @InvoicePrintCurrency = CAST(@value as int)
	EXEC adfParameterGet @Name='FacturePrintCurrency', @Group='Pjm5', @Value = @value OUTPUT
	SET @FacturePrintCurrency = CAST(@value as int)

	EXEC adfParameterGet @Name='DefaultMoneyScale', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @DefaultMoneyScale = ISNULL(CAST(@value as int), 2)

	EXEC adfParameterGet @Name='InvoiceExpirationPeriod', @Group='Pjm5', @Value = @value OUTPUT
	SET @InvoiceExpirationPeriod = CAST(@value as int)

	EXEC adfParameterGet @Name='InvoiceExpirationPeriodType', @Group='Pjm5', @Value = @value OUTPUT
	IF @value IS NOT NULL
		SET @InvoiceExpirationPeriodType = CAST(@value as int)
	ELSE
		SET @InvoiceExpirationPeriodType = 1

	EXEC adfParameterGet @Name='RoundInterval', @Group='Pjm5', @Value = @value OUTPUT
	SET @RoundInterval = CAST(@value as int)
	EXEC adfParameterGet @Name='RoundingMode', @Group='Pjm5', @Value = @value OUTPUT
	SET @RoundingMode = CAST(@value as int)
	
	EXEC adfParameterGet @Name='GroupCalculationLines', @Group='Pjm5', @Value = @value OUTPUT
	SET @GroupCalculationLines = ISNULL(CAST(@value as bit), 0)
	
	EXEC adfParameterGet @Name='ShowActivityTypes', @Group='Pjm5', @Value = @value OUTPUT
	SET @ShowActivityTypes = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='ShowPrice', @Group='Pjm5', @Value = @value OUTPUT
	SET @ShowPrice = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='CheckTaskWorkOverdraft', @Group='Pjm6', @Value = @value OUTPUT
	SET @CheckTaskWorkOverdraft = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='GroupingAdvanceCalculations', @Group='Pjm6', @Value = @value OUTPUT
	SET @GroupingAdvanceCalculations = ISNULL(CAST(@value as int), 0)
	
	EXEC adfParameterGet @Name='StatementCurrencyPoint', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @StatementCurrencyPoint = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='UseSubProjects', @Group='Pjm6', @Value = @value OUTPUT
	SET @UseSubProjects = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='ProjectLanguageCode', @Group='Pjm6', @Value = @value OUTPUT
	SET @ProjectLanguageCode = ISNULL(CAST(@value as VARCHAR(32)), NULL)

	SELECT
		@Date = CAST([Date] as datetime),
		@Number = [Number],
		@FileAs = [FileAs],
		@ProjectTypeID=[ProjectTypeID],
		@SupplierCompanyID = [SupplierCompanyID],
		@ProjectManagerEmployeeID=[ProjectManagerEmployeeID],
		@CustomerCompanyID = [CustomerCompanyID],
		@CustomerFinanceManagerID = [CustomerFinanceManagerID],
		@ResponsiblePersonEmployeeID = [ResponsiblePersonEmployeeID],
		@PriorityID= [PriorityID],
		@CurrencyCode = [CurrencyCode],
		@CostCenterID= [CostCenterID],
		@Budget=[Budget],
		@WSSDocumentsURL=[WSSDocumentsURL],
		@Comments=[Comments],
		@SupportsRequestManagement=[SupportsRequestManagement]
	FROM
		OPENXML(@doc, '/pjm5ProjectGet/Project', 2)
			WITH (
				[Date] varchar(19),
				[Number] varchar(32),
				[FileAs] nvarchar(256),
				[ProjectTypeID] int,
				[SupplierCompanyID] int,
				[ProjectManagerEmployeeID] int,
				[CustomerCompanyID] int,
				[CustomerFinanceManagerID] int,
				[ResponsiblePersonEmployeeID] int,
				[PriorityID] int,
				[CurrencyCode] char(3),
				[CostCenterID] int,
				[Budget] money,
				[ContractNumber] varchar(32),
				[ContractDate] varchar(19),
				[ContractSubject] nvarchar(256),
				[WSSDocumentsURL] varchar(512),
				[Comments] nvarchar(max),
				[RoundingInterval] int,
				[RoundingMode] int,
				[Billable] varchar(5),
				[SupportsRequestManagement] varchar(5)
				)
	EXEC adfParameterGet @Name='ApplyVAT', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @ApplyVAT = ISNULL((SELECT TOP (1) [Company].[ApplyVAT] FROM [Company] WHERE [Company].[ID] = @SupplierCompanyID AND [Company].[Own] = 1), CAST(@value as int))

	EXEC adfParameterGet @Name='PaymentCurrencyPoint', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @PaymentCurrencyPoint = ISNULL((SELECT TOP (1) [Company].[PaymentCurrencyPoint] FROM [Company] WHERE [Company].[ID] = @SupplierCompanyID AND [Company].[Own] = 1), CAST(@value as int))

	BEGIN TRANSACTION
	
	INSERT INTO [Project]
		([State], [Flag], [Date], [Number], [FileAs], [ProjectTypeID],
		[SupplierCompanyID], [ProjectManagerEmployeeID], [CustomerCompanyID],
		[CustomerFinanceManagerID],	[ResponsiblePersonEmployeeID], 
		[PriorityID], [CurrencyCode], [CostCenterID],
		[Budget], [ContractNumber], [ContractDate], 
		[ContractSubject], [ApplyVAT], [InvoiceExpirationPeriod], [InvoiceExpirationPeriodType], [WSSDocumentsURL],
		[Comments], [RoundingInterval],	[RoundingMode], [Billable],
		[SupportsRequestManagement], [PaymentCurrencyPoint],
		[Scale],
		[StatementCurrency], [InvoiceCurrency], [FactureCurrency], 
		[GroupCalculationLines], [CheckTaskWorkOverdraft], [ShowActivityTypes],
		[GroupingAdvanceCalculations], [ShowPrice],
		[StatementCurrencyPoint], [UseSubProjects], 
		[ProjectLanguageCode])
	VALUES
		(@State,	@Flag, @Date,@Number,@FileAs,@ProjectTypeID,
		@SupplierCompanyID,@ProjectManagerEmployeeID,@CustomerCompanyID,
		@CustomerFinanceManagerID,@ResponsiblePersonEmployeeID,
		@PriorityID,@CurrencyCode,@CostCenterID,
		@Budget,@Number,@Date,
		@FileAs,(CASE @ApplyVAT WHEN '1' THEN 'true' ELSE 'false' END),@InvoiceExpirationPeriod,@InvoiceExpirationPeriodType,	@WSSDocumentsURL,
		@Comments,	dbo.fnPjm5GetRoundInterval(@RoundInterval),	@RoundingMode,	(CASE  WHEN @ProjectTypeID IN (1) THEN 1 ELSE 0 END),
		(CASE @SupportsRequestManagement WHEN 'false' THEN 0 ELSE 1 END),	@PaymentCurrencyPoint,	
		@DefaultMoneyScale,
		@StatementPrintCurrency, @InvoicePrintCurrency, @FacturePrintCurrency,
		@GroupCalculationLines,	@CheckTaskWorkOverdraft, @ShowActivityTypes,
		@GroupingAdvanceCalculations, @ShowPrice,
		@StatementCurrencyPoint, @UseSubProjects,
		@ProjectLanguageCode)
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	INSERT INTO [ProjectDetail] 
		([ID], [DueDate])
	SELECT
		@ID,
		CAST([DueDate] as datetime)
	FROM
		OPENXML(@doc, '/pjm5ProjectGet/Project', 2)
			WITH ([DueDate] varchar(19)) 
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	INSERT INTO [ProjectActivityType]
		([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		[Billable],
		1
	FROM
		[ActivityType]
	WHERE
		([ProjectTypeID] = @ProjectTypeID OR [ProjectTypeID] IS NULL)
	AND
		[AddToNewProject] = 1 AND [State] = 1
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		[Billable],
		1
	FROM
		[ExpenseCode]
	WHERE
		([ProjectTypeID] = @ProjectTypeID OR [ProjectTypeID] IS NULL)
	AND
		[AddToNewProject] = 1 AND [State] = 1
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc
	EXEC pjm5ProjectGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5ProjectCreate TO PUBLIC
GO
