IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateCreate'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateCreate]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateCreate'
GO

/******************************************************************************
**		File: pjm5ProjectTemplateCreate.sql
**		Name: pjm5ProjectTemplateCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		22.04.11	SYV				  GroupCalculationLines, ShowActivityTypes
**									GroupingAdvanceCalculations 
**		14.07.11	SYV				 UseSubProjects
*******************************************************************************/
CREATE PROCEDURE [pjm5ProjectTemplateCreate]
	@Xml	XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@ProjectTypeID TIdentifier,
			@SupplierCompanyID TIdentifier,
			@CustomerCompanyID TIdentifier,
			@ResponsiblePersonEmployeeID TIdentifier,
			@PriorityID TIdentifier,
			@StartDate TDate,
			@EndDate TDate,
			@CurrencyCode TCode3,
			@CostCenterID TIdentifier,
			@ManHour TCount,
			@Budget TMoney,
			@ContractNumber TCode,
			@ContractDate TDate,
			@ContractSubject TName,
			@ServiceLevelID TIdentifier,
			@InvoiceExpirationPeriod TCount,
			@InvoiceExpirationPeriodType TIdentifier,
			@Comments TNotes,
			@doc INT,
			@AssignmentState TState,
			@value TVariant,
			@AssignmentID TIdentifier,
			@EmployeeName TName,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@BudgetTemplateID Tidentifier,
			@BudgetTemplateCurrency	TCode3,
			@UseBudgetPlanning TBool,
			@rv int,
			@UseSubProjects TBool
			

	
	SET NOCOUNT ON
	
	DECLARE @TemplateClass TClass,
			@ProjectClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm5.ProjectTemplate')
	SET @ProjectClass = dbo.adfGetClassByName('Pjm5.Project')
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml

	SELECT
		@CurrencyCode = [CurrencyCode],
		@BudgetTemplateID = [BudgetTemplateID]
	FROM
		OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectTemplate', 2)
			WITH (
				[ProjectManagerEmployeeID] int,
				[CurrencyCode] char(3),
				[BudgetTemplateID] int
				)
				
	-- Global parameters
	DECLARE @RoundInterval int,
			@RoundingMode int,
			@DefaultMoneyScale TCount,
			@StatementPrintCurrency TCount,
			@InvoicePrintCurrency TCount,
			@FacturePrintCurrency TCount,
			@ApplyVAT int,
			@GroupingAdvanceCalculations TCount,
			@ShowActivityTypes TBool,
			@GroupCalculationLines TBool,
			@ShowPrice TBool,
			@ProjectLanguageCode TCode
	
	EXEC adfParameterGet @Name='StatementPrintCurrency', @Group='Pjm5', @Value = @value OUTPUT
	SET @StatementPrintCurrency = CAST(@value as int)
	EXEC adfParameterGet @Name='InvoicePrintCurrency', @Group='Pjm5', @Value = @value OUTPUT
	SET @InvoicePrintCurrency = CAST(@value as int)
	EXEC adfParameterGet @Name='FacturePrintCurrency', @Group='Pjm5', @Value = @value OUTPUT
	SET @FacturePrintCurrency = CAST(@value as int)
	
	EXEC adfParameterGet @Name='DefaultMoneyScale', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @DefaultMoneyScale = ISNULL(CAST(@value as int), 2)
	
	EXEC adfParameterGet @Name='InvoiceExpirationPeriod', @Group='Pjm5', @Value = @value OUTPUT
	SET @InvoiceExpirationPeriod = CAST(@value as int)

	EXEC adfParameterGet @Name='UseBudgetPlanning', @Group='Pjm6', @Value = @value OUTPUT
	SET @UseBudgetPlanning = CAST(@value as bit)

	EXEC adfParameterGet @Name='InvoiceExpirationPeriodType', @Group='Pjm5', @Value = @value OUTPUT
	IF @value IS NOT NULL
		SET @InvoiceExpirationPeriodType = CAST(@value as int)
	ELSE
		SET @InvoiceExpirationPeriodType = 1

	EXEC adfParameterGet @Name='GroupingAdvanceCalculations', @Group='Pjm6', @Value = @value OUTPUT
	SET @GroupingAdvanceCalculations = ISNULL(CAST(@value as int), 0)

	EXEC adfParameterGet @Name='RoundInterval', @Group='Pjm5', @Value = @value OUTPUT
	SET @RoundInterval = CAST(@value as int)
	EXEC adfParameterGet @Name='RoundingMode', @Group='Pjm5', @Value = @value OUTPUT
	SET @RoundingMode = CAST(@value as int)
	EXEC adfParameterGet @Name='ApplyVAT', @Group='CommonBusiness', @Value = @value OUTPUT
	SET @ApplyVAT = CAST(@value as int)

	EXEC adfParameterGet @Name='GroupCalculationLines', @Group='Pjm5', @Value = @value OUTPUT
	SET @GroupCalculationLines = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='ShowActivityTypes', @Group='Pjm5', @Value = @value OUTPUT
	SET @ShowActivityTypes = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='ShowPrice', @Group='Pjm5', @Value = @value OUTPUT
	SET @ShowPrice = ISNULL(CAST(@value as bit), 0)

	EXEC adfParameterGet @Name='UseSubProjects', @Group='Pjm6', @Value = @value OUTPUT
	SET @UseSubProjects = ISNULL(CAST(@value as bit), 0)
	
	EXEC adfParameterGet @Name='ProjectLanguageCode', @Group='Pjm6', @Value = @value OUTPUT
	SET @ProjectLanguageCode = ISNULL(CAST(@value as VARCHAR(32)), NULL)

	BEGIN TRANSACTION
	
	INSERT INTO [Project]
		([State], [Flag], [Date], [Number], [FileAs], [ProjectTypeID],
		[SupplierCompanyID], [ProjectManagerEmployeeID], [CustomerCompanyID],
		[CustomerFinanceManagerID], [ResponsiblePersonEmployeeID],
		[PriorityID], 
		[CurrencyCode], [CostCenterID], [Budget],
		[ContractNumber], [ContractDate], [ContractEndDate], [ContractSubject], [ApplyVAT],
		[InvoiceExpirationPeriod], [InvoiceExpirationPeriodType],
		[WSSDocumentsURL], [Comments], [RoundingInterval], [RoundingMode], [Billable],
		[SupportsRequestManagement], [Scale],
		[StatementCurrency], [InvoiceCurrency], [FactureCurrency],
		[GroupingAdvanceCalculations],
		[ShowActivityTypes], [ShowPrice],
		[GroupCalculationLines], [UseSubProjects],
		[ProjectLanguageCode])
	SELECT
		5,
		0,
		CAST([Date] as datetime),
		[Number],
		[FileAs],
		[ProjectTypeID],
		[SupplierCompanyID],
		NULL,
		[CustomerCompanyID],
		[CustomerFinanceManagerID],
		[ResponsiblePersonEmployeeID],
		[PriorityID],
		[CurrencyCode],
		[CostCenterID],
		[Budget],
		[Number],
		CAST([Date] as datetime),
		CAST([Date] as datetime),
		[FileAs],
		@ApplyVAT,
		@InvoiceExpirationPeriod,
		@InvoiceExpirationPeriodType,
		[WSSDocumentsURL],
		[Comments],
		dbo.fnPjm5GetRoundInterval(@RoundInterval),
		@RoundingMode,
		(CASE [ProjectTypeID] WHEN 1 THEN 1 WHEN 2 THEN 1 ELSE 0 END),
		(CASE [SupportsRequestManagement] WHEN 'false' THEN 0 ELSE 1 END),
		@DefaultMoneyScale,
		@StatementPrintCurrency, @InvoicePrintCurrency, @FacturePrintCurrency,
		@GroupingAdvanceCalculations,
		@ShowActivityTypes, @ShowPrice,
		@GroupCalculationLines,
		@UseSubProjects,
		@ProjectLanguageCode
	FROM
		OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectTemplate', 2)
			WITH (
				[Date] varchar(19),
				[Number] varchar(32),
				[FileAs] nvarchar(256),
				[ProjectTypeID] int,
				[SupplierCompanyID] int,
				[ProjectManagerEmployeeID] int,
				[CustomerCompanyID] int,
				[CustomerFinanceManagerID] int,
				[ResponsiblePersonEmployeeID] int,
				[PriorityID] int,
				[CurrencyCode] char(3),
				[CostCenterID] int,
				[Budget] money,
				[ContractNumber] varchar(32),
				[ContractDate] varchar(19),
				[ContractSubject] nvarchar(256),
				[ApplyVAT] varchar(5),
				[WSSDocumentsURL] varchar(512),
				[Comments] nvarchar(max),
				[RoundingInterval] int,
				[RoundingMode] int,
				[Billable] varchar(5),
				[SupportsRequestManagement] varchar(5)
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	SELECT @ProjectTypeID = [ProjectTypeID] FROM [Project] WHERE ID = @ID
	
	INSERT INTO [ProjectDetail] 
		([ID], [DueDate])
	SELECT
		@ID,
		CAST([Date] as datetime)
	FROM
		OPENXML(@doc, '/pjm5ProjectTemplateGet/ProjectTemplate', 2)
			WITH ([Date] varchar(19)) 
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	-- FIX FOR CATEGORY SUPPORT
	
	INSERT INTO [Document]
		([Class], [ID], [State], [Flag], [FileAs], [Created], [CreatedBy],
		 [Modified], [ModifiedBy], [Timestamp])
	SELECT
		@TemplateClass,
		[ID],
		[State],
		[Flag],
		[FileAs],
		[Created],
		[CreatedBy],
		[Modified],
		[ModifiedBy],
		[Timestamp]
	FROM
		[Document]
	WHERE
		([ID] = @ID) AND ([Class] = @ProjectClass)
	
	-- END FIX
	
	INSERT INTO [ProjectTemplate]
		([ID])
	VALUES
		(@ID)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	INSERT INTO [ProjectActivityType]
		([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		[Billable],
		1
	FROM
		[ActivityType]
	WHERE
		([ProjectTypeID] = @ProjectTypeID OR [ProjectTypeID] IS NULL)
	AND
		[AddToNewProject] = 1 AND [State] = 1
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT
		@ID,
		[ID],
		[Billable],
		1
	FROM
		[ExpenseCode]
	WHERE
		([ProjectTypeID] = @ProjectTypeID OR [ProjectTypeID] IS NULL)
	AND
		[AddToNewProject] = 1 AND [State] = 1
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END

	IF @UseBudgetPlanning = 1
	BEGIN;
		UPDATE
			[ProjectTemplate]
		SET
			[BudgetTemplateID] = @BudgetTemplateID
		WHERE
			[ProjectTemplate].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END

	COMMIT TRANSACTION

	EXEC sp_xml_removedocument @doc
	EXEC pjm5ProjectTemplateGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5ProjectTemplateCreate TO PUBLIC
GO
 