 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trProjectUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm5trProjectUpdate'
		DROP  Trigger pjm5trProjectUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trProjectUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trProjectUpdate'
GO
CREATE TRIGGER pjm5trProjectUpdate ON [Project] FOR UPDATE
AS
	IF @@rowcount = 0 
		RETURN
	IF EXISTS(
		SELECT *
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[ID] = [inserted].[ID] 
		WHERE
			[deleted].[CurrencyCode] != [inserted].[CurrencyCode]
		)
	BEGIN
			IF(
				EXISTS (SELECT * FROM [Invoice] INNER JOIN [inserted] ON [Invoice].[ProjectID] = [inserted].[ID] WHERE  [Invoice].[State] IN (2, 5)) OR
				EXISTS (SELECT * FROM [Statement] INNER JOIN [inserted] ON [Statement].[ProjectID] = [inserted].[ID] WHERE [Statement].[State] IN (2, 3)) OR
				EXISTS (SELECT * FROM [Expense] INNER JOIN [inserted] ON [Expense].[ProjectID] = [inserted].[ID] WHERE [Expense].[State] IN (3, 6)) OR
				EXISTS (SELECT * FROM [CreditMemo] INNER JOIN [inserted] ON [CreditMemo].[ProjectID] = [inserted].[ID] WHERE [CreditMemo].[State] = 2) OR
				EXISTS (SELECT * FROM [Budget] INNER JOIN [inserted] ON [Budget].[DocumentClass] = [inserted].[Class] AND [Budget].[DocumentID] = [inserted].[ID])
			)
		BEGIN
			RAISERROR('#CannotChangeProjectCurrency', 16, -1)
			ROLLBACK TRANSACTION
		END
	END
	
	UPDATE [Task]
	SET
		[Task].[StartDate] = [inserted].[Date]
	FROM 
		[Task]
		INNER JOIN [inserted]
			ON [inserted].[ID] = [Task].[SubProjectID]
	WHERE
		[Task].[MsTaskID] IS NULL
	RETURN
GO

   