IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportFacture]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportFacture'
		DROP PROCEDURE [dbo].[ReportFacture]
	END
GO

PRINT 'Creating procedure ReportFacture'
GO

/******************************************************************************
**		File: ReportFacture.sql
**		Name: ReportFacture
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ReportFacture]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @CurrencyCode TCode
	SELECT			
		@CurrencyCode = CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Project].[CurrencyCode]
			ELSE [Facture].[CurrencyCode]
		END
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
	WHERE 
		[Facture].[ID] = @ID		

	DECLARE @CurrencyClass TClass, @CurrencyID TIdentifier, @CurrencyMale TBool, @CurrencyName TName
	SET @CurrencyClass = dbo.adfGetClassByName('Adf.Currency')
	SELECT @CurrencyID = [ID] FROM [Currency] WHERE [Code] = @CurrencyCode
	SET @CurrencyMale = CASE 
		WHEN dbo.adfPropertyValueGetText(@CurrencyClass, @CurrencyID, '00000001-0000-0000-0000-000000000000') = 'False'
			THEN 0
		ELSE 1
	END
	
	SELECT @CurrencyName = [FileAs] FROM [Currency] WHERE [Currency].[ID] = @CurrencyID
	
	DECLARE @DocumentNumber TNotes, @pID TIdentifier, @pNumber TName, @pDate TDate
	DECLARE payments CURSOR FAST_FORWARD FOR
		SELECT
			[Payment].[ID], [Payment].[Number], [Payment].[Date]
		FROM
			[Payment]
			INNER JOIN [FacturePayment]
				ON [FacturePayment].[PaymentID] = [Payment].[ID]
		WHERE
			[FacturePayment].[FactureID] = @ID
		ORDER BY
			[Payment].[Date]

	OPEN payments
	FETCH NEXT FROM payments INTO @pID, @pNumber, @pDate
	IF @@FETCH_STATUS = 0
	BEGIN
		SET @DocumentNumber = '' + @pNumber + '  ' + CONVERT(varchar(10), @pDate, 104)
		FETCH NEXT FROM payments INTO @pID, @pNumber, @pDate
	END
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @DocumentNumber = @DocumentNumber + ', ' + @pNumber + '  ' + CONVERT(varchar(10), @pDate, 104)
		FETCH NEXT FROM payments INTO @pID, @pNumber, @pDate
	END
	
	CLOSE payments
	DEALLOCATE payments

	SELECT
		[Facture].[Class],
		[Facture].[ID],
		[Facture].[State],
		[Facture].[Flag],
		[Facture].[FileAs],
		[Facture].[Date],
		[Facture].[Number],
		[Facture].[ProjectID],
		@CurrencyCode AS [CurrencyCode],
		@CurrencyMale AS [CurrencyMale],
		@CurrencyName AS [CurrencyName],
		[Facture].[CurrencyRate],
		[Facture].[Scale],
		[Facture].[SupplierCompanyID],
		dbo.fnPjm6GetDetailedLegalCompanyName([SupplierCompany].[LegalName], 1) AS [SupplierCompanyName],
		[SupplierCompany].[ExecutiveEmployeeID] AS [SupplierExecutiveEmployeeID],
		[SupplierCompany].[AccountantEmployeeID] AS [SupplierAccountantEmployeeID],
		[Facture].[SupplierAddress],
		[Facture].[SupplierINN],
		[Facture].[SupplierKPP],
		[Facture].[CustomerCompanyID],
		[CustomerCompany].[LegalName] AS [CustomerCompanyName],
		[CustomerCompany].[ExecutiveEmployeeID] AS [CustomerExecutiveEmployeeID],
		[CustomerCompany].[AccountantEmployeeID] AS [CustomerAccountantEmployeeID],
		[Facture].[CustomerAddress],
		[Facture].[CustomerINN],
		[Facture].[CustomerKPP],
		[Facture].[Sender],
		[Facture].[Recipient],
		@DocumentNumber AS [DocumentNumber],
		
		COALESCE(dbo.adfPropertyValueGetText([SupplierExecutiveEmployee].[Class], [SupplierExecutiveEmployee].[ID], '00000002-0000-0000-0000-000000000000'),
			[SupplierExecutiveEmployee].[LastName] + ISNULL(' ' + [SupplierExecutiveEmployee].[FirstName], '') + ISNULL(' ' + [SupplierExecutiveEmployee].[MiddleName], ''), [SupplierExecutiveEmployee].[FileAs], '                            ') 
			AS [Chief], 
		COALESCE(dbo.adfPropertyValueGetText([SupplierAccountantEmployee].[Class], [SupplierAccountantEmployee].[ID], '00000002-0000-0000-0000-000000000000'), 
			[SupplierAccountantEmployee].[LastName] + ISNULL(' ' + [SupplierAccountantEmployee].[FirstName], '') + ISNULL(' ' + [SupplierAccountantEmployee].[MiddleName], ''), [SupplierAccountantEmployee].[FileAs], '                            ') 
			AS [Accountant], 
		
		[Facture].[Created],
		[Facture].[CreatedBy],
		[Facture].[Modified],
		[Facture].[ModifiedBy],
		[Facture].[Comments],
		[Facture].[Timestamp],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[TotalPC]
			ELSE [Facture].[Total]
		END AS [Total],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[VATPC]
			ELSE [Facture].[VAT]
		END AS [VAT],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [Facture].[TotalWithVATPC]
			ELSE [Facture].[TotalWithVAT]
		END AS [TotalWithVAT]
	FROM
		[Facture]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
		INNER JOIN [Company] AS [CustomerCompany]	
			ON [Facture].[CustomerCompanyID] = [CustomerCompany].[ID]
		INNER JOIN [Company] AS [SupplierCompany]	
			ON [Facture].[SupplierCompanyID] = [SupplierCompany].[ID]
		LEFT OUTER JOIN [Employee] AS [SupplierExecutiveEmployee]
			ON [SupplierCompany].[ExecutiveEmployeeID] = [SupplierExecutiveEmployee].[ID]
		LEFT OUTER JOIN [Employee] AS [SupplierAccountantEmployee]
			ON [SupplierCompany].[AccountantEmployeeID] = [SupplierAccountantEmployee].[ID]
		
	WHERE
		[Facture].[ID] = @ID
	
	SELECT
		[FactureLine].[ID],
		[FactureLine].[FactureID],
		[FactureLine].[DocumentClass],
		[FactureLine].[DocumentID],
		[FactureLine].[UOMID],
		CASE
			WHEN [FactureLine].[UOMID] IS NULL AND [FactureLine].[Amount] = 1 THEN 0
			ELSE [FactureLine].[Amount]
		END AS [Amount],
		[FactureLine].[VATIsIncluded], 
		[FactureLine].[VATRate], 
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[OriginalPricePC]
			ELSE [FactureLine].[OriginalPrice]
		END AS [OriginalPrice],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[PricePC]
			ELSE [FactureLine].[Price]
		END AS [Price],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[TotalPC]
			ELSE [FactureLine].[Total]
		END AS [Total],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[ExcisePC]
			ELSE [FactureLine].[Excise]
		END AS [Excise],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[VATPC]
			ELSE [FactureLine].[VAT]
		END AS [VAT],
		CASE [Project].[FactureCurrency]
			WHEN 0 THEN [FactureLine].[TotalWithVATPC]
			ELSE [FactureLine].[TotalWithVAT]
		END AS [TotalWithVAT],
		CASE ISNULL([FactureLine].[Country], '')
			WHEN '' THEN '-'
			ELSE [FactureLine].[Country]
		END AS [Country],
		CASE ISNULL([FactureLine].[CustomDeclaration], '')
			WHEN '' THEN '-'
			ELSE [FactureLine].[CustomDeclaration]
		END AS [CustomDeclaration],
		[FactureLine].[Description],
		ISNULL([UOM].[Code], '-') AS [UOM]
	FROM
		[FactureLine]
		INNER JOIN [Facture]
			ON [FactureLine].[FactureID] = [Facture].[ID]
		INNER JOIN [Project]
			ON [Facture].[ProjectID] = [Project].[ID]
		LEFT OUTER JOIN [UOM]
			ON [UOM].[ID] = [FactureLine].[UOMID]
	WHERE
		[FactureLine].[FactureID] = @ID
	ORDER BY
		[FactureLine].[Description]
	RETURN 0
GO

GRANT EXECUTE ON [ReportFacture] TO PUBLIC
GO

 