IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportBalance')
	BEGIN
		PRINT 'Dropping Procedure ReportBalance'
		DROP  Procedure  ReportBalance
	END

GO

PRINT 'Creating Procedure ReportBalance'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportBalance
	
AS
	SET NOCOUNT ON
	SELECT
		[Company].[ID],
		[Company].[FileAs],
		COUNT([Project].[ID]) AS [Amount],
		0.0 AS [Invoices],
		0.0 AS [Payments],
		0.0 AS [Balance]
	FROM
		[Project]
		INNER JOIN [Company]
			ON [Company].[ID] = [Project].[CustomerCompanyID]
	WHERE 
		[Project].[State] NOT IN (1, 5, 6)
	GROUP BY 
		[Company].[ID],
		[Company].[FileAs]

	SELECT * FROM [Payment]
	SELECT * FROM [CreditMemo]

	SELECT
		[Project].[ID],
		[Project].[FileAs],
		[Project].[CustomerCompanyID],
		0 AS [Amount],
		0 AS [Invoices],
		0 AS [Payments],
		0 AS [Balance]
	FROM
		[Project]
	WHERE
		[Project].[CustomerCompanyID] IS NOT NULL
		
	SELECT * FROM [Invoice]

RETURN 0
GO

GRANT EXEC ON ReportBalance TO PUBLIC

GO
