IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportEmployeeCard')
	BEGIN
		PRINT 'Dropping Procedure ReportEmployeeCard'
		DROP  Procedure  ReportEmployeeCard
	END

GO

PRINT 'Creating Procedure ReportEmployeeCard'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportEmployeeCard
	@ID TIdentifier
	
AS
	SET NOCOUNT ON
	
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName
		
	SET @UserID = dbo.adfGetCurrentUserID()	
	
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID	
	

	SELECT [Employee].[Class]
      ,[Employee].[ID]
      ,[Employee].[FileAs]
      ,[Employee].[FirstName]
      ,[Employee].[MiddleName]
      ,[Employee].[LastName]
      ,[Employee].[BirthDate]
      ,[Employee].[BirthPlace]
      ,[Employee].[PositionID]
      ,[Employee].[CompanyID]
      ,[Employee].[DivisionID]
      ,[Employee].[QualificationID]
      ,[Employee].[HireDate]
      ,[Employee].[FireDate]
      ,[Position].[FileAs] AS [PositionName]
      ,[Qualification].[FileAs] AS [QualificationName]
      ,[Company].[FileAs] AS [CompanyName]
      ,[Division].[FileAs] AS [DivisionName]
      ,dbo.fnPjm5GetContactList([Employee].[ID], [Employee].[Class]) AS [Contacts]
	  ,dbo.fnPjm5GetCategoryList([Employee].[ID], [Employee].[Class]) AS [Categories]
	  ,@UserName AS [UserName]
	  ,dbo.fnPjm5GetAttachmentList([Employee].[ID], [Employee].[Class]) AS [AttachmentList]
	
  FROM [Employee]
	LEFT OUTER JOIN [Position] 
		ON [Employee].[PositionID] = [Position].[ID] 
	LEFT OUTER JOIN [Qualification] 
		ON [Employee].[QualificationID] = [Qualification].[ID] 	
	LEFT OUTER JOIN [Company] 
		ON [Employee].[CompanyID] = [Company].[ID] 
	LEFT OUTER JOIN [Division] 
		ON [Employee].[DivisionID] = [Division].[ID] 		
	WHERE
		[Employee].[ID] = @ID
	
DECLARE @MyTable TABLE (BusinessCardID int, AddressName nvarchar(256) ,AddressText nvarchar(256), A int )

INSERT INTO @Mytable
SELECT
	[Employee].[ID] As BusinessCardID, 
	[AddressType].[FileAs] AS [AddressName],
	dbo.fnPjm5AddressAsString([Address].[Street],[Address].[City],[Address].[Region],[Address].[PostalCode],[Address].[Country]) AS [AddressText],
	[A]=1
FROM
	[Employee]
	LEFT OUTER JOIN [Address]
		ON ([Employee].[ID] = [Address].[BusinessCardID]	AND
			[Employee].[Class] = [Address].[BusinessCardClass])
	LEFT OUTER JOIN [AddressType]
		ON ([AddressType].[ID] = [Address].[AddressTypeID])
WHERE
	[Employee].[ID] = @ID					
UNION
SELECT
	[Employee].[ID] AS BusinessCardID, 
	[PhoneType].[FileAs] AS [PhoneName],
	[Phone].[Phone] As [PhoneNumber],
	[A]=2
FROM
	[Employee]
	LEFT OUTER JOIN [Phone]
		ON ([Employee].[ID] = [Phone].[BusinessCardID]	AND
			[Employee].[Class] = [Phone].[BusinessCardClass])
	LEFT OUTER JOIN [PhoneType]
		ON ([PhoneType].[ID] = [Phone].[PhoneTypeID])

WHERE
	[Employee].[ID] = @ID
UNION
SELECT
	[Employee].[ID] AS BusinessCardID, 
	[EmailType].[FileAs] AS [EmailName],
	[Email].[Email] As [EmailText],
	[A]=3
FROM
	[Employee]
	LEFT OUTER JOIN [Email]
		ON ([Employee].[ID] = [Email].[BusinessCardID]	AND
			[Employee].[Class] = [Email].[BusinessCardClass])
	LEFT OUTER JOIN [EmailType]
		ON ([EmailType].[ID] = [Email].[EmailTypeID])

WHERE
	[Employee].[ID] = @ID

SELECT * FROM @MyTable

SELECT
	[IdentityCard].[Seria] AS [Seria],
	[IdentityCard].[Number] As [Number],
	[IdentityCard].[IssueDate] As [IssueDate],
	[IdentityCard].[Issuer] As [Issuer],
	[IdentityCard].[ExpirationDate] As [ExpirationDate]
FROM
	[Employee]
	LEFT OUTER JOIN [IdentityCard]
		ON ([Employee].[ID] = [IdentityCard].[EmployeeID])
WHERE
	[Employee].[ID] = @ID AND [IdentityCard].[IdentityCardTypeID] = 1

DECLARE @CountTable TABLE (CountAddr int, CountPhone int, CountEmail int )

INSERT INTO @CountTable 
SELECT 
  SUM(CASE C.A WHEN 1 THEN A ELSE 0 END) AS [1],
  SUM(CASE C.A WHEN 2 THEN A ELSE 0 END) AS [2],
  SUM(CASE C.A WHEN 3 THEN A ELSE 0 END) AS [3]
FROM (SELECT BusinessCardID , A FROM @MyTable
WHERE AddressName IS NOT NULL AND AddressText IS NOT NULL
) AS C

SELECT * FROM @CountTable
		
RETURN 0

GO

GRANT EXEC ON ReportEmployeeCard TO PUBLIC

GO