IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportFMELHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportFMELHeader'
		DROP  Procedure  ReportFMELHeader
	END

GO

PRINT 'Creating Procedure ReportFMELHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/ 
CREATE PROCEDURE [dbo].[ReportFMELHeader]
		@EmployeeID				int,
		@DateSelector			int,
        @StartDate				TDate	OUTPUT,
        @EndDate				TDate	OUTPUT
	AS

	SET NOCOUNT ON
	DECLARE
		@UserID				TIdentifier,
		@UserName			TName,
		@CompanyFileAs		TName,
		@DivisionFileAs		TName,
		@EmployeeFileAs		TName,
		@EmployeeNumber		Tname,
		@EmployeePosition	TName,
		@PeriodName			TName,
		@PeriodEnd			TDate,
		@Date				TDate,
		@Value				TVariant,
        @WorkingDays		decimal(18,2),
		@WorkingTime		decimal(18,2)
				
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@CompanyFileAs = [Company].[FileAs],
		@DivisionFileAs = [Division].[FileAs],
		@EmployeeFileAs = [Employee].[FileAs],
		@EmployeeNumber =  [Employee].[Number],
		@EmployeePosition = [Position].[FileAs]
	FROM
		[Employee]
		INNER JOIN [Company]
			ON  [Company].[ID] = [Employee].[CompanyID]
		LEFT OUTER JOIN [Division]
			ON [Division].[ID] = [Employee].[DivisionID]
		LEFT OUTER JOIN [Position]
			ON [Position].[ID] = [Employee].[PositionID]
	WHERE 
		[Employee].[ID] = @EmployeeID
	
	SET @Date = CAST(CONVERT(varchar(8), GETDATE(), 112) AS DATETIME)
	-- 1 = Previous month
	-- 0 = Current month
	IF @DateSelector = 0
		SELECT
			@StartDate = [StartDate],
			@EndDate = [EndDate]
		FROM	
			dbo.adfGetDateInterval(2, @Date, @Date, @Date)
	ELSE IF @DateSelector =1
		SELECT
			@StartDate = [StartDate],
			@EndDate = [EndDate]
		FROM	
			dbo.adfGetDateInterval(1, @Date, @Date, @Date)
	ELSE 
		SELECT
			@StartDate = CAST(CONVERT(varchar(8), @StartDate, 112) AS datetime),
			@EndDate = DATEADD(day, 1, CAST(CONVERT(varchar(8), @EndDate, 112) AS datetime))

	SET @PeriodEnd = DATEADD(day, -1, @EndDate)
	EXEC Pjm6GetTimeIntervalFormatted @StartDate, @PeriodEnd, 'ru', @Result = @PeriodName  OUTPUT

	--SET DATEFIRST 7
	SET @WorkingDays = dbo.fnPjm5GetWorkingDays(@StartDate, DATEADD(day, -1, @EndDate))
	--SET DATEFIRST 1

	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkingTime = CAST(@value AS decimal(18,2))
	SET @WorkingTime = @WorkingTime / 60.00
	

	SELECT
		@CompanyFileAs AS [CompanyName],
		@DivisionFileAs AS [DivisionName],
		@EmployeeFileAs AS [EmployeeName],
		@EmployeeNumber AS [EmployeeNumber],
		@EmployeePosition AS [EmployeePosition],
		@DateSelector AS [DateSelector],
		@StartDate AS [StartDate],
		DATEADD(day, -1, @EndDate) as [EndDate],
		@PeriodName AS [PeriodName],
		@WorkingDays AS [WorkingDays],
		@WorkingTime AS [WorkingTime],
		@UserName AS [UserName]

RETURN 0
GO

GRANT EXEC ON ReportFMELHeader TO PUBLIC

GO
