IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportLoadOfEmployee')
	BEGIN
		PRINT 'Dropping Procedure ReportLoadOfEmployee'
		DROP  Procedure  ReportLoadOfEmployee
	END

GO

PRINT 'Creating Procedure ReportLoadOfEmployee'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportLoadOfEmployee
	@EmployeeID int,
	@DateSelector int,
	@PeriodStart datetime,
	@PeriodEnd datetime
AS
	SET NOCOUNT ON

	DECLARE
		@FirstDayOfWeek TINYINT

	SET @FirstDayOfWeek = @@DATEFIRST
	SET DATEFIRST 7	
	
	DECLARE
		@DayCount		int

	
	
	SET @DayCount = DATEPART(day, GETDATE())
	SET @PeriodStart = CASE	@DateSelector
		WHEN 0 THEN CAST(CONVERT(varchar(8), DATEADD(day, 1-@DayCount, GETDATE()), 112) AS datetime)
		WHEN 1 THEN CAST(CONVERT(varchar(8), DATEADD(month, 1, DATEADD(day, 1-@DayCount, GETDATE())), 112) AS datetime)
		ELSE CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime)
	END
	SET @PeriodEnd = DATEADD(month, 1, @PeriodStart)		
		
	SELECT 
		@EmployeeID = [ID]
	FROM 
		[Employee] 
	WHERE 
		([Employee].[ID] = @EmployeeID) OR
		(@EmployeeID IS NULL AND [UserID] = dbo.adfGetCurrentUserID())
	
		
	DECLARE
		@t	table(
			[ProjectName]		varchar(256),
			[ContractNumber]	varchar(256),
			[ContractDate]		datetime,
			[Day01]				decimal(18,2),
			[Day02]				decimal(18,2),
			[Day03]				decimal(18,2),
			[Day04]				decimal(18,2),
			[Day05]				decimal(18,2),
			[Day06]				decimal(18,2),
			[Day07]				decimal(18,2),
			[Day08]				decimal(18,2),
			[Day09]				decimal(18,2),
			[Day10]				decimal(18,2),
			[Day11]				decimal(18,2),
			[Day12]				decimal(18,2),
			[Day13]				decimal(18,2),
			[Day14]				decimal(18,2),
			[Day15]				decimal(18,2),
			[Day16]				decimal(18,2),
			[Day17]				decimal(18,2),
			[Day18]				decimal(18,2),
			[Day19]				decimal(18,2),
			[Day20]				decimal(18,2),
			[Day21]				decimal(18,2),
			[Day22]				decimal(18,2),
			[Day23]				decimal(18,2),
			[Day24]				decimal(18,2),
			[Day25]				decimal(18,2),
			[Day26]				decimal(18,2),
			[Day27]				decimal(18,2),
			[Day28]				decimal(18,2),
			[Day29]				decimal(18,2),
			[Day30]				decimal(18,2),
			[Day31]				decimal(18,2)			
		)

	INSERT INTO @t(
		[ProjectName],
		[ContractNumber],
		[ContractDate],
		[Day01],
		[Day02],
		[Day03],
		[Day04],
		[Day05],
		[Day06],
		[Day07],
		[Day08],
		[Day09],
		[Day10],
		[Day11],
		[Day12],
		[Day13],
		[Day14],
		[Day15],
		[Day16],
		[Day17],
		[Day18],
		[Day19],
		[Day20],
		[Day21],
		[Day22],
		[Day23],
		[Day24],
		[Day25],
		[Day26],
		[Day27],
		[Day28],
		[Day29],
		[Day30],
		[Day31]		
	)
	
	SELECT
		[Project].[FileAs],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		SUM( CASE
			WHEN [BusyEntry].[Date] >= @PeriodStart AND [BusyEntry].[Date] < DATEADD(day, 1, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 1, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 2, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 2, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 3, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 3, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 4, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 4, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 5, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 5, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 6, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 6, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 7, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 7, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 8, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 8, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 9, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 9, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 10, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 10, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 11, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 11, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 12, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 12, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 13, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 13, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 14, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 14, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 15, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 15, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 16, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 16, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 17, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 17, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 18, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 18, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 19, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 19, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 20, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 20, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 21, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 21, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 22, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 22, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 23, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 23, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 24, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 24, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 25, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 25, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 26, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 26, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 27, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 27, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 28, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 28, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 29, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 29, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 30, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END),
		SUM( CASE
			WHEN [BusyEntry].[Date] >= DATEADD(day, 30, @PeriodStart) AND [BusyEntry].[Date] < DATEADD(day, 31, @PeriodStart) THEN ([Planned] - [Canceled]) / 60.0
			ELSE NULL
		END)			
	FROM
		[Project]
			INNER JOIN [BusyEntry] 
				ON [Project].[ID] = [BusyEntry].[ProjectID] AND
				   ([BusyEntry].[Date] >= @PeriodStart AND [BusyEntry].[Date] < @PeriodEnd)
						   
	WHERE
		[BusyEntry].[EmployeeID] = @EmployeeID AND [Project].[State] in(1,2,3,4) AND ([BusyEntry].[Planned] - [BusyEntry].[Canceled]) != 0				
	GROUP BY
		[Project].[FileAs],
		[Project].[ContractNumber],
		[Project].[ContractDate]
			
	EXECUTE ReportLoadOfEmployeeHeader @PeriodStart, @PeriodEnd, @EmployeeID

	SELECT
		[ProjectName],
		[ContractNumber],
		[ContractDate],
		ISNULL([Day01], 0) AS [Day01],
		ISNULL([Day02], 0) AS [Day02],
		ISNULL([Day03], 0) AS [Day03],
		ISNULL([Day04], 0) AS [Day04],
		ISNULL([Day05], 0) AS [Day05],
		ISNULL([Day06], 0) AS [Day06],
		ISNULL([Day07], 0) AS [Day07],
		ISNULL([Day08], 0) AS [Day08],
		ISNULL([Day09], 0) AS [Day09],
		ISNULL([Day10], 0) AS [Day10],
		ISNULL([Day11], 0) AS [Day11],
		ISNULL([Day12], 0) AS [Day12],
		ISNULL([Day13], 0) AS [Day13],
		ISNULL([Day14], 0) AS [Day14],
		ISNULL([Day15], 0) AS [Day15],
		ISNULL([Day16], 0) AS [Day16],
		ISNULL([Day17], 0) AS [Day17],
		ISNULL([Day18], 0) AS [Day18],
		ISNULL([Day19], 0) AS [Day19],
		ISNULL([Day20], 0) AS [Day20],
		ISNULL([Day21], 0) AS [Day21],
		ISNULL([Day22], 0) AS [Day22],
		ISNULL([Day23], 0) AS [Day23],
		ISNULL([Day24], 0) AS [Day24],
		ISNULL([Day25], 0) AS [Day25],
		ISNULL([Day26], 0) AS [Day26],
		ISNULL([Day27], 0) AS [Day27],
		ISNULL([Day28], 0) AS [Day28],
		ISNULL([Day29], 0) AS [Day29],
		ISNULL([Day30], 0) AS [Day30],
		ISNULL([Day31], 0) AS [Day31],
		CASE
			WHEN DATEADD(day, 28, @PeriodStart) < DATEADD(month, 1, @PeriodStart) THEN 1
			ELSE 0
		END AS [Present29],
		CASE
			WHEN DATEADD(day, 29, @PeriodStart) < DATEADD(month, 1, @PeriodStart) THEN 1
			ELSE 0
		END AS [Present30],
		CASE
			WHEN DATEADD(day, 30, @PeriodStart) < DATEADD(month, 1, @PeriodStart) THEN 1
			ELSE 0
		END AS [Present31]		
	FROM
		@t	


	SET DATEFIRST @FirstDayOfWeek
RETURN 0
GO

GRANT EXEC ON ReportLoadOfEmployee TO PUBLIC

GO
