IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportResourcePlanAbsent')
	BEGIN
		PRINT 'Dropping Procedure ReportResourcePlanAbsent'
		DROP  Procedure  ReportResourcePlanAbsent
	END

GO

PRINT 'Creating Procedure ReportResourcePlanAbsent'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportResourcePlanAbsent
	@PeriodSelector	int,
	@DateSelector	int,
	@PeriodStart	Tdatetime,
	@PeriodEnd		Tdatetime,
	@CompanyID		TIdentifier,
	@ProjectTypeID	TIdentifier,
	@DivisionSelector int,
	@DivisionID		TIdentifier
AS
	

	If @CompanyID IS NULL AND @DivisionSelector<>2
	BEGIN
		RAISERROR('#CompanyIsNotSelected', 16, -1)
		RETURN 1
	END
			IF @DivisionID IS NULL AND @DivisionSelector=2 
	BEGIN
		RAISERROR('#DivisionIsNotSelected', 16, -1)
		RETURN 1
	END


	DECLARE
		@DayCount	int,
		@EmployeeID TIdentifier,
		@LastSymbol	char(8),		
		@IsReportEnable bit,		
		@date datetime,
		@date1 datetime
		
	SET NOCOUNT ON
	
	SET @date = GETDATE()		
		
------------Year choise------------	
	IF @DateSelector = 0 -- . 
		SELECT
			@PeriodStart = CAST(CAST(YEAR(@date) AS varchar(4)) + '0101' AS datetime)
			
	IF @DateSelector = 1 -- . 
		SELECT
			@PeriodStart = CAST(CAST(YEAR(DATEADD(year,1,@date)) AS varchar(4)) + '0101' AS datetime)
			
	IF @DateSelector = 2 -- arbitrary year
		SELECT
			@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime)

------------Period choise----------	
	IF @PeriodSelector = 0 -- 1 .
		SELECT
			@PeriodEnd = DATEADD(month, 6, @PeriodStart)
			
	IF @PeriodSelector = 1 -- 2 .
		SELECT			
			@PeriodStart = DATEADD(month, 6, @PeriodStart),
			@PeriodEnd = DATEADD(month, 6, @PeriodStart)
			
	
	IF @PeriodSelector = 2 -- 
		SELECT						
			@PeriodEnd = DATEADD(year, 1, @PeriodStart)
			
		
		
			
	SELECT 	@date1 = DATEADD(day, -1, @PeriodEnd)	
	EXECUTE ReportResourcePlanAbsentHeader @PeriodSelector, @DateSelector, @PeriodStart, @date1, @CompanyID	, @DivisionID, @DivisionSelector
		
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	-- :		
	SET @IsReportEnable = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')) |
								  dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllEmployees'))
If 	@IsReportEnable = 1 
	--   
	SELECT
		[Employee].[ID] AS [EmployeeID],
		[Employee].[FileAs] AS [EmployeeName],
		[Position].[FileAs] AS [Position],
		[Task].[FileAs] AS [TaskName],
		[Task].[StartDate],
		[Task].[DueDate],
		DATEDIFF( day, [Task].[StartDate], [Task].[DueDate])+1 as [Duration]
	FROM 
		(((([Project]
			 INNER JOIN [vwAssignment] ON [Project].[ID] = [vwAssignment].[ProjectID])
				 INNER JOIN [TaskAssignment] ON [vwAssignment].[ID] = [TaskAssignment].[AssignmentID])
					 INNER JOIN [Task] ON [TaskAssignment].[TaskID] = [Task].[ID])
						 INNER JOIN 
								([Employee] INNER JOIN [Company] ON [Employee].[CompanyID] = [Company].[ID]) ON
								 [vwAssignment].[EmployeeID] = [Employee].[ID])
		LEFT OUTER JOIN [Division] 
				ON [Employee].[DivisionID] = [Division].[ID]						 
		LEFT JOIN [Position] ON [Employee].[PositionID] = [Position].[ID]
	WHERE 
		[Company].[Own]=1 AND [Project].[ProjectTypeID]=@ProjectTypeID AND 
		(
			@DivisionSelector = 0 OR 
			(@DivisionSelector = 1 AND [Employee].[DivisionID] IS NULL) OR
			(@DivisionSelector = 2 AND ([Employee].[DivisionID] = @DivisionID OR (@DivisionID IS NULL AND [Employee].[DivisionID] IS NOT NULL)))
		)AND 
		[Company].[ID]=@CompanyID AND
		(([Task].[StartDate] >= @PeriodStart and [Task].[StartDate]< @PeriodEnd )
			 OR 
		 ([Task].[DueDate]   >= @PeriodStart and [Task].[DueDate]  < @PeriodEnd ))
else			
	--  PM  
	DECLARE
		@t	table([ID]int)
	INSERT INTO @t([ID])
	SELECT DISTINCT [Employee].[ID]
			FROM [Employee]
				INNER JOIN [vwAssignment] ON [vwAssignment].[EmployeeID] = [Employee].[ID]
				INNER JOIN [Project] ON [Project].[ID] = [vwAssignment].[ProjectID]
			WHERE [Project].[ProjectManagerEmployeeID] = @EmployeeID
			
	SELECT
		[Employee].[ID] AS [EmployeeID],
		[Employee].[FileAs] AS [EmployeeName],
		[Position].[FileAs] AS [Position],
		[Task].[FileAs] AS [TaskName],
		[Task].[StartDate],
		[Task].[DueDate],
		DATEDIFF( day, [Task].[StartDate], [Task].[DueDate])+1 as [Duration]
	FROM 
		(((([Project]
			INNER JOIN [vwAssignment] ON [Project].[ID] = [vwAssignment].[ProjectID])
				INNER JOIN [TaskAssignment] ON [vwAssignment].[ID] = [TaskAssignment].[AssignmentID])
					INNER JOIN [Task] ON [TaskAssignment].[TaskID] = [Task].[ID])
						INNER JOIN 
								([Employee] INNER JOIN [Company] ON [Employee].[CompanyID] = [Company].[ID]) ON
								[vwAssignment].[EmployeeID] = [Employee].[ID])
		LEFT JOIN [Position] ON [Employee].[PositionID] = [Position].[ID]
		INNER JOIN @t AS [Table] ON [Table].[ID] = [Employee].[ID]
	WHERE 
		([Company].[Own]=1 AND [Project].[ProjectTypeID]=@ProjectTypeID AND 
		[Company].[ID]=@CompanyID) and
		(([Task].[StartDate] >= @PeriodStart and [Task].[StartDate]< @PeriodEnd )
			 OR 
		 ([Task].[DueDate]   >= @PeriodStart and [Task].[DueDate]  < @PeriodEnd ))
		 			

RETURN 0
GO

GRANT EXEC ON ReportResourcePlanAbsent TO PUBLIC

GO
