IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportResourcePlanHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportResourcePlanHeader'
		DROP  Procedure  ReportResourcePlanHeader
	END

GO

PRINT 'Creating Procedure ReportResourcePlanHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportResourcePlanHeader
	@PeriodStart	TDateTime,
	@PeriodEnd		TDateTime,
	@CompanyID		TIdentifier,
	@NotLogged		TString,
	@DivisionID     TIdentifier,
	@DivisionSelector int
AS
	SET NOCOUNT ON
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@CompanyName	TName,
		@DivisionName   TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)
		
		
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00	
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @CompanyName = '()'
	SET @DivisionName = CASE @DivisionSelector
         WHEN 0 THEN '()'
         WHEN 1 THEN ' '
	END			
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
	
	SELECT
		@CompanyName = [Company].[FileAs]
	FROM
		[Company]
	WHERE
		[Company].[ID] = @CompanyID			
		
		SELECT
		@DivisionName = [Division].[FileAs]
	FROM
		[Division]
	WHERE
		[Division].[ID] = @DivisionID
		
	SELECT
		@CompanyName AS [CompanyName],
		@DivisionName AS [DivisionName],
		@PeriodStart AS [Date],
		@UserName AS [UserName],
		@NotLogged AS [NotLogged],
		dbo.fnPjm5GetWorkingDays(@PeriodStart, DATEADD(day, -1, @PeriodEnd)) AS [WorkingDays],
		@WorkTime AS [WorkTime]
		

RETURN 0
GO

GRANT EXEC ON ReportResourcePlanHeader TO PUBLIC

GO
