IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportTotalOfEmployeesHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportTotalOfEmployeesHeader'
		DROP  Procedure  ReportTotalOfEmployeesHeader
	END

GO

PRINT 'Creating Procedure ReportTotalOfEmployeesHeader'
GO

--------------------------------------------------------------------------------------
-- Copyright (c) 2003 by Avicom
--------------------------------------------------------------------------------------
-- $Archive: $
-- $Author: $
-- $Revision: $
-- $Modtime: $
-- $Date: $
--
-- Description: this stored procedure ...........
-- Input:	.........
-- Output:      0 - success, negative number - otherwise
--
-- Notes:       no
--
--
/* $Log: $ 
   $NoKeywords: $ 
--------------------------------------------------------------------------------------*/
CREATE Procedure ReportTotalOfEmployeesHeader
	@DateSelector	int,
	@PeriodStart	TDateTime,
	@PeriodEnd		TDateTime
AS
	SET DATEFIRST 7
	DECLARE
		@UserID			TIdentifier,
		@UserName		TName,
		@value			TVariant,
		@WorkTime		decimal(18,2)		
	
	EXEC adfParameterGet 'WorkTime', 'Pjm5', @value OUTPUT  
	SET @WorkTime = CAST(@value AS decimal(18,2))
	SET @WorkTime = @WorkTime / 60.00
		
	SET @UserID = dbo.adfGetCurrentUserID()
		
	SELECT
		@UserName = [Trustee].[DisplayName]
	FROM
		[Trustee]
	WHERE
		[Trustee].[ID] = @UserID
		
	SELECT
		@DateSelector AS [DateSelector],
		@PeriodStart AS [PeriodStart],
		DATEADD(second, -1, @PeriodEnd) AS [PeriodEnd],
		@UserName AS [CurrentUser],
		dbo.fnPjm5GetWorkingDays(@PeriodStart, DATEADD(second, -1, @PeriodEnd)) AS [WorkingDays],
		@WorkTime AS [WorkTime]	

RETURN 0

GO

GRANT EXEC ON ReportTotalOfEmployeesHeader TO PUBLIC

GO
