
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ReportDocumentCard]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure ReportDocumentCard'
		DROP PROCEDURE [dbo].[ReportDocumentCard]
	END
GO

PRINT 'Creating procedure ReportDocumentCard'
GO

/******************************************************************************
**		File: ReportDocumentCard.sql
**		Name: ReportDocumentCard
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [ReportDocumentCard]
	@ID TIdentifier
AS
	DECLARE
		@DocumentClass TClass,
		@CompanyID TIdentifier,
		@CorrespondentCompanyID TIdentifier,
		@ContactID TIdentifier,
		@CorrespondentContactID TIdentifier,
		@CardOwnerID TIdentifier,
		@DivisionID TIdentifier,
		@DocumentCardID TIdentifier,
		@CustodyPlaceID TIdentifier,
		@CaseID TIdentifier,
		@DocumentItemID TIdentifier,
		@DocumentItemPath TNotes,
		@FolderID TIdentifier,
		@ItemCheckedOutByID TIdentifier 

	SET NOCOUNT ON	
	SET DATEFIRST 1	
	SELECT
		@DocumentClass = [DocumentCard].[Class],
		@CompanyID = [DocumentCard].[CompanyID],
		@CorrespondentCompanyID = [DocumentCard].[CorrespondentCompanyID],
		@ContactID = [DocumentCard].[ContactID],
		@CorrespondentContactID = [DocumentCard].[CorrespondentContactID],
		@CardOwnerID = [DocumentCard].[CardOwnerID],
		@DivisionID = [DocumentCard].[DivisionID],
		@DocumentCardID = [DocumentCard].[DocumentCardID],
		@CustodyPlaceID = [DocumentCard].[CustodyPlaceID],
		@CaseID = [DocumentCard].[CaseID]
	FROM [DocumentCard] WHERE [DocumentCard].[ID] = @ID
	
	SELECT
		@DocumentItemID = [DocumentItem].[ID],
		@ItemCheckedOutByID = [DocumentItem].[CheckedOutBy],
		@DocumentItemPath = ''
	FROM
		[DocumentItem]
	WHERE
		[DocumentItem].[DocumentCardID] = @ID
	
	-- Concat File Path
	SELECT 
		@FolderID = [Folder].[ID] 
	FROM 
		[Folder]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[FolderID] = [Folder].[ID]
			AND [DocumentCard].[ID] = @ID
	
	WHILE (@FolderID IS NOT NULL)
	BEGIN
		SELECT 
			@FolderID = [Folder].[FolderID],
			@DocumentItemPath = [FileAs] + '\' + @DocumentItemPath
		FROM 
			[Folder]
		WHERE
			[Folder].[ID] = @FolderID 
	END
	
	-- DocumentCard
	SELECT
		[DocumentCard].[ID],
		[DocumentCard].[FileAs],
		[DocumentCard].[State],
		[DocumentCard].[Class],
		[DocumentCard].[CompanyID],
		[DocumentCard].[ContactID],
		[DocumentCard].[CorrespondentCompanyID],
		[DocumentCard].[CorrespondentContactID],
		[DocumentCard].[CardOwnerID],
		[DocumentCard].[DivisionID],
		[DocumentCard].[CustodyPlaceID],
		[DocumentCard].[CaseID],
		[DocumentCard].[DocumentCardID] as [DocumentCardAnswerToID],
		[DocumentCard].[DocumentCardClassID],
		[DocumentCard].[DocumentSendTypeID],
		[DocumentCard].[DocumentSendBackTypeID],
		[DocumentCardClass].[FileAs] as [DocumentCardClass],
		[DocumentSendType].[FileAs] as [DocumentSentType],
		[DocumentSendBackType].[FileAs] as [DocumentSentBackType],
		[Folder].[ID] as [FolderID],
		[Folder].[FileAs] as [FolderFileAs],
		[DocumentCard].[Date],
		[DocumentCard].[DateIn],
		[DocumentCard].[DateOut],
		[DocumentCard].[Number],
		[DocumentCard].[NumberIn],
		[DocumentCard].[NumberOut],
		[DocumentCard].[AppendixCount],
		[DocumentCard].[PageCount],
		[DocumentCard].[Copy],
		[DocumentCard].[StorePeriod],
		[DocumentCard].[Package],
		[DocumentCard].[Created],
		[DocumentCard].[CreatedBy],
		[DocumentCard].[Modified],
		[DocumentCard].[ModifiedBy],
		[DocumentCard].[HasToBeSentBack],
		[DocumentCard].[SentBackTime]
	FROM [DocumentCard]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCard].[FolderID] 
		LEFT OUTER JOIN [DocumentCardClass]
			ON [DocumentCardClass].[ID] = [DocumentCard].[DocumentCardClassID]
		LEFT OUTER JOIN [DocumentSendType]
			ON [DocumentSendType].[ID] = [DocumentCard].[DocumentSendTypeID]
		LEFT OUTER JOIN [DocumentSendType] as [DocumentSendBackType]
			ON [DocumentSendBackType].[ID] = [DocumentCard].[DocumentSendBackTypeID]	
	WHERE
		[DocumentCard].[ID] = @ID
	
	-- DocumentCard Company
	SELECT
		[Company].[ID], 
		[Company].[FileAs],
		[Company].[LegalName],
		[Company].[Own],
		[Company].[KPP],
		[Company].[FoundationDate],
		[Company].[LegalCode],
		[Company].[Comments],
		[Company].[LastContact],
		[Company].[NextContact],
		[Company].[BankAccountID],
		[BankAccount].[FileAs] as [BankFileAs],
		[BankAccount].[Country] as [BankCountry],
		[BankAccount].[City] as [BankCity],
		[BankAccount].[Address] as [BankAddress],
		[BankAccount].[BankCode] as [BankCode],
		[BankAccount].[CurrencyCode] as [BankCurrencyCode],
		[BankAccount].[Account] as [BankAccount],
		[BankAccount].[SWIFT] as [BankSWIFT],
		[BankAccount].[ABA] as [BankABA],
		[BankAccount].[IBAN] as [BankIBAN],
		[BankAccount].[IntermediaryAccount] as [BankIntermediaryAccount],
		[BankAccount].[IntermediaryBank] as [BankIntermediaryBank],
		[BankAccount].[IntermediaryAddress] as [BankIntermediaryAddress],
		[BankAccount].[IntermediarySWIFT] as [BankIntermediarySWIFT],
		[BankAccount].[IntermediaryABA] as [BankIntermediaryABA],
		[BankAccount].[AdditionalAccounts] as [AdditionalAccounts],
		[Company].[ExecutiveEmployeeID],
		[ExecutiveEmployee].[FileAs] as [ExecutiveEmployeeFileAs],		
		[ExecutiveEmployeeQualification].[FileAs] as [ExecutiveEmployeeQualification],
		[ExecutiveEmployeePosition].[FileAs] as [ExecutiveEmployeePosition],
		[ExecutiveEmployeeDivision].[FileAs] as [ExecutiveEmployeeDivision],
		[Company].[AccountantEmployeeID],
		[AccountantEmployee].[FileAs] as [AccountantEmployeeFileAs],
		[AccountantEmployeeQualification].[FileAs] as [AccountantEmployeeQualification],
		[AccountantEmployeePosition].[FileAs] as [AccountantEmployeePosition],
		[AccountantEmployeeDivision].[FileAs] as [AccountantEmployeeDivision],
		[Company].[ManagerEmployeeID],
		[ManagerEmployee].[FileAs] as [ManagerEmployeeFileAs],
		[ManagerEmployeeQualification].[FileAs] as [ManagerEmployeeQualification],
		[ManagerEmployeePosition].[FileAs] as [ManagerEmployeePosition],
		[ManagerEmployeeDivision].[FileAs] as [ManagerEmployeeDivision],
		[Company].[CompanySizeID],
		[CompanySize].[FileAs] as [CompanySize],
		[Company].[CompanyStatusID],
		[CompanyStatus].[FileAs] as [CompanyStatus],
		[Company].[CompanyTurnOverID],
		[CompanyTurnOver].[From] as [CompanyTurnOverFrom],
		[CompanyTurnOver].[To] as [CompanyTurnOverTo]	
	FROM [Company]
		LEFT OUTER JOIN [BankAccount]
			ON [BankAccount].[ID] = [Company].[BankAccountID]		
		LEFT OUTER JOIN [Employee] as [ExecutiveEmployee]
			ON [ExecutiveEmployee].[ID] = [Company].[ExecutiveEmployeeID]	
		LEFT OUTER JOIN [Qualification] as [ExecutiveEmployeeQualification]
			ON [ExecutiveEmployeeQualification].[ID] = [ExecutiveEmployee].[QualificationID]
		LEFT OUTER JOIN [Position] as [ExecutiveEmployeePosition]
			ON [ExecutiveEmployeePosition].[ID] = [ExecutiveEmployee].[PositionID]
		LEFT OUTER JOIN [Division] as [ExecutiveEmployeeDivision]
			ON [ExecutiveEmployeeDivision].[ID] = [ExecutiveEmployee].[DivisionID]
		LEFT OUTER JOIN [Employee] as [AccountantEmployee]
			ON [AccountantEmployee].[ID] = [Company].[AccountantEmployeeID]
		LEFT OUTER JOIN [Qualification] as [AccountantEmployeeQualification]
			ON [AccountantEmployeeQualification].[ID] = [AccountantEmployee].[QualificationID]
		LEFT OUTER JOIN [Position] as [AccountantEmployeePosition]
			ON [AccountantEmployeePosition].[ID] = [AccountantEmployee].[PositionID]
		LEFT OUTER JOIN [Division] as [AccountantEmployeeDivision]
			ON [AccountantEmployeeDivision].[ID] = [AccountantEmployee].[DivisionID]	
		LEFT OUTER JOIN [Employee] as [ManagerEmployee]
			ON [ManagerEmployee].[ID] = [Company].[ManagerEmployeeID]
		LEFT OUTER JOIN [Qualification] as [ManagerEmployeeQualification]
			ON [ManagerEmployeeQualification].[ID] = [ManagerEmployee].[QualificationID]
		LEFT OUTER JOIN [Position] as [ManagerEmployeePosition]
			ON [ManagerEmployeePosition].[ID] = [ManagerEmployee].[PositionID]
		LEFT OUTER JOIN [Division] as [ManagerEmployeeDivision]
			ON [ManagerEmployeeDivision].[ID] = [ManagerEmployee].[DivisionID]
		LEFT OUTER JOIN [CompanySize]
			ON [CompanySize].[ID] = [Company].[CompanySizeID]
		LEFT OUTER JOIN [CompanyStatus]
			ON [CompanyStatus].[ID] = [Company].[CompanyStatusID]
		LEFT OUTER JOIN [CompanyTurnOver]
			ON [CompanyTurnOver].[ID] = [Company].[CompanyTurnoverID]		
	WHERE [Company].[ID] = @CompanyID

	-- DocumentCard Company All BankAccounts
	SELECT 
		[CompanyBankAccounts].[ID],
		[CompanyBankAccounts].[FileAs] as [BankFileAs],
		[CompanyBankAccounts].[Country] as [BankCountry],
		[CompanyBankAccounts].[City] as [BankCity],
		[CompanyBankAccounts].[Address] as [BankAddress],
		[CompanyBankAccounts].[BankCode] as [BankCode],
		[CompanyBankAccounts].[CurrencyCode] as [BankCurrencyCode],
		[CompanyBankAccounts].[Account] as [BankAccount],
		[CompanyBankAccounts].[SWIFT] as [BankSWIFT],
		[CompanyBankAccounts].[ABA] as [BankABA],
		[CompanyBankAccounts].[IBAN] as [BankIBAN],
		[CompanyBankAccounts].[IntermediaryAccount] as [BankIntermediaryAccount],
		[CompanyBankAccounts].[IntermediaryBank] as [BankIntermediaryBank],
		[CompanyBankAccounts].[IntermediaryAddress] as [BankIntermediaryAddress],
		[CompanyBankAccounts].[IntermediarySWIFT] as [BankIntermediarySWIFT],
		[CompanyBankAccounts].[IntermediaryABA] as [BankIntermediaryABA],
		[CompanyBankAccounts].[AdditionalAccounts] as [AdditionalAccounts],
		(CASE [CompanyBankAccounts].[ID] WHEN [Company].[BankAccountID] 
			THEN 1 ELSE 0 END) as [IsPrimary]
	FROM [BankAccount] as [CompanyBankAccounts]
		INNER JOIN [Company]
			ON [Company].[ID] = [CompanyBankAccounts].[CompanyID]
			AND [Company].[ID] = @CompanyID
	WHERE
			[CompanyBankAccounts].[State] = 1

	-- DocumentCard Contact
	SELECT 
		[Contact].[ID],
		[Contact].[State],
		[Contact].[FileAs],
		[Contact].[QualificationID],
		[ContactQualification].[FileAs] as [ContactQualification],
		[Contact].[PositionID],
		[ContactEmployeePosition].[FileAs] as [ContactEmployeePosition],
		[Contact].[DivisionID],
		[ContactEmployeeDivision].[FileAs] as [ContactEmployeeDivision],
		[Contact].[HireDate],
		[Contact].[FireDate],
		[Contact].[Comments],
		[Contact].[Title],
		[Contact].[FirstName],
		[Contact].[MiddleName],
		[Contact].[LastName],
		[Contact].[Suffix],
		[Contact].[Initials],
		[Contact].[BirthDate],
		[Contact].[BirthPlace],
		[Contact].[LastContact],
		[Contact].[NextContact],
		[Contact].[Number],
		[IdentityCard].[Seria] as [PassportSeria],
		[IdentityCard].[Number] as [PassportNumber],
		[IdentityCard].[IssueDate] as [PassportDate],
		[IdentityCard].[Issuer] as [PassportIssuer]
	FROM
		[Employee] as [Contact]
	LEFT OUTER JOIN [Qualification] as [ContactQualification]
		ON [ContactQualification].[ID] = [Contact].[QualificationID]
	LEFT OUTER JOIN [Position] as [ContactEmployeePosition]
		ON [ContactEmployeePosition].[ID] = [Contact].[PositionID]
	LEFT OUTER JOIN [Division] as [ContactEmployeeDivision]
		ON [ContactEmployeeDivision].[ID] = [Contact].[DivisionID]
	LEFT OUTER JOIN [IdentityCard]
		ON [IdentityCard].[EmployeeID] = [Contact].[ID]
	WHERE
		[Contact].[ID] = @ContactID

	-- DocumentCard CorrespondentCompany
	SELECT 
		[CorrespondentCompany].[ID],
		[CorrespondentCompany].[FileAs],
		[CorrespondentCompany].[LegalName],
		[CorrespondentCompany].[Own],
		[CorrespondentCompany].[KPP],
		[CorrespondentCompany].[FoundationDate],
		[CorrespondentCompany].[LegalCode],
		[CorrespondentCompany].[Comments],
		[CorrespondentCompany].[LastContact],
		[CorrespondentCompany].[NextContact],
		[CorrespondentCompany].[BankAccountID],
		[BankAccount].[FileAs] as [BankFileAs],
		[BankAccount].[Country] as [BankCountry],
		[BankAccount].[City] as [BankCity],
		[BankAccount].[Address] as [BankAddress],
		[BankAccount].[BankCode] as [BankCode],
		[BankAccount].[CurrencyCode] as [BankCurrencyCode],
		[BankAccount].[Account] as [BankAccount],
		[BankAccount].[SWIFT] as [BankSWIFT],
		[BankAccount].[ABA] as [BankABA],
		[BankAccount].[IBAN] as [BankIBAN],
		[BankAccount].[IntermediaryAccount] as [BankIntermediaryAccount],
		[BankAccount].[IntermediaryBank] as [BankIntermediaryBank],
		[BankAccount].[IntermediaryAddress] as [BankIntermediaryAddress],
		[BankAccount].[IntermediarySWIFT] as [BankIntermediarySWIFT],
		[BankAccount].[IntermediaryABA] as [BankIntermediaryABA],
		[BankAccount].[AdditionalAccounts] as [AdditionalAccounts],
		[CorrespondentCompany].[ExecutiveEmployeeID],
		[ExecutiveEmployee].[FileAs] as [ExecutiveEmployeeFileAs],		
		[ExecutiveEmployeeQualification].[FileAs] as [ExecutiveEmployeeQualification],
		[ExecutiveEmployeePosition].[FileAs] as [ExecutiveEmployeePosition],
		[ExecutiveEmployeeDivision].[FileAs] as [ExecutiveEmployeeDivision],
		[CorrespondentCompany].[AccountantEmployeeID],
		[AccountantEmployee].[FileAs] as [AccountantEmployeeFileAs],
		[AccountantEmployeeQualification].[FileAs] as [AccountantEmployeeQualification],
		[AccountantEmployeePosition].[FileAs] as [AccountantEmployeePosition],
		[AccountantEmployeeDivision].[FileAs] as [AccountantEmployeeDivision],
		[CorrespondentCompany].[ManagerEmployeeID],
		[ManagerEmployee].[FileAs] as [ManagerEmployeeFileAs],
		[ManagerEmployeeQualification].[FileAs] as [ManagerEmployeeQualification],
		[ManagerEmployeePosition].[FileAs] as [ManagerEmployeePosition],
		[ManagerEmployeeDivision].[FileAs] as [ManagerEmployeeDivision],
		[CorrespondentCompany].[CompanySizeID],
		[CompanySize].[FileAs] as [CompanySize],
		[CorrespondentCompany].[CompanyStatusID],
		[CompanyStatus].[FileAs] as [CompanyStatus],
		[CorrespondentCompany].[CompanyTurnOverID],
		[CompanyTurnOver].[From] as [CompanyTurnOverFrom],
		[CompanyTurnOver].[To] as [CompanyTurnOverTo]	
	FROM [Company] as [CorrespondentCompany]
		LEFT OUTER JOIN [BankAccount]
			ON [BankAccount].[ID] = [CorrespondentCompany].[BankAccountID]		
		LEFT OUTER JOIN [Employee] as [ExecutiveEmployee]
			ON [ExecutiveEmployee].[ID] = [CorrespondentCompany].[ExecutiveEmployeeID]	
		LEFT OUTER JOIN [Qualification] as [ExecutiveEmployeeQualification]
			ON [ExecutiveEmployeeQualification].[ID] = [ExecutiveEmployee].[QualificationID]
		LEFT OUTER JOIN [Position] as [ExecutiveEmployeePosition]
			ON [ExecutiveEmployeePosition].[ID] = [ExecutiveEmployee].[PositionID]
		LEFT OUTER JOIN [Division] as [ExecutiveEmployeeDivision]
			ON [ExecutiveEmployeeDivision].[ID] = [ExecutiveEmployee].[DivisionID]
		LEFT OUTER JOIN [Employee] as [AccountantEmployee]
			ON [AccountantEmployee].[ID] = [CorrespondentCompany].[AccountantEmployeeID]
		LEFT OUTER JOIN [Qualification] as [AccountantEmployeeQualification]
			ON [AccountantEmployeeQualification].[ID] = [AccountantEmployee].[QualificationID]
		LEFT OUTER JOIN [Position] as [AccountantEmployeePosition]
			ON [AccountantEmployeePosition].[ID] = [AccountantEmployee].[PositionID]
		LEFT OUTER JOIN [Division] as [AccountantEmployeeDivision]
			ON [AccountantEmployeeDivision].[ID] = [AccountantEmployee].[DivisionID]	
		LEFT OUTER JOIN [Employee] as [ManagerEmployee]
			ON [ManagerEmployee].[ID] = [CorrespondentCompany].[ManagerEmployeeID]
		LEFT OUTER JOIN [Qualification] as [ManagerEmployeeQualification]
			ON [ManagerEmployeeQualification].[ID] = [ManagerEmployee].[QualificationID]
		LEFT OUTER JOIN [Position] as [ManagerEmployeePosition]
			ON [ManagerEmployeePosition].[ID] = [ManagerEmployee].[PositionID]
		LEFT OUTER JOIN [Division] as [ManagerEmployeeDivision]
			ON [ManagerEmployeeDivision].[ID] = [ManagerEmployee].[DivisionID]
		LEFT OUTER JOIN [CompanySize]
			ON [CompanySize].[ID] = [CorrespondentCompany].[CompanySizeID]
		LEFT OUTER JOIN [CompanyStatus]
			ON [CompanyStatus].[ID] = [CorrespondentCompany].[CompanyStatusID]
		LEFT OUTER JOIN [CompanyTurnOver]
			ON [CompanyTurnOver].[ID] = [CorrespondentCompany].[CompanyTurnoverID]		
	WHERE [CorrespondentCompany].[ID] = @CorrespondentCompanyID

	-- DocumentCard CorrespondentCompany All BankAccounts
	SELECT 
		[CorrespondentCompanyBankAccounts].[ID],
		[CorrespondentCompanyBankAccounts].[FileAs] as [BankFileAs],
		[CorrespondentCompanyBankAccounts].[Country] as [BankCountry],
		[CorrespondentCompanyBankAccounts].[City] as [BankCity],
		[CorrespondentCompanyBankAccounts].[Address] as [BankAddress],
		[CorrespondentCompanyBankAccounts].[BankCode] as [BankCode],
		[CorrespondentCompanyBankAccounts].[CurrencyCode] as [BankCurrencyCode],
		[CorrespondentCompanyBankAccounts].[Account] as [BankAccount],
		[CorrespondentCompanyBankAccounts].[SWIFT] as [BankSWIFT],
		[CorrespondentCompanyBankAccounts].[ABA] as [BankABA],
		[CorrespondentCompanyBankAccounts].[IBAN] as [BankIBAN],
		[CorrespondentCompanyBankAccounts].[IntermediaryAccount] as [BankIntermediaryAccount],
		[CorrespondentCompanyBankAccounts].[IntermediaryBank] as [BankIntermediaryBank],
		[CorrespondentCompanyBankAccounts].[IntermediaryAddress] as [BankIntermediaryAddress],
		[CorrespondentCompanyBankAccounts].[IntermediarySWIFT] as [BankIntermediarySWIFT],
		[CorrespondentCompanyBankAccounts].[IntermediaryABA] as [BankIntermediaryABA],
		[CorrespondentCompanyBankAccounts].[AdditionalAccounts] as [AdditionalAccounts],
		(CASE [CorrespondentCompanyBankAccounts].[ID] WHEN [Company].[BankAccountID] 
			THEN 1 ELSE 0 END) as [IsPrimary]
	FROM [BankAccount] as [CorrespondentCompanyBankAccounts]
		INNER JOIN [Company]
			ON [Company].[ID] = [CorrespondentCompanyBankAccounts].[CompanyID]
			AND [Company].[ID] = @CorrespondentCompanyID
	WHERE
		[CorrespondentCompanyBankAccounts].[State] = 1
	

	-- DocumentCard CorrespondentContact
	SELECT 
		[CorrespondentContact].[ID],
		[CorrespondentContact].[State],
		[CorrespondentContact].[FileAs],
		[CorrespondentContact].[QualificationID],
		[ContactQualification].[FileAs] as [ContactQualification],
		[CorrespondentContact].[PositionID],
		[ContactEmployeePosition].[FileAs] as [ContactEmployeePosition],
		[CorrespondentContact].[DivisionID],
		[ContactEmployeeDivision].[FileAs] as [ContactEmployeeDivision],
		[CorrespondentContact].[HireDate],
		[CorrespondentContact].[FireDate],
		[CorrespondentContact].[Comments],
		[CorrespondentContact].[Title],
		[CorrespondentContact].[FirstName],
		[CorrespondentContact].[MiddleName],
		[CorrespondentContact].[LastName],
		[CorrespondentContact].[Suffix],
		[CorrespondentContact].[Initials],
		[CorrespondentContact].[BirthDate],
		[CorrespondentContact].[BirthPlace],
		[CorrespondentContact].[LastContact],
		[CorrespondentContact].[NextContact]
	FROM
		[Employee] as [CorrespondentContact]
	LEFT OUTER JOIN [Qualification] as [ContactQualification]
		ON [ContactQualification].[ID] = [CorrespondentContact].[QualificationID]
	LEFT OUTER JOIN [Position] as [ContactEmployeePosition]
		ON [ContactEmployeePosition].[ID] = [CorrespondentContact].[PositionID]
	LEFT OUTER JOIN [Division] as [ContactEmployeeDivision]
		ON [ContactEmployeeDivision].[ID] = [CorrespondentContact].[DivisionID]
	WHERE [CorrespondentContact].[ID] = @CorrespondentContactID

	-- DocumentCard CardOwner
	SELECT 
		[CardOwnerContact].[ID],
		[CardOwnerContact].[State],
		[CardOwnerContact].[FileAs],
		[CardOwnerContact].[QualificationID],
		[ContactQualification].[FileAs] as [ContactQualification],
		[CardOwnerContact].[PositionID],
		[ContactEmployeePosition].[FileAs] as [ContactEmployeePosition],
		[CardOwnerContact].[DivisionID],
		[ContactEmployeeDivision].[FileAs] as [ContactEmployeeDivision],
		[CardOwnerContact].[HireDate],
		[CardOwnerContact].[FireDate],
		[CardOwnerContact].[Comments],
		[CardOwnerContact].[Title],
		[CardOwnerContact].[FirstName],
		[CardOwnerContact].[MiddleName],
		[CardOwnerContact].[LastName],
		[CardOwnerContact].[Suffix],
		[CardOwnerContact].[Initials],
		[CardOwnerContact].[BirthDate],
		[CardOwnerContact].[BirthPlace],
		[CardOwnerContact].[LastContact],
		[CardOwnerContact].[NextContact]
	FROM
		[Employee] as [CardOwnerContact]
	LEFT OUTER JOIN [Qualification] as [ContactQualification]
		ON [ContactQualification].[ID] = [CardOwnerContact].[QualificationID]
	LEFT OUTER JOIN [Position] as [ContactEmployeePosition]
		ON [ContactEmployeePosition].[ID] = [CardOwnerContact].[PositionID]
	LEFT OUTER JOIN [Division] as [ContactEmployeeDivision]
		ON [ContactEmployeeDivision].[ID] = [CardOwnerContact].[DivisionID]
	WHERE 
		[CardOwnerContact].[ID] = @CardOwnerID

	-- DocumentCard Division 
	SELECT 
		[Division].[ID],
		[Division].[Class],
		[Division].[State],
		[Division].[Code],
		[Division].[FileAs],
		[Division].[Comments]
	FROM [Division]
	WHERE [Division].[ID] = @DivisionID

	-- CustodyPlace
	SELECT 
		[CustodyPlace].[ID],
		[CustodyPlace].[State],
		[CustodyPlace].[Code],
		[CustodyPlace].[FileAs],
		[CustodyPlace].[Comments]
	FROM [CustodyPlace]
	WHERE [CustodyPlace].[ID] = @CustodyPlaceID

	-- DocumentCard Case
	SELECT 
		[Case].[ID],
		[Case].[Class],
		[Case].[State],
		[Case].[Code],
		[Case].[FileAs],
		[Case].[EmployeeID],
		[Employee].[FileAs] as [EmployeeFileAs],
		[Qualification].[FileAs] as [QualificationFileAs],
		[Position].[FileAs] as [PositionFileAs],
		[Division].[FileAs] as [DivisionFileAs],
		[Case].[NumberTemplate],
		[Case].[StartDate],
		[Case].[EndDate],
		[Case].[CurrentNumber],
		[Case].[Increment],
		[Case].[AllowInternal],
		[Case].[AllowIncoming],
		[Case].[AllowOutgoing],
		[Case].[AllowFolder],
		[Case].[HasToBeSentBack],
		[Case].[WordTemplatesfolderID]
	FROM [Case]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [Case].[EmployeeID]
		LEFT OUTER JOIN [Qualification]
			ON [Qualification].[ID] = [Employee].[QualificationID]
		LEFT OUTER JOIN [Position]
			ON [Position].[ID] = [Employee].[PositionID]
		LEFT OUTER JOIN [Division]
			ON [Division].[ID] = [Employee].[DivisionID]
	WHERE [Case].[ID] = @CaseID
	
	-- DocumentCard DocumentItem
	SELECT
		[DocumentItem].[ID],
		[DocumentItem].[Class],
		[DocumentItem].[FileAs],
		[DocumentItem].[FileName],
		[DocumentItem].[Extension],
		@DocumentItemPath as [Path],
		[DocumentItem].[LatestVersion],
		[DocumentItem].[Created],
		[DocumentItem].[CreatedBy],
		[DocumentItem].[Modified],
		[DocumentItem].[ModifiedBy]
	FROM
		[DocumentItem]
	WHERE
		[DocumentItem].[DocumentCardID] = @ID
		
	-- DocumentCard DocumentItemCurrentCheckedOutBy
	SELECT 
		[ItemCheckedOutBy].[ID],
		[ItemCheckedOutBy].[State],
		[ItemCheckedOutBy].[FileAs],
		[ItemCheckedOutBy].[QualificationID],
		[ItemCheckedOutByQualification].[FileAs] as [Qualification],
		[ItemCheckedOutBy].[PositionID],
		[ItemCheckedOutByPosition].[FileAs] as [Position],
		[ItemCheckedOutBy].[DivisionID],
		[ItemCheckedOutByDivision].[FileAs] as [Division],
		[ItemCheckedOutBy].[HireDate],
		[ItemCheckedOutBy].[FireDate],
		[ItemCheckedOutBy].[Comments],
		[ItemCheckedOutBy].[Title],
		[ItemCheckedOutBy].[FirstName],
		[ItemCheckedOutBy].[MiddleName],
		[ItemCheckedOutBy].[LastName],
		[ItemCheckedOutBy].[Suffix],
		[ItemCheckedOutBy].[Initials],
		[ItemCheckedOutBy].[BirthDate],
		[ItemCheckedOutBy].[BirthPlace],
		[ItemCheckedOutBy].[LastContact],
		[ItemCheckedOutBy].[NextContact]
	FROM
		[Employee] as [ItemCheckedOutBy]
	LEFT OUTER JOIN [Qualification] as [ItemCheckedOutByQualification]
		ON [ItemCheckedOutByQualification].[ID] = [ItemCheckedOutBy].[QualificationID]
	LEFT OUTER JOIN [Position] as [ItemCheckedOutByPosition]
		ON [ItemCheckedOutByPosition].[ID] = [ItemCheckedOutBy].[PositionID]
	LEFT OUTER JOIN [Division] as [ItemCheckedOutByDivision]
		ON [ItemCheckedOutByDivision].[ID] = [ItemCheckedOutBy].[DivisionID]
	WHERE 
		[ItemCheckedOutBy].[ID] = @ItemCheckedOutByID
		
	-- Document Flow Entry
	SELECT
		[DocumentFlowEntry].[ID],
		[DocumentFlowEntry].[EmployeeID],
		[Employee].[FileAs] as [EmployeeFileAs],
		[DocumentFlowEntry].[ChargeDate],
		[DocumentFlowEntry].[ReturnDate],
		[DocumentFlowEntry].[Comments]
	FROM
		[DocumentFlowEntry]
		INNER JOIN [Employee]
			ON [DocumentFlowEntry].[EmployeeID] = [Employee].[ID]
	WHERE
		[DocumentFlowEntry].[DocumentClass] = @DocumentClass AND
		[DocumentFlowEntry].[DocumentID] = @ID

	-- Document Item Read Protocol
	SELECT
		[DocumentItemReadProtocol].[ID],
		[DocumentItemReadProtocol].[Version],
		[DocumentItemReadProtocol].[UserID],
		[Employee].[FileAs] as [UserFileAs],
		[DocumentItemReadProtocol].[Created]
	FROM
		[DocumentItemReadProtocol]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[UserID] = [DocumentItemReadProtocol].[UserID]
	WHERE
		[DocumentItemReadProtocol].[ID] = @DocumentItemID 
	
	-- DocumentVersion
	SELECT 
		[DocumentVersion].[Version],
		[DocumentVersion].[Created],
		[DocumentVersion].[CreatedBy],
		[Employee].[FileAs] as [CreatedByFileAs],
		[DocumentVersion].[Comments]
	FROM
		[DocumentVersion]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[UserID] = [DocumentVersion].[CreatedBy]
	WHERE
		[DocumentVersion].[DocumentItemID] = @DocumentItemID		

	-- DocumentCard Card
	SELECT
		[DocumentCardAnswerTo].[ID],
		[DocumentCardAnswerTo].[FileAs],
		[DocumentCardAnswerTo].[State],
		[DocumentCardAnswerTo].[Class],
		[DocumentCardAnswerTo].[CompanyID],
		[Company].[FileAs] as [CompanyFileAs],
		[DocumentCardAnswerTo].[ContactID],
		[Employee].[FileAs] as [ContactFileAs],				
		[DocumentCardAnswerTo].[CorrespondentCompanyID],
		[CorrespondentCompany].[FileAs] as [CorrespondentCompanyFileAs],
		[DocumentCardAnswerTo].[CorrespondentContactID],
		[EmployeeContact].[FileAs] as [CorrespondentContactFileAs],
		[DocumentCardAnswerTo].[CardOwnerID],
		[CardOwner].[FileAs] as [CardownerFileAs],
		[DocumentCardAnswerTo].[DivisionID],
		[Division].[FileAs] as [DivisionFileAs],
		[DocumentCardAnswerTo].[CustodyPlaceID],
		[CustodyPlace].[FileAs] as [CustodyPlaceFileAs],
		[DocumentCardAnswerTo].[CaseID],
		[Case].[FileAs] as [Case],
		[DocumentCardAnswerTo].[DocumentCardID] as [DocumentCardAnswerToID],
		[DocumentCardAnswerToDocumentAnswerTo].[FileAs] as [DocumentCardAnswerToFileAs], 
		[DocumentCardAnswerTo].[DocumentCardClassID],
		[DocumentCardAnswerTo].[DocumentSendTypeID],
		[DocumentCardAnswerTo].[DocumentSendBackTypeID],
		[DocumentCardAnswerTo].[FileAs] as [DocumentCardClass],
		[DocumentSendType].[FileAs] as [DocumentSentType],
		[DocumentSendBackType].[FileAs] as [DocumentSentBackType],
		[Folder].[ID] as [FolderID],
		[Folder].[FileAs] as [FolderFileAs],
		[DocumentCardAnswerTo].[Date],
		[DocumentCardAnswerTo].[DateIn],
		[DocumentCardAnswerTo].[DateOut],
		[DocumentCardAnswerTo].[Number],
		[DocumentCardAnswerTo].[NumberIn],
		[DocumentCardAnswerTo].[NumberOut],
		[DocumentCardAnswerTo].[AppendixCount],
		[DocumentCardAnswerTo].[PageCount],
		[DocumentCardAnswerTo].[Copy],
		[DocumentCardAnswerTo].[StorePeriod],
		[DocumentCardAnswerTo].[Package],
		[DocumentCardAnswerTo].[Created],
		[DocumentCardAnswerTo].[CreatedBy],
		[DocumentCardAnswerTo].[Modified],
		[DocumentCardAnswerTo].[ModifiedBy],
		[DocumentCardAnswerTo].[HasToBeSentBack],
		[DocumentCardAnswerTo].[SentBackTime]
	FROM [DocumentCard] as [DocumentCardAnswerTo]
		INNER JOIN [Folder]
			ON [Folder].[ID] = [DocumentCardAnswerTo].[FolderID] 
		LEFT OUTER JOIN [DocumentCardClass]
			ON [DocumentCardClass].[ID] = [DocumentCardAnswerTo].[DocumentCardClassID]
		LEFT OUTER JOIN [DocumentSendType]
			ON [DocumentSendType].[ID] = [DocumentCardAnswerTo].[DocumentSendTypeID]
		LEFT OUTER JOIN [DocumentSendType] as [DocumentSendBackType]
			ON [DocumentSendBackType].[ID] = [DocumentCardAnswerTo].[DocumentSendBackTypeID]	
		LEFT OUTER JOIN [Company]
			ON [Company].[ID] = [DocumentCardAnswerTo].[CompanyID]
		LEFT OUTER JOIN [Company] as [CorrespondentCompany]
			ON [Company].[ID] = [DocumentCardAnswerTo].[CompanyID]
		LEFT OUTER JOIN [Employee]
			ON [Employee].[ID] = [DocumentCardAnswerTo].[ContactID]
		LEFT OUTER JOIN [Employee] as [EmployeeContact]
			ON [EmployeeContact].[ID] = [DocumentCardAnswerTo].[CorrespondentContactID]
		LEFT OUTER JOIN [Employee] as [CardOwner]
			ON [CardOwner].[ID] = [DocumentCardAnswerTo].[CardOwnerID]
		LEFT OUTER JOIN [Division]
			ON [Division].[ID] = [DocumentCardAnswerTo].[DivisionID]
		LEFT OUTER JOIN [Case]
			ON [Case].[ID] = [DocumentCardAnswerTo].[CaseID]
		LEFT OUTER JOIN [DocumentCard] as [DocumentCardAnswerToDocumentAnswerTo]
			ON [DocumentCardAnswerTo].[ID] = [DocumentCardAnswerToDocumentAnswerTo].[DocumentCardID]
		LEFT OUTER JOIN [CustodyPlace]
			ON [CustodyPlace].[ID] = [DocumentCardAnswerTo].[CustodyPlaceID]
	WHERE
		[DocumentCardAnswerTo].[ID] = @DocumentCardID

-- Company Address
	SELECT
	[Address].[Street],
	[Address].[City],
	[Address].[Region],
	[Address].[PostalCode],
	[Address].[Country],
	[Address].[Mail],
	[Phone].[Phone]
FROM
	[DocumentCard]
	INNER JOIN [Company]
		ON [DocumentCard].[CompanyID] = [Company].[ID]
	INNER JOIN [Address]
		ON [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[BusinessCardID] = [Company].[ID] AND [Address].[AddressTypeID] = 1
	LEFT OUTER JOIN [Phone]
		ON [Phone].[BusinessCardClass] = [Company].[Class] AND [Phone].[BusinessCardID] = [Company].[ID] AND [Phone].[PhoneTypeID] = 7
WHERE
	[DocumentCard].[ID] = @Id

-- Correspondent Company Address
SELECT
	[Address].[Street],
	[Address].[City],
	[Address].[Region],
	[Address].[PostalCode],
	[Address].[Country],
	[Address].[Mail],
	[Phone].[Phone]
FROM
	[DocumentCard]
	INNER JOIN [Company]
		ON [DocumentCard].[CorrespondentCompanyID] = [Company].[ID]
	INNER JOIN [Address]
		ON [Address].[BusinessCardClass] = [Company].[Class] AND [Address].[BusinessCardID] = [Company].[ID] AND [Address].[AddressTypeID] = 1
	LEFT OUTER JOIN [Phone]
		ON [Phone].[BusinessCardClass] = [Company].[Class] AND [Phone].[BusinessCardID] = [Company].[ID] AND [Phone].[PhoneTypeID] = 7
WHERE
	[DocumentCard].[ID] = @Id
	
	RETURN 0
GO

GRANT EXECUTE ON [ReportDocumentCard] TO PUBLIC
GO