 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceFree]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceFree'
		DROP PROCEDURE [dbo].[pjm5ResourceFree]
	END
GO

PRINT 'Creating procedure pjm5ResourceFree'
GO

/******************************************************************************
**		File: pjm5ResourceFree.sql
**		Name: pjm5ResourceFree
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 06/02/2006 15:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5ResourceFree
	@ResourceID TIdentifier,
	@MeetingRequestID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE @ResourceRequestID TIdentifier
	
	DECLARE @result INT
	IF EXISTS(SELECT * FROM [ResourceRequest] WHERE [ResourceID] = @ResourceID AND [MeetingRequestID] = @MeetingRequestID)
	BEGIN
		SELECT 
			@ResourceRequestID = [ID] 
		FROM 
			[ResourceRequest] 
		WHERE 
			[ResourceID] = @ResourceID AND [MeetingRequestID] = @MeetingRequestID
		IF EXISTS(SELECT * FROM [ResourceRequest] WHERE [ID] = @ResourceRequestID AND [State] IN (2, 3))
		BEGIN
			EXEC @result = pjm5ResourceRequestChangeState @ResourceRequestID, 5
			IF @@ERROR != 0 OR @result != 0
				RETURN 1		
			DELETE [ResourceRequest] WHERE [ID] = @ResourceRequestID
			IF @@ERROR != 0
				RETURN 1		
		END
	END
	RETURN 0
GO

   