IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ResourceRequestCalendarBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ResourceRequestCalendarBrowse'
		DROP PROCEDURE [dbo].[pjm5ResourceRequestCalendarBrowse]
	END
GO

PRINT 'Creating procedure pjm5ResourceRequestCalendarBrowse'
GO

/******************************************************************************
**		File: pjm5ResourceRequestCalendarBrowse.sql
**		Name: pjm5ResourceRequestCalendarBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/15/2006 12:35:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		11.06.10	SYV				' '    
**		16.09.10	SYV				    
**		04.10.10	SYV				  fnPjm6AllowCreateResourceRequest
*******************************************************************************/
CREATE PROCEDURE [pjm5ResourceRequestCalendarBrowse]
	@PeriodStart TDate,
	@PeriodEnd TDate
AS
	SET NOCOUNT ON

	DECLARE @EmployeeID TIdentifier,
			@ViewAllFinance			TBool,
			@ViewAllProjects		TBool, 
			@Assistant				TBool
			
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	SELECT
		[ResourceRequest].[Class],
		[ResourceRequest].[ID],
		[ResourceRequest].[State],
		[ResourceRequest].[Flag],
		CASE
			WHEN dbo.fnPjm6AllowCreateResourceRequest([ResourceRequest].[ProjectID], @EmployeeID) = 1
				OR [ResourceRequest].[EmployeeID] = @EmployeeID
				THEN [ResourceRequest].[FileAs]
			ELSE
				NULL
		END AS [FileAs],
		[ResourceRequest].[StartTime],
		DATEADD(minute, [ResourceRequest].[Duration], [ResourceRequest].[StartTime]) as [EndTime],
		[ResourceRequest].[Duration],
		[ResourceRequest].[ProjectID],
		[ResourceRequest].[EmployeeID],
		[ResourceRequest].[ResourceID],
		[Resource].[ResourceTypeID],
		[Resource].[Code] as [ResourceCode],
		[ResourceRequest].[PriorityID],
		[ResourceRequest].[Color],
		CASE
			WHEN dbo.fnPjm6AllowCreateResourceRequest([ResourceRequest].[ProjectID], @EmployeeID) = 1
				OR [ResourceRequest].[EmployeeID] = @EmployeeID
				THEN [ResourceRequest].[Comments]
			ELSE
				NULL
		END AS [Comments],
		[ResourceRequest].[Created],
		[ResourceRequest].[CreatedBy],
		[ResourceRequest].[Modified],
		[ResourceRequest].[ModifiedBy],
		[ResourceRequest].[Timestamp]
	FROM
		[ResourceRequest]
		INNER JOIN [Resource]
			ON ([ResourceRequest].[ResourceID] = [Resource].[ID])
		LEFT OUTER JOIN [Project]
			ON ([Project].[ID] = [ResourceRequest].[ProjectID])
	WHERE
		(	
			([ResourceRequest].[State] IN (2, 3))
		OR
			([ResourceRequest].[State] IN (1, 4, 5) AND [ResourceRequest].[EmployeeID] = @EmployeeID)
		 )
	AND
		[ResourceRequest].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ResourceRequestCalendarBrowse] TO PUBLIC
GO
 