IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceRequestCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceRequestCreate'
		DROP PROCEDURE [dbo].[pjm5ServiceRequestCreate]
	END
GO

PRINT 'Creating procedure pjm5ServiceRequestCreate'
GO

/******************************************************************************
**		File: pjm5ServiceRequestCreate.sql
**		Name: pjm5ServiceRequestCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.07.10	MAN				 ,     .
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceRequestCreate]
	@Xml XML
AS
	DECLARE 
			@EmployeeID TIdentifier,
			@State TState,
			@ID TIdentifier,
			@ProjectID TIdentifier,
			@ExecutorID TIdentifier,
			@PriorityID TIdentifier,
			@Date TDate,
			@Number TCode,
			@FileAs TName,
			@StartDate TDate,
			@DueDate TDate,
			@Billable TBool,
			@VATIsIncluded TBool,
			@ServiceTypeID TIdentifier,
			@Comments TNotes,
			@Description TNotes,
			@doc int,
			@RecurrenceID TIdentifier,
			@ReminderState TState,
			@ReminderInterval TTimeSpan,
			@ManHour TCount
	
	SET NOCOUNT ON
	
	DECLARE @ServiceRequestClass TClass
	SET @ServiceRequestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	
	SET @State = dbo.adfwfGetInitialState('47383a06-ed8c-4aec-9468-4c4e4da3be29')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	
	SELECT
		@ProjectID = [XmlTable].[ProjectID],
		@ExecutorID = [XmlTable].[EmployeeID],
		@PriorityID = CASE WHEN [XmlTable].[PriorityID] IS NULL THEN 0 ELSE [XmlTable].[PriorityID] END,
		@Date = CONVERT(datetime, [XmlTable].[Date]),
		@Number = ISNULL([XmlTable].[Number], ''),
		@FileAs = ISNULL([XmlTable].[FileAs], ''),
		@StartDate = CONVERT(datetime, [XmlTable].[StartDate]),
		@DueDate = CONVERT(datetime, [XmlTable].[DueDate]),
		@Billable = CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END,
		@VATIsIncluded = CASE WHEN [XmlTable].[VATIsIncluded] = 'false' THEN 0 ELSE 1 END,
		@ServiceTypeID = [XmlTable].[ServiceTypeID],
		@Comments = [XmlTable].[Comments],
		@ReminderState = CASE WHEN [XmlTable].[ReminderState] = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval = [XmlTable].[ReminderInterval],
		@Description = [XmlTable].[Description],
		@ManHour = [XmlTable].[ManHour]
	FROM
		OPENXML(@doc, '/pjm5ServiceRequestGet/ServiceRequest', 2)
			WITH (
				[ProjectID] int 'ProjectID',
				[EmployeeID] int 'EmployeeID',
				[PriorityID] int 'PriorityID',
				[Date] nvarchar(19) 'Date',
				[Number] varchar(32) 'Number',
				[FileAs] nvarchar(512) 'FileAs',
				[StartDate] nvarchar(19) 'StartDate',
				[DueDate] nvarchar(19) 'DueDate',
				[Billable] varchar(5) 'Billable',
				[VATIsIncluded] varchar(5) 'VATIsIncluded',
				[ServiceTypeID] int 'ServiceTypeID',
				[Comments] nvarchar(max) 'Comments',
				[ReminderState] varchar(5) 'ReminderState',
				[ReminderInterval] int 'ReminderInterval',
				[Description] nvarchar(max),
				[ManHour] int
				) AS [XmlTable]
	

	IF(@ExecutorID IS NOT NULL)
	BEGIN
		IF NOT EXISTS(SELECT * FROM [vwAssignment] WHERE [ProjectID] = @ProjectID AND [EmployeeID] = @ExecutorID AND [State]=1)
		BEGIN
			RAISERROR('#notassignedtospecifiedproject', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE
		@RStartDate TDatetime, 
		@REndDate TDatetime, 
		@RRecurrenceType TIdentifier, 
		@ROccurrences TCount,
		@RInterval TCount, 
		@RDayOfWeekMask TIdentifier, 
		@RInstance TIdentifier, 
		@RMonthOfYear TCount, 
		@RDayOfMonth TCount
	SELECT
		@RStartDate = CAST([StartDate] as datetime),
		@REndDate = CAST([EndDate] as datetime),
		@RRecurrenceType = [RecurrenceType],
		@ROccurrences = [Occurrences],
		@RInterval = [Interval],
		@RDayOfWeekMask = [DayOfWeekMask],
		@RInstance = [Instance],
		@RMonthOfYear = [MonthOfYear],
		@RDayOfMonth = [DayOfMonth]
	FROM
		OPENXML(@doc, '/pjm5ServiceRequestGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19) 'StartDate',
				[EndDate] varchar(19) 'EndDate',
				[RecurrenceType] int 'RecurrenceType',
				[Occurrences] int 'Occurrences',
				[Interval] int 'Interval',
				[DayOfWeekMask] int 'DayOfWeekMask',
				[Instance] int 'Instance',
				[MonthOfYear] int 'MonthOfYear',
				[DayOfMonth] int 'DayOfMonth'
				)

	EXEC sp_xml_removedocument @doc
	
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @EmployeeID) = 0
	BEGIN
		IF dbo.fnPjm5AllowCreateProjectEntry(@ProjectID, NULL) = 0 AND
			dbo.fnPjm5IsProjectMember(@ProjectID, @EmployeeID) = 0
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	IF NOT EXISTS (SELECT * FROM [Project] WHERE [ID] = @ProjectID AND [State] = 2)
	BEGIN
		RAISERROR('#ProjectIsNotOpen', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	IF @RRecurrenceType IS NOT NULL
	BEGIN
		INSERT INTO [RecurrencePattern]
			([StartDate], [EndDate], [RecurrenceType], [Occurrences],
			[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
		VALUES
			(@RStartDate, @REndDate, @RRecurrenceType, @ROccurrences,
			@RInterval, @RDayOfWeekMask, @RInstance, @RMonthOfYear, @RDayOfMonth)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @RecurrenceID = SCOPE_IDENTITY()
	END

	INSERT INTO [ServiceRequest]
		([Flag], [State], [ProjectID], [EmployeeID], [PriorityID],
		 [Date], [Number], [FileAs], [StartDate], [DueDate], [Billable],
		 [VATIsIncluded], [Comments], [ServiceTypeID], [Description], [ManHour], [ActualManHour], [ActualBudget])	
	VALUES
		(0, @State,
		 @ProjectID, @ExecutorID, @PriorityID, @Date, @Number,
		 @FileAs, @StartDate, @DueDate, @Billable,
		 @VATIsIncluded, @Comments, @ServiceTypeID, @Description, ISNULL(@ManHour, 0), 0, 0)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @ServiceRequestClass AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	DECLARE @rv int		
	EXEC @rv = pjm5ServiceRequestReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	COMMIT TRANSACTION

	EXEC pjm5ServiceRequestGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5ServiceRequestCreate TO PUBLIC
GO 