IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskDelete'
		DROP PROCEDURE [dbo].[pjm5TaskDelete]
	END
GO

PRINT 'Creating procedure pjm5TaskDelete'
GO

/******************************************************************************
**		File: pjm5TaskDelete.sql
**		Name: pjm5TaskDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		24.06.10	KOV				      (1,2)    
*******************************************************************************/
CREATE PROCEDURE pjm5TaskDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE 
		@ProjectID TIdentifier,
		@MsTaskID TIdentifier,
		@State TState,
		@TaskIndex TCount
	SELECT 
		@ProjectID = [Task].[ProjectID],
		@MsTaskID = [Task].[MsTaskID],
		@State = [Task].[State],
		@TaskIndex = [TaskWbs].[TaskIndex]
	FROM 
		[Task]
		INNER JOIN [TaskWbs]
			ON [Task].[ID] = [TaskWbs].[TaskID]
	WHERE 
		[Task].[ID] = @ID
	
	IF(@MsTaskID IS NOT NULL AND @State != 6)
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END
	IF EXISTS(SELECT * FROM [SuperTimer] 
					WHERE [SuperTimer].[DocumentClass] = dbo.adfGetClassByName('Pjm5.Task') AND [SuperTimer].[DocumentID] = @ID AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION	
	DELETE FROM [BusyEntry] WHERE [TaskID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE FROM [Task] WHERE [Task].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE [MsTask]
	FROM
		[MsTask]
			INNER JOIN [Task]
			ON [Task].[MsTaskID] = [MsTask].[ID]
	WHERE [Task].[ID]=@ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END;
	
	WITH [Tasks] ([ID], [RowNumber]) AS
	(
		SELECT
			[TaskWbs].[TaskID],
			ROW_NUMBER() OVER (ORDER BY [TaskWbs].[TaskIndex] ASC)
		FROM
			[TaskWbs]
			INNER JOIN [Task]
				ON [Task].[ID] = [TaskWbs].[TaskID]
		WHERE
			[Task].[ProjectID] = @ProjectID AND 
			[Task].[ID] != @ID AND 
			[TaskWbs].[TaskIndex] >= @TaskIndex
	)
	UPDATE
		[TaskWbs]
	SET
		[TaskIndex] = @TaskIndex + ([Tasks].[RowNumber] - 1)
	FROM 
		[TaskWbs]
		INNER JOIN [Tasks]
			ON [Tasks].[ID] = [TaskWbs].[TaskID]
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskDelete TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskChangeState'
		DROP PROCEDURE [dbo].[pjm5TaskChangeState]
	END
GO


PRINT 'Creating procedure pjm5TaskChangeState'
GO
CREATE PROCEDURE pjm5TaskChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @MsTaskID TIdentifier,
			@FromState TState,
			@rv int
	
	SELECT
		@MsTaskID = [Task].[MsTaskID],
		@FromState = [Task].[State]
	FROM [Task]
	WHERE [Task].[ID] = @ID
	IF (@MsTaskID IS NOT NULL AND (@FromState = 6 OR @ToState = 6))
	BEGIN
		RAISERROR('#documentfrommsproject', 18, -1)
		RETURN 1
	END
	
	EXEC @rv = pjm5TaskChangeStateInternal @ID, @ToState
	IF @rv != 0
		RETURN 1
		
	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskChangeState TO PUBLIC
GO
 

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskChangeStateInternal]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskChangeStateInternal'
		DROP PROCEDURE [dbo].[pjm5TaskChangeStateInternal]
	END
GO
PRINT 'Creating procedure pjm5TaskChangeStateInternal'
GO
/******************************************************************************
**		File: pjm5TaskChangeState.sql
**		Name: pjm5TaskChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5TaskChangeStateInternal
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@EndDate TDate,
			@PercentComplete TPercent,
			@MsTaskID TIdentifier,
			@ProjectID	TIdentifier,
			@rv int
	
	SET NOCOUNT ON

	SELECT
		@Class = [Task].[Class],
		@FromState = [Task].[State],
		@EndDate = [Task].[EndDate],
		@PercentComplete = [Task].[PercentComplete],
		@MsTaskID = [Task].[MsTaskID],
		@ProjectID = [Task].[ProjectID]
	FROM
		[Task]
		INNER JOIN [Project]
			ON [Project].[ID] = [Task].[ProjectID]
	WHERE
		[Task].[ID] = @ID
	
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE
		@BudgetID TIdentifier
	--   
	SELECT
		[ID]
	FROM
		[Budget]
	WHERE
		[Budget].[DocumentID] = @ProjectID

	IF @ToState = 2 AND EXISTS(SELECT [ID] FROM [Budget] WHERE [Budget].[DocumentID] = @ProjectID)
	BEGIN
		RAISERROR('#TaskProjectHasBudgetPlanning', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	IF(@MsTaskID IS NOT NULL AND @ToState = 2 AND @FromState != 6)
	BEGIN
		WITH ParentTasks(ParentID) AS 
		(
		SELECT 
			[ParentID]
		FROM 
			[Task]
		WHERE 
			[ID] = @ID
		UNION ALL
		SELECT 
			[Task].[ParentID]
		FROM 
			[Task]
			INNER JOIN [ParentTasks]
				ON [Task].[ID] = [ParentTasks].[ParentID] 
		)
		UPDATE
			[Task]
		SET
			[State] = 2
		FROM
			[Task]
			INNER JOIN [ParentTasks]
				ON [Task].[ID] = [ParentTasks].[ParentID]
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @ToState = 3 OR @ToState = 6
		SET @EndDate = CONVERT(varchar(8), GETDATE(), 112)
	IF @ToState = 3 AND @PercentComplete != 1
		SET @PercentComplete = 1
	
	IF @ToState = 3
	BEGIN
		UPDATE [TaskAssignment]
		SET 
			[TaskAssignment].[RemainingWork] = 0,
			[TaskAssignment].[RemainingOvertimeWork] = 
				CASE 
					WHEN [TaskAssignment].[RemainingOvertimeWork] IS NOT NULL THEN 0 
					ELSE NULL 
				END
		FROM
			[TaskAssignment]
		WHERE
			[TaskAssignment].[TaskID] = @ID
			
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	UPDATE
		[Task]
	SET
		[Task].[EndDate] = CASE WHEN @ToState = 3 OR @ToState = 6 THEN @EndDate ELSE NULL END,
		[Task].[PercentComplete] = @PercentComplete,
		[Task].[State] = @ToState,
		[Task].[Modified] = DEFAULT,
		[Task].[ModifiedBy] = DEFAULT
	WHERE
		[Task].[ID] = @ID
	AND
		[Task].[State] = @FromState

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF @FromState IN (3, 8)
	BEGIN
		EXEC @rv = pjm6TaskBudgetUpdate @ID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	
	IF @ToState = 3 OR @ToState = 6
	BEGIN
		DECLARE 
			@ReminderID TIdentifier
			
		SET @ReminderID = (SELECT [ID] FROM [Reminder] WHERE DocumentClass = @Class AND DocumentID = @ID)
		
		EXEC @rv = pjm5AllUserReminderDismiss @ReminderID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
		
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskChangeStateInternal TO PUBLIC
GO
 