
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskUpdate'
		DROP PROCEDURE [dbo].[pjm5TaskUpdate]
	END
GO

PRINT 'Creating procedure pjm5TaskUpdate'
GO

/******************************************************************************
**		File: pjm5TaskUpdate.sql
**		Name: pjm5TaskUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5TaskUpdate
	@Xml	XML
AS
	
	DECLARE	@ID TIdentifier,
		@FileAs TName,
		@ProjectID TIdentifier,
		@PriorityID TIdentifier,
		@ParentID TIdentifier,
		@StartDate TDate,
		@DueDate TDate,
		@EndDate TDate,
		@Duration TAmount,
		@Estimated TBool,
		@ManHour TAmount,
		@Budget TMoney,
		@Milestone TBool,
		@SendStatusReport TBool,
		@Comments TNotes,
		@State TState,
		@ToState TState,
		@AllowFullUpdate TBool,
		@AssignmentState TState,
		@IsProjectTemplate int,
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@CreatedBy TIdentifier,
		@ReminderState TState,
		@ReminderTime TDateTime,
		@ReminderInterval TTimeSpan,
		@MsTaskID TIdentifier,
		@TaskIndex int,
		@Wbs TName,
		@doc int,
		@rv int
			
	SET NOCOUNT ON

	EXEC sp_xml_preparedocument @doc OUTPUT, @Xml
	SELECT
		@ID =[ID],
		@FileAs = [FileAs],
		@ProjectID = [ProjectID],
		@PriorityID = [PriorityID],
		@StartDate = [StartDate],
		@DueDate = [DueDate],
		@Duration = [Duration],
		@ManHour = [ManHour],
		@Milestone = (CASE [Milestone] WHEN 'false' THEN 0 ELSE 1 END),
		@SendStatusReport = (CASE [SendStatusReport] WHEN 'false' THEN 0 ELSE 1 END),
		@Comments = [Comments],
		@CreatedBy = [CreatedBy],
		@ReminderState = (CASE [ReminderState] WHEN 'false' THEN 0 ELSE 1 END),
		@ReminderTime = [ReminderTime],
		@TaskIndex = [TaskIndex],
		@Wbs = [Wbs]
	FROM
		OPENXML(@doc, '/pjm5TaskGet/Task', 2)
			WITH (
				[ID] int,
				[FileAs] nvarchar(256),
				[ProjectID] int,
				[PriorityID] int,
				[StartDate] varchar(19),
				[DueDate] varchar(19),
				[EndDate] varchar(19),
				[Duration] decimal(18,4),
				[ManHour] decimal(18,4),
				[PercentComplete] int,
				[Milestone] varchar(5),
				[SendStatusReport] varchar(5),
				[Comments] nvarchar(max),
				[CreatedBy] int,
				[ReminderState] varchar(5),
				[ReminderTime] varchar(19),
				[TaskIndex] int,
				[Wbs] nvarchar(256)
				)
		
	SELECT @MsTaskID = [MsTaskID] FROM [Task] WHERE [ID] = @ID
		
	IF @ManHour IS NOT NULL AND @ManHour < 0
	BEGIN
		RAISERROR('#ManHourIsInvalid', 18, -1)
		RETURN 1
	END

	SELECT 
		@State = [State],
		@CreatedBy = [CreatedBy]
	FROM 
		[Task] 
	WHERE 
		[Task].[ID] = @ID

	SET @AssignmentState = 1 --dbo.adfwfGetInitialState('7797BD53-86CE-415E-9E13-B11BCBD52359')
	SELECT @IsProjectTemplate = COUNT(*) FROM [ProjectTemplate] WHERE [ID] = @ProjectID
	
	IF EXISTS (SELECT * FROM [ProjectTemplate] WHERE [ID] = @ProjectID)
	BEGIN
		SET @AssignmentState = 3
	END
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @AllowFullUpdate = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	IF @State = 8 AND @CreatedBy = @CurrentUserID
	BEGIN
		SET @AllowFullUpdate = 1
	END

	SELECT
		@Budget = SUM([TaskAssignment].[Work] * [Assignment].[StandardRate] / 60.0)
	FROM
		[TaskAssignment]
		INNER JOIN [Assignment]
			ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
	WHERE
		[TaskAssignment].[TaskID] = @ID 
		
	BEGIN TRANSACTION
	IF @AllowFullUpdate = 1 OR @IsProjectTemplate > 0
	BEGIN
	
		DELETE 
			[MsAssignment] 
		FROM 
			[MsAssignment]
			INNER JOIN [Assignment]
				ON [MsAssignment].[ID] = [Assignment].[ID]
		WHERE 
			[TaskID] = @ID AND 
			[Assignment].[ID] NOT IN (SELECT [ID] FROM OPENXML(@doc, '/pjm5TaskGet/BusinessCard', 2) WITH ([ID] int))
		
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END	

		DELETE 
			[TaskAssignment] 
		WHERE 
			[TaskID] = @ID AND 
			[AssignmentID] NOT IN (SELECT [ID] FROM OPENXML(@doc, '/pjm5TaskGet/BusinessCard', 2) WITH ([ID] int))
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		-- TODO: Booking

		UPDATE
			[TaskAssignment]
		SET
			[Units] = [BC].[Units],
			[Work] = [BC].[Work],
			[RemainingWork] = CASE 
				WHEN [BC].[TaskAssignmentState] = 2 THEN 0
				WHEN
				(SELECT COUNT(ID) FROM [TimeEntry] WHERE [TaskID] = [TaskAssignment].[TaskID] AND [EmployeeID] = [Assignment].[EmployeeID]) = 0
				THEN [BC].[Work] ELSE [RemainingWork] END,
			[State] = [BC].[TaskAssignmentState]
		FROM 
			[TaskAssignment]
			INNER JOIN OPENXML(@doc, '/pjm5TaskGet/BusinessCard', 2)
				WITH (
					[ID] int,
					[Class] int,
					[Units] decimal(18,4),
					[Work] int,
					[TaskAssignmentState] int
					) AS [BC]
				ON ([BC].[ID] = [TaskAssignment].[AssignmentID])
			INNER JOIN [vwAssignment] as [Assignment]
				ON [Assignment].[ID] = [TaskAssignment].[AssignmentID]
		WHERE
			[TaskAssignment].[TaskID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		INSERT INTO [TaskAssignment] ([TaskID], [AssignmentID], [Units], [Work], [RemainingWork])
		SELECT
			@ID,
			[Assignment].[ID],
			[BC].[Units],
			[BC].[Work],
			[BC].[Work]
		FROM
			[vwAssignment] AS [Assignment]
			INNER JOIN OPENXML(@doc, '/pjm5TaskGet/BusinessCard', 2)
				WITH (
					[ID] int,
					[Class] int,
					[Units] decimal(18,4),
					[Work] int
					) AS [BC]
				ON ([BC].[ID] = [Assignment].[ID])
			LEFT OUTER JOIN [TaskAssignment]
				ON ([TaskAssignment].[TaskID] = @ID AND 
					[TaskAssignment].[AssignmentID] = [Assignment].[ID])
		WHERE
			[Assignment].[ProjectID] = @ProjectID AND 
			[Assignment].[State] = @AssignmentState AND
			[TaskAssignment].[AssignmentID] IS NULL
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		
		DECLARE @WorkHours TCount,
				@val TVariant
		EXEC adfParameterGet @Name='WorkTime', @Group='Pjm5', @Value = @val OUTPUT
		SET @WorkHours = CAST(@val as int)
		
		SELECT @DueDate = dbo.fnPjm5AddWorkingDays(@StartDate, @Duration)
		UPDATE [Task]
		SET
			[Task].[FileAs] = @FileAs,
			[Task].[ProjectID] = @ProjectID,
			[Task].[PriorityID] = @PriorityID,
			[Task].[StartDate] = @StartDate,
			[Task].[DueDate] = @DueDate,
			[Task].[EndDate] = @EndDate,
			[Task].[Duration] = @Duration,
			[Task].[ManHour] = CAST(@ManHour * 60 AS int),
			[Task].[Budget] = @Budget,
			[Task].[Milestone] = @Milestone,
			[Task].[SendStatusReport] = @SendStatusReport,
			[Task].[Comments] = @Comments,
			[Task].[Modified] = DEFAULT,
			[Task].[ModifiedBy] = DEFAULT
		WHERE
			[Task].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		EXEC @rv = pjm6TaskUpdateWbs @ID, @TaskIndex, @Wbs
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END

		-- TODO: Booking TaskAssignmentBooking
		DELETE [BusyEntry] WHERE [TaskID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
		
		;
		WITH [ActualTime] ([AssignmentID], [EmployeeID], [Date], [ActualWork]) AS
		(
			SELECT 
				[TimeEntry].[AssignmentID] as [AssignmentID],
				[TimeEntry].[EmployeeID],
				CONVERT(varchar(19), [TimeEntry].[StartTime], 112) as [Date],
				SUM([TimeEntry].[Duration]) as [ActualWork]
			FROM 
				[TimeEntry]
			WHERE
				[TimeEntry].[State] IN (2,3,6) AND
				[TimeEntry].[TaskID] = @ID
			GROUP BY
				[TimeEntry].[AssignmentID], 
				[TimeEntry].[EmployeeID],
				CONVERT(varchar(19), [TimeEntry].[StartTime], 112)
		)
		INSERT INTO [BusyEntry] ([AssignmentID], [ProjectID], [TaskID], [Date], [EmployeeID], [Planned], [Canceled], [Committed], [ActualWork])
		SELECT
			ISNULL([TaskAssignmentBooking].[AssignmentID], [ActualTime].[AssignmentID]),
			@ProjectID,
			@ID,
			CAST(ISNULL([TaskAssignmentBooking].[Date], [ActualTime].[Date])  AS DateTime),
			ISNULL([AssignmentEntry].[EmployeeID], [ActualTime].[EmployeeID]),
			ISNULL([TaskAssignmentBooking].[Planned], 0),
			ISNULL([TaskAssignmentBooking].[Canceled], 0),
			ISNULL((CASE [TaskAssignmentBooking].[Committed] WHEN 'false' THEN 0 ELSE 1 END), 0),
			ISNULL([ActualTime].[ActualWork], 0)
		FROM
			OPENXML(@doc, '/pjm5TaskGet/TaskAssignmentBooking', 2)
				WITH (
					[AssignmentID] int,
					[Date] varchar(19),
					[Planned] int,
					[Canceled] int,
					[Committed] varchar(5)
					) AS [TaskAssignmentBooking]
			INNER JOIN [AssignmentEntry]
				ON [AssignmentEntry].[AssignmentID] = [TaskAssignmentBooking].[AssignmentID]
			FULL OUTER JOIN [ActualTime]
				ON [ActualTime].[AssignmentID] = [TaskAssignmentBooking].[AssignmentID]
				AND CAST([ActualTime].[Date] as DateTime) = CAST([TaskAssignmentBooking].[Date] as DateTime) 
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	ELSE
	BEGIN
		IF NOT EXISTS(
				SELECT * 
				FROM
					[TaskAssignment]
					INNER JOIN [vwAssignment]
						ON [TaskAssignment].[AssignmentID] = [vwAssignment].[ID]
				WHERE
					[TaskAssignment].[TaskID] = @ID AND
					[vwAssignment].[EmployeeID] = @CurrentEmployeeID
				)
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END

		UPDATE [Task]
		SET
			[Task].[Modified] = DEFAULT,
			[Task].[ModifiedBy] = DEFAULT
		WHERE
			[Task].[ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @doc
			RETURN 1
		END
	END
	
	SET @ReminderInterval = DATEDIFF(minute, @ReminderTime, @DueDate)
	EXEC @rv = pjm5TaskReminderCreate @ID,
		@DueDate, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @ID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @doc
		RETURN 1
	END
	
	COMMIT TRANSACTION
	EXEC sp_xml_removedocument @doc
		
	EXEC pjm5TaskGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskUpdate TO PUBLIC
GO
 