 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestBrowseByCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestBrowseByCategory'
		DROP PROCEDURE [dbo].[pjm5TaskRequestBrowseByCategory]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestBrowseByCategory'
GO

/******************************************************************************
**		File: pjm5TaskRequestBrowseByCategory.sql
**		Name: pjm5TaskRequestBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		9.04.10		KOV				 @DateSelector  WHERE   
**									(     )
**
**		15.04.10	KOV				  " "  ""
**      13.10.10    BVY               ""  "" 
**      21.10.10    BVY                    ,     
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestBrowseByCategory]
	@Presentation varchar(32),
	@StateSelector	INT,
	@AuthorID TIdentifier,
	@EmployeeID TIdentifier,
	@DateSelector int,
	@PeriodStart TDateTime,
	@PeriodEnd TDateTime,
	@AcceptedSelector INT 

AS
	SET NOCOUNT ON

	DECLARE 
		@CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@CreatedBy TIdentifier,
		@Now datetime,
		@IsAssistant TBool,
		@AccessToPublicFolders TBool
		
	SET @AccessToPublicFolders = dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders'))
	SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @Now = GETDATE()
	IF @AuthorID IS NOT NULL
		SELECT @CreatedBy = ISNULL([UserID], -1) FROM [Employee] WHERE [ID] = @AuthorID

	DECLARE @none nvarchar(6)
	IF dbo.adfGetLanguage() = 'ru'
		SET @none = '()'
	ELSE
		SET @none = '(none)'

	IF @Presentation = 'ForMeToday'
	BEGIN
		SET @DateSelector = 0
		SET @PeriodStart = CONVERT(datetime, CONVERT(varchar(8), @Now, 112), 112)
		SET @PeriodEnd = DATEADD(day, 1, @PeriodStart)
	END
	ELSE IF @Presentation = 'ForMeNext7Days'
	BEGIN
		SET @DateSelector = 0
		SET @PeriodStart = CONVERT(datetime, CONVERT(varchar(8), @Now, 112), 112)
		SET @PeriodEnd = DATEADD(day, 7, @PeriodStart)
	END
	ELSE
	BEGIN
		IF @DateSelector = 1
			SET @PeriodStart = CAST(CAST(YEAR(@Now) AS varchar(4)) + '0101' AS datetime)
		ELSE IF @DateSelector = 2
			SET @PeriodStart = CAST(CAST(YEAR(@Now)+1 AS varchar(4)) + '0101' AS datetime)
		ELSE IF @DateSelector = 3
			SET @PeriodStart = DATEADD(day, 1-DATEPART(dayofyear, @PeriodStart), @PeriodStart)
		SET @PeriodStart = CONVERT(datetime, CONVERT(varchar(8), @PeriodStart, 112), 112)
		SET @PeriodEnd = DATEADD(year, 1, @PeriodStart)
	END



	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		ISNULL([adfvwDocumentCategory].[CategoryName], @none) AS [Category],
		[TaskRequest].[State],
		[TaskRequest].[Flag],
		[TaskRequest].[FileAs],
		[TaskRequest].[ProjectID],
		[TaskRequest].[PriorityID],
		[TaskRequest].[DueTime],
		[TaskRequest].[StartTime],
		[TaskRequest].[SendStatusReport],
		[TaskRequest].[TaskRequestStatusID],
		[TaskRequest].[PercentComplete],
		(CAST([TaskRequest].[PercentComplete] * 100 as int) / 25) * 25 as PC,
		[TaskRequest].[DocumentCardID],
		[TaskRequest].[SupervisorEmployeeID],
		[DocumentCard].[FileAs] AS [DocumentCardFileAs],
		[DocumentCard].[CardOwnerID],
		[TaskRequest].[Comments],
		[TaskRequest].[ExternalID],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy],
		[TaskRequest].[Timestamp],
		[TaskRequest].[ActualBudget],
		[TaskRequest].[ActualManHour],
		[TaskRequest].[Budget],
		[TaskRequest].[ManHour]
	FROM
		[TaskRequest] 
		LEFT OUTER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [TaskRequest].[DocumentCardID]
		LEFT OUTER JOIN [adfvwDocumentCategory]
			ON ([TaskRequest].[Class] = [adfvwDocumentCategory].[DocumentClass] AND
				[TaskRequest].[ID] = [adfvwDocumentCategory].[DocumentID])

	WHERE
		(
			@AccessToPublicFolders = 1 OR
			[TaskRequest].[DocumentCardID] IS NULL
		) AND
		(
			@CreatedBy IS NULL OR [TaskRequest].[CreatedBy] = @CreatedBy
		) AND
		(
			@DateSelector = 0 OR 
			(
				COALESCE([TaskRequest].[DueTime], [TaskRequest].[Created]) >= @PeriodStart
				AND
				COALESCE([TaskRequest].[StartTime], @Now) < @PeriodEnd
			)
		) AND
		(
			@EmployeeID IS NULL OR 
			EXISTS(
				SELECT * 
				FROM [TaskRequestAssignment] 
				WHERE 
					[TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND 
					[TaskRequestAssignment].[EmployeeID]=@EmployeeID
				)
		) AND
		(
			(@Presentation = 'OwnByCategory' AND -- 
					(
					@StateSelector = 0 OR 
					@StateSelector = 1 AND [TaskRequest].[State] IN (1, 2) OR
					@StateSelector = 2 AND [TaskRequest].[State] = 3 OR
					@StateSelector = 3 AND [TaskRequest].[State] = 4 OR
					@StateSelector = 4 AND [TaskRequest].[State] = 5
				) AND
					[TaskRequest].[CreatedBy] = @CurrentUserID AND	
				(
				  @AcceptedSelector=0 
				  OR 
				  ( @AcceptedSelector=1 AND 
				    EXISTS(SELECT [TaskRequestAssignment].[Accepted] FROM [TaskRequestAssignment] 
				    WHERE [TaskRequest].[ID]=[TaskRequestAssignment].[TaskRequestID] AND [TaskRequestAssignment].[Accepted]=0)) 
				  OR
				  (EXISTS(SELECT [TaskRequestAssignment].[Accepted] FROM [TaskRequestAssignment] 
				    WHERE [TaskRequest].[ID]=[TaskRequestAssignment].[TaskRequestID] AND [TaskRequestAssignment].[Accepted] IS NULL))
				)	
			)
			OR
			(@Presentation = 'ControlByCategory' AND -- 
				(@StateSelector = 0 OR (@StateSelector = 1 AND [TaskRequest].[State] IN (1, 2))
									OR (@StateSelector = 2 AND [TaskRequest].[State] = 3)
									OR (@StateSelector = 3 AND [TaskRequest].[State] = 4)
									OR (@StateSelector = 4 AND [TaskRequest].[State] = 5))
				AND
				[TaskRequest].[SupervisorEmployeeID] = @CurrentEmployeeID 
			)
			OR
			(@Presentation = 'AllByCategory' AND -- 
				(@StateSelector = 0 OR (@StateSelector != 0 AND [TaskRequest].[State] = @StateSelector))
				AND
				(
					@IsAssistant = 1 OR
					[TaskRequest].[CreatedBy] = @CurrentUserID OR
					[TaskRequest].[SupervisorEmployeeID] = @CurrentEmployeeID OR
					dbo.fnPjm5IsProjectMember([TaskRequest].[ProjectID], @CurrentEmployeeID) = 1 OR
					dbo.fnPjm5IsProjectManager([TaskRequest].[ProjectID], @CurrentEmployeeID) = 1 OR
					((EXISTS(SELECT * FROM [TaskRequestAssignment] WHERE [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID)) AND [TaskRequest].[ProjectID] IS NULL)
				)
			)
			OR
			(@Presentation = 'ForMeByCategory' 
				AND
				((@StateSelector = 0 AND [TaskRequest].[State] IN (2, 3, 5))
					OR (@StateSelector = 1 AND [TaskRequest].[State] = 2)
					OR (@StateSelector = 2 AND [TaskRequest].[State] = 3)
					OR (@StateSelector = 3 AND [TaskRequest].[State] = 5))
				AND
					(EXISTS(SELECT * FROM [TaskRequestAssignment] WHERE [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID))
				--dbo.fnPjm5IsProjectMember([TaskRequest].[ProjectID], @CurrentEmployeeID) = 1 
				--(EXISTS(SELECT * FROM [TaskRequestAssignment] WHERE [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID))
			)			
		)	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskRequestBrowseByCategory] TO PUBLIC
GO

 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestDocumentBrowseByCategory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestDocumentBrowseByCategory'
		DROP PROCEDURE [dbo].[pjm5TaskRequestDocumentBrowseByCategory]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestDocumentBrowseByCategory'
GO

/******************************************************************************
**		File: pjm5TaskRequestDocumentBrowseByCategory.sql
**		Name: pjm5TaskRequestDocumentBrowseByCategory
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
/*CREATE PROCEDURE [pjm5TaskRequestDocumentBrowseByCategory]
	@Presentation varchar(32),
	@StateSelector	INT
AS
	DECLARE @CurrentEmployeeID TIdentifier,
		@CurrentUserID TIdentifier,
		@StartTime datetime,
		@EndTime datetime,
		@Now datetime
		
	SET NOCOUNT ON
		
	DECLARE @none nvarchar(6)
	IF dbo.adfGetLanguage() = 'ru'
		SET @none = '()'
	ELSE
		SET @none = '(none)'

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @Now = GETDATE()
	
	IF @Presentation = 'ForMeToday'
	BEGIN
		SET @StartTime = CONVERT(datetime, CONVERT(varchar(8), @Now, 112), 112)
		SET @EndTime = DATEADD(day, 1, @StartTime)
	END
	ELSE IF @Presentation = 'ForMeNext7Days'
	BEGIN
		SET @StartTime = CONVERT(datetime, CONVERT(varchar(8), @Now, 112), 112)
		SET @EndTime = DATEADD(day, 7, @StartTime)
	END
	
	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		ISNULL([adfvwDocumentCategory].[CategoryName], @none) AS [Category],
		[TaskRequest].[State],
		[TaskRequest].[Flag],
		[TaskRequest].[FileAs],
		[TaskRequest].[ProjectID],
		[TaskRequest].[PriorityID],
		[TaskRequest].[DueTime],
		[TaskRequest].[StartTime],
		[TaskRequest].[SendStatusReport],
		[TaskRequest].[TaskRequestStatusID],
		[TaskRequest].[PercentComplete],
		(CAST([TaskRequest].[PercentComplete] * 100 as int) / 25) * 25 as PC,
		[TaskRequest].[DocumentCardID],
		[DocumentCard].[FileAs] AS [DocumentCardFileAs],
		[DocumentCard].[CardOwnerID],
		[TaskRequest].[Comments],
		[TaskRequest].[ExternalID],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy],
		[TaskRequest].[Timestamp]
	FROM
		[TaskRequest]
		INNER JOIN [DocumentCard]
			ON [DocumentCard].[ID] = [TaskRequest].[DocumentCardID]
		LEFT OUTER JOIN [adfvwDocumentCategory]
			ON ([TaskRequest].[Class] = [adfvwDocumentCategory].[DocumentClass] AND
				[TaskRequest].[ID] = [adfvwDocumentCategory].[DocumentID])
	WHERE
		(@Presentation = 'OwnByCategory' 
			AND 
			(@StateSelector = 0 OR (@StateSelector = 1 AND [TaskRequest].[State] IN (1, 2))
								OR (@StateSelector = 2 AND [TaskRequest].[State] = 3)
								OR (@StateSelector = 3 AND [TaskRequest].[State] = 4))
			AND
			[TaskRequest].[CreatedBy] = @CurrentUserID
		)
		OR
		(@Presentation = 'AllByCategory' AND 
			(@StateSelector = 0 OR (@StateSelector != 0 AND [TaskRequest].[State] = @StateSelector))
			AND
			(
				[TaskRequest].[CreatedBy] = @CurrentUserID 
				OR 
				EXISTS(SELECT * FROM [TaskRequestAssignment] WHERE [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID)
				OR
				dbo.fnPjm5IsProjectManager([TaskRequest].[ProjectID], @CurrentEmployeeID) = 1
			)
		)
		OR
		(@Presentation = 'ForMeByCategory' 
			AND
			((@StateSelector = 0 AND [TaskRequest].[State] IN (2, 3))
				OR (@StateSelector = 1 AND [TaskRequest].[State] = 2)
				OR (@StateSelector = 2 AND [TaskRequest].[State] = 3))
			AND
			(EXISTS(SELECT * FROM [TaskRequestAssignment] WHERE [TaskRequestAssignment].[TaskRequestID] = [TaskRequest].[ID] AND [TaskRequestAssignment].[EmployeeID]=@CurrentEmployeeID))
		)			
			
	RETURN 0*/
GO

--GRANT EXECUTE ON [pjm5TaskRequestDocumentBrowseByCategory] TO PUBLIC
GO

