IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskRequestCreateRecurrence]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskRequestCreateRecurrence'
		DROP PROCEDURE [dbo].[pjm5TaskRequestCreateRecurrence]
	END
GO

PRINT 'Creating procedure pjm5TaskRequestCreateRecurrence'
GO

/******************************************************************************
**		File: pjm5TaskRequestCreateRecurrence.sql
**		Name: pjm5TaskRequestCreateRecurrence
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: andrew.maklakov
**		Date: 08/02/2005 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		18.11.09	PAM               
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskRequestCreateRecurrence]
	@ID TIdentifier
AS
	DECLARE @State TState,
			@Class TClass,
			@FileAs TName,
			@ProjectID TIdentifier,
			@PriorityID TIdentifier,
			@DueTime TDateTime,
			@StartTime TDateTime,
			@SendStatusReport TBool,
			@TaskRequestStatusID TIdentifier,
			@PercentComplete int,
			@Comments TNotes,
			@ExternalID TExternalIdentifier,
			@RecurrenceID TIdentifier,
			@doc INT,
			@rv int,
			@UserID TIdentifier,
			@OldReminderState TState,
			@OldReminderInterval TTimeSpan,

			@DocumentCardID TIdentifier,
			@EmployeeID TIdentifier,
			@SupervisorEmployeeID TIdentifier,
			@EndTime TDateTime,
			@ManHour TCount,
			@Budget TMoney,
			--@Resolution TNotes,
			@DocumentEditAccess TBool
	
	SET NOCOUNT ON
	
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT
		@Class = [TaskRequest].[Class],
		@FileAs = [TaskRequest].[FileAs],
		@ProjectID = [TaskRequest].[ProjectID],
		@PriorityID = [TaskRequest].[PriorityID],
		@PercentComplete = [TaskRequest].[PercentComplete],
		@DueTime = [TaskRequest].[DueTime],
		@StartTime = [TaskRequest].[StartTime],
		@SendStatusReport = [TaskRequest].[SendStatusReport],
		@TaskRequestStatusID = [TaskRequest].[TaskRequestStatusID],
		@Comments = [TaskRequest].[Comments],
		--@Resolution = [Resolution],
		@DocumentEditAccess = [DocumentEditAccess],
		@ManHour = [TaskRequest].[ManHour],
		@Budget = [TaskRequest].[Budget],
		@DocumentCardID = [TaskRequest].[DocumentCardID],
		@EmployeeID = [TaskRequest].[EmployeeID],
		@SupervisorEmployeeID = [TaskRequest].[SupervisorEmployeeID],
		--@EndTime = [TaskRequest].[EndTime],
		--@Resolution = [TaskRequest].[Comments],

		@OldReminderState = [UserReminder].[State],
		@OldReminderInterval = [UserReminder].[OriginalInterval]
	FROM
		[TaskRequest]
		LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [TaskRequest].[Class] AND
				[Reminder].[DocumentID] = [TaskRequest].[ID] AND
				[Reminder].[Subtype] = 'RD')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @UserID)
	WHERE
		[TaskRequest].[ID] = @ID

	SELECT
		@RecurrenceID = [RecurrencePatternID]
	FROM
		[Document]
	WHERE
		[Class] = @Class AND [ID] = @ID
	IF @RecurrenceID IS NULL
		RETURN 0

	DECLARE 
		@NewID TIdentifier,
		@NewStartTime TDatetime,
		@NewDueTime TDatetime,
		@CurrentDate TDatetime

	SET @CurrentDate = GETDATE()
	SET @NewStartTime = dbo.fnPjm5RecurrenceGetNextDateTime(@RecurrenceID, @StartTime, @CurrentDate)
	IF @NewStartTime IS NULL
		RETURN 0

	SET @State = dbo.adfwfGetInitialState('87a91fee-cef2-4262-9019-30f8c6effd9d')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @StartTime IS NOT NULL
		SET @NewDueTime = DATEADD(day, DATEDIFF(day, @StartTime, @NewStartTime), @DueTime)
		
	INSERT INTO [TaskRequest]
		([Flag], [State], [FileAs], [ProjectID], [PriorityID], [DueTime], [StartTime], 
		[SendStatusReport], [TaskRequestStatusID], 
		[PercentComplete], [Comments],
		[DocumentCardID], [EmployeeID], [SupervisorEmployeeID], [EndTime],[ManHour],[Budget],[DocumentEditAccess])
	VALUES
		(0, @State, @FileAs, @ProjectID, @PriorityID, @NewDueTime, @NewStartTime, 
		@SendStatusReport, 1, 
		0, @Comments,
		@DocumentCardID, @EmployeeID, @SupervisorEmployeeID, @EndTime, @ManHour, @Budget,@DocumentEditAccess)
	IF @@ERROR != 0
		RETURN 1
	SET @NewID = SCOPE_IDENTITY()
	
	INSERT INTO [TaskRequestAssignment] ([TaskRequestID], [EmployeeID])
	SELECT
		@NewID, [EmployeeID]
	FROM
		[TaskRequestAssignment]
	WHERE
		[TaskRequestID] = @ID
	IF @@ERROR != 0
		RETURN 1
	
	EXEC @rv = adfDocumentCategoryCopy @Class, @ID, @NewID
	IF @rv != 0
		RETURN @rv

	EXEC @rv = adfDocumentContactCopy @Class, @ID, @NewID
	IF @rv != 0
		RETURN @rv

	EXEC @rv = pjm5TaskRequestChangeState @NewID, 2
	IF @rv != 0
		RETURN 1

	UPDATE
		[Document]
	SET
		[RecurrencePatternID] = @RecurrenceID
	WHERE
		[Class] = @Class AND [ID] = @NewID
	IF @@ERROR != 0
		RETURN 1
		
	DECLARE @Occurrences TCount
	SELECT @Occurrences = [Occurrences] FROM [RecurrencePattern] WHERE [ID] = @RecurrenceID
	IF ISNULL(@Occurrences, 0) > 0
	BEGIN
		UPDATE
			[RecurrencePattern]
		SET
			[Occurrences] = @Occurrences - 1
		WHERE
			[ID] = @RecurrenceID
		IF @@ERROR != 0
			RETURN 1
	END
	
	DECLARE
		@ReminderState TState,
		@ReminderInterval TTimeSpan
		
	IF @OldReminderState IS NULL
	BEGIN
		SELECT
			@ReminderState = dbo.fnPjm5GetUserInitialReminderState(@Class, 'RD', @UserID),
			@ReminderInterval = dbo.fnPjm5GetReminderInterval(@Class, 'RD', @UserID)
	END
	ELSE
	BEGIN
		SELECT
			@ReminderState = @OldReminderState,
			@ReminderInterval = @OldReminderInterval
	END
		
	EXEC @rv = pjm5TaskRequestReminderCreate @NewID,
		@NewDueTime, @ReminderState, @ReminderInterval
	IF @rv != 0
	BEGIN
		RETURN @rv
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5TaskRequestCreateRecurrence TO PUBLIC
GO  