IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[Pjm6TaskRequestBrowseByProject]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure Pjm6TaskRequestBrowseByProject'
		DROP PROCEDURE [dbo].[Pjm6TaskRequestBrowseByProject]
	END
GO

PRINT 'Creating procedure Pjm6TaskRequestBrowseByProject'
GO

/******************************************************************************
**		File: Pjm6TaskRequestBrowseByProject.sql
**		Name: pjm5IssueBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Pavel.Svintsov
**		Date: 08/14/2009 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**
**		29.04.10	KOV				     
**									    ->->
**
**		6.05.10		KOV				 -       
**    
*******************************************************************************/
CREATE PROCEDURE [Pjm6TaskRequestBrowseByProject]
	@StateSelector	INT,
	@AuthorID TIdentifier,
	@EmployeeID TIdentifier,
	@SupervisorEmployeeID TIdentifier,
	@ProjectID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE 
		@CurrentEmployeeID TIdentifier,
		@ViewAllFinance TBool
		
		
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	
	SELECT
		[TaskRequest].[Class],
		[TaskRequest].[ID],
		[TaskRequest].[State],
		[TaskRequest].[Flag],
		[TaskRequest].[FileAs],
		[TaskRequest].[ProjectID],
		[TaskRequest].[PriorityID],
		[TaskRequest].[DueTime],
		[TaskRequest].[StartTime],
		[TaskRequest].[SendStatusReport],
		[TaskRequest].[TaskRequestStatusID],
		[TaskRequest].[PercentComplete],
		(CAST([TaskRequest].[PercentComplete] * 100 as int) / 25) * 25 as PC,
		[TaskRequest].[DocumentCardID],
		[TaskRequest].[SupervisorEmployeeID],
		[TaskRequest].[Comments],
		[TaskRequest].[ExternalID],
		[TaskRequest].[Created],
		[TaskRequest].[CreatedBy],
		[TaskRequest].[Modified],
		[TaskRequest].[ModifiedBy],
		[TaskRequest].[Timestamp],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [TaskRequest].[ActualBudget]
			ELSE -1
		END AS [ActualBudget],
		[TaskRequest].[ActualManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [TaskRequest].[Budget]
			ELSE -1
		END AS [Budget],
		[TaskRequest].[ManHour]
	FROM
		[TaskRequest]
		INNER JOIN [Project]
			ON ([Project].[ID] = [TaskRequest].[ProjectID] AND [Project].[ID] = @ProjectID)
		WHERE
			(
				[TaskRequest].[State] = @StateSelector OR @StateSelector = 0
			) 
			AND(
				@EmployeeID IS NULL OR 
				(
				[TaskRequest].[ID] IN 
				(
					SELECT 
						[TaskRequestID] 
					From 
						[TaskRequestAssignment] 
					WHERE 
						[TaskRequestAssignment].[EmployeeID] = @EmployeeID
				)
			)
			) AND
			(
				@SupervisorEmployeeID IS NULL OR
				[TaskRequest].[SuperVisorEmployeeID] = @SupervisorEmployeeID
			) AND
			(
				@AuthorID IS NULL OR 
				[TaskRequest].[Createdby] IN 
				(
					SELECT 
						[UserID] 
					From 
						[Employee] 
					WHERE 
						[Employee].[ID] = @AuthorID
				)
			)
			
			
	RETURN 0
GO

GRANT EXECUTE ON [Pjm6TaskRequestBrowseByProject] TO PUBLIC
GO