IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trTaskRequestDelete')
	BEGIN
		PRINT 'Dropping Trigger pjm6trTaskRequestDelete'
		DROP  Trigger pjm6trTaskRequestDelete
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trTaskRequestDelete
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**		24.06.10		KOV				    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trTaskRequestDelete'
GO
CREATE TRIGGER pjm6trTaskRequestDelete 
ON [TaskRequest] FOR DELETE
AS
BEGIN
    IF @@rowcount = 0
       RETURN
       
	SET NOCOUNT ON

	IF
	(
		EXISTS
		(
			SELECT * FROM [deleted] INNER JOIN [TimeEntry]
				ON [TimeEntry].[DocumentClass] = [deleted].[Class] AND [TimeEntry].[DocumentID] = [deleted].[ID]
		) OR
		EXISTS
		(
			SELECT * FROM [deleted] INNER JOIN [Expense]
				ON [Expense].[DocumentClass] = [deleted].[Class] AND [Expense].[DocumentID] = [deleted].[ID]
		)
	)
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithTimeExpense', 18, -1)
		ROLLBACK TRANSACTION
	END
		IF EXISTS(SELECT * FROM [deleted] INNER JOIN [SuperTimer] 
					ON [SuperTimer].[DocumentClass] = [deleted].[Class] AND [SuperTimer].[DocumentID] = [deleted].[ID] AND 
					([SuperTimer].[State] in (1,2) OR ([SuperTimer].[State] = 3 AND [SuperTimer].[Persistent] = 1)))
	BEGIN
		RAISERROR('#CannotDeleteDocumentWithActiveTimer', 18, -1)
		ROLLBACK TRANSACTION
	END
END
GO
