IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryApproveBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryApproveBrowse'
		DROP PROCEDURE [dbo].[pjm5TimeEntryApproveBrowse]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryApproveBrowse'
GO

/******************************************************************************
**		File: pjm5TimeEntryApproveBrowse.sql
**		Name: pjm5TimeEntryApproveBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		07.11.12	SAP				  " "
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm5TimeEntryApproveBrowse]
	@DateSelector		int,
	@PeriodStart		datetime,
	@PeriodEnd			datetime,
	@EmployeeID			TIdentifier,
	@ProjectSelector	int,
	@ActiveProjectID	TIdentifier
AS
	SET NOCOUNT ON		

--	    
	EXEC 
		pjm6TimeEntryApproveBrowseParameters 
			@DateSelector, 
			@PeriodStart	OUTPUT,
			@PeriodEnd		OUTPUT

	SELECT
		[TimeEntry].[Class],
		[TimeEntry].[ID],
		[TimeEntry].[State],
		[TimeEntry].[Flag],
		[TimeEntry].[FileAs],
		[TimeEntry].[ActivityTypeID],
		[TimeEntry].[EmployeeID],
		[AvailableProjects].[CustomerCompanyID],
		[TimeEntry].[ProjectID],
		[TimeEntry].[TaskID],
		[TimeEntry].[StartTime],
		[TimeEntry].[Duration],
		[TimeEntry].[RoundedDuration],
		[TimeEntry].[Billable],
		[TimeEntry].[BillableDuration],
		[TimeEntry].[Overtime],
		[TimeEntry].[Rate],
		[TimeEntry].[CurrencyCode],
		[TimeEntry].[VATRate],
		CASE 
			WHEN [AvailableProjects].[ViewFinance] != 1 THEN -1
			ELSE CAST([TimeEntry].[Billable] AS int) * [TimeEntry].[Rate] * [TimeEntry].[BillableHour]
		END AS [Sum],
		[TimeEntry].[Color],
		[TimeEntry].[Comments],
		[TimeEntry].[Created],
		[TimeEntry].[CreatedBy],
		[TimeEntry].[Modified],
		[TimeEntry].[ModifiedBy],
		[TimeEntry].[Timestamp],
		[Project].[ProjectManagerEmployeeID],
		CASE
			WHEN [TimeEntry].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentClassName] FROM adfGetDocumentIdentity([TimeEntry].[DocumentID], [TimeEntry].[DocumentClass]))
				ELSE (SELECT dbo.adfGetDocumentClassNameByTable('Task'))
		END AS [DocumentClassName],
		CASE
			WHEN [TimeEntry].[TaskID] IS NULL
				THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([TimeEntry].[DocumentID], [TimeEntry].[DocumentClass]))
				ELSE (SELECT [Task].[FileAs] FROM [Task] WHERE [Task].[ID] = [TimeEntry].[TaskID])
		END AS [DocumentName],
		[CostCenter].[FileAs] AS [CostCenterName]
	FROM
		[vwTimeEntry] as [TimeEntry]
		INNER JOIN [Project]
			ON [Project].[ID] = [TimeEntry].[ProjectID]
		INNER JOIN
				dbo.fnPjm6GetAvailableProjectsForTimeEntryApproveBrowse (
				@ProjectSelector,
				@ActiveProjectID) as [AvailableProjects]
			ON [AvailableProjects].[ID] = [TimeEntry].[ProjectID]
		LEFT JOIN [CostCenter]
			ON [CostCenter].[ID] = [Project].[CostCenterID]
	WHERE
		(
			@EmployeeID IS NULL OR
			[TimeEntry].[EmployeeID] = @EmployeeID
		) 
			AND 
		(
			@DateSelector = 0 OR 
			[TimeEntry].[StartTime] BETWEEN @PeriodStart AND @PeriodEnd
		)	AND
		(
			[TimeEntry].[State] = 2
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimeEntryApproveBrowse] TO PUBLIC
GO
  