IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryCreate'
		DROP PROCEDURE [dbo].[pjm5TimeEntryCreate]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryCreate'
GO

/******************************************************************************
**		File: pjm5TimeEntryCreate.sql
**		Name: pjm5TimeEntryCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryCreate]
	@Xml	XML
AS
	DECLARE 
		@State TState,
		@ID TIdentifier,
		@FileAs TName,
		@ActivityTypeID TIdentifier,
		@ProjectID TIdentifier,
		@DocumentClass TClass,
		@DocumentID TIdentifier,
		@TaskID TIdentifier,
		@StartTime TDateTime,
		@Duration TCount,
		--@RoundedDuration TCount,
		@Billable TBool,
		--@BillableDuration TCount,
		@Overtime TBool,
		@Rate TMoney,
		@Comments TNotes,
		@EmployeeID TIdentifier,
		@Color TColor,
		@Doc int,
		@rv int,
		@RecurrenceID TIdentifier,
		@ReminderState TBool,
		@ReminderInterval TTimeSpan,
		@RemainingWork TAmount,
		@RemainingOvertimeWork TAmount
	
	SET NOCOUNT ON
	
	EXEC sp_xml_preparedocument @Doc OUTPUT, @Xml

	SELECT
		@FileAs = [XmlTable].[FileAs], 
		@ActivityTypeID = [XmlTable].[ActivityTypeID], 
		@ProjectID = [XmlTable].[ProjectID], 
		@DocumentClass = dbo.adfGetClassByName([XmlTable].[DocumentClass]),
		@DocumentID = [XmlTable].[DocumentID],
		@TaskID = [XmlTable].[TaskID], 
		@StartTime = CAST([XmlTable].[StartTime] as datetime), 
		@Duration = [XmlTable].[Duration],
		--@RoundedDuration = [XmlTable].[RoundedDuration],
		@Billable = CASE WHEN [XmlTable].[Billable] = 'false' THEN 0 ELSE 1 END, 
		--@BillableDuration = [XmlTable].[BillableDuration], 
		@Overtime = CASE WHEN [XmlTable].[Overtime] = 'false' THEN 0 ELSE 1 END, 
		@Comments = [XmlTable].[Comments],
		@EmployeeID = [XmlTable].[EmployeeID],
		@Color = [XmlTable].[Color],
		@ReminderState = CASE WHEN [XmlTable].[ReminderState] = 'false' THEN 0 ELSE 1 END,
		@ReminderInterval = [XmlTable].[ReminderInterval],
		@RemainingWork = [XmlTable].[RemainingWork],
		@RemainingOvertimeWork = [XmlTable].[RemainingOvertimeWork]
	FROM
		OPENXML(@Doc, '/pjm5TimeEntryGet/TimeEntry', 2)
			WITH (
				[FileAs] nvarchar(256),
				[ActivityTypeID] int,
				[EmployeeID] int,
				[ProjectID] int,
				[DocumentClass] varchar(32),
				[DocumentID] int,
				[TaskID] int,
				[StartTime] varchar(19),
				[Duration] int,
				[RoundedDuration] int,
				[Billable] varchar(5),
				[BillableDuration] int,
				[Overtime] varchar(5),
				[Color] int,
				[Comments] nvarchar(max),
				[ReminderState] varchar(5),
				[ReminderInterval] int,
				[RemainingWork] decimal(18,4),
				[RemainingOvertimeWork] decimal(18,4)
				) as [XmlTable]

	
	BEGIN TRANSACTION
	INSERT INTO [RecurrencePattern]
		([StartDate], [EndDate], [RecurrenceType], [Occurrences],
		[Interval], [DayOfWeekMask], [Instance], [MonthOfYear], [DayOfMonth])
	SELECT
		CAST([StartDate] as datetime),
		CAST([EndDate] as datetime),
		[RecurrenceType],
		[Occurrences],
		[Interval],
		[DayOfWeekMask],
		[Instance],
		[MonthOfYear],
		[DayOfMonth]
	FROM
		OPENXML(@doc, '/pjm5TimeEntryGet/RecurrencePattern', 2)
			WITH (
				[StartDate] varchar(19) 'StartDate',
				[EndDate] varchar(19) 'EndDate',
				[RecurrenceType] int 'RecurrenceType',
				[Occurrences] int 'Occurrences',
				[Interval] int 'Interval',
				[DayOfWeekMask] int 'DayOfWeekMask',
				[Instance] int 'Instance',
				[MonthOfYear] int 'MonthOfYear',
				[DayOfMonth] int 'DayOfMonth'
				)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @Doc
		RETURN 1
	END

	SET @RecurrenceID = SCOPE_IDENTITY()
	
	/*UPDATE [TaskAssignment]
	SET 
		[RemainingWork] = @RemainingWork,
		[RemainingOvertimeWork] = @RemainingOvertimeWork
	WHERE
		[TaskID] = @TaskID AND
		[AssignmentID] = dbo.fnPjm5GetProjectAssignment(@ProjectID, @EmployeeID)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @Doc
		RETURN 1
	END*/
	
	IF @DocumentID IS NULL SET @DocumentClass = NULL
	
	EXEC @rv = pjm5TimeEntryCreateInternal @ID OUTPUT, 
		@FileAs, 
		@ActivityTypeID, 
		@EmployeeID,
		@ProjectID,
		@DocumentClass,
		@DocumentID,
		@TaskID,
		@StartTime, 
		@Duration, 
		@Billable, 
		@Overtime, 
		@Color,
		@Comments,
		@RecurrenceID

	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @Doc
		RETURN 1
	END
	
	DECLARE @TimeEntryClass TClass
	SET @TimeEntryClass = dbo.adfGetClassByName('Pjm5.TimeEntry')

	IF @RecurrenceID IS NOT NULL
	BEGIN
		UPDATE
			[Document]
		SET
			[RecurrencePatternID] = @RecurrenceID
		WHERE
			[Class] = @TimeEntryClass AND [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			EXEC sp_xml_removedocument @Doc
			RETURN 1
		END
	END
	
	EXEC @rv = pjm5TimeEntryReminderCreate @ID,
		@StartTime, @ReminderState,	@ReminderInterval
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		EXEC sp_xml_removedocument @Doc
		RETURN @rv
	END
	
	EXEC @rv = pjm6TaskPercentUpdate @TaskID
	IF @rv != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
	EXEC sp_xml_removedocument @Doc
	EXEC pjm6TimeEntryGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryCreate TO PUBLIC
GO
 