IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TimeEntryAutoApproveForDocumentInFinalState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TimeEntryAutoApproveForDocumentInFinalState'
		DROP PROCEDURE [dbo].[pjm6TimeEntryAutoApproveForDocumentInFinalState]
	END
GO

PRINT 'Creating procedure pjm6TimeEntryAutoApproveForDocumentInFinalState'
GO

/******************************************************************************
**		File: pjm6TimeEntryAutoApproveForDocumentInFinalState.sql
**		Name: pjm6TimeEntryAutoApproveForDocumentInFinalState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Yuriy.Soldatkin
**		Date: 09.02.10
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6TimeEntryAutoApproveForDocumentInFinalState
	@DocumentClass TClass,
	@DocumentID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE @ToState TState,
			@FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@IsLocalError TBool,
			@IsAssignmentDeactivate TBool,
			@OldAssignmentID TIdentifier,
			@AssignmentID TIdentifier,
			@TaskAssignmentState TState,
			@var sql_variant,
			@ActivityTypeIsMandatory bit,
			@ActivityTypeID TIdentifier,
			@EmployeeID TIdentifier,
			@CurrentEmployeeID TIdentifier,
			@ProjectManager TBool,
			@Approver TBool,
			@Assistant TBool,
			@rv int,
			@TaskID TIdentifier,
			@TaskClass TClass

	SET @FromState = 2
	SET @ToState = 3

	SET @Class = dbo.adfGetClassByName('Pjm5.TimeEntry')
	SET @TaskClass = dbo.adfGetClassByName('Pjm5.Task')

	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RETURN 1
	END

	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())

	IF @TransitionTemplateID IS NULL
	BEGIN
		RETURN 1
	END

	DECLARE @TimeEntryAutoApproveID TIdentifier

	DECLARE For_AutoApprove CURSOR LOCAL FAST_FORWARD FOR 
		SELECT 
			[ID] 
		FROM
			[TimeEntry]
		WHERE
			(([DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID)
			OR
			([TaskID] = @DocumentID AND @DocumentClass = @TaskClass))
			 AND
			[State] = @FromState --    ?

	OPEN For_AutoApprove
	FETCH NEXT FROM For_AutoApprove INTO @TimeEntryAutoApproveID

	WHILE @@FETCH_STATUS = 0
	BEGIN
		--  -  -    
		SET @IsLocalError = 0

		SELECT
			@ProjectID = [TimeEntry].[ProjectID],
			@TaskID = [TimeEntry].[TaskID],
			@AssignmentID = dbo.fnPjm5GetProjectAssignment([TimeEntry].[ProjectID], [TimeEntry].[EmployeeID]),
			@OldAssignmentID = [TimeEntry].[AssignmentID],
			@TaskAssignmentState = [TaskAssignment].[State],
			@ActivityTypeID = [TimeEntry].[ActivityTypeID],
			@EmployeeID = [TimeEntry].[EmployeeID]
		FROM
			[TimeEntry]
			LEFT OUTER JOIN [TaskAssignment]
				ON [TaskAssignment].[AssignmentID] = [TimeEntry].[AssignmentID]
				AND [TaskAssignment].[TaskID] = [TimeEntry].[TaskID]
		WHERE
			[ID] = @TimeEntryAutoApproveID
		
		--  
		IF @ProjectID IS NULL
		BEGIN
			SET @IsLocalError = 1
		END

		SET @IsAssignmentDeactivate	= 0
	
		IF(@TaskID IS NULL
				AND 
				EXISTS (SELECT 
							* 
						FROM 
							[Assignment]
							INNER JOIN [TimeEntry]
								ON [Assignment].[ID] = [TimeEntry].[AssignmentID]	
						WHERE
							[TimeEntry].[ID] = @TimeEntryAutoApproveID
							AND [TimeEntry].[Created] <= [Assignment].[Modified]
							AND [Assignment].[State] = 2)
				)
		BEGIN
				SET @AssignmentID = @OldAssignmentID
				SET @IsAssignmentDeactivate	= 1
		END
		
		--  assignment
		IF @AssignmentID IS NULL AND @ToState != 4 AND @IsAssignmentDeactivate = 0
		BEGIN
			SET @IsLocalError = 1
		END
		
		-- taskassignment
		IF @TaskAssignmentState IS NOT NULL AND @TaskAssignmentState = 2
		BEGIN
			SET @IsLocalError = 1
		END
		
		 --     
		EXEC adfParameterGet 'ActivityTypeIsMandatory', 'Pjm5', @var OUTPUT
		IF @var IS NULL
			SET @ActivityTypeIsMandatory = 1
		ELSE
			SET @ActivityTypeIsMandatory = CAST(@var as BIT)

		IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
		BEGIN
			SET @ActivityTypeID = dbo.fnPjm5GetDefaultActivity(@ProjectID, @EmployeeID)
		END
		
		IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
		BEGIN
			SET @IsLocalError = 1
		END
		
		IF EXISTS
		(SELECT * FROM [TimeEntry] 
					INNER JOIN [Project]
						ON [Project].[ID] = [TimeEntry].[ProjectID]
			WHERE 
				[TimeEntry].[ID] = @TimeEntryAutoApproveID AND
				[Project].[MsProjectID] IS NOT NULL AND
				[TimeEntry].[TaskID] IS NULL)
				
		BEGIN
			SET @IsLocalError = 1
		END
	
		SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
		SET @ProjectManager = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
		SET @Approver = dbo.fnPjm5IsProjectApprover(@ProjectID, @CurrentEmployeeID)
		SET @Assistant = dbo.fnPjm5IsAssistant()
		
		IF @ToState IN (3, 4, 5) AND
			@ProjectManager = 0 AND
			@Approver = 0 AND
			@Assistant = 0
		BEGIN
			SET @IsLocalError = 1
		END
		
		IF @IsLocalError = 0
		BEGIN
			EXEC pjm5TimeEntryChangeState @TimeEntryAutoApproveID, 3
		END
		
		FETCH NEXT FROM For_AutoApprove INTO @TimeEntryAutoApproveID
	END
	CLOSE For_AutoApprove
	DEALLOCATE For_AutoApprove

	RETURN 0
GO

GRANT EXECUTE ON pjm6TimeEntryAutoApproveForDocumentInFinalState TO PUBLIC
GO