/****** Object:  StoredProcedure [pjmams].[ModuleGet]    Script Date: 12/12/2006 12:24:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[pjmams].[ModuleGet]') AND type in (N'P', N'PC'))
BEGIN
	PRINT 'Dropping procedure [pjmams].[ModuleGet]'
	DROP PROCEDURE [pjmams].[ModuleGet]
END
GO

PRINT 'Creating procedure [pjmams].[ModuleGet]'
GO

CREATE PROCEDURE [pjmams].[ModuleGet] 
	@Description nvarchar(max),
	@CategoryID int
AS
	SET NOCOUNT ON
	
	SELECT
		[Module].[Description] as [Module],
		[Category].[Name] as [Category]
	FROM
		[pjmams].[Module] INNER JOIN [pjmams].[Category]
			ON ([Module].[CategoryID] = [Category].[ID])
	WHERE
		[Module].[Description] = @Description
	AND
		[Module].[CategoryID] = @CategoryID
	
	SELECT DISTINCT
		[Session].[MachineName],
		[Module].[ID],
		[Module].[CategoryID],
		[Module].[Name],
		[Module].[Version],
		[Module].[Lang]
	FROM 
		[pjmams].[Module] INNER JOIN [pjmams].[Process]
			ON ([Module].[ID] = [Process].[ModuleID])
		INNER JOIN [pjmams].[Session]
			ON ([Process].[SessionID] = [Session].[ID])
	WHERE
		[Description] = @Description
	AND
		[CategoryID] = @CategoryID
	ORDER BY
		[Session].[MachineName],
		[Module].[Version] DESC
			
	
		
	RETURN 0
GO

 